
#ifndef __BASCOMPAT_HPP__
	#define __BASCOMPAT_HPP__
	
	#include <string>
	using namespace std;
	
	#define IIf(a, b, c) (a)?b:c
	
	enum MousePointerConstants {
		vbArrow = 1,
		vbArrowHourglass,
		vbArrowQuestion,
		vbCrosshair,
		vbHourglass,
		vbIbeam,
		vbIconPointer,
		vbNoDrop,
		vbSizeAll,
		vbSizeNESW,
		vbSizeNS,
		vbSizeNWSE,
		vbSizePointer,
		vbSizeWE,
		vbUpArrow
	};


	//// DATE/TIME
//	#include once "datetime.bi"

//	#ifndef vbUseSystem
//		const vbUseSystem       = fbUseSystem
//	#endif
//
//	const vbFirstJan1       = fbFirstJan1
//	const vbFirstFourDays   = fbFirstFourDays
//	const vbFirstFullWeek	= fbFirstFullWeek
//
//	const vbSunday          = fbSunday
//	const vbMonday          = fbMonday
//	const vbTuesday         = fbTuesday
//	const vbWednesday       = fbWednesday
//	const vbThursday        = fbThursday
//	const vbFriday          = fbFriday
//	const vbSaturday        = fbSaturday

	//// STRING
//	#include once "string.bi"

	//// DIR
	#define vbReadOnly		0x01
	#define vbHidden		0x02
	#define vbSystem		0x04
	#define vbDirectory		0x10
	#define vbArchive		0x20
	#define vbNormal		(fbReadOnly || fbArchive)

	//// CHAR
	const string vbBack             = "\b";
	#ifdef __WIN32
		const string vbNewLine      = "\r\n";
	#else
		const string vbNewLine      = "\n";
	#endif
//	#define vbNullChar		chr( 0x0 );
	const string vbNullString       = "";
	const string vbFormFeed         = "\f";
	const string vbVerticalTab      = "\v";
	const string vbTab              = "    ";

	//// FILE
//	#include once "file.bi"

	bool fileExists(string p_fileName); //Dir
	int fileGetSize(string p_fileName); //FileLen
	string Space(int p_size);
	string String(int p_size, string p_char);
	string Left(string p_source, int p_len);
	string Mid(string p_source, unsigned int p_start, unsigned int p_len = 0);
	string Right(string p_source, int p_len);
	int InStr(string p_source, string p_find);
	int InStr(int p_start, string p_source, string p_find);
	double Val(string p_source);
	double CDbl(string p_source);
	double CDbl(unsigned long p_source);
	double CDbl(bool p_source);
	double CDbl(int p_source);
	long CLng(int p_source);
	double CBool(string p_source);
	double CBool(double p_source);
	unsigned long CULng(int p_source);
	unsigned long CULng(string p_source);
	string Trim(string p_source);
	string Chr(int p_source);
	string Str(bool p_source);
	string Str(int p_source);
	string Str(unsigned int p_source);
	string Str(float p_source);
	string Str(long p_source);
	string Str(unsigned long p_source);
	string Str(double p_source);
	string fileOpen(string p_fileName);

	string stringToUpper(string p_str);
	string LCase(string p_str);
	int CInt(string p_source);
	int CInt(double p_source);
	unsigned int CUInt(string p_source);
	unsigned int CUInt(double p_source);
	
	extern int Err;
	extern string Erl; //should be int?
	string getFilePath(string p_fileName);
	string getFileName(string p_fileName);
#endif
