const int kseENTITY_MOVE = 1;
const int kseENTITY_NO_SPRITE = -1;

enum kseDIRECTION {
	dNOT_SET = 0,
	dDOWN = 1,
	dLEFT = 2,
	dRIGHT = 3,
	dirUP = 4 //dUP conflicts with dup(licate)
};

struct typeEntityInstance {
    bool bUsed;
    string sName; //alias (entity instance name); will be used for xxxLoop, xxxOnHit, xxxOnLoad, xxxOnUnload
    int iObstructValue;  //when entity got obstructed, this will contain which area hit it.
    int iEntityIdx;      //which is the parent entity
    bool IsAttachedToMap;    //is instance attached to map?
};

struct typeEntity {
	bool bUsed;
	string sName;
	int iX;
	int iY;
	int iWidth;
	int iHeight;
	int iSpriteIndex;		//holds the Image index which is the attached sprite fot this entity
	bool bHide;			   //should this entity be shown or not
//	POWER_TYPE Power;
//	long Frame;
	bool bStatic; //if map is not moving player should not be animated walking
	kseDIRECTION iDirection;
	int iAnmt_UpCtr;		 //counts number of frames for MOVE-UP animation
	int iAnmt_DownCtr;	   //counts number of frames for MOVE-DOWN animation
	int iAnmt_LeftCtr;	   //counts number of frames for MOVE-LEFT animation
	int iAnmt_RightCtr;	  //counts number of frames for MOVE-RIGHT animation
	
	vector<int> iSpriteHandlers;  //holds the array of frames
	vector<int> iAnmt_UpTiles;    //holds series of sprite tiles for MOVE-UP animation
	vector<int> iAnmt_DownTiles;  //holds series of sprite tiles for MOVE-DOWN animation
	vector<int> iAnmt_LeftTiles;  //holds series of sprite tiles for MOVE-LEFT animation
	vector<int> iAnmt_RightTiles; //holds series of sprite tiles for MOVE-RIGHT animation
	
	bool IsAttachedToMap;	 //if attached to map
//	long ID;
};

//struct typeEntitySprite {
//	bool bStatic;  //animate or halt
//	//int iDelay;   //how many times a frame will be showed; connected to animation
//	int iCtr;	 //animation counter
//	int iIdx;	 //would contain the index from an animation
//};

struct typeSpriteAnimation {
	bool bUsed;
	int iCtr;	  //frame counter
	//int iTiles[10000];  //will hold series of tiles for animation

			vector<int> iTiles;  //will hold series of tiles for animation
};

extern vector<typeEntity> kseEntity;
extern vector<typeEntityInstance> kseEntityInstance;
//extern vector<typeEntitySprite> kseEntitySprites;
extern vector<typeSpriteAnimation> kseSpriteAnimation;

//extern int iEntityCtr;
//extern int iEntityInstanceCtr;
extern long iEntitySpritesCtr;
extern long iSpriteAnimationCtr;

//functions
unsigned long EntityAttachSprite(unsigned long &iIndex);
unsigned long EntityDetachSprite(unsigned long &iIndex);
unsigned long EntitySetX(unsigned long &iIndex);
unsigned long EntitySetY(unsigned long &iIndex);
unsigned long EntityGenerate(unsigned long &iIndex);
unsigned long EntityNew(unsigned long &iIndex);
int CreateNewEntity();
unsigned long EntityLoad(unsigned long &iIndex);
void Engine_RunEntityScript(string flName, string fxName, string ksExt = ".ks");
unsigned long EntityUnload(unsigned long &iIndex);
unsigned long EntitySetMoveUp(unsigned long &iIndex);
unsigned long EntitySetMoveDown(unsigned long &iIndex);
unsigned long EntitySetMoveLeft(unsigned long &iIndex);
unsigned long EntitySetMoveRight(unsigned long &iIndex);
void Engine_EntityChangeDirection(int entity, kseDIRECTION dDir);
unsigned long Entity_SkipOpenParenthesisAfter(string sWhat, unsigned long &iIndex);
unsigned long Entity_SkipCommaAfter(string sWhat, unsigned long &iIndex);
unsigned long Entity_SkipCloseParenthesisAfter(string sWhat, unsigned long &iIndex);
//class
unsigned long SynEntity(unsigned long &iIndex);
