Extern kseMAP_CURRENT_RENDER As Integer


Public Const kseMAP_MOVE = 1 'is it related to kseMAP_MOVE_TILEBASED_MODE

''
' Used for checking if no playing entity was set.
'
' @remarks It does not seem to be implemented.
Public Const kseMAP_NO_PLAYER = 0

''
' Used for checking if no entity was attached to a map.
' Flag for there is no entity in the tile location.
'
' @remarks It does not seem to be implemented.
Public Const kseMAP_NO_ENTITY = 0

''
' Used for checking if no tileset was attached to a map.
'
' @remarks None.
Public Const kseMAP_NO_TILESET = -1

''
' Indicates how will the map move.
'
' @remarks Non-tile-based mode is not yet implemented.
Public Const kseMAP_MOVE_TILEBASED_MODE = 0

''
' Indicates how many times to move a map when arrow key is pressed.
'
' @return Integer
' @remarks None.
Extern iMapMoveCtrMax As Integer

''
' Counts the movement.
'
' @return Integer
' @remarks None.
Extern iMapMoveCtr  As Integer

''
' Indicates pixels to travel.
'
' @return Integer
' @remarks None.
Extern iMapMove As Integer

''
' Indicates layer for obstructions.
'
' @return Integer
' @remarks None.
Extern iObsLayer As Integer

''
' Indicates layer for triggers.
'
' @return Integer
' @remarks None.
Extern iTrgLayer As Integer

''
' Current map filename being executed.
'
' @return String
' @remarks None.
Extern sMapName As String

''
' Current map's layer count.
'
' @return Integer
' @remarks None.
Extern iMapLayers As Integer

''
' Game's map width.
'
' @return Integer
' @remarks None.
Extern iMapWidth As Integer

''
' Game's map height.
'
' @return Integer
' @remarks None.
Extern iMapHeight As Integer

''
' Indicates layer on which entities reside.
'
' @return Integer
' @remarks None.
Extern iMapEntityLayer As Integer

''
' To check if game is focuusing on an entity.
'
' @return Byte
' @remarks None.
Extern bMapFocusingOnEntity As Byte

''
' For <b>Game:Render()</b>; needed to hook controls on map
'
' @return Byte
' @remarks Needed for rendering.
Extern bMapRender As Byte

''
' For <b>Game:Render()</b>s pause-state checking; needed to hook controls on map
'
' @return Byte
' @remarks Needed for rendering.
Extern bMapRendering As Byte

''
' To check if user map should move left.
'
' @return Byte
' @remarks Needed to hook controls on game.
Extern bMapMoveLeft As Byte

''
' To check if user map should move right.
'
' @return Byte
' @remarks Needed to hook controls on game.
Extern bMapMoveRight As Byte

''
' To check if user map should move up.
'
' @return Byte
' @remarks Needed to hook controls on game.
Extern bMapMoveUp As Byte

''
' To check if user map should move down.
'
' @return Byte
' @remarks Needed to hook controls on game.
Extern bMapMoveDown As Byte


'Type typeMapTile
'	bStatic As Byte  'not animated
'	iDelay As Integer   'how many times a frame will be showed; connected to animated tiles
'	iChance As Integer  'x/100 -> chance for a trigger(event) be triggered; connected to trigger tiles
'	bTBlit As Byte   'render with transparency
'	bHide As Byte	'should this tile be shown or not
'	iCtr As Integer	 'animation counter
'	iIdx As Integer	 'would contain the:
'						'   - index from tileset
'						'   - or, index from an animation
'						'   - or, obstruction data
'						'   - or, index from triggers
'	'since there is an entity layer, instead of using the
'	'variables above, let's use another for entity location
'	'iEntityIdx As Integer   'who is that entity
'End Type
'
'Type typeTileAnimation
'	bUsed As Byte
'	iCtr As Integer		'frame counter
'	'iTiles(10000) As Integer	'will hold series of tiles for animation
'
'			iTiles As Integer Ptr 'will hold series of tiles for animation
'			iTileMax As Integer   '   for ubound
'End Type
'
'Type typeTileTrigger
'	bUsed As Byte
'	sFunction As String  'function to call when triggered
'End Type
'
'Extern iMapEntityHandlers() As Integer		    'will hold array of entity-indices
'	Extern iMapEntityHandlersCtr As Long		 'counts the number of entity-indices
'Extern kseTileAnimation() As typeTileAnimation 'will hold array of sequence of tiles-indices for animated tiles
'	Extern iTileAnimationCtr As Long			    'counts the number of sequences for tiles-indices of animated tiles
'Extern kseTileTrigger() As typeTileTrigger	    'will hold array of triggers for a tile
'	Extern iTileTriggerCtr As Long			    'counts the number of triggers


'dev api
Declare Sub Engine_CheckForMovement()
Declare Sub Engine_RunMapScript(fxName As String, bWarn As Byte = 1)
Declare Sub Engine_RunScript(sScriptFile As String, fxName As String, sFileExt As String = ".ks", bWarn As Byte = True)
Declare Sub Engine_SpriteBillboardCheckup()

Declare Function KSE_GetSpriteAnimation(iEntity As Integer) As Integer
Declare Function KSE_GetTileAnimation(iTileIdx As Integer, iMID As Integer) As Integer
Declare Function ReDim_MapEntity(new_list_count As Integer,map_idx As Integer) As Byte
Declare Function ReDim_MapEntityName(new_list_count As Integer,map_idx As Integer) As Byte

'functions
Declare Function GameAttachEntity(ByRef iIndex As Long) As Integer
Declare Function GameDetachEntity(ByRef iIndex As Long) As Integer
Declare Function GameEntityGetX(ByRef iIndex As Long) As Integer
Declare Function GameEntityGetY(ByRef iIndex As Long) As Integer
Declare Function GameEntitySetX(ByRef iIndex As Long) As Integer
Declare Function GameEntitySetY(ByRef iIndex As Long) As Integer
Declare Function GameFocusEntity(ByRef iIndex As Long) As Integer
Declare Function GameGetCameraX(ByRef iIndex As Long) As Integer
Declare Function GameGetCameraY(ByRef iIndex As Long) As Integer
Declare Function GamePause(ByRef iIndex As Long) As Integer
Declare Function GameRender(ByRef iIndex As Long) As Integer
Declare Function GameResume(ByRef iIndex As Long) As Integer
Declare Function GameSetCameraX(ByRef iIndex As Long) As Integer
Declare Function GameSetCameraY(ByRef iIndex As Long) As Integer
Declare Function GameSetPlayer(ByRef iIndex As Long) As Integer
Declare Function GameStop(ByRef iIndex As Long) As Integer
'wrappers
Declare Function Game_SkipCloseParenthesisAfter(sWhat As String, ByRef iIndex As Long) As Integer
Declare Function Game_SkipCommaAfter(sWhat As String, ByRef iIndex As Long) As Integer
Declare Function Game_SkipOpenParenthesisAfter(sWhat As String, ByRef iIndex As Long) As Integer
'class
Declare Function SynGame(ByRef iIndex As Long) As Integer
