extern unsigned long kseMAP_CURRENT_RENDER;


const int kseMAP_MOVE = 1; //is it related to kseMAP_MOVE_TILEBASED_MODE

/*
 Used for checking if no playing entity was set.

 @remarks It does not seem to be implemented.
*/
const int kseMAP_NO_PLAYER = 0;

/*
 Used for checking if no entity was attached to a map.
 Flag for there is no entity in the tile location.

 @remarks It does not seem to be implemented.
*/
const int kseMAP_NO_ENTITY = 0;

/*
 Used for checking if no tileset was attached to a map.

 @remarks None.
*/
const int kseMAP_NO_TILESET = -1;

/*
 Indicates how will the map move.

 @remarks Non-tile-based mode is not yet implemented.
*/
const int kseMAP_MOVE_TILEBASED_MODE = 0;

/*
 Indicates how many times to move a map when arrow key is pressed.

 @return int
 @remarks None.
*/
extern int iMapMoveCtrMax;

/*
 Counts the movement.

 @return int
 @remarks None.
*/
extern int iMapMoveCtr;

/*
 Indicates pixels to travel.

 @return int
 @remarks None.
*/
extern int iMapMove;

/*
 Indicates layer for obstructions.

 @return int
 @remarks None.
*/
extern int iObsLayer;

/*
 Indicates layer for triggers.

 @return int
 @remarks None.
*/
extern int iTrgLayer;

/*
 Current map filename being executed.

 @return Stringstring
 @remarks None.
*/
extern string sMapName;

/*
 Current map's layer count.

 @return int
 @remarks None.
*/
extern int iMapLayers;

/*
 Game's map width.

 @return int
 @remarks None.
*/
extern int iMapWidth;

/*
 Game's map height.

 @return int
 @remarks None.
*/
extern int iMapHeight;

/*
 Indicates layer on which entities reside.

 @return int
 @remarks None.
*/
extern int iMapEntityLayer;

/*
 To check if game is focuusing on an entity.

 @return bool
 @remarks None.
*/
extern bool bMapFocusingOnEntity;

/*
 For <b>Game:Render()</b>; needed to hook controls on map

 @return bool
 @remarks Needed for rendering.
*/
extern bool bMapRender;

/*
 For <b>Game:Render()</b>s pause-state checking; needed to hook controls on map

 @return bool
 @remarks Needed for rendering.
*/
extern bool bMapRendering;

/*
 To check if user map should move left.

 @return bool
 @remarks Needed to hook controls on game.
*/
extern bool bMapMoveLeft;

/*
 To check if user map should move right.

 @return bool
 @remarks Needed to hook controls on game.
*/
extern bool bMapMoveRight;

/*
 To check if user map should move up.

 @return bool
 @remarks Needed to hook controls on game.
*/
extern bool bMapMoveUp;

/*
 To check if user map should move down.

 @return bool
 @remarks Needed to hook controls on game.
*/
extern bool bMapMoveDown;


/*struct typeMapTile {
	bool bStatic  //not animated
	int iDelay;   //how many times a frame will be showed; connected to animated tiles
	int iChance;  //x/100 -> chance for a trigger(event) be triggered; connected to trigger tiles
	bool bTBlit;   //render with transparency
	bool bHide;	//should this tile be shown or not
	int iCtr;	 //animation counter
	int iIdx;	 //would contain the:
						//   - index from tileset
						//   - or, index from an animation
						//   - or, obstruction data
						//   - or, index from triggers
	//since there is an entity layer, instead of using the
	//variables above, let's use another for entity location
	//iEntityIdx As Integer   'who is that entity
};
*/

/*
struct typeTileAnimation {
	bool bUsed;
	int iCtr;		//frame counter
	intiTiles[10000];	//will hold series of tiles for animation

			vector<int> iTiles; //will hold series of tiles for animation
};
*/

/*
struct typeTileTrigger {
	bool bUsed;
	string sFunction;  //function to call when triggered
};
*/

/*
extern vector<int> iMapEntityHandlers;		    //will hold array of entity-indices
	extern long iMapEntityHandlersCtr;		 //counts the number of entity-indices
extern vector<typeTileAnimation> kseTileAnimation; //will hold array of sequence of tiles-indices for animated tiles
	extern long iTileAnimationCtr;			    //counts the number of sequences for tiles-indices of animated tiles
extern vector<typeTileTrigger> kseTileTrigger;	    //will hold array of triggers for a tile
	extern long iTileTriggerCtr;			    //counts the number of triggers
*/

//dev api
void Engine_CheckForMovement();
void Engine_RunMapScript(string fxName, bool bWarn = true);
void Engine_RunScript(string sScriptFile, string fxName, string sFileExt = ".ks", bool bWarn = true);
void Engine_SpriteBillboardCheckup();

int KSE_GetSpriteAnimation(int iEntity);
int KSE_GetTileAnimation(int iTileIdx, int iMID);
bool ReDim_MapEntity(int new_list_count, int map_idx);
bool ReDim_MapEntityName(int new_list_count, int map_idx);

//functions
unsigned long GameAttachEntity(unsigned long &iIndex);
unsigned long GameDetachEntity(unsigned long &iIndex);
unsigned long GameEntityGetX(unsigned long &iIndex);
unsigned long GameEntityGetY(unsigned long &iIndex);
unsigned long GameEntitySetX(unsigned long &iIndex);
unsigned long GameEntitySetY(unsigned long &iIndex);
unsigned long GameFocusEntity(unsigned long &iIndex);
unsigned long GameGetCameraX(unsigned long &iIndex);
unsigned long GameGetCameraY(unsigned long &iIndex);
unsigned long GamePause(unsigned long &iIndex);
unsigned long GameRender(unsigned long &iIndex);
unsigned long GameResume(unsigned long &iIndex);
unsigned long GameSetCameraX(unsigned long &iIndex);
unsigned long GameSetCameraY(unsigned long &iIndex);
unsigned long GameSetPlayer(unsigned long &iIndex);
unsigned long GameStop(unsigned long &iIndex);
//wrappers
unsigned long Game_SkipCloseParenthesisAfter(string sWhat, unsigned long &iIndex);
unsigned long Game_SkipCommaAfter(string sWhat, unsigned long &iIndex);
unsigned long Game_SkipOpenParenthesisAfter(string sWhat, unsigned long &iIndex);
//class
unsigned long SynGame(unsigned long &iIndex);
