
Type typeMapTile
	bStatic As Byte  'not animated
	iDelay As Integer   'how many times a frame will be showed; connected to animated tiles
	iChance As Integer  'x/100 -> chance for a trigger(event) be triggered; connected to trigger tiles
	bTBlit As Byte   'render with transparency
	bHide As Byte	'should this tile be shown or not
	iCtr As Integer	 'animation counter
	iIdx As Integer	 'would contain the:
						'   - index from tileset
						'   - or, index from an animation
						'   - or, obstruction data
						'   - or, index from triggers
	'since there is an entity layer, instead of using the
	'variables above, let's use another for entity location
	'iEntityIdx As Integer   'who is that entity
End Type

Type typeTileAnimation
	bUsed As Byte
	iCtr As Integer		'frame counter
	'iTiles(10000) As Integer	'will hold series of tiles for animation

			'iTiles As Integer Ptr 'will hold series of tiles for animation
			'iTileMax As Integer   '   for ubound
			iTiles As typeIntCollection
End Type

Type typeTileTrigger
	bUsed As Byte
	sFunction As String  'function to call when triggered
End Type

Extern iMapEntityHandlers() As Integer		    'will hold array of entity-indices
	Extern iMapEntityHandlersCtr As Long		 'counts the number of entity-indices
Extern kseTileAnimation() As typeTileAnimation 'will hold array of sequence of tiles-indices for animated tiles
	Extern iTileAnimationCtr As Long			    'counts the number of sequences for tiles-indices of animated tiles
Extern kseTileTrigger() As typeTileTrigger	    'will hold array of triggers for a tile
	Extern iTileTriggerCtr As Long			    'counts the number of triggers

'11.28.06 - attempt to write out a good datastructure for a map
Type typeMap
	bUsed As Byte				'is the index being used
	sName As String		   'map name - should be the same as the map-file
	Map As Integer				'the whole map as an image; this is where layers will be drawn at
	MapDimension As Integer	'the maps pixel movement for tile-based
	iTileSet As Integer	   'handles image-file index
	'iTileImgHdlr(100) As Integer 'handles each tile in tileset per index
		'basically, the MAP itself; will hold array of pics handled by iTileImgHdlr()
		'upon Map:Render, this will construct the whole map image
		'iTileData(100) As typeMapTile
	iLayers As Integer		  'number of layers - spec'd tru Map:SetLayers
	'iLayer(100) As Integer	  'handles images of each layer
	iLayerObstruct As Integer 'the obstruction layer
	iLayerTrigger As Integer  'the data-for-trigger-of-events' layer
	iLayerEntity As Integer   'the entity layer
	'entity --------------------------------------
	EntitiesCtr As Integer	'number of entities - depends on how many is attached
	'EntitiesName(1000) As String  'name of an entity instance
	'Entities(1000) As typeEntity  'attached entities
	EntityFocus As Integer	'index of entity to focus camera onto
	'player --------------------------------------
	iPlayer As Integer	'index of entity to be controlled
	'camera location -----------------------------
        'used to focus on entity
            iX  As Integer            'x location
            iY  As Integer            'y location
        'used for reference
            iCamX  As Integer         'x location
            iCamY  As Integer         'y location
	'area ----------------------------------------
	iWidth As Integer		'width in tile-count
	iHeight As Integer	'height in tile-count
	'render --------------------------------------
	bRender As Byte		'for Map:Render() --end or continue
	bRendering As Byte	'for Map:Render() --pause or continue
	'movement ------------------------------------
	iMoveMode As Integer	'movement mode
	bMoveLeft As Byte	  	'should it move left
	bMoveRight As Byte	'should it move right
	bMoveUp As Byte		'should it move up
	bMoveDown As Byte		'should it move down

			iTileImgHdlr As Integer Ptr 'handles each tile in tileset per index
			iTileImgHdlrMax As Integer  '  for ubound
			iTileData As typeMapTile Ptr
			iTileDataMax As Integer     '  for ubound
			iLayer As Integer Ptr 	    'handles images of each layer
			EntitiesName As String Ptr  'name of an entity instance
			Entities As typeEntity Ptr  'attached entities
End Type

Extern kseMap() As typeMap
Extern iMapCtr As Long


'functions
Declare Sub Engine_NormalizeEntityLocation()

Declare Function MapAttachTileSet(ByRef iIndex As Long) As Integer
Declare Function MapSetArea(ByRef iIndex As Long) As Integer
Declare Function MapSetLayers(ByRef iIndex As Long) As Integer
Declare Function MapGenerate(ByRef iIndex As Long) As Integer
Declare Function MapLoad(ByRef iIndex As Long) As Integer
Declare Function MapDegenerate(ByRef iIndex As Long) As Integer
Declare Function MapDetachTileSet(ByRef iIndex As Long) As Integer
Declare Function MapResume(ByRef iIndex As Long) As Integer
Declare Function MapUnload(ByRef iIndex As Long) As Integer
Declare Function MapDetachEntity(ByRef iIndex As Long) As Integer
Declare Function MapSetEntityLayer(ByRef iIndex As Long) As Integer
Declare Function MapSetObstructionLayer(ByRef iIndex As Long) As Integer
Declare Function MapSetTriggerLayer(ByRef iIndex As Long) As Integer
Declare Function MapNew(ByRef iIndex As Long) As Integer
Declare Function MapFree(ByRef iIndex As Long) As Integer
Declare Function CreateNewMap() As Integer
'wrappers
Declare Function Map_SkipOpenParenthesisAfter(sWhat As String, ByRef iIndex As Long) As Integer
Declare Function Map_SkipCommaAfter(sWhat As String, ByRef iIndex As Long) As Integer
Declare Function Map_SkipCloseParenthesisAfter(sWhat As String, ByRef iIndex As Long) As Integer
'class
Declare Function SynMap(ByRef iIndex As Long) As Integer
