
struct typeMapTile {
	bool bStatic;  //not animated
	int iDelay;   //how many times a frame will be showed; connected to animated tiles
	int iChance;  //x/100 -> chance for a trigger(event) be triggered; connected to trigger tiles
	bool bTBlit;   //render with transparency
	bool bHide;	//should this tile be shown or not
	int iCtr;	 //animation counter
	long iIdx;	 //would contain the:
						//   - index from tileset
						//   - or, index from an animation
						//   - or, obstruction data
						//   - or, index from triggers
	//since there is an entity layer, instead of using the
	//variables above, let's use another for entity location
	//int iEntityIdx;   //who is that entity
};

struct typeTileAnimation {
	bool bUsed;
	int iCtr;		//frame counter
	//int iTiles[10000];	//will hold series of tiles for animation

			vector<int> iTiles; //will hold series of tiles for animation
};

struct typeTileTrigger {
	bool bUsed;
	string sFunction;  //function to call when triggered
};

extern vector<int> iMapEntityHandlers;			  //will hold array of entity-indices
	extern long iMapEntityHandlersCtr;			  //counts the number of entity-indices
extern vector<typeTileAnimation> kseTileAnimation; //will hold array of sequence of tiles-indices for animated tiles
	extern unsigned long iTileAnimationCtr;				  //counts the number of sequences for tiles-indices of animated tiles
extern vector<typeTileTrigger> kseTileTrigger;	  //will hold array of triggers for a tile
	extern unsigned long iTileTriggerCtr;				  //counts the number of triggers

//11.28.06 - attempt to write out a good datastructure for a map
struct typeMap {
	bool bUsed;				//is the index being used
	string sName;		   //map name - should be the same as the map-file
	int Map;				//the whole map as an image; this is where layers will be drawn at
	int MapDimension;	//the maps pixel movement for tile-based
	int iTileSet;	   //handles image-file index
	//int iTileImgHdlr[100]; //handles each tile in tileset per index
		//basically, the MAP itself; will hold array of pics handled by iTileImgHdlr()
		//upon Map:Render, this will construct the whole map image
		//typeMapTile iTileData[100];
	int iLayers;		  //number of layers - spec//d tru Map:SetLayers
	//int iLayer[100];	  //handles images of each layer
	int iLayerObstruct; //the obstruction layer
	int iLayerTrigger;  //the data-for-trigger-of-events// layer
	int iLayerEntity;   //the entity layer
	//entity --------------------------------------
	int EntitiesCtr;	//number of entities - depends on how many is attached
	//string EntitiesName[1000];  //name of an entity instance
	//typeEntity Entities[1000];  //attached entities
	int EntityFocus;	//index of entity to focus camera onto
	//player --------------------------------------
	int iPlayer;	//index of entity to be controlled
	//camera location -----------------------------
        //used to focus on entity
            int iX;            //x location
            int iY;            //y location
        //used for reference
            int iCamX;         //x location
            int iCamY;         //y location
	//area ----------------------------------------
	int iWidth;		//width in tile-count
	int iHeight;	//height in tile-count
	//render --------------------------------------
	bool bRender;		//for Map:Render() --end or continue
	bool bRendering;	//for Map:Render() --pause or continue
	//movement ------------------------------------
	int iMoveMode;	//movement mode
	bool bMoveLeft;	  	//should it move left
	bool bMoveRight;	//should it move right
	bool bMoveUp;		//should it move up
	bool bMoveDown;		//should it move down

			vector<int> iTileImgHdlr; //handles each tile in tileset per index
			int iTileImgHdlrMax;  //  for ubound
			vector<typeMapTile> iTileData;
			int iTileDataMax;     //  for ubound
			vector<int> iLayer; 	    //handles images of each layer
			vector<string> EntitiesName;  //name of an entity instance
			vector<typeEntity> Entities;  //attached entities
};

extern vector<typeMap> kseMap;
extern unsigned long iMapCtr;


//functions
void Engine_NormalizeEntityLocation();

unsigned long MapAttachTileSet(unsigned long &iIndex);
unsigned long MapSetArea(unsigned long &iIndex);
unsigned long MapSetLayers(unsigned long &iIndex);
unsigned long MapGenerate(unsigned long &iIndex);
unsigned long MapLoad(unsigned long &iIndex);
unsigned long MapDegenerate(unsigned long &iIndex);
unsigned long MapDetachTileSet(unsigned long &iIndex);
unsigned long MapResume(unsigned long &iIndex);
unsigned long MapUnload(unsigned long &iIndex);
unsigned long MapDetachEntity(unsigned long &iIndex);
unsigned long MapSetEntityLayer(unsigned long &iIndex);
unsigned long MapSetObstructionLayer(unsigned long &iIndex);
unsigned long MapSetTriggerLayer(unsigned long &iIndex);
unsigned long MapNew(unsigned long &iIndex);
unsigned long MapFree(unsigned long &iIndex);
unsigned long CreateNewMap();
//wrappers
unsigned long Map_SkipOpenParenthesisAfter(string sWhat, unsigned long &iIndex);
unsigned long Map_SkipCommaAfter(string sWhat, unsigned long &iIndex);
unsigned long Map_SkipCloseParenthesisAfter(string sWhat, unsigned long &iIndex);
//class
unsigned long SynMap(unsigned long &iIndex);
