
''
' Parser for KonsolScript's <b>Net</b> class.
'
' Uses ChiSock.<br>
' TODO:
' <ul>
'  <li>finish Net:SendTo
'  <li>way for users to fetch list of players that are currently in session
'  <li>add Net:Kick
' </ul>
' @date 2008.04.10

Public Const APP_GUID = "{F2EE50F7-6A3E-E461-4E24-C2A214AE77E4}"
                         'freesoft-game-engi-ne24-czarinaellen
                         '  (ware)
''
' Uses a constant <b>2400</b> as port for communication
'
' @remarks This should also be configurable through <b>ksCONFIG_FILE</b>
Public Const kseNET_PORT = 2400

''
' Used by engine for parsing and interpreting
'
' @return String
' @remarks None.
Extern cNetTxt As String

''
' Holds lists of players currently in network
'
' @return String
' @remarks None.
'Extern lstPlayer() As String

''
' Holds lists of messages queued for manual fetching
'
' @return String
' @remarks If you plan to implement KonsolScript in other language (C/C++), use linked list instead.
Extern sNetMsg As String

''
' Holds lists of game-data-messages queued for manual fetching
'
' @return String
' @remarks If you plan to implement KonsolScript in other language (C/C++), use linked list instead.
Extern sNetData As String

Declare Function SynNet(iIndex As Integer) As Integer
Declare Function NetQuit(iIndex As Integer) As Integer
Declare Function NetHost(iIndex As Integer) As Integer
Declare Function NetCheck(iIndex As Integer) As Integer
Declare Function NetJoin(iIndex As Integer) As Integer
Declare Function NetSend(iIndex As Integer) As Integer
Declare Function NetSendTo(iIndex As Integer) As Integer
Declare Function NetGetMessage(iIndex As Integer) As Integer
Declare Function NetSendData(iIndex As Integer) As Integer
Declare Function NetGetData(iIndex As Integer) As Integer
Declare Function NetListClientName(iIndex As Integer) As Integer
Declare Function Net_SkipOpenParenthesisAfter(sWhat As String, iIndex As Integer) As Integer
Declare Function Net_SkipCommaAfter(sWhat As String, iIndex As Integer) As Integer
Declare Function Net_SkipCloseParenthesisAfter(sWhat As String, iIndex As Integer) As Integer
Declare Function Engine_InitConnectionList() As Byte
Declare Function Engine_ListSessions() As Byte
Declare Function Engine_UpdatePlayers() As String
Declare Sub Engine_CheckConnection()
Declare Function Engine_Host() As Byte
Declare Function Engine_Join(serverName As String, port As Integer) As Byte
Declare Function Engine_Send(sMsg As String, MsgTYPE As Long = 0) As Byte
Declare Function Engine_InitConnection() As Byte
Declare Sub Engine_DisableJoin()
Declare Function Engine_ParseIP(sIP As String) As Integer
