
/*
 Parser for KonsolScript's <b>Net</b> class.

 Uses FbNet.<br>
 TODO:
 <ul>
  <li>finish Net:SendTo
  <li>way for users to fetch list of players that are currently in session
  <li>add Net:Kick
 </ul>
 @date 2008.04.10
*/
const string APP_GUID = "{F2EE50F7-6A3E-E461-4E24-C2A214AE77E4}";
                         //freesoft-game-engi-ne24-czarinaellen
                         //  (ware)
/*
 Uses a constant <b>2400</b> as port for communication

 @remarks This should also be configurable through <b>ksCONFIG_FILE</b>
*/
const int kseNET_PORT = 2400;

/*
 Used by engine for parsing and interpreting

 @return string
 @remarks None.
*/
extern string cNetTxt;

/*
 Holds lists of players currently in network

 @return String
 @remarks None.
*/
//vector<string> lstPlayer;

/*
 Holds lists of messages queued for manual fetching

 @return string
 @remarks If you plan to implement KonsolScript in other language (C/C++), use linked list instead.
*/
extern string sNetMsg;

/*
 Holds lists of game-data-messages queued for manual fetching

 @return string
 @remarks If you plan to implement KonsolScript in other language (C/C++), use linked list instead.
*/
extern string sNetData;

unsigned long SynNet(long &iIndex);
long NetQuit(long &iIndex);
long NetHost(long &iIndex);
long NetCheck(long &iIndex);
long NetJoin(long &iIndex);
long NetSend(long &iIndex);
long NetSendTo(long &iIndex);
long NetGetMessage(long &iIndex);
long NetSendData(long &iIndex);
long NetGetData(long &iIndex);
long NetListClientName(long &iIndex);
long Net_SkipOpenParenthesisAfter(string sWhat, long &iIndex);
long Net_SkipCommaAfter(string sWhat, long &iIndex);
long Net_SkipCloseParenthesisAfter(string sWhat, long &iIndex);
bool Engine_InitConnectionList();
bool Engine_ListSessions();
string Engine_UpdatePlayers();
void Engine_CheckConnection();
bool Engine_Host();
bool Engine_Join(string serverName, int port);
bool Engine_Send(string sMsg, long MsgTYPE = 0, FDSOCKET pTo = -1);
bool Engine_InitConnection();
void Engine_DisableJoin();
long Engine_ParseIP(string sIP);

void Engine_ServerStartThread(void *foo);
void Engine_ClientStartThread(void *pAny);
void Engine_ServerStart(void *pAny);
void Engine_NetQuit();


bool Engine_NetDataPush(int iMsgType, int iFromID, int iToID, string sContent);
typeNetData Engine_NetDataPop();
