
Var:Number iY, iY_sub, iTmp,
	iBX, iBY, iBColor, iBS,                                   //blue-paddle-related variables
	iRX, iRY, iRColor, iRS,                                   //red-paddle-related variables
	iOX, iOY, iOColor, bBall_HDir, bBall_VDir, iOM,           //ball-related variables
	sndPing, sndPong, sndWall, sndMiss, sndChoose, sndSelect; //sound-handlers
	
Var:Boolean bUseBlue = true;

Var:Number
	MAX_SCORE    =  7,
	PLAYER_SPEED =  7,
	BALLRAD      =  2,
	iPW          =  5,
	iPH          = 50,
	iCW          =  5,
	iCH          = 50;

Var:Number
	iState           = 0,
	STATE_MainMenu   = 0,
	STATE_GameForm   = 1,
	STATE_GamePaused = 2,
	STATE_OptionForm = 3,
	STATE_QuitForm   = 4;

function main() {
	//initialize Quixie for ksPong
	Sound:Load("resource/ping.wav", sndPing)
	Sound:Load("resource/pong.wav", sndPong)
	Sound:Load("resource/wall.wav", sndWall)
	Sound:Load("resource/miss.wav", sndMiss)
	Sound:Load("resource/choose.wav", sndChoose)
	Sound:Load("resource/select.wav", sndSelect)
	
	Konsol:RGB(0, 100, 255, iBColor)
	Konsol:RGB(255, 100, 0, iRColor)
	Konsol:RGB(255, 255, 100, iOColor)
	
	iBX = 10;
	iRX = screenwidth-20;
	iY = 120;
	
	Mouse:Hide()
}

function keydown() {
	if (iState == STATE_MainMenu) {
		MainMenu_onKeyDown()
	} else if (iState == STATE_GameForm) {
		GameForm_onKeyDown()
	} else if (iState == STATE_GamePaused) {
		GamePaused_onKeyDown()
	} else if (iState == STATE_OptionForm) {
		OptionForm_onKeyDown()
	} else if (iState == STATE_QuitForm) {
		QuitForm_onKeyDown()
	}
}

function cleanrender() {
	if (iState == STATE_MainMenu) {
		MainMenu()
	} else if (iState == STATE_GameForm) {
		GameForm()
	} else if (iState == STATE_GamePaused) {
		GamePaused()
	} else if (iState == STATE_OptionForm) {
		OptionForm()
	} else if (iState == STATE_QuitForm) {
		QuitForm()
	}
}

function MainMenu() {
	Screen:GoToXY(50,50)
	Screen:PrintString("Mj Mendoza IV's")
	Screen:GoToXY(60,70)
	Screen:PrintString("ksPong")
	
	Screen:GoToXY(70,120)
	Screen:PrintString("New Game")
	Screen:GoToXY(70,135)
	Screen:PrintString("Option")
	Screen:GoToXY(70,150)
	Screen:PrintString("Credits")
	Screen:GoToXY(70,165)
	Screen:PrintString("Quit")
	
	//draw the *menu pointer*
	Screen:GoToXY(50, iY)
	Screen:PrintString(">")
}
function MainMenu_onKeyDown() {
	//check if user/player pressed ENTER key
	if (B3 == true) {
		Sound:Play(sndSelect)
		
		//do what the user wants according to the *pointer* location
		if (iY == 120) {
			iState = STATE_GameForm;
			
			ResetGame()
		} else if (iY == 135) {
			iY_sub = 120;
			iState = STATE_OptionForm;
		} else if (iY == 150) {
			Konsol:Message("This game is scripted to demonstrate classes such as:\n" +
						   "\tDraw, Konsol, Sound\n" +
						   "\tMouse, Screen, Var\n\n" +
						   "This game also demonstrates:\n" +
						   "\t- code structuring with 'while' and 'for' loop\n" +
						   "\t- code branching with 'if-else' iStatement\n" +
						   "\t- code management with user-defined functions\n" +
						   "\t- simple AI\n\n" +
						   "Written with KonsolScript\n" +
						   "by Mj Mendoza IV\n" +
						   "mjmendoza@konsolscript.org", "Credits")
		} else if (iY == 165) {
			iY_sub = 120;
			iState = STATE_QuitForm;
		}
	}
	
	//move the *pointer* location
	if (BU == true) {
		if (iY > 120) {
			iY -= 15;
			Sound:Play(sndChoose)
		}
	} else if (BD == true) {
		if (iY < 165) {
			iY += 15;
			Sound:Play(sndChoose)
		}
	}
	
	//if ESC key is pressed, end game
	if (B1 == true) {
		Konsol:Exit()
	}
}

function GameForm() {
	DrawRedPaddle()
	DrawBluePaddle()
	DrawBall()
	DrawScore()
	
	CheckWinner()
}
function GameForm_onKeyDown() {
	if (B1 == true) {
		iState = STATE_GamePaused;
		Sound:Play(sndSelect)
	}
}

function GamePaused() {
	Screen:GoToXY(50,80)
	Screen:PrintString("Do you want to End the Game?")
	Screen:GoToXY(70,120)
	Screen:PrintString("Yes")
	Screen:GoToXY(70,135)
	Screen:PrintString("No")
	
	Screen:GoToXY(50, iY_sub)
	Screen:PrintString(">")
}
function GamePaused_onKeyDown() {
	if (B3 == true) {
		Sound:Play(sndSelect)
		if (iY_sub == 135) {
			iState = STATE_GameForm;
		} else {
			iState = STATE_MainMenu;
		}
	}
	
	if (BU == true) {
		if (iY_sub > 120) {
			iY_sub -= 15;
			Sound:Play(sndChoose)
		}
	} else if (BD == true) {
		if (iY_sub < 135) {
			iY_sub += 15;
			Sound:Play(sndChoose)
		}
	}
	
	if (B1 == true) {
		iState = STATE_GameForm;
		Sound:Play(sndSelect)
	}
}

function OptionForm() {
	Screen:GoToXY(50,80)
	Screen:PrintString("Option")
	Screen:GoToXY(70,120)
	Screen:PrintString("Play Blue Paddle")
	Screen:GoToXY(70,135)
	Screen:PrintString("Play Red Paddle")
	
	Screen:GoToXY(50, iY_sub)
	Screen:PrintString(">")
}
function OptionForm_onKeyDown() {
	if (B3 == true) {
		if (iY_sub == 120) {
			bUseBlue = true;
		} else {
			bUseBlue = false;
		}
		iState = STATE_MainMenu;
		Sound:Play(sndSelect)
	}
	
	if (BU == true) {
		if (iY_sub > 120) {
			iY_sub -= 15;
			Sound:Play(sndChoose)
		}
	} else if (BD == true) {
		if (iY_sub < 135) {
			iY_sub += 15;
			Sound:Play(sndChoose)
		}
	}
	
	if (B1 == true) {
		iState = STATE_MainMenu;
		Sound:Play(sndSelect)
	}
}

function QuitForm() {
	Screen:GoToXY(50,80)
	Screen:PrintString("Are you sure you want to quit?")
	Screen:GoToXY(70,120)
	Screen:PrintString("Yes")
	Screen:GoToXY(70,135)
	Screen:PrintString("No")

	Screen:GoToXY(50, iY_sub)
	Screen:PrintString(">")
}
function QuitForm_onKeyDown() {
	if (B3 == true) {
		if (iY_sub == 120) {
			//Konsol:Message("Thanks for checking out!\n\t\t\t ||||||\n\t\t\td6,6b\n\t\t\t  \\_/","ksPong")
			Konsol:Exit()
		} else {
			Sound:Play(sndSelect)
		}
	}
	
	if (BU == true) {
		if (iY_sub > 120) {
			iY_sub -= 15;
			Sound:Play(sndChoose)
		}
	} else if (BD == true) {
		if (iY_sub < 135) {
			iY_sub += 15;
			Sound:Play(sndChoose)
		}
	}
	
	if (B1 == true) {
		iState = STATE_MainMenu;
		Sound:Play(sndSelect)
	}
}

function DrawBluePaddle() {
	if (bUseBlue == true) {
		//check for user input
		if (BU == true) {
			if (iBY > 0) {
				iBY -= PLAYER_SPEED;
			}
		} else if (BD == true) {
			if (iBY < screenheight-50) {
				iBY += PLAYER_SPEED;
			}
		}
	} else {
		if (bBall_HDir == 2) {
			iTmp = iBY + 25; //25 is half of paddle's length
			if (iTmp < iOY) {
				if (iBY < screenheight-50) {
					iBY += 3;
				}
			} else {
				if (iBY > 0) {
					iBY -= 3;
				}
			}
		} else {
			//center computer paddle if ball direction is towards red-paddle
			if (iBY != (screenheight/2)-25) {
				if (iBY < (screenheight/2)-25) {
					if (iBY < screenheight-50) {
						iBY++;
					}
				} else {
					if (iBY > 0) {
						iBY--;
					}
				}
			}
		}
	}
	
	Draw:RectFill(iBX, iBY, iPW, iPH, iBColor, screen)
}
function DrawRedPaddle() {
	if (bUseBlue == false) {
		//check for user input
		if (BU == true) {
			if (iRY > 0) {
				iRY -= PLAYER_SPEED;
			}
		} else if (BD == true) {
			if (iRY < screenheight-50) {
				iRY += PLAYER_SPEED;
			}
		}
	} else {
		if (bBall_HDir == 1) {
			iTmp = iRY + 25; //25 is half of paddle's length
			if (iTmp < iOY) {
				if (iRY < screenheight-50) {
					iRY += 3;
				}
			} else {
				if (iRY > 0) {
					iRY -= 3;
				}
			}
		} else {
			//center computer paddle if ball direction is towards blue-paddle
			if (iRY != (screenheight/2)-25) {
				if (iRY < (screenheight/2)-25) {
					if (iRY < screenheight-50) {
						iRY++;
					}
				} else {
					if (iRY > 0) {
						iRY--;
					}
				}
			}
		}
	}
	
	Draw:RectFill(iRX, iRY, iCW, iCH, iRColor, screen)
}

function DrawBall() {	
	//compute horizontal direction
	if (bBall_HDir == 1) {
		//check collition with computer-paddle
		if (iOX >= iRX-10) {
			if (iOX <= iRX+5) {
				if (iOY >= iRY) {
					iTmp = iRY + iCH;
					if (iOY <= iTmp) {
						bBall_HDir = 2; //change vertical direction
						iOM++;	//speed up ballmovement
						Sound:Play(sndPong)
					}
				}
			}
		}
		iOX += iOM;	// -->
	} else {
		//check collition with blue-paddle
		if (iOX <= iBX+10) {
			if (iOX >= iBX+5) {
				if (iOY >= iBY) {
					iTmp = iBY + iPH;
					if (iOY <= iTmp) {
						bBall_HDir = 1; //change vertical direction
						iOM++;	//speed up ballmovement
						Sound:Play(sndPing)
					}
				}
			}
		}
		iOX -= iOM;	// <--
	}
	//compute vertical direction
	if (bBall_VDir == 1) {
		iOY += iOM;	// downwards
	} else {
		iOY -= iOM;	// upwards
	}
	
	//check for vertical *out of bounds*
	if (iOY < 0) {
		iOY = 0;
		bBall_VDir = 1; //change vertical direction
		Sound:Play(sndWall)
	} else if (iOY > screenheight) {
		iOY = screenheight - 4;
		bBall_VDir = 2; //change vertical direction
		Sound:Play(sndWall)
	}	
	//check for horizontal *out of bounds*
	if (iOX < 0) {
		iOX = 0;
		iRS++;
		iOM = 2; //reset ball speed
		bBall_HDir = 1; //change horizontal direction
		Sound:Play(sndMiss)
	} else if (iOX > screenwidth) {
		iOX = screenwidth - 4;
		iBS++;
		iOM = 2; //reset ball speed
		bBall_HDir = 2; //change horizontal direction
		Sound:Play(sndMiss)
	}
	
	Draw:Circ(iOX, iOY, BALLRAD, iOColor, screen)
}

function DrawScore() {
	Screen:GoToXY(100,10)
	Screen:PrintStringNoBC("Blue Paddle: " + iBS)
	Screen:GoToXY(110,30)
	Screen:PrintStringNoBC("Red Paddle: " + iRS)
}

function ResetGame() {
	iY_sub = 120;
	iBY = 95;
	iRY = 95;	
	
	iOM = 2; //reset ball speed
	
	//reset score
	iBS = 0;
	iRS = 0;
	
	ResetBallLocation()
}

function ResetBallLocation() {
	bBall_HDir = 2;
	iOX = screenwidth/2 - 4;
	iOY = screenheight/2 - 4;
}

function CheckWinner() {
	if (iBS == MAX_SCORE) {
		DrawScore() //this will make sure that the score was printed
		Screen:Render()
		B1 = true;
		Konsol:Message("Blue Paddle Wins!","Game Over")
		ResetGame()
	} else if (iRS == MAX_SCORE) {
		DrawScore() //this will make sure that the score was printed
		Screen:Render()
		B1 = true;
		Konsol:Message("Red Paddle Wins!","Game Over")
		ResetGame()
	}
}
