BrandingText "KonsolScript.org"
Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "quixie-${PRODUCT_VERSION}${KSE_UI}.exe"
InstallDir "$LOCALAPPDATA\KonsolScript\Engine"
InstallDirRegKey HKLM "${PRODUCT_DIR_REGKEY}" ""
ShowInstDetails nevershow
ShowUnInstDetails nevershow

Section "Core" SEC01
  SectionIn RO
  SetOutPath "$INSTDIR\include"
  SetOverwrite ifnewer

  File "${FILE_PATH}\..\..\include\console.kh"
  File "${FILE_PATH}\..\..\include\basic.kh"
  File "${FILE_PATH}\..\..\include\c.kh"
  File "${FILE_PATH}\..\..\include\pascal.kh"
  File "${FILE_PATH}\..\..\include\math.kh"
  File "${FILE_PATH}\..\..\include\time.kh"
  File "${FILE_PATH}\..\..\include\pagong.kh"

  SetOutPath "$INSTDIR\include\math"
  SetOverwrite ifnewer

  File "${FILE_PATH}\..\..\include\math\random.kh"
  File "${FILE_PATH}\..\..\include\math\round.kh"

  SetOutPath "$INSTDIR\include\time"
  SetOverwrite ifnewer

  File "${FILE_PATH}\..\..\include\time\gettimer.kh"
  File "${FILE_PATH}\..\..\include\time\getday.kh"
  File "${FILE_PATH}\..\..\include\time\gethour.kh"
  File "${FILE_PATH}\..\..\include\time\getminute.kh"
  File "${FILE_PATH}\..\..\include\time\getmonth.kh"
  File "${FILE_PATH}\..\..\include\time\getsecond.kh"
  File "${FILE_PATH}\..\..\include\time\getyear.kh"

  SetOutPath "$INSTDIR\image"
  SetOverwrite ifnewer
  File "${FILE_PATH}\..\..\image\pagong_e.bmp"
  File "${FILE_PATH}\..\..\image\pagong_n.bmp"
  File "${FILE_PATH}\..\..\image\pagong_ne.bmp"
  File "${FILE_PATH}\..\..\image\pagong_nw.bmp"
  File "${FILE_PATH}\..\..\image\pagong_s.bmp"
  File "${FILE_PATH}\..\..\image\pagong_se.bmp"
  File "${FILE_PATH}\..\..\image\pagong_sw.bmp"
  File "${FILE_PATH}\..\..\image\pagong_w.bmp"

  SetOutPath "$INSTDIR\res"
  SetOverwrite ifnewer
  File "${FILE_PATH}\images\kh.ico"
  File "${FILE_PATH}\images\ks.ico"
  File "${FILE_PATH}\images\ksl.ico"

  SetOutPath "$INSTDIR"
  SetOverwrite ifnewer
  File "${FILE_PATH}\..\..\quixie.exe"
  File "${FILE_PATH}\..\..\libcairo-2.dll"
  File "${FILE_PATH}\..\..\libexpat-1.dll"
  File "${FILE_PATH}\..\..\libfontconfig-1.dll"
  File "${FILE_PATH}\..\..\libpng14-14.dll"
  File "${FILE_PATH}\..\..\freetype6.dll"
  File "${FILE_PATH}\..\..\zlib1.dll"
  File "${FILE_PATH}\..\..\readme.txt"
  File "${FILE_PATH}\..\..\LICENSE"
  File "${FILE_PATH}\..\..\changes.txt"
  File "${FILE_PATH}\test_script.konsl"
  File "${FILE_PATH}\test_script.ks"
  File "${FILE_PATH}\ks.ini"
  

  SetOutPath "$SYSDIR"
  SetOverwrite ifnewer
  File "${FILE_PATH}\..\..\zlib1.dll"
SectionEnd

Section "Demo" SEC02
  SetOutPath "$INSTDIR\demo"
  SetOverwrite ifnewer

  File "${FILE_PATH}\demo\main.konsl"
  File "${FILE_PATH}\demo\main.ks"
  File "${FILE_PATH}\demo\README.txt"

  SetOutPath "$INSTDIR\fbsound"
  SetOverwrite ifnewer

  File "${FILE_PATH}\..\..\fbsound\plug-mm.dll"

  SetOutPath "$INSTDIR\demo\resource"
  SetOverwrite ifnewer

  File "${FILE_PATH}\demo\resource\choose.wav"
  File "${FILE_PATH}\demo\resource\miss.wav"
  File "${FILE_PATH}\demo\resource\ping.wav"
  File "${FILE_PATH}\demo\resource\pong.wav"
  File "${FILE_PATH}\demo\resource\select.wav"
  File "${FILE_PATH}\demo\resource\wall.wav"
SectionEnd

Section -AdditionalIcons
  CreateDirectory "$SMPROGRAMS\KonsolScript"
  CreateDirectory "$SMPROGRAMS\KonsolScript\Uninstall"
  CreateShortCut "$SMPROGRAMS\KonsolScript\Uninstall\Remove Engine.lnk" "$INSTDIR\uninst.exe"
  
  IfFileExists "$INSTDIR\demo\main.ks" 0 +2
	CreateShortCut "$SMPROGRAMS\KonsolScript\Demo.lnk" "$INSTDIR\demo\main.ks"
  
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "$INSTDIR\quixie.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\quixie.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"

  SetFileAttributes "$INSTDIR\readme.txt" READONLY
  SetFileAttributes "$INSTDIR\license" READONLY
  SetFileAttributes "$INSTDIR\changes.txt" READONLY
  SetFileAttributes "$INSTDIR\ks.ini" READONLY

  ;this enables "ks myscript.ks" to execute using command prompt
  FileOpen $0 "$SYSDIR\ks.bat" w
    IfErrors done
    FileWrite $0 "@echo off$\r$\n"
    FileWrite $0 "$\"$INSTDIR\quixie.exe$\" %1$\r$\n"
  FileClose $0
  done:
  
  ;write assoc's
    ;KH
    WriteRegStr HKCR ".kh" "" "KonsolScript.Header"
    WriteRegStr HKCR ".kh\ShellNew" "NullFile" ""
    WriteRegStr HKCR "KonsolScript.Header" "" "KonsolScript Header"
    WriteRegStr HKCR "KonsolScript.Header\shell\Compile\command" "" "$INSTDIR\quixie.exe %1"
    WriteRegStr HKCR "KonsolScript.Header\DefaultIcon" "" "$INSTDIR\res\kh.ico"
    ;KS
    WriteRegStr HKCR ".ks" "" "KonsolScript.Document"
    WriteRegStr HKCR ".ks\ShellNew" "NullFile" ""
    WriteRegStr HKCR "KonsolScript.Document" "" "KonsolScript Document"
    WriteRegStr HKCR "KonsolScript.Document\shell\Execute\command" "" "$INSTDIR\quixie.exe %1"
    WriteRegStr HKCR "KonsolScript.Document\DefaultIcon" "" "$INSTDIR\res\ks.ico"
    ;KSL
    WriteRegStr HKCR ".ksl" "" "KonsolScript.Library"
    WriteRegStr HKCR "KonsolScript.Library" "" "KonsolScript Library"
    WriteRegStr HKCR "KonsolScript.Library\DefaultIcon" "" "$INSTDIR\res\ksl.ico"

    ;WriteRegStr HKCR "dir" "entry" "value" -- template
    
    ;WriteRegStr HKCR "KonsolScript.Header\shell\Open\command" "" "KSE_PATH %1"
    ;WriteRegStr HKCR "KonsolScript.Document\shell\Open\command" "" "KSE_PATH %1"
SectionEnd

!insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC01} "KonsolScript core files."
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC02} "Simple Demo."
!insertmacro MUI_FUNCTION_DESCRIPTION_END


Function .onInit
 
  ReadRegStr $R0 HKLM \
  "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}" \
  "UninstallString"
  StrCmp $R0 "" done
 
  MessageBox MB_OKCANCEL|MB_ICONEXCLAMATION \
  "${PRODUCT_NAME} is already installed. $\n$\nClick `OK` to remove the \
  previous version or `Cancel` to cancel this upgrade." \
  IDOK uninst
  Abort
 
;Run the uninstaller
uninst:
  ClearErrors
  Exec $INSTDIR\uninst.exe ; instead of the ExecWait line
 
done:
 
FunctionEnd

Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "Restart your PC to completely uninstall $(^Name)."
FunctionEnd

Function un.onInit
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Uninstall $(^Name)?" IDYES +2
  Abort
FunctionEnd

Section Uninstall
  Delete "$INSTDIR\uninst.exe"
  Delete "$INSTDIR\quixie.exe"
  Delete "$INSTDIR\libcairo-2.dll"
  Delete "$INSTDIR\libexpat-1.dll"
  Delete "$INSTDIR\libfontconfig-1.dll"
  Delete "$INSTDIR\libpng14-14.dll"
  Delete "$INSTDIR\freetype6.dll"
  Delete "$INSTDIR\zlib1.dll"

  Delete "$INSTDIR\include\console.kh"
  Delete "$INSTDIR\include\basic.kh"
  Delete "$INSTDIR\include\c.kh"
  Delete "$INSTDIR\include\pascal.kh"
  Delete "$INSTDIR\include\math.kh"
  Delete "$INSTDIR\include\time.kh"
  Delete "$INSTDIR\include\pagong.kh"
  Delete "$INSTDIR\include\math\add.kh"
  Delete "$INSTDIR\include\math\random.kh"
  Delete "$INSTDIR\include\math\round.kh"
  Delete "$INSTDIR\include\time\gettimer.kh"
  Delete "$INSTDIR\include\time\getday.kh"
  Delete "$INSTDIR\include\time\gethour.kh"
  Delete "$INSTDIR\include\time\getminute.kh"
  Delete "$INSTDIR\include\time\getmonth.kh"
  Delete "$INSTDIR\include\time\getsecond.kh"
  Delete "$INSTDIR\include\time\getyear.kh"

  Delete "$INSTDIR\image\pagong_e.bmp"
  Delete "$INSTDIR\image\pagong_n.bmp"
  Delete "$INSTDIR\image\pagong_ne.bmp"
  Delete "$INSTDIR\image\pagong_nw.bmp"
  Delete "$INSTDIR\image\pagong_s.bmp"
  Delete "$INSTDIR\image\pagong_se.bmp"
  Delete "$INSTDIR\image\pagong_sw.bmp"
  Delete "$INSTDIR\image\pagong_w.bmp"

  Delete "$INSTDIR\res\kh.ico"
  Delete "$INSTDIR\res\ks.ico"
  Delete "$INSTDIR\res\ksl.ico"

  Delete "$INSTDIR\test_script.ks"
  Delete "$INSTDIR\test_script.konsl"
  Delete "$INSTDIR\ks.ini"
  Delete "$INSTDIR\readme.txt"
  Delete "$INSTDIR\license"
  Delete "$INSTDIR\changes.txt"
  
  Delete "$SYSDIR\ks.bat"

  RMDir "$INSTDIR\include\math"
  RMDir "$INSTDIR\include\time"
  RMDir "$INSTDIR\include"
  RMDir "$INSTDIR\image"
  RMDir "$INSTDIR\res"
  
  Delete "$INSTDIR\fbsound\plug-mm.dll"
  RMDir "$INSTDIR\fbsound"
	
	;check if demo was installed. if so, remove it too
	IfFileExists "$INSTDIR\demo\main.ks" 0 +17
	  Delete "$INSTDIR\demo\main.konsl"
	  Delete "$INSTDIR\demo\main.ks"
	  Delete "$INSTDIR\demo\README.txt"
	  
	  
	  Delete "$INSTDIR\demo\resource\choose.wav"
	  Delete "$INSTDIR\demo\resource\miss.wav"
	  Delete "$INSTDIR\demo\resource\ping.wav"
	  Delete "$INSTDIR\demo\resource\pong.wav"
	  Delete "$INSTDIR\demo\resource\select.wav"
	  Delete "$INSTDIR\demo\resource\wall.wav"
	  
	  RMDir "$INSTDIR\demo\resource"
	  RMDir "$INSTDIR\demo"
  
  RMDir "$INSTDIR"
  
  IfFileExists "$INSTDIR\demo\main.ks" 0 +2
	Delete "$SMPROGRAMS\KonsolScript\Demo.lnk"
  
  Delete "$SMPROGRAMS\KonsolScript\Uninstall\Remove Engine.lnk"
  RMDir "$SMPROGRAMS\KonsolScript\Uninstall"
  RMDir "$SMPROGRAMS\KonsolScript"

  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey HKLM "${PRODUCT_DIR_REGKEY}"
  
  ;remove reg entries made by installer
  DeleteRegKey HKCR ".ks"
  DeleteRegKey HKCR ".kh"
  DeleteRegKey HKCR ".ksl"
  DeleteRegKey HKCR ".konsl"
  DeleteRegKey HKCR "KonsolScript"
  DeleteRegKey HKCR "KonsolScript.Document"
  DeleteRegKey HKCR "KonsolScript.Header"
  DeleteRegKey HKCR "KonsolScript.Library"

  SetAutoClose true
SectionEnd
