#Define FALSE 0
#Define TRUE 1
#Define App_EXEName Command(0)

#include "version.bi"

#ifndef QUIXIE_CGI
	#IfDef QUIXIE_SDL
		#IfDef QUIXIE_CAIRO
			#Undef QUIXIE_CAIRO
		#EndIf
		'use vdecampo's SDL-wrapper		
		#Include "SDL_Object.bas"
	#Else 'default to MySoft's OpenGL-wrapper
		' using OpenGL for rendering to avoid tearing, which gives illusion of unwanted flickering
		#define Render_OpenGL
		#Include "OpenGL.bas"
	#EndIf
	'//----- for JPG support ------
	#include "lib\fbjpg\fbjpg.bi" '-- same as the jpeg4gfxlib.bi
	'----------------------------//

	'//----- for PNG support ------
	#ifdef __FB_LINUX__
		#libpath "lib\fbpng\gnu_linux\libfbpng.a"
	#else '__FB_WIN32__
		#libpath "lib\fbpng\windows\libfbpng.a"
	#EndIf
	#Include "lib\fbpng\fbpng.bi"
	#Include "lib\fbpng\png_image.bi"
	'----------------------------//

	'//----- for Network support ------
	#include "lib/chisock/chisock.bi"
#EndIf

#Define App_Path ExePath
#Define App_Comments "Krixware's Script Engine for KonsolScript both primarily written by Mj Mendoza IV"

#Ifdef __FB_LINUX__
'gnu_linux.bi includes kageExterns.bi earlier than clsCollection.bi should have
'  #Include Once "gnu_linux/gnu_linux.bi"
	Declare Function GetTempPath(ByVal dummy As Integer, ByRef temp_dir As String) As Long
	#IfNDef QUIXIE_CGI
		Declare Sub ShowCursor(visibility As Integer)
	#EndIf
#Else '__FB_WIN32__
	#Include Once "windows.bi"
#EndIf

#Include Once "vbcompat.bi"

#Include "inc/clsCollection.bi"
#Include "src/clsCollection.bas"
#Include Once "kageExterns.bi"

ReDim Shared kseUDT() As typeUDT
Dim Shared iUDTctr As Integer

ReDim Shared kseUDT_Instance() As typeUDT_Instance
Dim Shared iUDT_InstanceCtr As Integer

Declare Sub MsgBox (msg As String, cap As String)
Declare Function IsBooleanic(sValue As String) As Byte
Declare Function BooleanVal(ByVal sVal As String) As Byte
Declare Function IsNumeric(sValue As String) As Byte
Declare Function IsHexic(ByVal sVal As String) As Byte
Declare Function HexVal(ByVal sVal As String) As ULong
Declare Function Replace(src As String,find As String,replace_ As String) As String
Declare Function StrReverse(value As String) As String
Declare Function Split(src As String, _
					   del As String, _
					   res() As String) As Integer
Declare Function kSplit(ByVal src As String, _
			   		 del As String, _
			   		 res() As String) As Integer
Declare Function IsLaunchedByFile() As Byte
Declare Function fbArrayToArray(src() As Integer, ret() As Integer) As Byte
Declare Function fbUDTtoUDT(ByRef src As Integer Ptr ,ByRef ret As Integer  Ptr, ctr As Integer) As Byte
Declare Sub Engine_HideScreen()
Declare Sub KSE_MouseToggle(p_toggle As UByte)

Declare Function KSE_CleanURL(par As String) As String
Declare Sub Engine_GetParams()
#Ifdef QUIXIE_CGI
	Declare Sub KSE_DeclareEnviron(p_var As String)
	Declare Sub KSE_DeclareEnvirons()
#EndIf
Declare Function kHash(par As String, p_len As Integer = 8) As String

#Include "inc/cls_Function.bi"
#Include "inc/kse_zLib.bi"
'prototypes (core)
#Include "inc/core/kse_Main.bi"
#Include "inc/core/kse_Main_Header_Associate.bi"
#Include "inc/core/kse_Main_Header_Engine.bi"
#Include "inc/core/kse_Main_Header_Media.bi"
#Include "inc/core/kse_Main_Header_Process.bi"
#Include "inc/core/kse_Main_Header_Execute.bi"


'prototypes (classes)
#Include "inc/cls/kse_Array.bi"
#Include "inc/cls/kse_File.bi"
#Include "inc/cls/kse_Konsol.bi"
#Include "inc/cls/kse_Math.bi"
#Include "inc/cls/kse_Net.bi"
#Include "inc/cls/kse_String.bi"
#Include "inc/cls/kse_Time.bi"
#Include "inc/cls/kse_Var.bi"

#ifndef QUIXIE_CGI
	#Include "inc/cls/kse_Draw.bi"
	#Include "inc/cls/kse_Image.bi"
	#Include "inc/cls/kse_Key.bi"
	#Include "inc/cls/kse_Layer.bi"
	#Include "inc/cls/kse_Mouse.bi"
	#Include "inc/cls/kse_Screen.bi"
	#Include "inc/cls/kse_Sound.bi"
	#Include "inc/cls/kse_SpriteSet.bi"
	#Include "inc/cls/kse_TileSet.bi"
	
	#Include "inc/cls/kse_Entity.bi"
	#Include "inc/cls/kse_Map.bi"
		#Include "inc/cls/kse_Game.bi"
	
#EndIf

#Ifdef QUIXIE_MYSQL
	#Include "inc/cls/kse_MySQL.bi"
#EndIf

#Include "inc/kse_Math_Equation.bi"
#Include "inc/kse_String_Equation.bi"
'prototypes (control statements)
#Include "inc/ctrl/kse_For_Statement.bi"
#Include "inc/ctrl/kse_If_Statement.bi"
#Include "inc/ctrl/kse_While_Statement.bi"



#Include "src/cls_Function.bas"
#Include "src/kse_zLib.bas"
'declares (core)
#Include "src/core/kse_Main.bas"
#Include "src/core/kse_Main_Header_Associate.bas"
#Include "src/core/kse_Main_Header_Engine.bas"
#IfNDef QUIXIE_CGI
	#Include "src/core/kse_Main_Header_Media.bas"
#EndIf
#Include "src/core/kse_Main_Header_Process.bas"
#Include "src/core/kse_Main_Header_Execute.bas"


'declares (classes)
#Include "src/cls/kse_Array.bas"
#Include "src/cls/kse_File.bas"
#Include "src/cls/kse_Konsol.bas"
#Include "src/cls/kse_Math.bas"
#Include "src/cls/kse_Net.bas"
#Include "src/cls/kse_String.bas"
#Include "src/cls/kse_Time.bas"
#Include "src/cls/kse_Var.bas"

#IfNDef QUIXIE_CGI
	#Include "src/cls/kse_Draw.bas"
	#Include "src/cls/kse_Image.bas"
	#Include "src/cls/kse_Key.bas"
	#Include "src/cls/kse_Layer.bas"
	#Include "src/cls/kse_Mouse.bas"
	#Include "src/cls/kse_Screen.bas"
	#Include "src/cls/kse_Sound.bas"
	#Include "src/cls/kse_SpriteSet.bas"
	#Include "src/cls/kse_TileSet.bas"
	
	#Include "src/cls/kse_Map.bas"
	#Include "src/cls/kse_Entity.bas"
		#Include "src/cls/kse_Game.bas"
#EndIf

#Include "src/kse_Math_Equation.bas"
#Include "src/kse_String_Equation.bas"
'declares (control statements)
#Include "src/ctrl/kse_For_Statement.bas"
#Include "src/ctrl/kse_If_Statement.bas"
#Include "src/ctrl/kse_While_Statement.bas"

#IfDef QUIXIE_MYSQL
	#Include once "mysql/mysql.bi"
	#Include "src/cls/kse_MySQL.bas"
#EndIf

#IfDef __FB_LINUX__
  #Include Once "gnu_linux/gnu_linux.bi"
#Else
'  #Include Once "windows.bi"
#EndIf
