#include "kage.hpp"
#include "kageExterns.hpp"

string App_Path = "";
string App_EXEName = "";

vector<typeUDT> kseUDT;
int iUDTctr;

vector<typeUDT_Instance> kseUDT_Instance;

vector<ofstream> OFStreams;

void AddSourceName(string sSrcName) {
	kseSourceFiles.push_back(sSrcName);
}

vector<typeEntityInstance> kseEntityInstance;
vector<typeTileSet> kseTileSet;
vector<typeSprite> kseSprite;
vector<typeTileTrigger> kseTileTrigger;
vector<typeTileAnimation> kseTileAnimation;
vector<typeImage_Data> kseImg_Data;
vector<typeMap> kseMap;
vector<typeEntity> kseEntity;
vector<typeSound> kseSnd;
vector<typeImage> kseImg;

#ifdef QUIXIE_CAIRO
	cairo_t *quixie_cairo_cr;
	cairo_surface_t *quixie_cairo_surface;
#endif

#ifdef QUIXIE_CGI
	/*shared*/ string KS_CGI_Out;
	/*shared*/ vector<typeUploadedFile> kseUploadedFile;
	/*shared*/ int iUploadedFileCtr;
#endif
vector<typeParenPair> kseParenPairs;
int iParenPairsCtr;

int iTimerSeconds;
int iTimerPrev;
int iTimerNow;
int iTimerCtr;
unsigned long iTimerFPS;
bool bFormShown;
string sTmpRetParVar;
   //initialized before calling Main; see below
		int fpslimit;
		double frameintvl;
	double stt;
	int sleepintvl;
int iTileSetCtr;
int iSpriteCtr;
unsigned long iTokenCtr;
unsigned int iVarNumCtr;
unsigned int iVarStrCtr;
unsigned int iVarBoolCtr;
string sKONSoL;
string sScriptPath;
bool bREAD_ESCAPE_CHARS;
bool bKONSoLE_Reading;
bool bKONSoLE_DeclaringVar;
string sKONSoLE_LastDeclaredFunction;
string sKONSoLE_LastDeclaredVarName;
long iKONSoLE_LastDeclaredFunction;
unsigned long iFunctionCtr;
unsigned long iCrntFunc = ULONG_MAX;
int MouseX;
int MouseY;
	bool MouseL;
	bool MouseR;
bool MouseToggle;
int VAR_MOUSEX;
int VAR_MOUSEY;
int VAR_SCREENWIDTH;
int VAR_SCREENHEIGHT;
int VAR_B1;
int VAR_B2;
int VAR_B3;
int VAR_B4;
int VAR_BU;
int VAR_BD;
int VAR_BL;
int VAR_BR;
int VAR_LMB;
int VAR_MMB;
int VAR_RMB;
int VAR_LASTPRESS;
int VAR_LASTUNPRESS;
string sTempString;
string sStartScript;
string sCleanUpLogFile;
int iNoLogFile;
int iShowScript;
string sShowAboutKONSoLE;
string sReleaseMode;
string sKonsolPath;
int iShowFPS;
int iExitOnError;
string sShowStatus;
string sKillKonfig;
int iOverClock;
int iShowError;
int iScreenSize;
int iFullScreen;
	int iScreenSizeWidth;
	int iScreenSizeHeight;
	string sScreenCaption;
	string sScreenVersion;
string sgblCmd;
string sgblCmdArg;

int iRender;
bool bRenderClear;
int iMouseMove;
int iMouseDown;
int iMouseUp;
int iKeyDown;
int iKeyUp;
int iGotMessage;
int iGotDisconnected;

unsigned int iEntityCtr;
unsigned int iEntityInstanceCtr;
//long iEntitySpritesCtr;
//long iSpriteAnimationCtr;

long kseKey_count;
//from Game class
	unsigned long kseMAP_CURRENT_RENDER;
	int iMapMoveCtrMax;
	int iMapMoveCtr;
	int iMapMove;
	int iObsLayer;
	int iTrgLayer;
	string sMapName;
	int iMapLayers;
	int iMapWidth;
	int iMapHeight;
	int iMapEntityLayer;
	bool bMapFocusingOnEntity;
	bool bMapRender;
	bool bMapRendering;
	bool bMapMoveLeft;
	bool bMapMoveRight;
	bool bMapMoveUp;
	bool bMapMoveDown;
	long iMapEntityHandlersCtr;
	unsigned long iTileAnimationCtr;
	unsigned long iTileTriggerCtr;
	unsigned long iMapCtr;
int kseScreenX;
int kseScreenY;
vector<string> kseSourceFiles;
long kseImg_count;
long kseSnd_count;
typeNet kseNet;
long quixieSCREEN;

vector<typeToken> kseToken;

vector<typeFunction> kseFunction;

vector<typeArray> kseArray;
vector<typeVarNum> kseVarNum;
vector<typeVarStr> kseVarStr;
vector<typeVarBool> kseVarBool;

#ifdef QUIXIE_MYSQL
	MYSQL/*shared*/ quixie_mysqlConn
	string quixie_mysqlHost;
	string quixie_mysqlUsername;
	string quixie_mysqlPassword;
	string quixie_mysqlDBname;
	int quixie_mysqlSQLqry;
	
	mysql_init( &quixie_mysqlConn );
#endif

int tmpIdx;

string kseTEMP_EXT = "__________.tmp";  //for de/compiling files
string kseSCRIPT_SEP = "KwSkRiPt";	  //to distinguish another file
string kseSOURCE_SEP = "KwSoUrCe";	  //to distinguish another's script
string kseSCRIPT_MARK = "KwSMrKr";	  //to distinguish another script file

string kseSCREEN = "screen";
string kseTRUE = "true";
string kseFALSE = "false";
string ksePATH = "path";
string kseREAD = "READ";
string kseWRITE = "WRITE";
string kseAPPEND = "APPEND";
string kseRANDOM = "WREAD";
string ksePTR_APPEND = "append";

bool IsLaunchedByFile() {
	if (sgblCmd != "") { return true; }
	return false;
}

int Split(string src, string del, vector<string> &res) {
	res.clear();
	
	unsigned int i, l = 0;
	
	//// find all delimiters
	string substr;
	for (i = 0; i < src.length()-del.length(); ++i) {
		substr = Mid(src, i, del.length());
		if (substr == del) {
			res.push_back(Mid(src, l, i-l));
			l = i + del.length();
			i = i + del.length()-1;
		}
	}
	if (i != l) {
		res.push_back(Mid(src, l));
	}
	
	return res.size();
}

int kSplit(string src,
			string del,
			vector<string> &res) {
	
	if (src.length() < 5) { return false; } //X-X-X; N-1-x
	
	res.clear(); //string res[3];
	string s = src;
	//trace("var:" + s);
	res.push_back(Left(s, 1));
	s = Mid(s, 2);
	
	unsigned long i;
	char l_tmpChr;
	l_tmpChr = del[0];
	for (i = 1; i < s.length(); ++i) {
		if (s[i] == l_tmpChr) {
			res.push_back(Left(s, i)); //res[1] = Left(s, i);
			res.push_back(Mid(s, i + 1)); //res[2] = Mid(s, i + 2);
			break;
		}
	}
	
	return 0;
}

vector<string> split(const string &s, const string &delim, const bool keep_empty) {
	vector<string> l_rets;
	if (delim.empty()) {
		l_rets.push_back(s);
		return l_rets;
	}
	string::const_iterator substart = s.begin(), subend;
	while (true) {
		subend = search(substart, s.end(), delim.begin(), delim.end());
		string temp(substart, subend);
		if (!temp.empty()) {
			l_rets.push_back(Trim(temp));
		}
		if (subend == s.end()) {
			break;
		}
		substart = subend + delim.size();
	}
	return l_rets;
}
#include <chrono>
void DrawString(int p_X, int p_Y, string p_string, float p_R, float p_G, float p_B) {
	kage->m_KageStage.drawString(p_X, p_Y, p_string, p_R, p_G, p_B);
}

string _msg;
string _cap;
bool _displayMessage = false;
void MsgBox(string p_msg, string p_cap) {
#ifndef QUIXIE_CGI
	_msg = p_msg;
	_cap = p_cap;
	_displayMessage = true;
	kage->m_KageStage.render();
	while (_displayMessage) {
		std::this_thread::sleep_for(std::chrono::milliseconds(16));
	}
#endif
}
void Engine_DrawWord(int *img_ptr, int i_x, int i_y, string s_Word, unsigned long ul_color) {
	string sCap = s_Word;
	int iX = i_x;
	int iY = i_y;
	int iH = 12;
	double iniW = 8;
	int iLoc = 1;
	string sChar;
	string sWord;
	int ChrCtr = 0;
	std::cout << "Engine_DrawWord ? " << s_Word << std::endl;
	for (unsigned int i = 1; i < sCap.length() - 1; ++i) {
		sChar = Mid(sCap, i, 1); //was Mid(sCap, i, 2);
		if (sChar == "\r\n") {
			//print only the characters before the ["\r\n"]
			sWord = Mid(sCap, iLoc, i - iLoc - 1); //was Mid(sCap, iLoc, i - iLoc);
			DrawString(iX, iY, sWord, RGBA_R(ul_color), RGBA_G(ul_color), RGBA_B(ul_color));

			//skip ["\r\n"]
			++i;
			//move to next character location
			iLoc = i + 1;

			//then move iY to the next line.
			iX = 0;
			iY = iY + iH;
			ChrCtr = 0;
		}
		else if (kseTAB == Mid(sCap, i, 0)) { //was Mid(sCap, i, 1)) {
											  //print only the characters before the [vbTab]
			sWord = Mid(sCap, iLoc, i - iLoc - 1); //was Mid(sCap, iLoc, i - iLoc);

			DrawString(iX, iY, sWord, RGBA_R(ul_color), RGBA_G(ul_color), RGBA_B(ul_color));

			//skip [vbTab]
			//the FOR loop will skip it for us
			//move to next character location
			iLoc = i + 1;

			//then move iX to the next location.
			iX = iX + (iniW * (sWord.length() + 4));
			//* there is no need to move iY because there's no need to change line.
			++ChrCtr;
		}
		else {
			++ChrCtr;
			if (ChrCtr == 100) {
				//print only the characters before the ["\r\n"]
				sWord = Mid(sCap, iLoc, 99); //was Mid(sCap, iLoc, 100);
				DrawString(iX, iY, sWord, RGBA_R(ul_color), RGBA_G(ul_color), RGBA_B(ul_color));

				//skip nothing
				//move to next character location
				iLoc = i + 1;

				//then move iY to the next line.
				iX = 0;
				iY = iY + iH;
				ChrCtr = 0;
			}
		}
	}

	//get the value to be printed
	sWord = Mid(sCap, iLoc - 1); //was Mid(sCap, iLoc);
	DrawString(iX, iY, sWord, RGBA_R(ul_color), RGBA_G(ul_color), RGBA_B(ul_color));
}

string Replace(string src, string find, string replace_) {
	//attempt to make Replace function this 09.23.07@8:10 PM
	string substr;
	for (unsigned long i = 0; i < src.length() - find.length(); ++i) {
		substr = Mid(src, i, find.length());
		if (substr == find) {
			src = Mid(src, 0, i) + replace_ + Mid(src, i+find.length());
		}
	}
	return src;
}

string StrReverse(string value) {
	string l_Value(value);
	std::reverse(l_Value.begin(), l_Value.end());

	return l_Value;
}

bool IsBooleanic(string sValue) {
//	trace("IsBooleanic " + sValue)
	if (LCase(sValue) == "true" || LCase(sValue) == "false") {
		return true;
	}
	return false;
}

bool BooleanVal(string sVal) {
	if (LCase(sVal) != "false" && sVal != "") {
		return true;
	} //else if (LCase(sValue) == "false") {
	return false;
}

bool IsNumeric(string sValue) {
	//trace("IsNumeric " + sValue);
	bool bGotDOT = false;
   
	//if (Left(sChr, 1) == "-") {
	//	sChr = Mid(sChr, 2, sChr.length() - 1);
	//}
		
	for (unsigned int i = 0; i < sValue.length(); ++i) {
		switch (sValue[i]) {//[0]) {
			case '0': case '1': case '2':
			case '3': case '4': case '5':
			case '6': case '7': case '8':
			case '9':
				//okay
				break;
			case '-':
				if (i > 0 || sValue.length() == 1) { return false; }
				break;
			case '.':
				if (bGotDOT == false) {
					bGotDOT = true;
				} else {
					//can't have a value of "1.2.3"
					return false;
				}
				break;
			default:
				return false;
		}
	}
   
	return true;
}

//attempt to support 0x336699 hex value Format
bool IsHexic(string sVal) {
	//trace("IsHexic " + sVal);
	string sValue = sVal;
	
	if (Left(sValue, 1) == "-") {
		sValue = Mid(sValue, 2, sValue.length() - 1);
	}
   
	if (Left(sValue, 1) == "0" && Mid(sValue, 2, 1) == "x") {
		sValue = Mid(sValue, 3, sValue.length() - 2);
	} else {
		return false;
	}
	
   sValue = stringToUpper(sValue);
   for (unsigned int i = 0; i < sValue.length(); ++i) {
		switch (Mid(sValue,i,1)[0]) {
			case '0': case '1': case '2':
			case '3': case '4': case '5':
			case '6': case '7': case '8':
			case '9':
				//okay
				break;
			case 'A': case 'B': case 'C': case 'D': case 'E': case 'F':
				//okay
				break;
			default:
				return false;
		}
	}
	
	return true;
}

unsigned long HexVal(string sVal) {
	string sValue = sVal ;
	bool bIsNeg = false;
   
	if (Left(sValue, 1) == "-") {
		sValue = Mid(sValue, 2, sValue.length() - 1);
		bIsNeg = true;
	}
   
	if (Left(sValue, 1) == "0" && Mid(sValue, 2, 1) == "x") {
		sValue = Mid(sValue, 3, sValue.length() - 2);
	} else {
		return 0;
	}
   
	if (bIsNeg == true) {
		return 0 - Val("0x" + sValue);
	}
	return Val("0x" + sValue);
}

bool fbArrayToArray(vector<int> src, vector<int> &ret) {
	ret.clear();
	for (unsigned int i = 0; i < src.size(); ++i) {
		ret.push_back(src[i]);
	}
	return true;
}

bool fbUDTtoUDT(vector<int> &src, vector<int> &ret, int ctr) {
	ret.clear();// = Allocate(ctr*sizeof(int));
	unsigned int l_max = ctr;
	if (l_max < src.size()) {
		l_max = src.size();
	}
	
	for (unsigned int i = 0; i < l_max; ++i) {
		ret.push_back(src[i]);
	}
	
	return false;
}

void Engine_HideScreen() {
	#ifndef QUIXIE_CGI
		//hackish way of initializing the fbgfx w/o showing a screen :D
		//by Dr_D and MySoft
		if (bFormShown == true) {
			bFormShown = false;

				//[QuixiePP] use gtk_window_iconify()

		}
	#endif
}

string KSE_CleanURL(string par) {
	//see http://www.blooberry.com/indexdot/html/topics/urlencoding.htm
	string cleaned = par;
	cleaned = Replace(cleaned, "%22", kseDOUBLE_QUOTES);
	cleaned = Replace(cleaned, "%20", kseSPACE);
	cleaned = Replace(cleaned, "%3C", "<"); //Less Than
	cleaned = Replace(cleaned, "%3E", ">"); //Greater Than
	cleaned = Replace(cleaned, "%23", kseNUMBER_SIGN); //Pound
	cleaned = Replace(cleaned, "%25", ksePERCENT_SIGN);
	cleaned = Replace(cleaned, "%7B", kseOPEN_CURL);
	cleaned = Replace(cleaned, "%7D", kseCLOSE_CURL);
	cleaned = Replace(cleaned, "%7C", "|"); //Vertical Bar/Pipe
	cleaned = Replace(cleaned, "%5C", kseBACK_SLASH);
	cleaned = Replace(cleaned, "%5E", kseCARET);
	cleaned = Replace(cleaned, "%7E", "~"); //Tilde
	cleaned = Replace(cleaned, "%5B", kseOPEN_BRACKET);
	cleaned = Replace(cleaned, "%5D", kseCLOSE_BRACKET);
	cleaned = Replace(cleaned, "%60", "`"); //Grave Accent
	
	cleaned = Replace(cleaned, "%28", kseOPEN_PAREN);
	cleaned = Replace(cleaned, "%29", kseCLOSE_PAREN);
	cleaned = Replace(cleaned, "+", kseSPACE);
	cleaned = Replace(cleaned, "%26", "&");
	cleaned = Replace(cleaned, "%2B", "+");
	
	return cleaned;
}

void Engine_GetParams() {
	vector<string> args;
	vector<string> vars;
	vector<string> vals;
	
	#ifdef QUIXIE_CGI
	//get any GET/POST data
		string method = Environ("REQUEST_METHOD");
		string request;
		int length;
		
		unsigned char bSource[];
	
		switch (Ucase(method)) {
			case "GET":
				request = Environ("QUERY_STRING");
				break;
			case "POST":
				length = Val(Environ("CONTENT_LENGTH"));
				
				bSource[length - 1];
				open cons For Input #1 // [QuixiePP] find a way to read input from console?!?
					//Dim j Integer
					//For j = 0 To length -1
					//	//request = request + Input$(1,#1)
					//	bSource(j) = CUByte(Input$(1,1)) 
					//Next
					Get #1,,bSource()
				close #1
				//request = Space( length )
				request = fbArrayToStr(bSource);
		}
		
		//fix data format when [enctype="multipart/form-data"] was used in FORM tag 
		if (InStr(1, request, "Content-Disposition: form-data; name=" + kseDOUBLE_QUOTES) > 0) {
//Engine_Log("<p><b>request</b><pre>" + request + "</pre>", 1
			string l_tmpRequest = Right(request, request.length() - 29); //skip 29 dashes (-)
			string l_tmpRandomInt;
			
			//get random int which seemed to be used for time of data upload
			while (IsNumeric(Left(l_tmpRequest, 1)) == true) {
				l_tmpRandomInt = l_tmpRandomInt + Left(l_tmpRequest, 1);
				l_tmpRequest = Right(l_tmpRequest, l_tmpRequest.length()) - 1);
			}
			request = Replace(request, l_tmpRandomInt + "\n", kseNULL_STRING);
			request = Replace(request, "-----------------------------", kseNULL_STRING);
			//request = Replace(request, "Content-Disposition: form-data; name=" + kseDOUBLE_QUOTES, "&");
			//request = Replace(request, "\n" + "&", "&");
			request = Replace(request, "Content-Disposition: form-data; name=" + kseDOUBLE_QUOTES, "\n" + "\n" + kseSOURCE_SEP + "\n" + "\n");
			request = Replace(request, "\n" + "\n" + "\n" + kseSOURCE_SEP, "\n" + "\n" + kseSOURCE_SEP);
			request = Replace(request, kseDOUBLE_QUOTES + "\n" + "\n", "=");
			
				string requestCopy = request;
				string requestFile;
				vector<string> varTmp;
				varTmp = split(requestCopy, "\n" + "\n" + kseSOURCE_SEP + "\n" + "\n");
				
				int jjj;
				vector<string> l_tmpFile;
				vector<string> l_tmpFilename;
				string tmp_dir;
				for (jjj = 0; jjj < varTmp.size(); ++jjj) {
					if (InStr(varTmp(jjj), "; filename=") > 0) {
						requestCopy = Replace(requestCopy, "\n" + "\n" + kseSOURCE_SEP + "\n" + "\n" + varTmp(jjj), kseNULL_STRING)
						requestFile = Replace(varTmp(jjj), kseDOUBLE_QUOTES + "; filename=" + kseDOUBLE_QUOTES, "=")
						requestFile = Replace(requestFile, kseDOUBLE_QUOTES + "\n" + "Content-Type: ", "\n" + "\n" + kseSOURCE_SEP + "\n" + "\n");
						l_tmpFile = split(requestFile, "\n" + "\n" + kseSOURCE_SEP + "\n" + "\n");
						l_tmpFilename = split(l_tmpFile[0], "=");
						l_tmpFile[0] = "";
						while (Left(l_tmpFile[1], 1) != "\n") {
							l_tmpFile[0] = l_tmpFile[0] + Left(l_tmpFile[1], 1);
							l_tmpFile[1] = Right(l_tmpFile[1], l_tmpFile[1].length() - 1);
						}
						l_tmpFile[1] = Right(l_tmpFile[1], l_tmpFile[1].length() - 2);	//skip 2 extra "\n"
						
						requestFile = l_tmpFile[1];
						Engine_Log("<h1>" + l_tmpFile[0] + "</h1>", true);
						//output uploaded file; later, put it under TMP then,
						//have it transfered to somewhere else depending on the script
						//fbStrToArray(requestFile, bSource); // [QuixiePP] simply file-out 'requestFile'
						
						tmp_dir = GetTempDir() + kseSLASH + kHash(l_tmpFilename[1])
							++iUploadedFileCtr;
							typeUploadedFile l_uploadedFile;
								l_uploadedFile.sFileID = l_tmpFilename[1];
								l_uploadedFile.sTempname = tmp_dir;
							kseUploadedFile.push_back(l_uploadedFile);
						Open tmp_dir For Binary Access Write #1
							Put #1,,bSource[]
							//fileout << requestFile; //[QuixiePP] like so!
						Close #1
					}
				}
			
			request = Replace(requestCopy, "\n" + "\n" + kseSOURCE_SEP + "\n" + "\n", "&");
			//request = Replace(request, "\n" + "&", "&");
			
			//remove trailing unwanted data
			vector<string> l_tmpStr;
			l_tmpStr = split(request, l_tmpRandomInt + "--");
			
				request = l_tmpStr[0];
		}
	
		if (request != "" && Right(sgblCmd, request.request()) != request) {
			//if we have request let's check sgblCmd
			if (InStr(1, sgblCmd, "?") > 0) {
				//append REQUEST content
				sgblCmd += ("&" + request);
			} else {
				//include REQUEST content
				sgblCmd += ("?" + request);
			}
		}
	#endif
	
	if (InStr(1, sgblCmd, "?") > 0) {
		args = split(sgblCmd, "?");
		sgblCmd = args[0];
		unsigned int i;
		sgblCmdArg = args[1];
		for (i = 2; i < args.size() - 1; ++i) {
			sgblCmdArg = sgblCmdArg + "?" + args[i];
		}
		
		vars = split(sgblCmdArg, "&");
		
		for (i = 0; i < vars.size() - 1; ++i) {
			vals = split(vars[i], "=");
			
			if (vals.size() > 1) {
				//if (InStr(vals(0), "; filename=") > 0) {
				//	sgblCmdArg = Replace(sgblCmdArg,vars[i],kseNULL_STRING);
				//}
				
				if (IsNumeric(vals[1]) == true) {
					KSE_DeclareNum(vals[0], CDbl(vals[1]), false, true);
				} else {
					KSE_DeclareStr(vals[0], KSE_CleanURL(vals[1]), false, true);
				}
			} else {
				KSE_DeclareStr(vals[0], KSE_CleanURL(vals[1]), false, true);
			}
		}
	}
	
	KSE_DeclareStr("args", sgblCmdArg, true);  //make this accessible to users
}

#ifdef QUIXIE_CGI
	void KSE_DeclareEnviron(p_var String)
		KSE_DeclareStr p_var, Environ(p_var)
	End Sub
	
	void KSE_DeclareEnvirons() {
		//HTTP headers:
		KSE_DeclareEnviron("HTTP_USER_AGENT");
		KSE_DeclareEnviron("HTTP_REFERER");
		KSE_DeclareEnviron("HTTP_COOKIE");
		KSE_DeclareEnviron("HTTP_FORWARDED");
		KSE_DeclareEnviron("HTTP_HOST");
		KSE_DeclareEnviron("HTTP_PROXY_CONNECTION");
		KSE_DeclareEnviron("HTTP_ACCEPT");
		
		//connection + request:
		KSE_DeclareEnviron("REMOTE_ADDR");
		KSE_DeclareEnviron("REMOTE_HOST");
		KSE_DeclareEnviron("REMOTE_PORT");
		KSE_DeclareEnviron("REMOTE_USER");
		KSE_DeclareEnviron("REMOTE_IDENT");
		KSE_DeclareEnviron("REQUEST_METHOD");
		KSE_DeclareEnviron("SCRIPT_FILENAME");
		KSE_DeclareEnviron("PATH_INFO");
		KSE_DeclareEnviron("QUERY_STRING");
		KSE_DeclareEnviron("AUTH_TYPE");
			
		//server internals:
		KSE_DeclareEnviron("DOCUMENT_ROOT");
		KSE_DeclareEnviron("SERVER_ADMIN");
		KSE_DeclareEnviron("SERVER_NAME");
		KSE_DeclareEnviron("SERVER_ADDR");
		KSE_DeclareEnviron("SERVER_PORT");
		KSE_DeclareEnviron("SERVER_PROTOCOL");
		KSE_DeclareEnviron("SERVER_SOFTWARE");
		
		//date and time:
		KSE_DeclareEnviron("TIME_YEAR");
		KSE_DeclareEnviron("TIME_MON");
		KSE_DeclareEnviron("TIME_DAY");
		KSE_DeclareEnviron("TIME_HOUR");
		KSE_DeclareEnviron("TIME_MIN");
		KSE_DeclareEnviron("TIME_SEC");
		KSE_DeclareEnviron("TIME_WDAY");
		KSE_DeclareEnviron("TIME");
		
		//specials:
		KSE_DeclareEnviron("API_VERSION");
		KSE_DeclareEnviron("THE_REQUEST");
		KSE_DeclareEnviron("REQUEST_URI");
		KSE_DeclareEnviron("REQUEST_FILENAME");
		KSE_DeclareEnviron("IS_SUBREQ");
		KSE_DeclareEnviron("HTTPS");
	}
#endif

string kHash(string par, int p_len) {
	unsigned int i = par.length();
	string hArr[i - 1];
	int hNum[16];
	int hVal = 10;
	string sHash;

	//delimit hash length
	if (p_len < 8) { p_len = 8; }
	if (p_len > 24) { p_len = 24; }
	
	hNum[0] = 75;
	hNum[1] = 114;
	hNum[2] = 105;
	hNum[3] = 120;
	hNum[4] = 119;
	hNum[5] = 97;
	hNum[6] = 114;
	hNum[7] = 101;
	hNum[8] = 32;
	hNum[9] = 83;
	hNum[10] = 116;
	hNum[11] = 117;
	hNum[12] = 100;
	hNum[13] = 105;
	hNum[14] = 111;
	hNum[15] = 115;
	unsigned int ii;
	int ii2, temp, prem = ((int)Mid(par, 1, 1)[0]) % hVal;
	
	for (ii = 0; ii < par.length() - 1; ++ii) {
		//hArr[ii] = Mid(par, ii + 1, 1)[0];
		hArr[ii] = par[ii+1];
		for (ii2 = 0; ii2 < 16; ++ii2) {
			temp = (hNum[ii2] + atoi(hArr[ii].c_str()) + prem) % hVal;
			if (temp < 25) {
				temp = 97 + temp % 26;
			} else {
				temp = 65 + temp;
			}
			prem = temp % 52;
			hNum[ii2] = temp;
		}
		prem = atoi(hArr[ii].c_str()) % hVal;
	}
	
	sHash = char(hNum[ 0]) + (hNum[ 1]) +
			char(hNum[ 2]) + (hNum[ 3]) +
			char(hNum[ 4]) + (hNum[ 5]) +
			char(hNum[ 6]) + (hNum[ 7]) +
			char(hNum[ 8]) + (hNum[ 9]) +
			char(hNum[10]) + (hNum[11]) +
			char(hNum[12]) + (hNum[13]) +
			char(hNum[14]) + (hNum[15]);
	
	return Left(sHash, p_len);
}
void KSE_MouseToggle(bool p_toggle) {
	MouseToggle = p_toggle;

	ShowCursor(MouseToggle);
}
void KSE_MouseToggle(char p_toggle) {
	if (p_toggle > 2) {
		p_toggle = 2;
	} else if (p_toggle < 0) {
		p_toggle = 0;
	}
	
	if (p_toggle == 2) {
		p_toggle = (MouseToggle == false) ? true : false;
	}
	
	MouseToggle = p_toggle;
	
	ShowCursor(MouseToggle);
}

string kseLOG_FILE = "ks.log";

vector<string> g_argv;
int main(int argc, char *argv[]) {
	Gtk::Main kit(argc, argv);
	
	g_argv = argHandler(argc, argv);
	
	App_Path = getFilePath(g_argv[0]);
	App_EXEName = getFileName(g_argv[0]);
	
	kage = new Kage();
	
	Gtk::Main::run(*kage);
	return EXIT_SUCCESS;
}

void ScreenRes(int p_width, int p_height) {
//	w1920;
//	h1080
	if (kage != NULL) {
		kage->set_resizable(true);
		kage->set_default_size(p_width, p_height);
		kage->set_resizable(false);
	}
}
void WindowTitle(string p_title) {
	if (kage != NULL) {
		kage->set_title(p_title);
	}
}

vector<string> argHandler(int &argc, char *argv[]) {
	int i;
	vector<string> l_argv;
	string l_tmp;
		for (i = 0; i < argc; ++i) {
			l_argv.push_back(argv[i]);
		}
	return l_argv;
}
