#ifndef KAGE_HPP
	#define KAGE_HPP

	#ifdef QUIXIE_CGI
		#define	NOT_SUPPORTED "Error #30: Not supported in cgi-port"
		#undef	QUIXIE_GAMEENGINE
	#endif

	#define CLASS_VAR
	#define CLASS_ARRAY
	#define CLASS_MATH
	#define CLASS_KONSOL
	#define CLASS_TIME
	#define CLASS_STRING
	#define CLASS_FILE // [QuixiePP] -- write File-handler to support File class
	//#define CLASS_NET // [QuixiePP] -- to be enabled after a working C++-based Quixie
	#define CONTROL_FOR
	#define CONTROL_IF
	#define CONTROL_WHILE

	#ifdef QUIXIE_GAMEENGINE
		#define CLASS_ENTITY
		#define CLASS_IMAGE
		#define CLASS_KEY
		#define CLASS_SCREEN
		#define CLASS_GAME
		#define CLASS_MAP
		#define CLASS_TILESET
		#define CLASS_SPRITESET
		#define CLASS_LAYER
		#define CLASS_MOUSE
		#define CLASS_DRAW
		#define CLASS_SOUND
	#endif
	
	#include "version.hpp"
	#include "kse_gui.hpp"
	
	#ifdef __linux__
	//gnu_linux.hpp includes kageExterns.hpp earlier than [removed "clsCollection"] should have
	//  #include Once "gnu_linux/gnu_linux.hpp"
		long GetTempPath(int dummy, string &temp_dir);
		#ifndef QUIXIE_CGI
			void ShowCursor(int visibility);
		#endif
	#elif _WIN32
		#include <windows.h>
	#else
		#error "OS not supported!"
	#endif

	#include "bascompat.hpp"
	#include "kageExterns.hpp"
	
	#include <zlib.h>
	#include <stdlib.h> //strtod/rand
	#include <stdio.h> //remove
	//#include <cmath> //abs
	
	#include <algorithm> //search
	
	using namespace std;
	
	vector<string> split(const string &s, const string &delim, const bool keep_empty = false);
	vector<string> argHandler(int &argc, char *argv[]);
	
	extern vector<ofstream> OFStreams;
	
	#ifndef QUIXIE_CGI
		////----- for JPG support ------
		//#include "lib\fbjpg\fbjpg.hpp" //-- [QuixiePP] will revisit when loading JPEG is needed  //-- same as the jpeg4gfxlib.bi
		//----------------------------//

		////----- for PNG support ------ //-- [QuixiePP] will use Cairo's PNG loader instead
		#ifdef CLASS_NET
		//	#include "lib/fbnet/net.hpp"
		
		//----------------------------//
			////----- for Network support ------
		//	#include "lib/chisock/chisock.hpp"
			#include "lib/fbnet/net.hpp"
		#endif
	#endif
	extern vector<string> g_argv;
	extern string App_Path;
	extern string App_EXEName;
	#define App_Comments "Krixware's Script Engine for KonsolScript both primarily written by Mj Mendoza IV"

	extern vector<typeUDT> kseUDT;
	extern int iUDTctr;

	extern vector<typeUDT_Instance> kseUDT_Instance;

	extern string _msg;
	extern string _cap;
	extern bool _displayMessage;
	void DrawString(int p_X, int p_Y, string p_string, float p_R, float p_G, float p_B);
	void Engine_DrawWord(int *img_ptr, int i_x, int i_y, string s_Word, unsigned long ul_color);
	void MsgBox (string msg, string cap);
	bool IsBooleanic(string sValue);
	bool BooleanVal(string sVal);
	bool IsNumeric(string sValue);
	bool IsHexic(string sVal);
	unsigned long HexVal(string sVal);
	string Replace(string src, string find, string replace_);
	string StrReverse(string value);
	int Split(string src,
				string del,
				vector<string> &res);
	int kSplit(string src,
				string del,
				vector<string> &res);
	bool IsLaunchedByFile();
	bool fbArrayToArray(vector<int> src, vector<int> ret);
	bool fbUDTtoUDT(vector<int> &src, vector<int> &ret, int ctr);
	void Engine_HideScreen();
	void KSE_MouseToggle(bool p_toggle);

	string KSE_CleanURL(string par);
	void Engine_GetParams();
	#ifdef QUIXIE_CGI
		void KSE_DeclareEnviron(string p_var);
		void KSE_DeclareEnvirons();
	#endif
	string kHash(string par, int p_len = 8);

	#include "inc/cls_Function.hpp"
	#include "inc/kse_zLib.hpp"
	//prototypes (core)
	#include "inc/core/kse_Main.hpp"
	#include "inc/core/kse_Main_Header_Associate.hpp"
	#include "inc/core/kse_Main_Header_Engine.hpp"
	#include "inc/core/kse_Main_Header_Media.hpp"
	#include "inc/core/kse_Main_Header_Process.hpp"
	#include "inc/core/kse_Main_Header_Execute.hpp"


	//prototypes (classes)
	#include "inc/cls/kse_Array.hpp"
	#include "inc/cls/kse_File.hpp"
	#include "inc/cls/kse_Konsol.hpp"
	#include "inc/cls/kse_Math.hpp"
//	#include "inc/cls/kse_Net.hpp"
	#include "inc/cls/kse_String.hpp"
	#include "inc/cls/kse_Time.hpp"
	#include "inc/cls/kse_Var.hpp"

	#ifndef QUIXIE_CGI
		#include "inc/cls/kse_Draw.hpp"
		#include "inc/cls/kse_Image.hpp"
		#include "inc/cls/kse_Key.hpp"
		#include "inc/cls/kse_Layer.hpp"
		#include "inc/cls/kse_Mouse.hpp"
		#include "inc/cls/kse_Screen.hpp"
		#include "inc/cls/kse_Sound.hpp"
		#include "inc/cls/kse_SpriteSet.hpp"
		#include "inc/cls/kse_TileSet.hpp"
		
		#include "inc/cls/kse_Entity.hpp"
		#include "inc/cls/kse_Map.hpp"
			#include "inc/cls/kse_Game.hpp"
	#endif

	#ifdef QUIXIE_MYSQL
		#include "inc/cls/kse_MySQL.hpp"
	#endif

	#include "inc/kse_Math_Equation.hpp"
	#include "inc/kse_String_Equation.hpp"
	//prototypes (control statements)
	#include "inc/ctrl/kse_For_Statement.hpp"
	#include "inc/ctrl/kse_If_Statement.hpp"
	#include "inc/ctrl/kse_While_Statement.hpp"

	void ScreenRes(int p_width, int p_height);
	void WindowTitle(string p_title);

	#ifdef QUIXIE_MYSQL
		#include once "mysql/mysql.hpp"
		#include "src/cls/kse_MySQL.cpp"
	#endif

	#ifdef __linux__
	  #include Once "gnu_linux/gnu_linux.hpp"
	#else
	//  #include Once "windows.hpp"
	#endif
#endif
