
#include "kse_gui.hpp"
#include "version.hpp"
#include "kage.hpp"
#include "kageExterns.hpp"

#include <sstream>
#include <chrono>
bool g_LMB = false, g_RMB = false, g_MMB = false;
bool g_B1 = false, g_B2 = false, g_B3 = false, g_B4 = false;
bool g_BU = false, g_BD = false, g_BL = false, g_BR = false;
const guint BUTTON_LEFT = 1;
const guint BUTTON_RIGHT = 3;
unsigned long b_A = KAGE_RGBA(240, 240, 240, 255), b_C = KAGE_RGBA(150, 150, 150, 255), b_B;
int b_pressed = 0, b_clicked = 0, b_cap = 0;
class Kage;
KageStage::KageStage(Kage *p_win) {
	win = p_win;

	//	set_flags(Gtk::CAN_FOCUS);
	set_can_focus(true); //to accept key_press
	add_events(Gdk::BUTTON_PRESS_MASK | Gdk::BUTTON_RELEASE_MASK);
	add_events(Gdk::ENTER_NOTIFY_MASK | Gdk::LEAVE_NOTIFY_MASK);
	add_events(Gdk::FOCUS_CHANGE_MASK);
	add_events(Gdk::POINTER_MOTION_MASK);
	gotContext = false;
}

KageStage::~KageStage() {
	//
}

void KageStage::set_message(Glib::ustring p_foo) {
	render();
	foo = p_foo;
}
bool KageStage::on_key_press_event(GdkEventKey *e) {
	if (e->keyval == 65307) { //[ESCAPE] key
		SetVarBoolValue(VAR_B1, true);
		SetVarNumValue(VAR_LASTPRESS, 27);
		bMapRendering = true;  //for Game:Render --pause
		g_B1 = true;
	} else if (e->keyval == 65507 || e->keyval == 65508) { //[CONTROL]
		SetVarBoolValue(VAR_B2, true);
		SetVarNumValue(VAR_LASTPRESS, 29);
	} else if (e->keyval == 65505 || e->keyval == 65506) { //[SHIFT]
		g_B2 = true;
		// [QuixiePP] which KonsolScript internal handles SHIFT?
	} else if (e->keyval == 13) { //[ENTER] (kuno)
		SetVarBoolValue(VAR_B3, true);
		SetVarNumValue(VAR_LASTPRESS, 13);
		g_B3 = true;
	} else if (e->keyval == 32) { // [SPACE]
		SetVarBoolValue(VAR_B4, true);
		SetVarNumValue(VAR_LASTPRESS, 32);
		g_B4 = true;
	} else if (e->keyval == 65362) { // UP-ARROW
		SetVarBoolValue(VAR_BU, true);
		SetVarNumValue(VAR_LASTPRESS, 38);
		bMapMoveUp = true;      //for Map Class
		g_BU = true;
	} else if (e->keyval == 65364) { // DOWN-ARROW
		SetVarBoolValue(VAR_BD, true);
		SetVarNumValue(VAR_LASTPRESS, 37);
		bMapMoveDown = true;    //for Map Class
		g_BD = true;
	} else if (e->keyval == 65361) { // LEFT-ARROW
		SetVarBoolValue(VAR_BL, true);
		SetVarNumValue(VAR_LASTPRESS, 40);
		bMapMoveLeft = true;    //for Map Class
		g_BL = true;
	} else if (e->keyval == 65363) { // RIGHT-ARROW
		SetVarBoolValue(VAR_BR, true);
		SetVarNumValue(VAR_LASTPRESS, 39);
		bMapMoveRight = true;   //for Map Class
		g_BR = true;
	}
	//	if (e.ascii > 0) {
	//		Key_Pressed(e.ascii);
	//	}
	if (iKeyDown >= 0) { kseFunction[iKeyDown].RunScript(); }

	return true;
}
bool KageStage::on_key_release_event(GdkEventKey *e) {
	if (e->keyval == 65307) { //[ESCAPE]
		SetVarBoolValue(VAR_B1, false);
		SetVarNumValue(VAR_LASTUNPRESS, 27);
		bMapRendering = false;  //for Game:Render --pause
		g_B1 = false;
	} else if (e->keyval == 65507 || e->keyval == 65508) { //[CONTROL]
		SetVarBoolValue(VAR_B2, false);
		SetVarNumValue(VAR_LASTUNPRESS, 29);
		g_B2 = false;
	} else if (e->keyval == 65505 || e->keyval == 65506) { //[SHIFT]
		// [QuixiePP] which KonsolScript internal handles SHIFT?
	} else if (e->keyval == 13) { //[ENTER] (kuno)
		SetVarBoolValue(VAR_B3, false);
		SetVarNumValue(VAR_LASTUNPRESS, 13);
		g_B3 = false;
	} else if (e->keyval == 32) { // [SPACE]
		SetVarBoolValue(VAR_B4, false);
		SetVarNumValue(VAR_LASTUNPRESS, 32);
		g_B4 = false;
	} else if (e->keyval == 65362) { // UP-ARROW
		SetVarBoolValue(VAR_BU, false);
		SetVarNumValue(VAR_LASTUNPRESS, 38);
		bMapMoveUp = false;     //for Map Class
		g_BU = false;
	} else if (e->keyval == 65364) { // DOWN-ARROW
		SetVarBoolValue(VAR_BD, false);
		SetVarNumValue(VAR_LASTUNPRESS, 37);
		bMapMoveDown = false;   //for Map Class
		g_BD = false;
	} else if (e->keyval == 65361) { // LEFT-ARROW
		SetVarBoolValue(VAR_BL, false);
		SetVarNumValue(VAR_LASTUNPRESS, 40);
		bMapMoveLeft = false;   //for Map Class
		g_BL = false;
	} else if (e->keyval == 65363) { // RIGHT-ARROW
		SetVarBoolValue(VAR_BR, false);
		SetVarNumValue(VAR_LASTUNPRESS, 39);
		bMapMoveRight = false;  //for Map Class
		g_BR = false;
	}
	//	if ((e.ascii > 0) {
	//		Key_UnPressed(e.ascii);
	//	}
	if (iKeyUp >= 0) { kseFunction[iKeyUp].RunScript(); }

	return true;
}

void KageStage::render() {
	//	Kage::timestamp();
		std::cout << " KageStage::render <" << std::endl;
	if (!window) {
		window = get_window();
	}

	if (window) {
		// force our program to redraw the entire stage
		Gdk::Rectangle r(0, 0, get_allocation().get_width(),
			get_allocation().get_height());
		window->invalidate_rect(r, false);
	}
	//	Kage::timestamp();
		std::cout << " KageStage::render >" << std::endl;
}

bool KageStage::on_draw(const Cairo::RefPtr<Cairo::Context>& p_cr) {
	//	Kage::timestamp();
//		std::cout << " KageStage::on_draw <" << std::endl;
	if (!window) {
		window = get_window();
	}
	if (window) {
		cr = p_cr;
	}

	clearScreen();

	Pango::FontDescription font;
	font.set_family("Monospace");
	font.set_weight(Pango::WEIGHT_BOLD);

	// http://developer.gnome.org/pangomm/unstable/classPango_1_1Layout.html
	auto layout = create_pango_layout("hello " + foo + "!");
	layout->set_font_description(font);

	//		int text_width;
	//		int text_height;
	//		
	//		//get the text dimensions (it updates the variables -- by reference)
	//		layout->get_pixel_size(text_width, text_height);

	// Position the text in the middle
	cr->set_source_rgb(1.0, 0.0, 0.0);
	cr->move_to(100, 100);

	layout->show_in_cairo_context(cr);
	////
	////
	////
	//		cr->select_font_face("Courier New", CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_BOLD);
	//		cr->set_font_size   (12);
	//		cr->set_source_rgb  (1.0, 0.0, 0.0);
	//		
	//			cr->move_to     (10, 10);
	//			cr->show_text   ("hello world!");
	//	Kage::timestamp();
//		std::cout << " KageStage::on_draw >" << std::endl;
	std::cout << "on_draw ? _displayMessage = " << _displayMessage << std::endl;
	if (_displayMessage) {
		PseudoMessageBoxRender(true);
	}

	return true;
}

void KageStage::PseudoMessageBoxRender(bool p_loop) {
	//simple, not-well-thought-out drawn msgbox for gnu/linux; adapted for QuixiePP to hanging-thread caused by GtkDialog
	string msgcopy = _msg;
	std::cout << "PseudoMessageBoxRender ? " << msgcopy << " | " << _cap << std::endl;
	int x = 0, y = 0, buttons, res;
//	unsigned long b_A = KAGE_RGBA(240, 240, 240, 255), b_C = KAGE_RGBA(150, 150, 150, 255), b_B;
//	int b_pressed = 0, b_clicked = 0, b_cap = 0;
	int t_Width = 640, t_Height = 480;
	int t_WidthCenter = (t_Width / 2);
	int t_HeightCenter = (t_Height / 2);

	//check if the screen is already shown; if not, show it
	bool bFormClose = false;
	if (bFormShown == false) {
		bFormShown = true;
		bFormClose = true;
		ScreenRes(t_Width, t_Height);// , 32);
	}

	bool bMouseShown;
	if (MouseToggle == true) {
		bMouseShown = true;
	}
	else {
		KSE_MouseToggle(true); //show mousecursor when showing MessageBox
	}

	res = CreateNewImage();
	InitializeImage(res, t_Width, t_Height);

	if (_cap.length() > 30) { _cap = Mid(_cap, 0, 30) + "..."; } //was Mid(_cap, 1, 30) + "..."; }
	//BOX (text-msg-buffer)
	cr->set_line_cap(Cairo::LINE_CAP_ROUND);
	cr->set_line_width(0);
	/*
	cr->move_to(0, 0);
	cr->line_to(t_Width, 0);
	cr->line_to(t_Width, t_Height);
	cr->line_to(0, t_Height);
	cr->line_to(0, 0);
	cr->set_source_rgb(1.0, 0.0, 1.0);
	cr->fill_preserve();
	cr->set_source_rgb(1.0, 0.0, 1.0);
	cr->stroke();*/
//	Engine_DrawWord(kseImg[res].img, 0, y, _msg, KAGE_RGBA(50, 50, 50, 255)); //[QuixiePP] moved after drawing form; see `MESSAGE'

	//BOX (caption)
	cr->set_line_cap(Cairo::LINE_CAP_ROUND);
	cr->set_line_width(0);

	cr->move_to(10, 40);
	cr->line_to(t_Width - 10, 40);
	cr->line_to(t_Width - 10, 60);
	cr->line_to(10, 60);
	cr->line_to(10, 40);
	cr->set_source_rgb(0.3137f, 0.3137f, 0.8627f);
	cr->fill_preserve();
	cr->set_source_rgb(0.3137f, 0.3137f, 0.8627f);
	cr->stroke();
	
	//CAPTION
	DrawString(15, 45, _cap, 0.0f, 0.0f, 0.0f);
	DrawString(14, 44, _cap, 1.0f, 1.0f, 1.0f);

	//BOX (msg)
	cr->set_line_cap(Cairo::LINE_CAP_ROUND);
	cr->set_line_width(0);
//	(10, 60)-(t_Width - 10, t_Height - 40)
	cr->move_to(10, 60);
	cr->line_to(t_Width - 10, 60);
	cr->line_to(t_Width - 10, t_Height - 40);
	cr->line_to(10, t_Height - 40);
	cr->set_source_rgb(0.8627f, 0.8627f, 0.8627f); cr->fill_preserve(); //[QuixiePP] fishing
	cr->set_source_rgb(0.8627f, 0.8627f, 0.8627f);
	cr->stroke();
	
	//MESSAGE
	//		Put kseImg[quixieSCREEN].img, (15, 70), kseImg[res].img, Trans
	DrawString(25, 70, _msg, 0.1961f, 0.1961f, 0.1961f);

	//OUTLINE (caption)
	cr->set_line_cap(Cairo::LINE_CAP_ROUND);
	cr->set_line_width(1);

	cr->move_to(11, 39);
	cr->line_to(t_Width - 11, 39);
	cr->move_to(9, 41);
	cr->line_to(9, 58); 
	cr->set_source_rgb(0.4706f, 0.4706f, 0.9412f); //C = 120, 120, 240
	cr->stroke();
	cr->move_to(9, 59);
	cr->line_to(t_Width - 9, 59);
	cr->move_to(t_Width - 9, 41);
	cr->line_to(t_Width - 9, 58);
	cr->set_source_rgb(0.5882f, 0.5882f, 0.5882f); //C = 150, 150, 150
	cr->stroke();


	cr->set_line_cap(Cairo::LINE_CAP_ROUND);
	cr->set_line_width(1);

	cr->move_to(10, 60);
	cr->line_to(t_Width - 10, 60);
	cr->move_to(t_Width - 9, 60);
	cr->line_to(t_Width - 9, t_Height - 41);
	cr->move_to(11, t_Height - 39);
	cr->line_to(t_Width - 11, t_Height - 39);
	cr->set_source_rgb(0.5882f, 0.5882f, 0.5882f); //b_C = 150, 150, 150
	cr->stroke();
	cr->move_to(9, 60);
	cr->line_to(9, t_Height - 41);
	cr->move_to(10, 61);
	cr->line_to(t_Width - 10, 61);
	cr->set_source_rgb(0.9412f, 0.9412f, 0.9412f); //b_A = 240, 240, 240
	cr->stroke();
	
	//		ScreenSync();
	//	sleep(1);

	//unpress all keys first
	//	while (MultiKey(fb.SC_ENTER) || MultiKey(fb.SC_SPACE)) {
	//		sleep(1);
	//	}

	//now, show dialog
//	while (b_clicked == 0) {
		//OK button
		cr->set_line_cap(Cairo::LINE_CAP_ROUND);
		cr->set_line_width(1);

		cr->move_to(t_WidthCenter + 39, t_Height - 56 - 24);

		cr->line_to(t_WidthCenter - 39, t_Height - 56 - 24);
		cr->line_to(t_WidthCenter - 39, t_Height - 55);
//		cr->set_source_rgb(0.9412f, 0.9412f, 0.9412f); //b_A = 240, 240, 240
		cr->set_source_rgb(float(RGBA_R(b_A)/255.0f), float(RGBA_G(b_A) / 255.0f), float(RGBA_B(b_A) / 255.0f));
		cr->stroke();
		cr->line_to(t_WidthCenter + 39, t_Height - 55);
		cr->line_to(t_WidthCenter + 39, t_Height - 56 - 24);
		cr->set_source_rgb(0.5882f, 0.5882f, 0.5882f); //b_C = 150, 150, 150
		cr->set_source_rgb(float(RGBA_R(b_C) / 255.0f), float(RGBA_G(b_C) / 255.0f), float(RGBA_B(b_C) / 255.0f));
		cr->stroke();
		//cr->set_source_rgb(0.5882f, 0.5882f, 0.5882f); //b_C = 150, 150, 150
		//cr->fill_preserve();

		//OK caption
		cr->set_line_cap(Cairo::LINE_CAP_ROUND);
		cr->set_line_width(0);

		cr->move_to(t_WidthCenter - 38, t_Height - 56 - 23);

		cr->line_to(t_WidthCenter - 38, t_Height - 56);
		cr->line_to(t_WidthCenter + 38, t_Height - 56);
		cr->line_to(t_WidthCenter + 38, t_Height - 56 - 23);
		cr->line_to(t_WidthCenter - 38, t_Height - 56 - 23);
		cr->set_source_rgb(0.8627f, 0.8627f, 0.8627f); //220, 220, 220
		cr->stroke();
		cr->set_source_rgb(0.8627f, 0.8627f, 0.8627f); //220, 220, 220
		cr->fill_preserve();
		DrawString(t_WidthCenter - 7/*153*/ + b_cap, t_Height - 56 - 23 + 9/*170*/ + b_cap, "OK", 0.19f, 0.19f, 0.19f); //C = 50, 50, 50
		
		DrawString(MouseX, MouseY, "oh yeah! g_LMB:" + Str(g_LMB) + " b_pressed:" + Str(b_pressed) + " t_WidthCenter:" + Str(t_WidthCenter) + " t_Height:" + Str(t_Height), 1.0, 0.0, 0.0);
		DrawString(200, 200, "b_A:" + Str(b_A) + " b_C:" + Str(b_C), 0.0, 0.0, 0.0);
		x = MouseX;
		y = MouseY;
		if (g_LMB == true && x > (t_WidthCenter - 39) && x < (t_WidthCenter + 39) && y >(t_Height - 56 - 24) && y < (t_Height - 56) && b_pressed == 0) {
			DrawString(200, 250, "w00t!", 0.0, 0.0, 0.0);
			//pressed inside OK button
			b_B = b_A;
			b_A = b_C;
			b_C = b_B;
			b_pressed = 1;
			b_cap = 1;
			if (p_loop) PseudoMessageBoxRender(false);
		} else if (g_LMB == true && b_pressed == 0) {
			//pressed outside OK button
			b_pressed = 2;
			if (p_loop) PseudoMessageBoxRender(false);
//		} else if (buttons == 0 && b_pressed == 1 && x > (t_WidthCenter - 39) && x < (t_WidthCenter + 39) && y >(t_Height - 56 - 24) && y < (t_Height - 56) || MultiKey(fb.SC_ENTER) || MultiKey(fb.SC_SPACE)) {
		} else if (buttons == 0 && b_pressed == 1 && x > (t_WidthCenter - 39) && x < (t_WidthCenter + 39) && y >(t_Height - 56 - 24) && y < (t_Height - 56) || g_B3 == true || g_B4 == true) {
			//OK button is `clicked' [QuixiePP] via keyboard?
			b_clicked = 1;
			_displayMessage = false;
			if (p_loop) PseudoMessageBoxRender(false);
		} else if (g_LMB == false && b_pressed == 1) {
			//unpressed the pressed OK button (inside/outside it)
			b_B = b_A;
			b_A = b_C;
			b_C = b_B;
			b_pressed = 0;
			b_cap = 0;
			if (p_loop) PseudoMessageBoxRender(false);
		} else if (g_LMB == true && b_pressed == 2) {
			//unpressed outside OK button
			b_pressed = 0;
			b_cap = 0;
			if (p_loop) PseudoMessageBoxRender(false);
		}
		std::this_thread::sleep_for(std::chrono::milliseconds(8));
//	}

	//unpress all keys first
	//	while (MultiKey(fb.SC_ENTER) || MultiKey(fb.SC_SPACE)) {
	//		sleep(1);
	//	}

	if (bMouseShown == false) {
		KSE_MouseToggle(false); //hide mouse when it was previously hidden
	}
	
	if (bFormClose == true) { Engine_HideScreen(); }
	UnloadImage(res);
	std::cout << "PseudoMessageBoxRender x" << std::endl;
}
//#endif

void KageStage::clearScreen() {
	if (!cr) return;
	if (window) {
		Gtk::Allocation allocation = get_allocation();
		const int width = allocation.get_width();
		const int height = allocation.get_height();

		//draw stage area
		cr->move_to(0, 0);
		cr->line_to(width, 0);
		cr->line_to(width, height);
		cr->line_to(0, height);
		cr->close_path();
			cr->set_source_rgb(0.0, 0.0, 0.0);
			cr->fill();
	}
}

bool KageStage::on_expose_event(GdkEventExpose* e) {
	if (!window) {
		window = get_window();
	}

	if (window) {
		render();
	}
	return true;
}

bool KageStage::on_mouse_press_event(GdkEventButton *e) {
	std::cout << " KageStage::on_mouse_press_event ? " << e->button << std::endl;
	if (e->button == BUTTON_LEFT) {
		SetVarBoolValue(VAR_LMB, true);
		g_LMB = true;
	} else if (e->button == BUTTON_RIGHT) {
		SetVarBoolValue(VAR_RMB, true);
		g_RMB = true;
	} else {
		SetVarBoolValue(VAR_MMB, true);
		g_MMB = true;
	}
	if (iMouseDown >= 0) { kseFunction[iMouseDown].RunScript(); }
}
bool KageStage::on_mouse_release_event(GdkEventButton *e) {
	if (e->button == BUTTON_LEFT) {
		SetVarBoolValue(VAR_LMB, false);
		g_LMB = false;
	} else if (e->button == BUTTON_RIGHT) {
		SetVarBoolValue(VAR_RMB, false);
		g_RMB = false;
	} else {
		SetVarBoolValue(VAR_MMB, false);
		g_MMB = false;
	}
	if (iMouseUp >= 0) { kseFunction[iMouseUp].RunScript(); }
}
bool KageStage::on_event(GdkEvent *e) {
//	Kage::timestamp();
//	std::cout << " KageStage::on_event < " << e->type << std::endl;
	if (e->type == GDK_ENTER_NOTIFY) {

	} else if (e->type == GDK_LEAVE_NOTIFY) {

	} else if (e->type == GDK_KEY_PRESS) {
		on_key_press_event((GdkEventKey*)e);
		return true;
	} else if (e->type == GDK_KEY_RELEASE) {
		on_key_release_event((GdkEventKey*)e);
		return true;
	} else if (e->type == GDK_BUTTON_PRESS) { ///mouse down
		on_mouse_press_event((GdkEventButton*)e);
	} else if (e->type == GDK_BUTTON_RELEASE) { ///mouse up
		on_mouse_release_event((GdkEventButton*)e);
		grab_focus();
	} else if (e->type == GDK_MOTION_NOTIFY) { ///mouse move
		SetVarNumValue(VAR_MOUSEX, e->button.x);
		SetVarNumValue(VAR_MOUSEY, e->button.y);
		MouseX = e->button.x;
		MouseY = e->button.y;
		if (iMouseMove >= 0) { kseFunction[iMouseMove].RunScript(); }
		std::cout << "\t\t\t\tKageStage::on_mouse_move" << std::endl;
	} else if (e->type == GDK_EXPOSE) {
//		bRenderGraphics = true;
		on_expose_event((GdkEventExpose*)e);
	} else if (e->type == GDK_FOCUS_CHANGE) {
		//filter out from echos
		///
		///
		//on Application lost focus?
		//sleep(100, 1); //try to let other process take over CPU speed

		//bRenderGraphics = false; // stop rendering
	} else if (e->type == GDK_CONFIGURE) {
		//filter out from echos 
	} else {
		//		std::cout << "stage? e " << e->type << std::endl;
	}
//	Kage::timestamp();
//	std::cout << " KageStage::on_event >" << std::endl;
	render();
	return true;
}

void KageStage::drawString(int p_X, int p_Y, string p_string, float p_R, float p_G, float p_B) {
	std::cout << "drawString ? " << p_string << std::endl;
	Pango::FontDescription font;
	font.set_family("Monospace");
	font.set_weight(Pango::WEIGHT_BOLD);

	// http://developer.gnome.org/pangomm/unstable/classPango_1_1Layout.html
	auto layout = create_pango_layout(p_string);
	layout->set_font_description(font);
	cr->set_source_rgb(p_R, p_G, p_B);
	cr->move_to(p_X, p_Y);

	layout->show_in_cairo_context(cr);
}

Kage::Kage() : m_KageStage(this), m_Worker(), m_renderEnforcer() {
	sScreenVersion = string("0.4.") + App_Major + App_Minor + App_Revision;
	sScreenCaption = "Quixie v" + sScreenVersion;
	
	//	bFormShown = true;
	
	add(m_VBox);
	
	m_VBox.pack_start(m_VPaned, Gtk::PACK_EXPAND_WIDGET);
	m_VPaned.add1(m_KageStage);
	m_KageStage.set_size_request(800, 600);
	m_KageStage.show();
	
	set_title(sScreenCaption);
	//	set_icon_from_file("kage.xpm");
	set_border_width(0);
	//workaround for known bug about resizing/maximizing main window with gtk3.22-9
	//	set_default_size(800, 600);
	set_default_size(1920, 1080);
	set_resizable(false);

	show_all();

		m_WorkerThread = new std::thread(
			[this] {
				m_Worker.do_work(this);
			}
		);
}

Kage::~Kage() {
	//
}

void Kage::notify() {
	m_Dispatcher.emit();
}

Kage *kage;