#ifndef __KSE_GUI_HPP__
	#define __KSE_GUI_HPP__
	
	#include <gtkmm/main.h>
	#include <gtkmm/window.h>
	#include <gtkmm/box.h>
	#include <gtkmm/paned.h>
	#include <gtkmm/drawingarea.h>
	#include <gtkmm/messagedialog.h>
	#include <cairomm/context.h>
	#include <iostream>
	
	#include <thread>
	#include <mutex>
	
	#include <glibmm/dispatcher.h>

	#include "version.hpp"
	#include "kse_thread.hpp"
	
	using namespace std;
	
	class Kage;
	class KageStage : public Gtk::DrawingArea {
	public:
		KageStage(Kage *p_win);
		virtual ~KageStage();

		void render();
		void clearScreen();
		void set_message(Glib::ustring p_foo);
		void drawString(int p_X, int p_Y, string p_string, float p_R, float p_G, float p_B);
	protected:
		Kage * win;
		Glib::RefPtr<Gdk::Window> window;
		Cairo::RefPtr<Cairo::Context> cr;
		bool gotContext;

		Glib::ustring foo;
		
		//Override default signal handler:
		virtual bool on_expose_event(GdkEventExpose *e);
		virtual bool on_key_press_event(GdkEventKey *e);
		virtual bool on_key_release_event(GdkEventKey *e);
		virtual bool on_mouse_press_event(GdkEventButton *e);
		virtual bool on_mouse_release_event(GdkEventButton *e);
		virtual bool on_event(GdkEvent *e);
		
		bool on_draw(const Cairo::RefPtr<Cairo::Context>& cr) override;
		void PseudoMessageBoxRender(bool p_loop);
	};
	
	class Kage : public Gtk::Window {
	public:
		Kage();
		virtual ~Kage();

		Gtk::VBox m_VBox;
		Gtk::VPaned m_VPaned;

		KageStage m_KageStage;

		Glib::Dispatcher m_Dispatcher;
		ScriptWorker m_Worker;
		std::thread *m_WorkerThread;
		void notify();
	};

#endif // __KSE_GUI_HPP__