#include "kse_thread.hpp"
#include "kageExterns.hpp"

#include "kse_thread.hpp"
#include "kse_gui.hpp"

#include <sstream>
#include <chrono>

void Main(); //forward declaration-ish

ScriptWorker::ScriptWorker() :
	m_Mutex(),
	m_shall_stop(false),
	m_has_stopped(false),
	m_fraction_done(0.0),
	m_message() {
}

void ScriptWorker::stop_work() {
	std::lock_guard<std::mutex> lock(m_Mutex);
	m_shall_stop = true;
}

bool ScriptWorker::has_stopped() const {
	std::lock_guard<std::mutex> lock(m_Mutex);
	return m_has_stopped;
}

void ScriptWorker::do_work(Kage *caller) {
	std::cout << "ScriptWorker::do_work ?" << std::endl;
	{
		std::lock_guard<std::mutex> lock(m_Mutex);
		m_has_stopped = false;
		m_fraction_done = 0.0;
		m_message = "";
	} // The mutex is unlocked here by lock's destructor.
	std::cout << "ScriptWorker::do_work A" << std::endl;
	// Simulate a long calculation.
	for (unsigned short xxx = 0; xxx < USHRT_MAX; ++xxx) {
		//do nothing
	}
	std::cout << "ScriptWorker::do_work B" << std::endl;
	Main();
	caller->notify();
	
	{
		std::lock_guard<std::mutex> lock(m_Mutex);
		m_shall_stop = false;
		m_has_stopped = true;
	}
	std::cout << "ScriptWorker::do_work B" << std::endl;
	caller->notify();
}