#ifndef __KSE_THREAD_HPP__
	#define __KSE_THREAD_HPP__

	#include <thread>
	#include <mutex>
	#include <glibmm.h>
	
	class Kage;
	class ScriptWorker {
	public:
		ScriptWorker();

		// Thread function.
		void do_work(Kage *caller);

		void stop_work();
		bool has_stopped() const;

	private:
		// Synchronizes access to member data.
		mutable std::mutex m_Mutex;

		// Data used by both GUI thread and worker thread.
		bool m_shall_stop;
		bool m_has_stopped;
	};

#endif // !__KSE_THREAD_HPP__
