#Include "chisock-system.bi"

#Ifdef __FB_WIN32__
	Dim Shared As WSAData w
	If( WSAStartup( (1 Shl 8) Or 1, @w ) <> 0 ) Then
	End If
#EndIf

Namespace chi
	
	Operator socket_info.cast( ) As String
		Operator = "{address: " & *inet_ntoa( data.sin_addr ) & ", port: " & ntohs( data.sin_port ) & "}"
	End Operator
	
	Operator socket_info.cast( ) As sockaddr Ptr
		Operator = Cast(sockaddr Ptr, @Data)
	End Operator
	
	Private Function base_HTTP_path( ByRef thing As String ) As String
		Var res = InStr( thing, "/" )
		If( res = 0 ) Then
			Function = thing
		Else
			Function = Left( thing, res - 1 )
		End If
	End Function
	
	Function translate_error _ 
		( _ 
			ByVal err_code As Integer _
		) As String
		
		Select Case As Const err_code
			Case SOCKET_OK
				Return "No error"
			Case FAILED_INIT
				Return "Failed initialization"
			Case FAILED_RESOLVE
				Return "Failed to resolve host"
			Case FAILED_CONNECT
				Return "Failed connection"
			Case FAILED_REUSE
				Return "Failed to reuse socket"
			Case FAILED_BIND
				Return "Failed to bind socket"
			Case FAILED_LISTEN
				Return "Failed listening"
		End Select
	End Function
	
	Function resolve _ 
		( _ 
			ByRef host As String _ 
		) As UInteger
	 	
	 	Dim As String host_temp = host
		Dim As UInteger ip = inet_addr( host_temp )
		If( ip = NOT_AN_IP ) Then
		 	host_temp = base_HTTP_path( LTrim( host_temp, "http://" ) )
	  
			Dim As hostent Ptr info = gethostbyname( host_temp )
			If( info = NULL ) Then
				Return NOT_AN_IP
			End If
			Function = *Cast( UInteger Ptr, info->h_addr )
		Else
			Function = ip
		End If
	
	End Function
	
	Function client_core _ 
		( _ 
			ByRef result As UInteger, _ 
			ByRef info As socket_info, _
			ByVal ip As Integer, _ 
			ByVal port As Integer, _ 
			ByVal from_socket As UInteger, _ 
			ByVal do_connect As Integer = TRUE, _
			ByVal local_port As Integer = 0 _
		) As Integer
		
		Dim As Integer reuse = C_TRUE
		
		If( setsockopt( from_socket, _ 
		               SOL_SOCKET, _ 
		               SO_REUSEADDR, _ 
		               Cast(Any Ptr, @reuse), _ 
		               Len(Integer) ) = SOCKET_ERROR ) Then 
			Return FAILED_REUSE
		End If
		
		#Print "Including new port code...."
		If local_port Then
   		Dim lport As socket_info
   		lport = Type( AF_INET, htons( local_port ), BUILD_IP(127,0,0,1) )
   		Var ret = bind(from_socket, Cast(sockaddr Ptr, @lport), Len(lport) )
		EndIf
		
		If( do_connect = TRUE ) Then
			info = Type( AF_INET, htons( port ), ip )
					
			Var res = connect( from_socket, Cast(sockaddr Ptr, @info), Len(info) )
			If( res = SOCKET_ERROR ) Then
				Return FAILED_CONNECT
			End If
		End If
		
		result = from_socket
	
	End Function
	
	Function server_core _ 
		( _ 
			ByRef result As UInteger, _ 
			ByRef info As socket_info, _
			ByVal port As Integer, _ 
			ByVal ip As Integer, _
			ByVal from_socket As UInteger _
		) As Integer
	
		Dim As Integer reuse = C_TRUE
		If( setsockopt( from_socket, _ 
		               SOL_SOCKET, _ 
		               SO_REUSEADDR, _ 
		               Cast(Any Ptr, @reuse), _ 
		               Len(Integer) ) = SOCKET_ERROR ) Then 
			Return FAILED_REUSE
		End If
	    
		info = Type( AF_INET, htons( port ), ip )
		If bind( from_socket, _ 
		         Cast(sockaddr Ptr, @info), _ 
		         Len(info) ) = SOCKET_ERROR Then 
			Return FAILED_BIND
		End If
	
		result = from_socket
	
	End Function
	
	Function Close _
		( _ 
			ByVal sock_ As UInteger _ 
		) As Integer
		Dim As Integer res=Any
		#Ifdef __FB_WIN32__
			res = closesocket( sock_ )
		#Else
			res = shutdown( sock_, SHUT_RDWR )
		#EndIf
		Function = res
	End Function
	
	Function is_readable _
		( _ 
			ByVal sock_ As UInteger _ 
		) As Integer
		
		If( sock_ = SOCKET_ERROR ) Then
			Exit Function
		End If
		
		Dim As fd_set set 
		fd_zero( @set )
		fd_set_( sock_, @set )
	
		Dim As ULongInt timeout = 0
		select_( sock_+1, @set, NULL, NULL, Cast(timeval Ptr, @timeout) )
	
		Return (FD_ISSET( sock_, @set ) <> 0)
		
	End Function
	
	Function new_sockaddr OverLoad( ByVal serv As Integer, ByVal port As Short ) As socket_info Ptr
		Function = New socket_info( AF_INET, htons( port ), serv )
	End Function
	
	Function new_sockaddr( ByRef serv As String, ByVal port As Short ) As socket_info Ptr
		Var ip = resolve( serv )
		If( ip = NOT_AN_IP ) Then
			Exit Function
		End If
		
		Function = new_sockaddr( ip, port )
	End Function
	
End Namespace
