'--------------------------------------------------------------------------
'JPEG loader by Antoni Gual   12/1999    antonigual@eic.ictnet.es
'commented version            10/2003
'Ported to FB                  5/2005
'Adapted to FB0.17 by Luke Landriaut 11/2006
'removed multikey,floating point,unneeded byref parameters 
'added jpeg_dimension by Mj Mendoza IV 03/2009
'--------------------------------------------------------------------------
' to do 
' make it a library 
' better header parsing
' add support for progresive jpeg 
' make it smaller
'SUB DECLARES----------------------------------------------------------------
#include "lib\fbjpg\fbjpg.bi" '#include "jpeg4gfxlib.bi"


'DEFINT A-Z
CONST dc = 0, AC = 1              'indexs to huffman and quant tables
CONST false = 0, true = NOT false

'JPEG markers
'start of frames
CONST mk_sof0 = &HFFC0&
CONST mk_sof1 = &HFFC1&, mk_sof2 = &HFFC2&, mk_sof3 = &HFFC3&
CONST mk_sof5 = &HFFC5&, mk_sof6 = &HFFC6&, mk_sof7 = &HFFC7&
CONST mk_rsrvd = &HFFC8&
CONST mk_sof9 = &HFFC9&, mk_sofa = &HFFCA&, mk_sofb = &HFFCB&
CONST mk_sofd = &HFFCD&, mk_sofe = &HFFCE&, mk_soff = &HFFCF&

'tables and miscelaneous
CONST mk_tblhuff = &HFFC4&, mk_tblari = &HFFCC&
CONST mk_tblquan = &HFFDB&, mk_tbldri = &HFFDD&
CONST mk_com = &HFFFE&
CONST mk_app0 = &HFFE0&, mk_app1 = &HFFE1&, mk_app2 = &HFFE2, mk_app3 = &HFFE3
CONST mk_app4 = &HFFE4, mk_app5 = &HFFE5, mk_app6 = &HFFE6, mk_app7 = &HFFE7
CONST mk_app8 = &HFFE8, mk_app9 = &HFFE9, mk_appa = &HFFEA, mk_appb = &HFFEB
CONST mk_appc = &HFFEB, mk_appd = &HFFED, mk_appe = &HFFEE, mk_appf = &HFFEF&

'restarts
CONST mk_rst0 = &HFFD0&, mk_rst1 = &HFFD1, mk_rst2 = &HFFD2, mk_rst3 = &HFFD3
CONST mk_rst4 = &HFFD4, mk_rst5 = &HFFD5, mk_rst6 = &HFFD6, mk_rst7 = &HFFD7&

'headers
CONST mk_soi = &HFFD8&, mk_eoi = &HFFD9&
CONST mk_SOS = &HFFDA&, mk_dnl = &HFFDC&
CONST mk_dhp = &HFFDF6, mk_exp = &HFFDF&
CONST mk_dri = &HFFDD&
'reserved
CONST mk_jpg0 = &HFFF0, mk_jpg1 = &HFFF1, mk_jpg2 = &HFFF2, mk_jpg3 = &HFFF3
CONST mk_jpg4 = &HFFF4, mk_jpg5 = &HFFF5, mk_jpg6 = &HFFF6, mk_jpg7 = &HFFF7
CONST mk_jpg8 = &HFFF8, mk_jpg9 = &HFFF9, mk_jpga = &HFFFA, mk_jpgb = &HFFFB
CONST mk_jpgc = &HFFFB, mk_jpgd = &HFFFD

#define IS_A_SOF mk_sof0 to mk_sof3,mk_sof5 to mk_sof7,mk_sof9 to mk_sofb,mk_sofd to mk_soff
#define IS_A_APPn mk_app0 to mk_appF


'stores  the JPEG image parmeters
TYPE JpegType
  jfifmajor     AS integer   'version
  jfifMinor     AS integer
  densunits     AS integer        'density units and values (not used)
  Xdens         AS INTEGER
  ydens         AS INTEGER
  ThWidth       AS integer   'thumbnail size
  Theigth       AS integer
  pendbytes     as integer 
  rows          AS INTEGER      'jpeg height
  cols          AS INTEGER      'jpeg width
  samplesyx     AS INTEGER      'sampling ratios
  samplesyy     AS INTEGER      'sampling ratios
  samplescbcrx  AS INTEGER
  samplescbcry  AS INTEGER
  qty           AS INTEGER      'number of quantization tables
  qtcbr         AS INTEGER
  HDCTY         AS INTEGER      'number of huffman tables (DC and AC)
  HDCTCBR       AS INTEGER
  HaCTY         AS INTEGER
  HaCTcbr       AS INTEGER
  numcomp       AS INTEGER      'number of components
  restart       AS INTEGER      'blocks between restart marks
  size          AS LONG         'FILE SIZE
END TYPE

TYPE vesatype
 xres          AS INTEGER
 yres          AS INTEGER
 depth         as integer
END TYPE

'------------------------------------------------------------------------


'SHARED VARIABLES. 

'simple vars
DIM shared as integer jfile                     'file vars

dim shared as uinteger jpegmem
dim shared as ubyte ptr jpegmem_ptr
DIM shared AS INTEGER buf2_ptr
dim shared as uinteger buf2           'pointer to Huffman decoder secondary buffer

dim shared pbuff as ubyte ptr: const bsize=1023
redim  shared buff(0) as ubyte

'UDT


DIM shared vport AS vesatype
dim shared as integer inscan
DIM shared jpeg AS JpegType

'JPEG tables

' quantization
REDIM shared as integer quant(0, 0)
'huffman decoding
dim shared huffstart(15) as integer
const hufftblsize=761
reDIM shared as integer Hufftree(0) 'AS Huffmantreeentry

'dim shared buffer as any ptr

DIM shared as integer zz(0 TO 63) => {_
                              0,  1,  8, 16,  9,  2,  3, 10,_
                             17, 24, 32, 25, 18, 11,  4,  5,_
                             12, 19, 26, 33, 40, 48, 41, 34,_
                             27, 20, 13,  6,  7, 14, 21, 28,_
                             35, 42, 49, 56, 57, 50, 43, 36,_
                             29, 22, 15, 23, 30, 37, 44, 51,_
                             58, 59, 52, 45, 38, 31, 39, 46,_
                             53, 60, 61, 54, 47, 55, 62, 63}         
                          

'dim shared imgcomment
'dim shared marker, email

'used in huffman decoder
dim shared as uinteger ptr p1stbit,pmaskbits
dim shared as integer indx,mxind
 

'START------------------------------------------------------------------
private function GFxlibOn as integer
  if screenptr =0 then return err_nogfxlib
  screeninfo vport.xres,vport.yres,vport.depth
  if vport.depth<15 then return err_palmode
end function
'
'---------------------------------------------------------------------------
FUNCTION JPEGGetByte as integer
'used when decoding the headers (not critical), inscan turns on an off
'detection of pairs FF00 and it's conversion of FF
static as ubyte lb,b

lb=b
if jfile <> 0 then
   get #jfile,,b
else
   b = jpegmem_ptr[ jpegmem ]
   jpegmem += 1
end if
if inscan then
   if lb=255 and b=0 then
      if jfile <> 0 then
         get #jfile,,b
      else
         b = jpegmem_ptr[ jpegmem ]
         jpegmem += 1
      end if
   end if
end if
jpeg.pendbytes -=1
function=lb

END FUNCTION
'
'----------------------------------------------------------------------------
Function GetByteBuffered as integer
'using in decoding image scans (a speed critical part)
'detection of pairs FF00 and it's conversion of FF is made when bufferis filled  
static as integer i,j
dim as integer k
if indx>mxind then
  if jfile <> 0 then
      get #jfile,,buff()
  else
     for k = lbound(buff) to ubound(buff)
       buff(k) = jpegmem_ptr[ jpegmem ]
       jpegmem += 1
     next k
  end if
  indx=0
  mxind=bsize
  if pbuff[mxind]=&hff then
     mxind-=1
     if jfile <> 0 then
      seek jfile,seek(jfile)-1
     else
      jpegmem -= 1
     end if
  end if
  i=0 
  
   do 
    if pbuff[i]=&hFF then
      if pbuff[i+1]=0 then 
      for j=i+1 to mxind-1
        pbuff[j]=pbuff[j+1]
      next
      mxind-=1
      end if
    end if
    i+=1 
  loop until i>=mxind
  
end if  
function=pbuff[indx]:indx+=1
end function

'
'---------------------------------------------------------------------------
FUNCTION JPEGGetHuff (posini as integer) as integer
'Called by JpegGet8x8
'Gets bits from file until they match a Huffman table entry. When match
' found it returns the associated code.
'The table is in the form of a binary tree
dim as integer h_ptr =any ,i = any
  'shared Huftree(),buf2,buf2_ptr
  'init pointer to tree array
  h_ptr = huffstart(posini)
  
  'gather bits until we match a huffman pattern and read Huff code from tree
  DO
    'prepare mask the next bit in input buffer    
    if buf2_ptr=0 then buf2=getbytebuffered:buf2_ptr=8
     buf2_ptr -=1
    i=1 shl (buf2_ptr)
    
    'select side depending of next bit
    IF buf2 AND i THEN h_ptr+=1
    'read value in that side
    h_ptr = Hufftree(h_ptr)
       
  'if h_ptr<1 we have reached a tree leaf
  LOOP until h_ptr<1
  'return the code we read in the leaf 
  function = -h_ptr
END FUNCTION
'
'---------------------------------------------------------------------------
FUNCTION JPEGGetNBits (nbits as integer) as integer
'Called by JpegGet8x8
'Fetches nbits bits from the file, if first bit off it performs the "negation"
'required by Jpeg specs.
'#define bit3(x) (1 shl (x))-1
dim as integer GetNBits =any
  'fillbitbuffer 
  while buf2_ptr < nbits
      buf2 = (buf2 shl 8) or  GetBytebuffered  
      buf2_ptr += 8
  wend

  'get n bits.
  buf2_ptr = buf2_ptr - nbits
  GetNBits = buf2 shr buf2_ptr 
 
  'clip left ,then if msb is 0 negate and make negative (jpeg spec)
  IF GetNBits AND p1stbit[nbits] THEN 
    	function = GetNBits and pmaskbits[nbits] 
  ELSE 
      function = -(not GetNBits and pmaskbits[nbits])
  end if
END FUNCTION

'

'
'
'---------------------------------------------------------------------------
SUB JPEGGet8x8 (vector as integer ptr, comp as integer, byref dcCoef as integer) 
' Reads enough bits from JPEG file so Huffman decoder can build an 8X8 block
' Then reorders block based on zigzafg table, dequantizaes and IDCT
' transforms the block so the returned block is an ordered 8x8 Y, Cb or Cr
' component block
'
' Decoding of progressive jpegs would need saving all 8x8 blocks at the output
'  of the huffman decoder so they could be updated with the data from several
'  scans before zigzag-dequant-idct-display-ing them

' vector Returns a block
' comp tells us if it's a luminance(Y) or a chrominance component, as differnt
'  dequant-huffman tables must be used
' In dccoef we receive the dc component  from last block and return
'  the dc component of this block (dc component is coded incrementally)


'HUFFMAN DECODER-----------------------------------------------------------
' Reads enough bits from JPEG file to build an 8X8 block and de-zigzags it
' A block's coefficient is encoded as two variable length values:
'   an entry to a huffman table and the actual value.
' The entry to Huff table indexes a code made of 2 nibbles
'   codes 0 and 3270 have special meanings; for the rest
'   high nibble is an offset from the present position in the block
'   low nibble is nr of bits to retrieve for the value
'--------------------------------------------------------------------------
  'select correct  Huffman and dequant tables
dim as integer tx=any,dekode=any,nbits=any,k=any,thebits=any
'dim p as any ptr=any
  
  SELECT CASE as const comp
  CASE 1: tx = 0
  CASE 2: tx = 2
  CASE ELSE
    
  END SELECT
     
  'preset the complete vector to zeros
  for k=0 to 63:vector[k]=0:next 
 
  'The DC coefficient is incremental
  nbits = JPEGGetHuff(tx)
  dcCoef += JPEGGetNBits(nbits)
  vector[0] = dcCoef
       
  'AC Coefficients are calculated from scratch
  k = 1
  DO
    dekode = JPEGGetHuff(tx + 1)
    SELECT CASE as const dekode and &hff
    CASE 0 'EndOfBlock.Rest of vector is already padded with 0's 
      
  '    print #1, dekode, "eob"
      EXIT DO
    CASE 240 'ZeroRunLength encountered  240=15*16+0
   '   print #1, dekode, "zrl" 
      k = k + 16
    CASE ELSE 'a true coefficient follows
      'first nibble: index increment
      k += dekode shr 4
      'second nibble:nr of bits to fetch
      vector[zz(k)] =JPEGGetNBits(dekode AND 15) 
      k+=  1
    END SELECT
  LOOP UNTIL k > 63
end sub
'
'----------------------------------------------------------------------------
sub IDCT(vector as integer ptr,comp as integer)

'Dequantization and IDCT routines-----------------------------------------------

'The true IDCT is as follows:
'The 4 dimensional IDCT coefficients matrix
'DIM dct!(X,Y,U,V)
'FOR x = 0 TO 7           'Initialize our cosine table
' FOR y = 0 TO 7
'    FOR u = 0 TO 7
'     FOR v = 0 TO 7
'        t! = COS((2 * x + 1) * u * .1963495) * COS((2 * y + 1) * v * .1963495)
'        IF u = 0 THEN t! = t! * .707107
'        IF v = 0 THEN t! = t! * .707107
'        dct!(x, y, u, v) = t!
'     NEXT v
'    NEXT u
' NEXT y
'NEXT x
'
'IDCT calculation for a given vector: output in array2
'FOR x = 0 TO 7
'    FOR y = 0 TO 7
'        sum! = 0
'        FOR v = 0 TO 7
'            FOR u = 0 TO 7
'                temp! = vector(u, v)
'                IF temp! THEN temp! = temp! * dct!(x, y, u, v)
'                sum! = sum! + temp!
'            NEXT u
'        NEXT v
'        array2!(x, y) = sum!+128!
'   NEXT y
'NEXT x
'
'The actual method used there is ported from the C source examples by the
'independant JPEG group.It reduces greatly the number of operations needed 

'temporals for the IDCT routines
DIM z1 AS LONG, z2 AS LONG, z3 AS LONG, z4 AS LONG, z5 AS LONG
DIM z10 AS LONG, z11 AS LONG, z12 AS LONG, z13 AS LONG
DIM tmp0 AS LONG, tmp1 AS LONG, tmp2 AS LONG, tmp3 AS LONG
dIM tmp10 AS LONG, tmp11 AS LONG, tmp12 AS LONG, tmp13 AS LONG
dim as integer u,v,quantnum

dim as integer ptr ptr1,pqnt

'Inverse Discrete Cosinus Transform & dequantization using fixed point
'Loeffler,Ligtenberg and Moschytz algorythm  

#define descale12(a) ((a)+(1 shl 11)) shr 12
#define descale17(a) ((a)+(1 shl 16)) shr 17 

 CONST fix029 = 2446&
 CONST FIX039 = -3196&
 CONST FIX054 = 4433&
 CONST FIX076 = 6270&
 CONST FIX089 = -7373&
 CONST FIX117 = 9633&
 CONST fix150 = 12299&
 CONST FIX184 = -15137&
 CONST FIX196 = -16069&
 CONST fix205 = 16819&
 CONST FIX256 = -20995&
 CONST fix307 = 25172&

const idctw=8
       
select case comp
case 1 
  quantnum = jpeg.qty 
case 2 
 quantnum = jpeg.qtcbr
end select

'row calc
pqnt=@quant(quantnum,0)

ptr1=vector
'print pqnt
'print ptr1

FOR u = 0 TO 7
 'if all row zeros, short circuit row calc
 IF (ptr1[idctw*1] OR ptr1[idctw*2] OR ptr1[idctw*3] OR ptr1[idctw*4] OR ptr1[idctw*5] _
     OR ptr1[idctw*6] OR ptr1[idctw*7]) = 0 THEN
   tmp0 = ptr1[idctw*0] * pqnt[idctw*0] shl 1
   ptr1[idctw*0] = tmp0
   ptr1[idctw*1] = tmp0
   ptr1[idctw*2] = tmp0
   ptr1[idctw*3] = tmp0
   ptr1[idctw*4] = tmp0
   ptr1[idctw*5] = tmp0
   ptr1[idctw*6] = tmp0
   ptr1[idctw*7] = tmp0
 ELSE
 z2 = ptr1[idctw*2] * pqnt[idctw*2]
 z3 = ptr1[idctw*6] * pqnt[idctw*6]
 z1 = (z2 + z3) * FIX054
 tmp2 = z1 + (z3 * FIX184)
 tmp3 = z1 + (z2 * FIX076)
 z2 = ptr1[idctw*0] * pqnt[idctw*0]
 z3 = ptr1[idctw*4] * pqnt[idctw*4]
 tmp0 =  (z2 + z3) shl 13
 tmp1 =  (z2 - z3) shl 13
 tmp10 = tmp0 + tmp3
 tmp13 = tmp0 - tmp3
 tmp11 = tmp1 + tmp2
 tmp12 = tmp1 - tmp2
 tmp0 = ptr1[idctw*7] * pqnt[idctw*7]
 tmp1 = ptr1[idctw*5] * pqnt[idctw*5]
 tmp2 = ptr1[idctw*3] * pqnt[idctw*3]
 tmp3 = ptr1[idctw*1] * pqnt[idctw*1]
 z1 = tmp0 + tmp3
 z2 = tmp1 + tmp2
 z3 = tmp0 + tmp2
 z4 = tmp1 + tmp3
 z5 = (z3 + z4) * FIX117
 tmp0 *= fix029
 tmp1 *= fix205
 tmp2 *= fix307
 tmp3 *= fix150
 z1 *= FIX089
 z2 *= FIX256
 z3 *= FIX196
 z4 *= FIX039
 z3 += z5
 z4 += z5
 tmp0 += z1 + z3
 tmp1 += z2 + z4
 tmp2 += z2 + z3
 tmp3 += z1 + z4
 ptr1[idctw*0] = descale12(tmp10 + tmp3) 
 ptr1[idctw*7] = descale12(tmp10 - tmp3) 
 ptr1[idctw*1] = descale12(tmp11 + tmp2) 
 ptr1[idctw*6] = descale12(tmp11 - tmp2) 
 ptr1[idctw*2] = descale12(tmp12 + tmp1) 
 ptr1[idctw*5] = descale12(tmp12 - tmp1) 
 ptr1[idctw*3] = descale12(tmp13 + tmp0) 
 ptr1[idctw*4] = descale12(tmp13 - tmp0) 
 
END IF
ptr1+=1
pqnt+=1

NEXT

ptr1=vector
'column calcs
FOR v = 0 TO 7
 z2 = ptr1[ 2]
 z3 = ptr1[ 6]
 z1 = (z2 + z3) * FIX054
 tmp2 = z1 + (z3 * FIX184)
 tmp3 = z1 + (z2 * FIX076)
 tmp0 = (ptr1[ 0] + ptr1[ 4])shl 13
 tmp1 = (ptr1[ 0] - ptr1[ 4])shl 13
 tmp10 = tmp0 + tmp3
 tmp13 = tmp0 - tmp3
 tmp11 = tmp1 + tmp2
 tmp12 = tmp1 - tmp2
 tmp0 = ptr1[ 7]
 tmp1 = ptr1[ 5]
 tmp2 = ptr1[ 3]
 tmp3 = ptr1[ 1]
 z1 = tmp0 + tmp3
 z2 = tmp1 + tmp2
 z3 = tmp0 + tmp2
 z4 = tmp1 + tmp3
 z5 = (z3 + z4) * FIX117
 tmp0 *= fix029
 tmp1 *= fix205
 tmp2 *= fix307
 tmp3 *= fix150
 z1 *= FIX089
 z2 *= FIX256
 z3 *= FIX196
 z4 *= FIX039
 z3 +=  z5
 z4 +=  z5
 tmp0 += z1 + z3
 tmp1 += z2 + z4
 tmp2 += z2 + z3
 tmp3 += z1 + z4
 ptr1[ 0] = descale17(tmp10 + tmp3)
 ptr1[ 7] = descale17(tmp10 - tmp3)
 ptr1[ 1] = descale17(tmp11 + tmp2)
 ptr1[ 6] = descale17(tmp11 - tmp2)
 ptr1[ 2] = descale17(tmp12 + tmp1)
 ptr1[ 5] = descale17(tmp12 - tmp1)
 ptr1[ 3] = descale17(tmp13 + tmp0)
 ptr1[ 4] = descale17(tmp13 - tmp0)

 ptr1+=8  

NEXT

END SUB
'
'---------------------------------------------------------------------------
FUNCTION JPEGgetstr (num as integer) as string
  'gets an array of bytes from a JPEG file and returns them as a string
  if num=0 then function="":exit function
  dim as string a
  dim as integer i
  'print num
   a = SPACE(num)
  'I can't do a single GET as i'm using a buffered file access
  
  FOR i = 0 TO num-1
   a[i] = JPEGGetByte
  NEXT
  
  function=a
 
END FUNCTION
'
'---------------------------------------------------------------------------
FUNCTION JPEGGetWord as long
'gets a big endian word from the current position in file
dim as integer temp
temp = JPEGGetByte
function =  (temp  shl 8) + JPEGGetByte
END FUNCTION
'
'---------------------------------------------------------------------------
SUB JPEGMakeHuffTree(byref Actables as integer,byref Dctables as integer,byref tni as integer,byref tindx as integer)
'Called by JpegGetParams whenever it founds a Huffman table marker
'It reads Huffman table and converts it into a binary tree  
'the tree is formed by pairs of integers. The even element corresponds to
'a zero in the code, the right maps to a 1. If an element is negative it is
'an index to a branch. If the element is positive, it is a leaf and the value
'is a code.

dim as integer l0,c0,tc,th,i,s,x,_ptr,nxt,temp0,nxtfree,bitt
dim as long curnum
     'chunk size, counter
     jpeg.pendbytes = JPEGGetWord&-2
     'number of coefficients for each size
      REDIM as integer huffamount(1 TO 16)
      
      DO
      'read a table
      temp0 = JPEGGetByte
      tc = temp0 shr 4
      th = temp0 AND 15

      'read number of entries for each size
      FOR i = 1 TO 16
       huffamount(i) = JPEGGetByte
       'print huffamount (i), 
      NEXT i
      'create huffman tree in a single array

      'save start of this tree
      huffstart(th * 2 + tc) = tni
      nxtfree = tni+2
      curnum = 0
       
      FOR s = 1 TO 16               'for each length
       FOR x = 1 TO huffamount(s)   'for each tree entry   
       _ptr=tni
        'for each bit in entry
        FOR bitt =  (s - 1) TO 1 STEP -1
            'if bitt is 1
            IF curnum AND (1 shl bitt) THEN _ptr+=1
            nxt = Hufftree(_ptr)
            'next exists
            IF nxt>1 THEN
                _ptr = nxt
            'don't exist, create it
            ELSEif nxt=1 then
              Hufftree(_ptr) = nxtfree
              _ptr = nxtfree: nxtfree = nxtfree + 2
            else 
              print #1, "Huff tree redundancy"
              sleep
              stop
            END IF
        
        NEXT bitt
        IF (curnum and 1) then
          Hufftree(_ptr+1) = jpeggetbyte * -1
			else
		    Hufftree(_ptr) = jpeggetbyte * -1
		  end if
        curnum = curnum + 1
       NEXT x
       curnum = curnum * 2 
     next s
     IF tc THEN ACTAbles = ACTAbles + 1 ELSE DCtables = DCtables + 1
     
     tni = nxtfree
     tindx=tindx+1
   loop UNTIL jpeg.pendbytes=0   'for each table
   redim  huffamount(0)
   
END SUB

'
'---------------------------------------------------------------------------

sub JPEGGetParms (jpegsize as uinteger)
'
'Scans a JPEG to see if we are able to display it. If we are, get Huffman
'and quantization coefs
'When the first baseline start of frame is found, routine is exited
'
'This routine is very tolerant, it accept the different blocks in any order
' In fact a precise sequence should be enforced...
'
'Markers:----------------------------------------------------------------
'FFD8 Start of Image /FFD9 End Of image /FFDA Start of Scan
'
'START OF FRAME      DCT SINGLE   DCT DIFFE   ARITHMETICAL  ARITHMETICAL
'                     FRAME        RENTIAL    SINGLE FRAME  DIFFERENTIAL
'Baseline              FFC0                
'Extended sequential   FFC1         FFC5        FFC9          FFCD
'Progressive           FFC2         FFc6        FFCA          FFCE
'Lossless sequential   FFC3         FFC7        FFCB          FFCF
'
'FFC4 Huffman table  /FFCC Aritmetical table  /FFDB Dequantization table
'FFDC Define Nr of lines /FFDF Expand ref Components /FFDE Define hierarchical
'FFE0 - FFEF App segment /FFF0-FFFD Jpeg extension /FF01 to FFBF Reserved
'FFFE -Comment /  FF00 ==  byte FF
'FFDD -Define restart interval /FFD0 - FFD7 Restart marks  
'---------------------------------------------------------------------------
dim as integer e,i,temp4,temp0,temp1,temp2,id,ncomp,getsos,l0,c0
dim as string imgcomment,marker,d
dim as integer tni,tindx,ACTAbles, DCtables,qtables
redim as integer hufftree(0 to hufftblsize)
for i=0 to hufftblsize:hufftree(i)=1:next
REDIM quant(0 to 1,0 to 63) '2 quantization tables (Y, CbCr)
inscan=1
tni=0
tindx = 0:tni=0
if jfile <> 0 then
   jpeg.size = LOF(jfile)
else
   jpeg.size = jpegsize
end if
qtables = 0                            'Initialize some checkpoint variables
ACTAbles = 0
DCtables = 0
jpeg.restart = 0

marker = ""
DO                                      'Primary control loop for markers
  IF JPEGGetByte = 255 THEN             'Marker Found
   e = JPEGGetByte

'   marker = marker + CHR(d)
   '? "marker ";hex(d)
   SELECT CASE as const e                        'which one is it?
   
   CASE &HC0, &HC1                      'SOF0-1: Frame marker.Only baseline..
    'get frame attributes
    jpeg.pendbytes = JPEGGetWord&-2     'Length of segment
    temp0 = JPEGGetByte                 'Data precision
    IF temp0 <> 8 THEN return 
    jpeg.rows = JPEGGetWord&
    jpeg.cols = JPEGGetWord&
    ncomp = JPEGGetByte         'Number of components
    'get data for each image component (Y-CB-CR)
    FOR i = 1 TO ncomp
     id = JPEGGetByte
     SELECT CASE as const id
     CASE 1
      temp1 = JPEGGetByte
      jpeg.samplesyx = temp1 \ 16
      jpeg.samplesyy = temp1 AND 15
      jpeg.qty = JPEGGetByte
     CASE 2, 3
      temp1 = JPEGGetByte
      jpeg.samplescbcrx = temp1 \ 16
      jpeg.samplescbcry = temp1 AND 15
      jpeg.qtcbr = JPEGGetByte%
     CASE ELSE
        jpegerr=err_mt3comp:exit sub
     END SELECT
    NEXT i

   CASE &HC2:jpegerr= err_progframe:exit sub
    
   CASE &HC5 TO &HC7:jpegerr= err_diffframe:exit sub
  
   CASE &HC9 TO &HCF:jpegerr= err_arithcode:exit sub
  
   CASE &HC4                             'DHT:  Huffman tables
    IF ACTAbles < 2 OR DCtables < 2 THEN
      JPEGMakeHuffTree (Actables,Dctables,tni,tindx)
    ELSE
      jpegerr= err_mt2huff:exit sub
    END IF

   CASE &HD8 'SOI                        'Start of image.Should not be here
     jpegerr=err_soimispl:exit sub
  
   CASE &HD9 'EOI                        'END of image.(Should be the EOF)
     jpegerr=err_fnoframe:exit sub
   CASE &HDA 'SOS                        'start of scan.The true image
    'get scan header parameters 
    'print "scan header found"                             
    jpeg.pendbytes = JPEGGetWord&-2
    temp0 = JPEGGetByte
    IF temp0 <> 1 AND temp0 <> 3 THEN jpegerr= err_mt3comp:exit sub
    jpeg.numcomp = temp0
    FOR i = 1 TO temp0
     temp1 = JPEGGetByte
     SELECT CASE as const temp1
     CASE 1
      temp2 = JPEGGetByte
      jpeg.HaCTY = temp2 AND 15
      jpeg.HDCTY = temp2 \ 16
     CASE 2, 3
      temp2 = JPEGGetByte
      jpeg.HaCTcbr = temp2 AND 15
      jpeg.HDCTCBR = temp2 \ 16
     CASE ELSE
       jpegerr= err_mt3comp:exit sub
     END SELECT
    NEXT i

    d = JPEGgetstr(3)

    IF (DCtables = 2 AND ACTAbles = 2 AND qtables = 2) OR jpeg.numcomp = 1 THEN
     'If we have all tables needed, exit and start displaying the image
     EXIT DO
    ELSE
     jpegerr=err_notalltbl:exit sub 

    END IF
  
   CASE &HDD                          'DRI: Define restart interval
    jpeg.pendbytes = JPEGGetWord&-2                  'some images have synch marks embedded..
    jpeg.restart = JPEGGetWord&           'we must skip them

   CASE &HDB                          'DQT: A quantization table. Read it
    IF qtables < 2 THEN
      jpeg.pendbytes = JPEGGetWord&-2
      c0 = 2
      DO
       temp0 = JPEGGetByte
       IF temp0 AND &HF0 THEN jpegerr= err_quantprec:exit sub
       temp0 = temp0 AND 15
       FOR i = 0 TO 63
         quant(temp0, zz(i)) = JPEGGetByte
       NEXT i
       qtables = qtables + 1
      LOOP UNTIL jpeg.pendbytes=0
    ELSE
     jpegerr=err_mt2qtbl:exit sub
    END IF
   CASE &HE0                          'APP0- application specific data
    jpeg.pendbytes = JPEGGetWord& -2   'We are only interested in JFIF block
    IF left(JPEGgetstr(5),4) <> ("JFIF") THEN jpegerr= err_a0notjfif:exit sub
    
    'jpeggetbyte
    jpeg.jfifmajor = JPEGGetByte
    jpeg.jfifMinor = JPEGGetByte
    jpeg.densunits = JPEGGetByte
    jpeg.Xdens = JPEGGetWord&
    jpeg.ydens = JPEGGetWord&
    jpeg.ThWidth = JPEGGetByte
    jpeg.Theigth = JPEGGetByte
  
   CASE &HFE                          'COM a comment. Just read it
    imgcomment = JPEGgetstr(JPEGGetWord& - 2)
  
   CASE &HE1 TO &HEF                  'APP1 to AP15  marker. Just skip it
     inscan=0
     d = JPEGgetstr(JPEGGetWord& - 2)
     inscan=1
   CASE ELSE
      jpegerr=err_markunk:exit sub
   END SELECT
  END IF
  'IF multikey(1) THEN jpegerr=err_escpress:exit sub
  
LOOP

'return 1 if succesful


END sub
'
'---------------------------------------------------------------------------

Function YCrCb2RGB(Y as integer,cr as integer,cb as integer) as integer
  'convert Y-CR-Cb to rgb
  static as integer i,yy, r_g_b(2)
  yy=1000*y
  r_g_b(0)= (yy+1402*Cr)\1000
  r_g_b(1)= (yy-344*cb-714*cr)\1000
  r_g_b(2)= (yy+1772*cb)\1000 
  
  for i = 0 to 2
   
     if r_g_b(i)>255 then 
        r_g_b(i)=255
     elseif r_g_b(i)<0 then 
        r_g_b(i)=0
     end if
   
  next i
  return rgb(r_g_b(0), r_g_b(1), r_g_b(2))
end function
'
'---------------------------------------------------------------------------
FUNCTION JPEGRenderColor (x0 as integer, y0 as integer,rndrbuff as any ptr) as integer
'JPEGGetParams exits when  a SOF marker is found.Then the main loop sets a
' SVGA mode and this routine (or the mono one) is called.

'JPEGRenderColor calls decoder for each block, combines them and sends pixels to
' screen. It skips Restart markers,checks for screen boundaries,selects
' svga banks and draw pixels.
' If an image mcu is outside the top, left or right boundaries of the
' screen, its blocks are just Huffman decoded, IDCT is skipped. viw flag
' controls it. When the bottom of the screen is reached, decoding is just
' stopped.

'shared vport AS vportblock
'shared buf2_ptr AS INTEGER, viw AS INTEGER
'shared jpeg AS JpegType

'shared rcrv(), gcbv(), gcrv(), bcbv()
'shared _rgb() AS INTEGER


'vectors save the 8x8 blocks returned bu JPEGGet8x8, to be combined in an
' image mcu

dim as integer dcY,dcCb,dcCr,xindex,yindex,mcu,xinc,yinc,nsy,xrend,yrend,xi0,yi,ylim
dim as integer xi,xlim,y2,j2,yyy,viw,yput
dim prgb as uinteger ptr
dim as integer ptr vector, yvector,cbvector,crvector

yvector=allocate (64*4*4)                     
cbvector=allocate (64*4)
crvector=allocate (64*4)  

  'We initialize the dc coefficients for each component
  'at start and at each restart mark: they are cumulative
 
  dcY = 0: dcCb = 0: dcCr = 0
  'indexes to the image
  xindex = 0: yindex = 0
  'huffman decoder buffer _ptr
  buf2_ptr = 0
  'mcu counter. Used only if restart marks present
  mcu = 0
  'print x0,y0
  'set parameters for 2x2. 2x1, 1x2 ,1x1 files
  xinc=jpeg.samplesyx*8
  yinc=jpeg.samplesyy*8
  nsy=jpeg.samplesyx*jpeg.samplesyy
  
  'prepere an output buffer
  'prgb=ImageCreate(16,16,,32)
  prgb=allocate(8*8*4+4)
  prgb[0]=(8 shl 3) or (8 shl 16) 'we will pset in 16x16 blocks
 
  'rendering loop
  DO                                     'for each mcu
    'check if present mcu  is fully off screen limits,set viw flag
    'if so we will only partially decode it and will not try to display it
    viw = -1
    xi0 = xindex + x0
    IF (xi0 >= vport.xres) or (xi0+8 < 0) or((yindex + y0+8) < 0) then viw=0
             
    'get next blocks from decoder
     vector=yvector  
     for y As Integer =1 to nsy
       JPEGGet8x8 Vector, 1, dcY
       vector+=64 
      next
       
    JPEGGet8x8 CbVector, 2, dcCb
    JPEGGet8x8 CrVector, 2, dcCr
      
    
    IF viw THEN 'display the image mcu
      'perform idct's 	    
	    vector=yvector 
	    for y As Integer =1 to nsy
	     idct Vector, 1
       vector+=64 
      next
	    idct Cbvector,2 
       idct Crvector,2

      'combine components, do colorspace transform write to PUT buffer, then PUT it to out buffer
      dim as integer xii,yii,xc,yc 
      vector=yvector
      xi=x0+xindex
      yi=y0+yindex
      for x As integer=0 to jpeg.samplesyy-1
       yii=8*(x) 
       for x1 As Integer =0 to jpeg.samplesyx-1
        xii=8*(x1)    
        
        for y1 As Integer =0 to 7
        	For y2 As Integer= 0 To 7 
          yc= y1\jpeg.samplesyx+xii\2+8*(y2\jpeg.samplesyy+yii\2)
          Dim As integer y= y1+8*y2 
          prgb[y+1]=YCrCb2RGB(vector[y]+128,crvector[yc],cbvector[yc])
        	Next
        next	
       put rndrbuff,(xi+xii,yi+yii),prgb,pset
       vector+=64
      next 
     next

    END IF                             'if mcu must be displayed
           
    'if image has restart marks, keep counting nr of elements (mcu)
    IF jpeg.restart THEN
       mcu = mcu + 1
       'if restart interval reached skip restart mark and reset DC components
       IF jpeg.restart = mcu THEN
        buf2_ptr = 0:getbytebuffered:getbytebuffered
        dcY = 0: dcCb = 0: dcCr = 0: mcu = 0
       END IF
    END IF
             
    'move right the graphics cursor to next mcu
    xindex = xindex + xinc
    IF jpeg.cols - xindex < xinc THEN
      xrend = jpeg.cols - xindex - 1
    ELSE
     xrend = xinc - 1
    END IF
    ' 
    'if right side of image reached, go for next mcu row of mcu's
    IF xindex >= jpeg.cols THEN
      xindex = 0: xrend = xinc - 1
      yindex = yindex + yinc
      IF jpeg.rows - yindex < yinc THEN
        yrend = jpeg.rows - yindex - 1
      ELSE
       yrend = yinc - 1
      END IF
      
    END IF
           
    'stop if no more mcu's or bottom of  screen reached
  LOOP UNTIL yindex >= jpeg.rows OR yindex + y0 >= vport.yres
 
  'kindly free memory for other uses
  deallocate (yvector)
  deallocate (crvector)
  deallocate (cbvector)
  deallocate (prgb)
  return 0
END FUNCTION
'
'---------------------------------------------------------------------------
FUNCTION JPEGRenderMono (x0 as integer, y0 as integer,rndrbuff as any ptr) as integer

  'monochrome jpeg. This is easy, we have only the Y component, Image elements
  'are 8X8, the same as blocks

'vectors save the 8x8 blocks returned bu JPEGGet8x8, to be combined in an
' image mcu

dim as integer dcy,xindex,yindex,xi0,y,x,xj,yi,yyy,xlim,ylim,xrend,yrend,viw,mcu,yput
dim as uinteger ptr prgb
dim as integer ptr Yvector1
  yvector1=allocate (64*4)

  'We initialize the dc coefficients for each component
  'at start and at each restart mark: they are cumulative

  prgb=allocate(64*4+4):prgb[0]=(8 shl 3) or (8 shl 16)
  dcY = 0 
  xindex = 0: yindex = 0
  buf2_ptr = 0
  mcu = 0
  xlim = vport.xres - x0
  ylim = vport.yres - y0
  xrend = 7: yrend = 7
DO
  'check if present mcu  is fully off screen limits,set viw flag
  'if so we will only partially decode it and will not try to display it
  viw = -1
  xi0 = xindex + x0
  IF (xi0 >= vport.xres) or (xi0 < 0) or((yindex + y0) < 0) then viw=0
  
  'go decode a block
  JPEGGet8x8 YVector1, 1, dcY
 

  'If block must be viewed, display it
  IF viw THEN
     idct yvector1,1  
    'for each line
       FOR y = 0 TO 63
        yyy=yvector1[y]+128
        'clamp the value   
        IF yyy < 0 THEN
          yyy = 0
        ELSEIF y > 255 THEN
          yyy = 255
        END IF
        prgb[y+1] =(yyy shl 16) or  (yyy shl 8) or yyy
    NEXT y    'next line
   'display mcu
    put rndrbuff,(xindex+x0,yindex+y0),prgb,pset   
    
  END IF      'mcu was to be displayed
    
  'if image has restart marks, keep counting nr of elements
  'if restart interval reached skip restart mark and reset DC components
    IF jpeg.restart THEN
       mcu = mcu + 1:
       IF jpeg.restart = mcu THEN
        buf2_ptr = 0:getbytebuffered:getbytebuffered
        dcY = 0: mcu = 0
       END IF
    END IF
    
    'move right the graphics cursor to next mcu
    xindex = xindex + 8
    IF jpeg.cols - xindex < 8 THEN
      xrend = jpeg.cols - xindex - 1
    ELSE
     xrend = 7
    END IF
    'if right side of image reached, go for next mcu row of mcu's
    IF xindex >= jpeg.cols THEN
      xindex = 0: xrend = 7
      yindex = yindex + 8
      IF jpeg.rows - yindex < 8 THEN
        yrend = jpeg.rows - yindex - 1
      ELSE
       yrend = 7
      END IF
      'return -1 if escaped
      'IF multikey(1) THEN
      '	JPEGRenderMono = -1
      '	EXIT DO
      'end if
    END IF
'if at bottom of the image or screen, stop decoding
LOOP UNTIL yindex >= jpeg.rows OR yindex + y0 >= vport.yres
'be kind and free memory for other uses
 
'ERASE YVector1
deallocate (prgb):deallocate (yvector1)
 return 0
END FUNCTION
'
'------------------------------------------------------------------------
sub renderjpeg(x0 as integer,y0 as integer,rndrbuff as any ptr)
  'decodes a scan and displays the image
  indx=mxind+1
  'init fast buffered file reading and aux bit buffer
  buf2_ptr = -1
  redim  buff(bsize) as ubyte
  pbuff=@buff(0)
  'undo the byte pre-fetch used in Getparams
  if jfile <> 0 then
    seek jfile,seek(jfile)-1
  else
    jpegmem -= 1
  end if
  
  'init tables for GetNbits
  dim as integer i,temp
  p1stbit=allocate(16*4)
  pmaskbits=allocate(16*4)
  FOR i = 0 TO 15:
      temp = 1 shl i 
      pmaskbits[i] = temp - 1
      p1stbit[i] = temp shr 1
  NEXT
  '
  'go for it...................
  SELECT CASE as const jpeg.numcomp
  CASE 3: JPEGRenderColor( x0, y0,rndrbuff)
  CASE 1: JPEGRenderMono( x0, y0,rndrbuff)
  END SELECT
  
  redim Hufftree(0), buff(0),quant(0,0)
  deallocate (p1stbit)
  deallocate(pmaskbits)
end sub
'
'-----------------------------------------------------------------------
function printerror() as string
  select case as const jpegerr 
  case err_ok       : function="File succesfully read"
  case err_escpress : function="Escape pressed while decoding" 
  case err_nogfxlib : function="You Need to set a  SCREEN mod in GfxLib before using jpeg4fb"
  case err_palmode  : function="Can't work in paletted modes...yet"
  case err_nofile   : function="Requires a jpeg file name"
  'case err_nofile   : function="Could not open file"
  case err_fnotexist: function="File does not exist" 
  case err_fnojpeg  : function="Not a jpeg file"
  case err_fnoframe : function="Can't find a frame in the file"   
  case err_progframe: function="Can't decode a progressive frame"
  case err_diffframe: function="Can't decode a differential frame"
  case err_arithcode: function="Can't read arithmetical encoded jpegs"
  case err_quantprec: function="Quantization table is not 8 bit precission"
  case err_mt2huff  : function="More than 2 huffman tables per component"
  case err_soimispl : function="Misplaced start of image marker"
  case err_smplsz   : function="Sample size is not 8 x 8" 
'  case err_smplsz   : function="More than 3 components"
  case err_notalltbl: function="Not all tables read before first scan" 
  case err_mt2qtbl  : function="Can't handle more than 2 quantization tables"
  case err_a0notjfif: function="Incorrect jfif header"
  case err_markunk  : function="Unknown marker found"
  case err_putbuff  : function="Can't create the put buffer"
  case err_scrbuff  : function="Can't get the screen buffer"
  case else         : function="Unknown error "+str(jpegerr)
  end select
end function
'
'
'---------------------------------------------------------------------------------

private function openfile(jpg_file as string) as integer 'opens file and checks for the jpeg header
  if jpg_file="" then return err_nofile 
	if asc(jpg_file)=34 then jpg_file=mid(jpg_file,2,len(jpg_file)-2)
	jfile = FREEFILE
	if OPEN (jpg_file FOR BINARY AS #jfile) then return err_fnotfound
	if lof(jfile)=0 then close jfile:kill jpg_file:return err_fnotexist
	jpeggetbyte      'to feed the read-ahead buffer
	'check for JPEG SOI marker at start
	IF JPEGGetWord <> &HFFD8& THEN return err_fnojpeg
end function
'
'-------------------------------------------------------------------------------
function jpegget(jpg_file as string,x1 as integer=-1,y1 as integer=-1,x2 as integer=-1,y2 as integer=-1) as any ptr 'buffer returns with a jpeg in it
  jpegerr=0 
  gfxlibon:if jpegerr then return 0
  openfile(jpg_file):if jpegerr then return 0
  JPEGGetParms(0):if jpegerr then CLOSE #jfile: return 0
  if x2>jpeg.cols then x2=jpeg.cols
  if y2>jpeg.rows then y2=jpeg.rows
  if x1<0 then x1=0:x2=jpeg.cols
  if y1<0 then y1=0:y2=jpeg.rows
  if x1>jpeg.cols or y1>jpeg.rows or x2<0 or y2<0 THEN jpegerr =err_getoutl:return 0
  vport.xres=x2-x1+1
  vport.yres=y2-y1+1
  dim rndrbuff as any ptr = imagecreate(vport.xres,vport.yres) 
  if rndrbuff=0 then jpegerr= err_putbuff:return 0
  renderjpeg(-x1,-y1,rndrbuff):if jpegerr then CLOSE #jfile:return 0 
  CLOSE #jfile
  function =rndrbuff
end function

'
'------------------------------------------------------------------------------
Function jpeg_dimensions(jpg_file As String, ByRef wid As Integer, ByRef hgt As Integer) As Integer
	Dim As Integer jpegerr = 0
	gfxlibon:if jpegerr then return 0
	openfile(jpg_file):if jpegerr then return 0
	JPEGGetParms(0)
		if jpegerr then CLOSE #jfile: return 0
	wid = jpeg.cols
	hgt = jpeg.rows
End Function

'
'------------------------------------------------------------------------------
function jpeggetmem(jpegptr as ubyte ptr,jpegsize as uinteger, x1 as integer=-1,y1 as integer=-1,x2 as integer=-1,y2 as integer=-1) as any ptr 'buffer returns with a jpeg in it
   jpegerr=0
   jpegmem=0
   jfile = 0
   gfxlibon:if jpegerr then return 0
   jpegmem_ptr = jpegptr
   jpegmem += 3  'eww.. :P
   JPEGGetParms( jpegsize ): if jpegerr then return 0
   if x2>jpeg.cols then x2=jpeg.cols
   if y2>jpeg.rows then y2=jpeg.rows
   if x1<0 then x1=0:x2=jpeg.cols
   if y1<0 then y1=0:y2=jpeg.rows
   if x1>jpeg.cols or y1>jpeg.rows or x2<0 or y2<0 THEN jpegerr =err_getoutl:return 0
   vport.xres=x2-x1+1
   vport.yres=y2-y1+1
   dim rndrbuff as any ptr = imagecreate(vport.xres,vport.yres)
   if rndrbuff=0 then jpegerr= err_putbuff:return 0
   renderjpeg(-x1,-y1,rndrbuff):if jpegerr then return 0
   function = rndrbuff
end function
'------------------------------------------------------------------------------

sub jpeg2screen(jpg_file as string,x0 as integer=jpg_center,y0 as integer=jpg_center,x1 as integer=0,y1 as integer=0,x2 as integer=-1,y2 as integer=-1)

dim rndrbuff as any ptr
   jpegerr=0
   gfxlibon:if jpegerr then exit sub
  openfile(jpg_file):if jpegerr then exit sub
 
  JPEGGetParms(0): if jpegerr then CLOSE #jfile:exit sub

     if x2=-1 then x2=vport.yres
     if y2=-1 then y2=vport.yres
       
     if y0=jpg_center then y0 =((vport.yres - jpeg.rows) \ 2) and &hfffffff0
     if x0=jpg_center then x0 =((vport.xres - jpeg.cols) \ 2) and &hfffffff0
      
     'print x0,y0,jfile,vport.xres,vport.yres,jpeg.cols,jpeg.rows
     rndrbuff=0 'screenptr
     'if rndrbuff=0 then jpegerr=err_scrbuff:exit sub
     screenlock 
     renderjpeg(x0,y0,rndrbuff)
     screenunlock   
     if jpegerr then CLOSE #jfile:exit sub
CLOSE #jfile
end sub
'
'
'------------------------------------------------------------------------------
sub getframesize(jpg_file as string,sizex as integer,sizey as integer,components as integer,fmt as integer)
  'gets size, components format from the first frame found (not in an APP segment) 
	'skip markers up to frame marker
  dim as integer n,i
  dim as string d
  openfile(jpg_file)
   
  do until eof(jfile) 
    n=JpeggetWord()
    select case as const n
    'no FF-00 removal here 
	  case mk_app0 to mk_appf,mk_com:
      inscan=false
      d=JPEGgetstr(JPEGGetWord() - 2)
 
			'skip ()
      inscan=true
    'we found the marker we were searching for 
		case IS_A_SOF
      exit do
    'skip everything else 
    case else 'skip( )
    d=JPEGgetstr(JPEGGetWord() - 2)

	  end select    
	loop
  if eof(jfile) then close jfile:jpegerr= err_fnoframe :exit sub
  'we are now at a frame marker
  'skip chunk length
	jpeggetword() 
	'skip data item precission
  jpeggetbyte
  'we reached it!
	sizey=jpeggetword()
	sizex=jpeggetword()
	components=jpeggetbyte
	fmt=n and &hff
	'print hex(sizex), sizey,components,fmt
  close  jfile
END sub
'----------------------------------------------------------------------