@ECHO off
cls
title Quixie Builder
ECHO Make sure FreeBASIC 0.20 is installed
ECHO and path to FBC is added to PATH
ECHO NOTE: FBC 0.21 isn't compatible
ECHO.
IF "%1"=="" GOTO MENU
IF "%1"=="help" GOTO HELP_MAKE
IF "%1"=="1" GOTO MAKE_QUIXIE
IF "%1"=="2" GOTO MAKE_QUIXIE_DEBUG
IF "%1"=="3" GOTO MAKE_QUIXIE_CAIRO
IF "%1"=="4" GOTO MAKE_QUIXIE_CAIRO_DEBUG
IF "%1"=="5" GOTO MAKE_QUIXIE_MYSQL
IF "%1"=="6" GOTO EOF
IF "%1"=="quixie" GOTO MAKE_QUIXIE
IF "%1"=="debug" GOTO MAKE_QUIXIE_DEBUG
IF "%1"=="cairo" GOTO MAKE_QUIXIE_CAIRO
IF "%1"=="cairod" GOTO MAKE_QUIXIE_CAIRO_DEBUG
IF "%1"=="mysql" GOTO MAKE_QUIXIE_MYSQL
PAUSE
GOTO MENU

:HELP_MAKE
ECHO Usage: make [flag]
ECHO   flags:
ECHO       quixie  compile Quixie in Release mode
ECHO       debug   compile Quixie in Debug mode
ECHO       cairo   compile Quixie with Cairo in Release mode
ECHO       cairod  compile Quixie with Cairo in Debug mode
ECHO       mysql   compile Quixie with MySQL in Release mode
GOTO EXIT_MAKE


:MENU
ECHO ------------------------------
ECHO Choose from the following...
ECHO ------------------------------
ECHO.
ECHO 1 - Compile in Release mode
ECHO 2 - Compile in Debug mode
ECHO 3 - Compile with Cairo in Release mode
ECHO 4 - Compile with Cairo in Debug mode
ECHO 5 - Compile with MySQL in Release mode
ECHO 6 - Exit
ECHO.
SET /P M=Type 1, 2, 3, 4, 5, or 6, then press ENTER: 

IF %M%==6 GOTO EOF
ECHO ------------------------------
ECHO Creating version.bi...
ECHO ------------------------------
quixie version.ks

IF %M%==1 GOTO MAKE_QUIXIE
IF %M%==2 GOTO MAKE_QUIXIE_DEBUG
IF %M%==3 GOTO MAKE_QUIXIE_CAIRO
IF %M%==4 GOTO MAKE_QUIXIE_CAIRO_DEBUG
IF %M%==5 GOTO MAKE_QUIXIE_MYSQL

:MAKE_QUIXIE
ECHO Compiling Quixie in Release mode. Please wait...
ECHO ------------------------------
fbc -s gui -w 1 "kage.bas" -mt "lib\fbjpg\jpeg4fb.bas" "kage.rc" -x "quixie.exe" -d QUIXIE_GAMEENGINE
GOTO CHECK_COMPILE

:MAKE_QUIXIE_DEBUG
ECHO Compiling Quixie in Debug mode. Please wait...
ECHO ------------------------------
REM fbc -g -w pedantic -exx "kage.bas" -mt "lib\fbjpg\jpeg4fb.bas" "kage.rc" -x "quixied.exe" -d QUIXIE_GAMEENGINE -d QUIXIE_DEBUG
fbc -s console -g -w 1 -exx "kage.bas" -mt "lib\fbjpg\jpeg4fb.bas" "kage.rc" -x "quixied.exe" -d QUIXIE_GAMEENGINE -d QUIXIE_DEBUG
REM fbc -s console -g -w 1 "kage.bas" -mt "lib\fbjpg\jpeg4fb.bas" "kage.rc" -x "quixied.exe" -d QUIXIE_GAMEENGINE -d QUIXIE_DEBUG
GOTO CHECK_COMPILE

:MAKE_QUIXIE_CAIRO
ECHO Compiling Quixie Cairo in Release mode. Please wait...
ECHO ------------------------------
fbc -s gui -w 1 "kage.bas" -mt "lib\fbjpg\jpeg4fb.bas" "kage.rc" -x "quixie_cairo.exe" -d QUIXIE_GAMEENGINE -d QUIXIE_CAIRO
GOTO CHECK_COMPILE

:MAKE_QUIXIE_CAIRO_DEBUG
ECHO Compiling Quixie Cairo in Debug mode. Please wait...
ECHO ------------------------------
fbc -g -w 1 "kage.bas" -mt "lib\fbjpg\jpeg4fb.bas" "kage.rc" -x "quixie_cairod.exe" -d QUIXIE_GAMEENGINE -d QUIXIE_CAIRO -d QUIXIE_DEBUG

GOTO CHECK_COMPILE

:MAKE_QUIXIE_MYSQL
ECHO Compiling Quixie MySQL in Debug mode. Please wait...
ECHO ------------------------------
fbc -s gui -w 1 "kage.bas" -mt "lib\fbjpg\jpeg4fb.bas" "kage.rc" -x "quixie_mysql.exe" -d QUIXIE_GAMEENGINE -d QUIXIE_MYSQL

:CHECK_COMPILE
IF errorlevel==1 GOTO MAKE_FAIL

:okay
ECHO Compiling successfully done...
GOTO done

:MAKE_FAIL
ECHO Compiling failed...
GOTO done

:EOF
ECHO Exiting...

:done
ECHO ------------------------------
ECHO.

PAUSE
@ECHO on