//translated this 18.06.12 by mjmendozaIV
#include "../../kage.hpp"
#include "../../kageExterns.hpp"

unsigned long SynArray(unsigned long &iIndex) {
	iIndex = GetNearestTokenIndex(kseCOLON, "Array", iIndex);			  //look for	  :
	iIndex = GetNextIndex(iIndex);
	
	if (kseToken[iIndex].sToken == "New") {
		return ArrayNew(iIndex);						 //declare array
	
	} else if (kseToken[iIndex].sToken == "GetLength") {
		return ArrayGetLength(iIndex);					//return array value
	
	} else if (kseToken[iIndex].sToken == "Push") {
		return ArrayPush(iIndex);
	
	} else if (kseToken[iIndex].sToken == "Pop") {
		return ArrayPop(iIndex);
	
	} else {
		Engine_Message(KSE_GetErrFileSrc(iIndex) + "(  " + KSE_GetToken(iIndex) + "  ) is not in Array Class.", "SYNTAX ERROR AT LINE " + kseToken[iIndex].iLine);
		Engine_Exit();
	}
	return ULONG_MAX;
}

unsigned long ArrayNew(unsigned long &iIndex) {
	unsigned long iName;
	string sName;
	unsigned long iSize;
	unsigned long iSizeVal;
	unsigned long iType;
	string sType;
	string sChar;
	unsigned long i;
	bool bUDT;
	//syntax:
	//--------------
	// Array:New myArray[80]:Number
	//
	//CHECK SYNTAX ===================================================================
	iIndex = GetNextIndex(iIndex);
	iName = iIndex;
	
	++iIndex;										//move index to next
	if (kseToken[iIndex].sToken == kseOPEN_BRACKET) {
		iIndex = GetNextIndex(iIndex);
		iSize = iIndex;
		
		++iIndex;									//move index to next
		iIndex = LookFor(kseCLOSE_BRACKET, "Array Size parameter", iIndex); //look for	  ]
		++iIndex;									//move index to next
		if (kseToken[iIndex].sToken == kseCOLON) {
			++iIndex;								//move index to next
			iType = iIndex;
			
		} else {
			Engine_Message(KSE_GetErrFileSrc(iIndex) + "Expecting a (  :  ) before (  " + KSE_GetToken(iIndex) + "  ).", "SYNTAX ERROR AT LINE " + Str(kseToken[iIndex].iLine));
			Engine_Exit();
		}
	} else {
		Engine_Message(KSE_GetErrFileSrc(iIndex) + "Expecting an (  [  ) before (  " + KSE_GetToken(iIndex) + "  ).", "SYNTAX ERROR AT LINE " + Str(kseToken[iIndex].iLine));
		Engine_Exit();
	}
	//CHECK PARAMETER ==================================================================
	//get Name
	if (IsTokenDeclared(iName) == false) {
		
		sName = kseToken[iName].sToken;
		
		sChar = Left(sName, 1);
		
		if (IsNumeric(sChar) || fbIsAlpha(sChar) == false) {
			Engine_Message(KSE_GetErrFileSrc(iName) + "Expecting an (  Identifier  ) before (  " + KSE_GetToken(iName) + "  ).", "SYNTAX ERROR AT LINE " + Str(kseToken[iName].iLine));
			Engine_Exit();
		} else if (kseToken[iName].sToken == kseVARMARK
				|| kseToken[iName].sToken == kseVARSEPARATOR
				|| kseToken[iName].sToken == kseVALUESEP) {
			Engine_Message(KSE_GetErrFileSrc(iName) + "Unable to declare (  " + KSE_GetToken(iName) + "  ); it's an Engine constant.", "SYNTAX ERROR AT LINE " + Str(kseToken[iName].iLine));
			Engine_Exit();
		}
	} else {
		Engine_Message(KSE_GetErrFileSrc(iName) + "(  " + KSE_GetToken(iName) + "  ) is already declared.", "ERROR AT LINE " + kseToken[iName].iLine);
		Engine_Exit();
	}
	
	if (IsNumeric(kseToken[iSize].sToken)) {
		iSizeVal = Val(kseToken[iSize].sToken);
	} else if (IsTokenNum(iSize)) {
		iSizeVal = GetNumValue(iSize);
	} else if (IsTokenNum2(iSize)) {
		iSizeVal = GetNumValue2(iSize);
	} else {
		VarNotDeclared(KSE_GetToken(iSize), "Number", iSize);
	}
	
	//get Type
	//struct can only be Number/String/Byte
	if (kseToken[iType].sToken == "Number"
			|| kseToken[iType].sToken == "String"
			|| kseToken[iType].sToken == "Boolean" ) {
		sType = kseToken[iType].sToken;
	} else if (IsUDT(kseToken[iType].sToken)) {
		sType = kseToken[iType].sToken;
		bUDT = true;
	} else {
		Engine_Message(KSE_GetErrFileSrc(iType) + "Expecting (  Array type  ) before (  " + KSE_GetToken(iType) + "  ).", "SYNTAX ERROR AT LINE " + Str(kseToken[iType].iLine));
		Engine_Exit();
	}
	//EXECUTE SCRIPT ===================================================================
	//get avilable slot
	unsigned long iIdx = KSE_GetUDTIdx(kseToken[iType].sToken);
	for (i = 0; i < kseArray.size(); ++i) {
		
			if (kseArray[i].sName == "") {
				kseArray[i].iVal.clear();// = Callocate(iSizeVal,sizeof(Integer));
				//if (0 >= kseArray[i].iVal) { Engine_Log("unable to create Array", 1); exit(1); }
				kseArray[i].sName = sName;
				kseArray[i].sType = sType;
				kseArray[i].iSize = iSizeVal;// + 1
				kseArray[i].bUDT = bUDT;
				if (sType == "Number") {
					kseArray[i].iType = kseVALUE_ISTOKENNUM;
				} else if (sType == "String") {
					kseArray[i].iType = kseVALUE_ISTOKENSTR;
				} else if (sType == "Boolean") {
					kseArray[i].iType = kseVALUE_ISTOKENBOOL;
				} else if (bUDT == true) {
					kseArray[i].iType = kseVALUE_ISTOKENUDT;
				}
				//place several copies of variable separator based on Array Size less 1
				for (unsigned long ii = 0; ii < iSizeVal; ++ii) {
					kseArray[i].iVal.push_back(0);
					if (kseArray[i].iType == kseVALUE_ISTOKENNUM) {
						kseArray[i].iVal[ii] = KSE_DeclareNum(sName + "[" + Str(ii) + "]",      0, false, false, true);
					} else if (kseArray[i].iType == kseVALUE_ISTOKENSTR) {
						kseArray[i].iVal[ii] = KSE_DeclareStr(sName + "[" + Str(ii) + "]",     "", false, false, true);
					} else if (kseArray[i].iType == kseVALUE_ISTOKENBOOL) {
						kseArray[i].iVal[ii] = KSE_DeclareBool(sName + "[" + Str(ii) + "]", false, false, false, true);
					} else if (kseArray[i].iType == kseVALUE_ISTOKENUDT) {
						kseArray[i].iVal[ii] = KSE_DeclareUDT_Instance(iIdx, sName + "[" + Str(ii) + "]");
					}
				}
				break;
			}
		
	}
	if (i >= kseArray.size()) {
		Engine_Message(KSE_GetErrFileSrc(iName) + "Unable to declare (  " + KSE_GetToken(iName) + "  ) as Array.", "SYNTAX ERROR AT LINE " + kseToken[iName].iLine);
		Engine_Exit();
	}
	
	return iIndex;
}

unsigned long ArrayGetLength(unsigned long &iIndex) {
	unsigned long iName;
	unsigned long iRet;
	double iRetVal;
	//syntax:
	//--------------
	// Array:GetLength(myArray, myNumber)
	//
	//CHECK SYNTAX ===================================================================
	++iIndex;
	iIndex = LookFor(kseOPEN_PAREN, "GetLength", iIndex);
	
	iIndex = GetNextIndex(iIndex);
	iName = iIndex;
	
	iIndex = GetNearestTokenIndex(kseCOMMA, "Array Name", iIndex);
	
	iIndex = GetNextIndex(iIndex);
	iRet = iIndex;
	
	++iIndex;
	iIndex = LookFor(kseCLOSE_PAREN, "return parameter", iIndex);
	//CHECK PARAMETER ==================================================================
	//get array
	vector<string> ArrList;
	//get the name of the Array
	kSplit(kseToken[iName].sToken, kseMINUS_SIGN, ArrList);
	
	if (ArrList[0] == "A") {
		iRetVal = kseArray[Val(ArrList[1])].iSize;
	} else {
		Engine_Message(KSE_GetErrFileSrc(iName) + "(  " + KSE_GetToken(iName) + "  ) is not an Array.", "SYNTAX ERROR AT LINE " + kseToken[iName].iLine);
		Engine_Exit();
	}
	//EXECUTE SCRIPT ===================================================================
	SetNumValue(iRet, iRetVal);
	
	return iIndex;
}

double ArrGetNum(unsigned long &iIndex) {
//extracted and publicized from Priv Func ArrayGetNumber by 02.11.06 to be accessed by other function
	int iName;
	double iRetVal;
	unsigned long iIndVal;
	//get array
	vector<string> ArrList;
	//CHECK SYNTAX ===================================================================
	iName = iIndex;
	iIndex = GetNearestTokenIndex(kseOPEN_BRACKET, "Array Name", iIndex);
	
		iIndVal = KSE_GetTokenNumValueOf(iIndex, true);
	
	++iIndex;
	iIndex = LookFor(kseCLOSE_BRACKET, "Array Index", iIndex);
	//CHECK PARAMETER ==================================================================
	//get the name of the Array
	kSplit(kseToken[iName].sToken, kseMINUS_SIGN, ArrList);
	
	if (ArrList[0] == "A") {
		
			if (kseArray[Val(ArrList[1])].sType != "Number") {
				Engine_Message(KSE_GetErrFileSrc(iName) + "(  " + ArrList[2] + "  ) is not an Array of Number.", "LOGIC ERROR AT LINE " + kseToken[iName].iLine);
				Engine_Exit();
			}
			iRetVal = KSE_GetNum(ArrList[2] + "[" + Str(iIndVal) + "]");
		
	} else {
		Engine_Message(KSE_GetErrFileSrc(iName) + "(  " + KSE_GetToken(iName) + "  ) is not an Array.", "SYNTAX ERROR AT LINE " + kseToken[iName].iLine);
		Engine_Exit();
	}
	
	return iRetVal;
}

string ArrGetStr(unsigned long &iIndex) {
//extracted and publicized from Priv Func ArrayGetstring by 02.11.06 to be accessed by other function
	int iName;
	string sRetVal;
	unsigned long iIndVal;
	//get array
	vector<string> ArrList;
	
	//CHECK SYNTAX ===================================================================
	iName = iIndex;
	
	iIndex = GetNearestTokenIndex(kseOPEN_BRACKET, "Array Name", iIndex);
	
		iIndVal = KSE_GetTokenNumValueOf(iIndex, true);
	
	++iIndex;
	iIndex = LookFor(kseCLOSE_BRACKET, "Array Index", iIndex);
	//CHECK PARAMETER ==================================================================
	//get the name of the Array
	kSplit(kseToken[iName].sToken, kseMINUS_SIGN, ArrList);
	
	if (ArrList[0] == "A") {
		
			if (kseArray[CInt(ArrList[1])].sType != "String") {
				Engine_Message(KSE_GetErrFileSrc(iName) + "(  " + ArrList[2] + "  ) is not an Array of String.", "LOGIC ERROR AT LINE " + kseToken[iName].iLine);
				Engine_Exit();
			}
			sRetVal = KSE_GetStr(ArrList[2] + "[" + Str(iIndVal) + "]");
		
	} else {
		Engine_Message(KSE_GetErrFileSrc(iName) + "(  " + KSE_GetToken(iName) + "  ) is not an Array.", "SYNTAX ERROR AT LINE " + kseToken[iName].iLine);
		Engine_Exit();
	}
	
	return sRetVal;
}

bool ArrGetBool(unsigned long &iIndex) {
//extracted and publicized from Priv Func ArrayGetbool by 02.11.06 to be accessed by other function
	int iName;
	bool bRetVal;
	unsigned long iIndVal;
	//get array
	vector<string> ArrList;
	
	//CHECK SYNTAX ===================================================================
	iName = iIndex;
	
	iIndex = GetNearestTokenIndex(kseOPEN_BRACKET, "Array Name", iIndex);
	
		iIndVal = KSE_GetTokenNumValueOf(iIndex, true);
		
	++iIndex;
	iIndex = LookFor(kseCLOSE_BRACKET, "Array Index", iIndex);
	//CHECK PARAMETER ==================================================================
	//get the name of the Array
	kSplit(kseToken[iName].sToken, kseMINUS_SIGN, ArrList);
	
	if (ArrList[0] == "A") {
		
			if (kseArray[Val(ArrList[1])].sType != "Boolean") {
				Engine_Message(KSE_GetErrFileSrc(iName) + "(  " + ArrList[2] + "  ) is not an Array of Boolean.", "LOGIC ERROR AT LINE " + kseToken[iName].iLine);
			}
			if (KSE_GetBool(ArrList[2] + "[" + Str(iIndVal) + "]") > 0) {
				bRetVal = true;
			} else {
				bRetVal = false;
			}
		
	} else {
		Engine_Message(KSE_GetErrFileSrc(iName) + "(  " + KSE_GetToken(iName) + "  ) is not an Array.", "SYNTAX ERROR AT LINE " + kseToken[iName].iLine);
	}
	
	return bRetVal;
}

bool IsTokenArray(unsigned long &iIndex) {
//trace "IsTokenArray A " + iIndex
	vector<string> sArrName;
	//get the name of the variable
	kSplit(kseToken[iIndex].sToken, kseMINUS_SIGN, sArrName);
	if (sArrName.size() > 0 && sArrName[0] == "A") {
		return true; //it is an array
	}
	return false;
}

bool IsTokenArray2(unsigned long iIndex) {
	string sArrName = kseToken[iIndex].sToken;
	
	for (unsigned long i = 0; i < kseArray.size(); ++i) {
		if (kseArray[i].sName == sArrName) {
			return true;
		}
	}
	return false;
}

string GetArrayType(unsigned long &iIndex) {
	vector<string> sArrName;
	
	//get the name of the variable
	kSplit(kseToken[iIndex].sToken, kseMINUS_SIGN, sArrName);
	
	if (sArrName[0] == "A") {
		//get the name of the active function
		return kseArray[CInt(sArrName[1])].sType;
	}
	return "";
}

string ArrGetValue(unsigned long &iIndex) {
//for implicit taking of "whatever "array value --mjmendoza
	string arrType = GetArrayType(iIndex);
	if (arrType == "Number") {
		return Str(ArrGetNum(iIndex));
	} else if (arrType == "String") {
		return ArrGetStr(iIndex);
	} else if (arrType == "Boolean") {
		return Str(ArrGetBool(iIndex));
	} else if (IsUDT(arrType)) {
		return ArrGetUDT(iIndex, arrType);
	}
	return "";
}

////
// (<b>Dev API</b>) For implicit setting of value to a "whatever" array.
//
// @param	iIndex - Index of the parsed script
// @return	New index value of the parsed script.
// @remarks  Used by function, while, if and for statements.<br>
unsigned long DirectSetArray(unsigned long &iIndex) {
//	trace("DirectSetArray " + kseToken[iIndex].sToken);
//	unsigned long iName;
	string sVal;
	vector<string> sArr;
	string sPocket;
	unsigned long iIdx;
	
	kSplit(kseToken[iIndex].sToken, kseMINUS_SIGN, sArr);
	unsigned long iTmpIdx;
	unsigned long iTmpPocketIdx;
	iTmpIdx = Val(sArr[1]);
	
//			iName = iIndex;
		
		tmpIdx = iIndex;
			iIndex = GetNearestTokenIndex(kseOPEN_BRACKET, sArr[2], iIndex);
		kseToken[tmpIdx].lSkip = iIndex;
			//get index of array whose value is to be set
			iIdx = KSE_GetTokenNumValueOf(iIndex, true);
		
		tmpIdx = iIndex;
			iIndex = GetNearestTokenIndex(kseCLOSE_BRACKET, "array_index", iIndex);
		kseToken[tmpIdx].lSkip = iIndex;
		
		if (kseArray[iTmpIdx].bUDT == true) {
			tmpIdx = iIndex;
				iIndex = GetNearestTokenIndex(kseDOT, kseCLOSE_BRACKET, iIndex);
				++iIndex; //move to the very next token
			kseToken[tmpIdx].lSkip = iIndex;
			iTmpPocketIdx = iIndex;
			sPocket = kseToken[iIndex].sToken;
		}
		
		tmpIdx = iIndex;
			iIndex = GetNextIndex(iIndex);
			iIndex = LookFor(kseEQUAL_SIGN, "array_variable", iIndex);
		kseToken[tmpIdx].lSkip = iIndex;
		
		double nVal;
		if (kseArray[iTmpIdx].iType == kseVALUE_ISTOKENNUM) {
			nVal = GetVal(iIndex);
		} else if (kseArray[iTmpIdx].iType == kseVALUE_ISTOKENBOOL) {
			nVal = GetVal(iIndex);
			if (nVal != 0) { nVal = 1; }
		} else { //kseArray[iTmpIdx].sType = "String" or a UDT
			sVal = KSE_GetTokenStrValueOf(iIndex);
		}
		
		tmpIdx = iIndex;
			iIndex = GetNextIndex(iIndex);
			iIndex = LookFor(kseSEMICOLON, "array_value", iIndex);
		kseToken[tmpIdx].lSkip = iIndex;
		
		if (iIdx >= 0 && iIdx < kseArray[iTmpIdx].iSize) {
			if (kseArray[iTmpIdx].bUDT == true) {
				kseToken[iTmpPocketIdx].lPtr = KSE_SetUDTValue(kseArray[iTmpIdx].iVal[iIdx], sPocket, sVal);
			} else if (kseArray[iTmpIdx].iType == kseVALUE_ISTOKENNUM) {
				SetVarNumValue(kseArray[iTmpIdx].iVal[iIdx], nVal);
				//KSE_SetNum(sArr(2) + "[" + iIdx + "]", CDbl(sVal))
			} else if (kseArray[iTmpIdx].iType == kseVALUE_ISTOKENBOOL) {
				SetVarBoolValue(kseArray[iTmpIdx].iVal[iIdx], CBool(nVal));
				//KSE_SetBool(sArr(2) + "[" + iIdx + "]", CBool(sVal))
			} else if (kseArray[iTmpIdx].iType == kseVALUE_ISTOKENSTR) {
				SetVarStrValue(kseArray[iTmpIdx].iVal[iIdx], sVal);
				//KSE_SetStr(sArr(2) + "[" + iIdx + "]", sVal)
			}
		} else {
			Engine_Log("Warning: index " + Str(iIdx) + " is out of " + kseArray[iTmpIdx].sName + "'s range.");
		}
	return iIndex;
}

unsigned long JIO_DirectSetArray(unsigned long &iIndex) {
//	unsigned long iName;
	string sVal;
	string sPocket;
	unsigned long iIdx;
	unsigned long iTmpIdx;
	unsigned long iTmpPocketIdx;
	
	iTmpIdx = kseToken[iIndex].lPtr;
	
//			iName = iIndex;
		
		iIndex = kseToken[iIndex].lSkip;
			//get index of array whose value is to be set
			iIdx = KSE_GetTokenNumValueOf(iIndex, true);
		
		iIndex = kseToken[iIndex].lSkip;
		
		if (kseArray[iTmpIdx].bUDT == true) {
			iIndex = kseToken[iIndex].lSkip;
			iTmpPocketIdx = iIndex;
			sPocket = kseToken[iIndex].sToken;
		}
		
		iIndex = kseToken[iIndex].lSkip;
		
		double nVal;
		
		if (kseArray[iTmpIdx].iType == kseVALUE_ISTOKENNUM) {
			nVal = GetVal(iIndex);
		} else if (kseArray[iTmpIdx].iType == kseVALUE_ISTOKENBOOL) {
			nVal = GetVal(iIndex);
			if (nVal != 0) { nVal = 1; }
		} else if (kseArray[iTmpIdx].iType == kseVALUE_ISTOKENSTR) {
			sVal = KSE_GetTokenStrValueOf(iIndex);
		} else { //is it a UDT
			sVal = KSE_GetTokenStrValueOf(iIndex);
		}
		
		iIndex = kseToken[iIndex].lSkip;
		if (iIdx >= 0 && iIdx < kseArray[iTmpIdx].iSize) {
			if (kseArray[iTmpIdx].bUDT == true) {
				JIO_KSE_SetUDTValue(kseArray[iTmpIdx].iVal[iIdx], kseToken[iTmpPocketIdx].lPtr, sVal);
			} else if (kseArray[iTmpIdx].iType == kseVALUE_ISTOKENNUM) {
				SetVarNumValue(kseArray[iTmpIdx].iVal[iIdx], nVal);
				//KSE_SetNum(sArr(2) + "[" + iIdx + "]", CDbl(sVal))
			} else if (kseArray[iTmpIdx].iType == kseVALUE_ISTOKENBOOL) {
				SetVarBoolValue(kseArray[iTmpIdx].iVal[iIdx], CBool(nVal));
				//KSE_SetBool(sArr(2) + "[" + iIdx + "]", CBool(sVal))
			} else if (kseArray[iTmpIdx].iType == kseVALUE_ISTOKENSTR) {
				SetVarStrValue(kseArray[iTmpIdx].iVal[iIdx], sVal);
				//KSE_SetStr(sArr(2) + "[" + iIdx + "]", sVal)
			}
		} else {
			Engine_Log("Warning: index " + Str(iIdx) + " is out of " + kseArray[iTmpIdx].sName + "'s range.");
		}
	return iIndex;
}

unsigned long KSE_GetUDT_InstanceIdX(string sUDTname) {
	for (unsigned long i = 0; i < kseUDT_Instance.size(); ++i) {
		if (kseUDT_Instance[i].sName == sUDTname) {
			return i;
		}
	}
	return -1;
}

string ArrGetUDT(unsigned long &iIndex, string udtName) {
	unsigned long iName;
	string uRetVal;
	unsigned long iIndVal;
	vector<string> udtVar;
	unsigned long udtIdx;
	string udtCompartment;
	
	//CHECK SYNTAX ===================================================================
	iName = iIndex;
	
	iIndex = GetNearestTokenIndex(kseOPEN_BRACKET, "Array Name", iIndex);
	
		iIndVal = KSE_GetTokenNumValueOf(iIndex, true);
	
	iIndex = GetNearestTokenIndex(kseCLOSE_BRACKET, "array_index", iIndex);
	
	iIndex = GetNearestTokenIndex(kseDOT, kseCLOSE_BRACKET, iIndex);
		
		++iIndex;
		udtCompartment = kseToken[iIndex].sToken;
	//CHECK PARAMETER ==================================================================
	kSplit(kseToken[iName].sToken, kseMINUS_SIGN, udtVar);
	if (udtVar[0] == "A" && udtVar.size() > 0) {
		udtIdx = KSE_GetUDT_InstanceIdX(udtVar[2] + "[" + Str(iIndVal) + "]");
		if (udtIdx >= 0) {
			uRetVal = KSE_GetUDTValue(udtIdx, udtCompartment);
		} else {
			Engine_Log("Warning: index " + Str(iIndVal) + " is out of " + udtVar[2] + "'s range.");
			uRetVal = "0";
		}
	}
	//get value in array index
	return uRetVal;
}

unsigned long ArrayPush(unsigned long &iIndex) {
	string sDataVal;
	unsigned long iArr;
	//syntax:
	//--------------
	// Array:Push(data, myArray)
	//
	//CHECK SYNTAX ===================================================================
	iIndex = GetNearestTokenIndex(kseOPEN_PAREN, "Push", iIndex);	//look for	  (
		
		sDataVal = KSE_GetTokenStrValueOf(iIndex);
	
	++iIndex;								 //move index to next
	iIndex = LookFor(kseCOMMA, "data", iIndex);	//look for	  ,
	
		iIndex = GetNextIndex(iIndex);
		iArr = iIndex;
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseCLOSE_PAREN, "array", iIndex); //look for	  )
	
	//EXECUTE SCRIPT ===================================================================
	vector<string> ArrList;
	kSplit(kseToken[iArr].sToken, kseMINUS_SIGN, ArrList);
	if (ArrList[0] == "A") {
		
			kseArray[Val(ArrList[1])].iVal.push_back(0);
			++kseArray[Val(ArrList[1])].iSize;
			int iNewIdx = kseArray[Val(ArrList[1])].iSize - 1;
			if (kseArray[Val(ArrList[1])].bUDT == true) {
				unsigned long iIdx = KSE_GetUDTIdx(kseArray[Val(ArrList[1])].sType);
				kseArray[Val(ArrList[1])].iVal[iNewIdx] = KSE_DeclareUDT_Instance(iIdx, kseArray[Val(ArrList[1])].sName + "[" + Str(iNewIdx) + "]");
				//TODO: copy UDT content to new UDT index
			} else {
				switch (kseArray[Val(ArrList[1])].iType) {
					case kseVALUE_ISTOKENNUM:
						kseArray[Val(ArrList[1])].iVal[iNewIdx] = KSE_DeclareNum(kseArray[Val(ArrList[1])].sName + "[" + Str(iNewIdx) + "]", CDbl(sDataVal));
						break;
					case kseVALUE_ISTOKENSTR:
						kseArray[Val(ArrList[1])].iVal[iNewIdx] = KSE_DeclareStr(kseArray[Val(ArrList[1])].sName + "[" + Str(iNewIdx) + "]", sDataVal);
						break;
					case kseVALUE_ISTOKENBOOL:
						kseArray[Val(ArrList[1])].iVal[iNewIdx] = KSE_DeclareBool(kseArray[Val(ArrList[1])].sName + "[" + Str(iNewIdx) + "]", (CDbl(sDataVal) > 0) ? true : false);
				}
			}
		
	} else {
		Engine_Message(KSE_GetErrFileSrc(iArr) + "(  " + KSE_GetToken(iArr) + "  ) is not an Array.", "LOGIC ERROR AT LINE " + kseToken[iArr].iLine);
		Engine_Exit();
	}
	
	return iIndex;
}

unsigned long ArrayPop(unsigned long  &iIndex) {
	string sDataVal;
	int iArr;
	//syntax:
	//--------------
	// Array:Pop(myArray)
	//
	//CHECK SYNTAX ===================================================================
	iIndex = GetNearestTokenIndex(kseOPEN_PAREN, "Pop", iIndex);	//look for	  (
	
		iIndex = GetNextIndex(iIndex);
		iArr = iIndex;
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseCLOSE_PAREN, "array", iIndex); //look for	  )
	
	//EXECUTE SCRIPT ===================================================================
	vector<string> ArrList;
	kSplit(kseToken[iArr].sToken, kseMINUS_SIGN, ArrList);
	if (ArrList[0] == "A") {
		
			--kseArray[Val(ArrList[1])].iSize;
			int iNewIdx = kseArray[Val(ArrList[1])].iSize;
			if (kseArray[Val(ArrList[1])].bUDT == true) {
//				int iIdx
//				iIdx = KSE_GetUDTIdx(kseArray[Val(ArrList[1])].sType);
//				//TODO: free all UDT content
			} else {
				switch (kseArray[Val(ArrList[1])].iType) {
					case kseVALUE_ISTOKENNUM:
						
							kseVarNum[kseArray[Val(ArrList[1])].iVal[iNewIdx]].sName = "";
							kseVarNum[kseArray[Val(ArrList[1])].iVal[iNewIdx]].nVal = 0;
							kseVarNum[kseArray[Val(ArrList[1])].iVal[iNewIdx]].bUsed = false;
							kseVarNum[kseArray[Val(ArrList[1])].iVal[iNewIdx]].sFunc = kseNULL_STRING;
							kseVarNum[kseArray[Val(ArrList[1])].iVal[iNewIdx]].lFunc = -1; //global
							kseVarNum[kseArray[Val(ArrList[1])].iVal[iNewIdx]].bReadOnly = 0;
							kseVarNum[kseArray[Val(ArrList[1])].iVal[iNewIdx]].bAppArg = false;
					//		kseVarNum[kseArray[Val(ArrList[1])].iVal[iNewIdx]].bProtect = bProtect;
						
						--iVarNumCtr;
						break;
					case kseVALUE_ISTOKENSTR:
						
							kseVarStr[kseArray[Val(ArrList[1])].iVal[iNewIdx]].sName = "";
							kseVarStr[kseArray[Val(ArrList[1])].iVal[iNewIdx]].sVal = "";
							kseVarStr[kseArray[Val(ArrList[1])].iVal[iNewIdx]].bUsed = false;
							kseVarStr[kseArray[Val(ArrList[1])].iVal[iNewIdx]].sFunc = kseNULL_STRING;
							kseVarStr[kseArray[Val(ArrList[1])].iVal[iNewIdx]].lFunc = -1; //global
							kseVarStr[kseArray[Val(ArrList[1])].iVal[iNewIdx]].bReadOnly = 0;
							kseVarStr[kseArray[Val(ArrList[1])].iVal[iNewIdx]].bAppArg = false;
					//		kseVarStr[kseArray[Val(ArrList[1])].iVal[iNewIdx]].bProtect = bProtect;
						
						--iVarStrCtr;
						break;
					case kseVALUE_ISTOKENBOOL:
						
							kseVarBool[kseArray[Val(ArrList[1])].iVal[iNewIdx]].sName = "";
							kseVarBool[kseArray[Val(ArrList[1])].iVal[iNewIdx]].bVal = 0;
							kseVarBool[kseArray[Val(ArrList[1])].iVal[iNewIdx]].bUsed = false;
							kseVarBool[kseArray[Val(ArrList[1])].iVal[iNewIdx]].sFunc = kseNULL_STRING;
							kseVarBool[kseArray[Val(ArrList[1])].iVal[iNewIdx]].lFunc = -1; //global
							kseVarBool[kseArray[Val(ArrList[1])].iVal[iNewIdx]].bReadOnly = 0;
							kseVarBool[kseArray[Val(ArrList[1])].iVal[iNewIdx]].bAppArg = false;
					//		kseVarBool[kseArray[Val(ArrList[1])].iVal[iNewIdx]].bProtect = bProtect;
						
						--iVarBoolCtr;
				}
			}
			kseArray[Val(ArrList[1])].iVal.pop_back();
		
	} else {
		Engine_Message(KSE_GetErrFileSrc(iArr) + "(  " + KSE_GetToken(iArr) + "  ) is not an Array.", "LOGIC ERROR AT LINE " + kseToken[iArr].iLine);
		Engine_Exit();
	}
	
	return iIndex;
}
