//translated this 18.06.10 by mjmendozaIV
#include "../../kage.hpp"
#include "../../kageExterns.hpp"

string /*shared*/ cEntityTxt;

unsigned long SynEntity(unsigned long &iIndex) {
	iIndex = GetNearestTokenIndex(kseCOLON, "Entity", iIndex);   //look for		:
	iIndex = GetNextIndex(iIndex);
	if (kseToken[iIndex].sToken == "Load") {
		return EntityLoad(iIndex);
	} else if (kseToken[iIndex].sToken == "AttachSprite") {
		return EntityAttachSprite(iIndex);
	} else if (kseToken[iIndex].sToken == "Generate") {
		return EntityGenerate(iIndex);
	} else if (kseToken[iIndex].sToken == "SetX") {
		return EntitySetX(iIndex);
	} else if (kseToken[iIndex].sToken == "SetY") {
		return EntitySetY(iIndex);
	//} else if (kseToken[iIndex].sToken == "Degenerate") {
	//	return EntityDegenerate(iIndex);
	} else if (kseToken[iIndex].sToken == "DetachSprite") {
		return EntityDetachSprite(iIndex);
	} else if (kseToken[iIndex].sToken == "Unload") {
		return EntityUnload(iIndex);
	} else if (kseToken[iIndex].sToken == "New") {
		return EntityNew(iIndex);
	} else if (kseToken[iIndex].sToken == "SetMoveUp") {
		return EntitySetMoveUp(iIndex);
	} else if (kseToken[iIndex].sToken == "SetMoveDown") {
		return EntitySetMoveDown(iIndex);
	} else if (kseToken[iIndex].sToken == "SetMoveLeft") {
		return EntitySetMoveLeft(iIndex);
	} else if (kseToken[iIndex].sToken == "SetMoveRight") {
		return EntitySetMoveRight(iIndex);
	} else {
			Engine_Message(KSE_GetErrFileSrc(iIndex) + "(  " + KSE_GetToken(iIndex) + "  ) is not in Entity Class.", "SYNTAX ERROR AT LINE " + kseToken[iIndex].iLine);
	}
	//to be implemented once KonsolScript is ready for production release
	//return GetNearestTokenIndex(kseSEMICOLON, kseCLOSE_PAREN, SynEntity)   //look for		;
	return ULONG_MAX;
}

unsigned long EntityAttachSprite(unsigned long &iIndex) {
	int iSpr;
	int iIdx;
	
	iIndex = Entity_SkipOpenParenthesisAfter("AttachSprite", iIndex);    //look for       (
		
		iSpr = KSE_GetTokenNumValueOf(iIndex);
		
	iIndex = Entity_SkipCommaAfter("sprite", iIndex);
		
		iIdx = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = Entity_SkipCloseParenthesisAfter("entity", iIndex);
	//EXECUTE SCRIPT =====================================================================
	kseEntity[iIdx].iSpriteIndex = iSpr;
	
	return iIndex;
}

unsigned long EntityDetachSprite(unsigned long &iIndex) {
	int iIdx;
	
	iIndex = Entity_SkipOpenParenthesisAfter("DetachSprite", iIndex);    //look for       (
	
	iIdx = KSE_GetTokenNumValueOf(iIndex);
		
	iIndex = Entity_SkipCloseParenthesisAfter("entity", iIndex);
	//EXECUTE SCRIPT =====================================================================
	kseEntity[iIdx].iSpriteIndex = kseENTITY_NO_SPRITE;
	
	return iIndex;
}

unsigned long EntitySetX(unsigned long &iIndex) {
	int iIdx;
	int iVal;
	
	iIndex = Entity_SkipOpenParenthesisAfter("SetX", iIndex);    //look for       (
		
		iVal = KSE_GetTokenNumValueOf(iIndex);
		
	iIndex = Entity_SkipCommaAfter("value", iIndex);
	
		iIdx = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = Entity_SkipCloseParenthesisAfter("entity", iIndex);
	//EXECUTE SCRIPT =====================================================================
	
	kseEntity[iIdx].iX = iVal;
	
	return iIndex;
}

unsigned long EntitySetY(unsigned long &iIndex) {
	int iIdx;
	int iVal;
	
	iIndex = Entity_SkipOpenParenthesisAfter("SetY", iIndex);    //look for       (
		
		iVal = KSE_GetTokenNumValueOf(iIndex);
		
	iIndex = Entity_SkipCommaAfter("value", iIndex);
	
		iIdx = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = Entity_SkipCloseParenthesisAfter("entity", iIndex);
	//EXECUTE SCRIPT =====================================================================
	
	kseEntity[iIdx].iY = iVal;
	
	return iIndex;
}

unsigned long EntityGenerate(unsigned long &iIndex) {
	int iIdx;
	
	iIndex = Entity_SkipOpenParenthesisAfter("Generate", iIndex);    //look for       (
	
		iIdx = KSE_GetTokenNumValueOf(iIndex);
		
	iIndex = Entity_SkipCloseParenthesisAfter("entity", iIndex);
	//EXECUTE SCRIPT =====================================================================
	
	int iSpriteSet;
	long iSpriteHgt;
	long iSpriteWid;
	int iSpriteCol;
	int iSpriteRow;
	int iSpriteX;
	int iSpriteY;
	long iSprite;
	int iSpriteIdx;
	
	string sEntityName;
	
	//make sure entity is being used
	if (kseEntity[iIdx].bUsed == false) {
		Engine_Message(KSE_GetErrFileSrc(iIndex) + "Entity was unloaded earlier.", "LOGIC ERROR AT LINE " + kseToken[iIndex].iLine);
	}
	
	//set default direction
	if (kseEntity[iIdx].iDirection == dNOT_SET) { kseEntity[iIdx].iDirection = dDOWN; }
	
	int iSpriteIndex = kseEntity[iIdx].iSpriteIndex;
	
	if (iSpriteIndex == kseENTITY_NO_SPRITE) {
		Engine_Message(KSE_GetErrFileSrc(iIndex) + "Entity does not have a Sprite.", "LOGIC ERROR AT LINE " + kseToken[iIndex].iLine);
	}
	//get TileSet data
	iSpriteSet = kseSprite[iSpriteIndex].iPicture;
	iSpriteHgt = kseSprite[iSpriteIndex].iHgt;
	iSpriteWid = kseSprite[iSpriteIndex].iWid;
	iSpriteCol = kseSprite[iSpriteIndex].iCol;
	iSpriteRow = kseSprite[iSpriteIndex].iRow;
	
	kseEntity[iIdx].iWidth = iSpriteWid;
	kseEntity[iIdx].iHeight = iSpriteHgt;
	
	//leave out the file extension
	kseEntity[iIdx].sName = Replace(LCase(kseSourceFiles[CInt(kseToken[iIndex].iSrc)]), ".ks", "");
	kseEntity[iIdx].sName = Replace(kseEntity[iIdx].sName, ".kh", "");
	
	//create allocation all at once
	if (kseEntity[iIdx].iSpriteHandlers.size() > 0) { kseEntity[iIdx].iSpriteHandlers.clear(); }
	
	//extract tiles from TileSet
	iSpriteX = 1;
	iSpriteY = 1;
	iSpriteIdx = 1;
	for (int i = 1; i < iSpriteRow; ++i) {
		for (int ii = 1; ii < iSpriteCol; ++ii) {
			iSprite = CreateNewImage();
			
			InitializeImage(iSprite, iSpriteWid, iSpriteHgt);
			
			#ifdef QUIXIE_CAIRO
				kseImg[iSprite].imgCairo = cairo_image_surface_create_for_data(kseImg[iSprite].img, CAIRO_FORMAT_ARGB32, iSpriteWid, iSpriteHgt, iSpriteWid * sizeof(int));
			#endif
			
			//extract a tile from tileset
				Engine_GrabRegion(iSpriteX,
									iSpriteY,
									iSpriteWid,
									iSpriteHgt,
									iSpriteSet,
									iSprite);
			//review if setting integer value to integer pointer iSpriteHandlers
			//is better than setting pointer address of image (btw, why assign the image pointer?)
			kseEntity[iIdx].iSpriteHandlers[iSpriteIdx] = iSprite;
			iSpriteX = iSpriteX + iSpriteWid + 1;
			++iSpriteIdx;
		}
		iSpriteX = 1;
		iSpriteY = iSpriteY + iSpriteHgt + 1;
	}
	
	return iIndex;
}

unsigned long EntityNew(unsigned long &iIndex) {
	string sImagePath;
	int iNum;
	int iEntityIdx;
	
	iIndex = Entity_SkipOpenParenthesisAfter("New", iIndex);    //look for       (
		
	iIndex = GetNextIndex(iIndex);
		iNum = iIndex;
		//EXECUTE SCRIPT =====================================================================
		iEntityIdx = CreateNewEntity();
		
		SetNumValue(iNum, CDbl(iEntityIdx), "", LOCK_IT);
		//====================================================================================
	iIndex = Entity_SkipCloseParenthesisAfter("handler", iIndex);

	return iIndex;
}

unsigned long EntityNewInstance(unsigned long &iIndex) {
    int iIdx;
    int iVal;
    string sName;
    
    iIndex = Entity_SkipOpenParenthesisAfter("NewInstance", iIndex);    //look for       (
        
        iVal = KSE_GetTokenNumValueOf(iIndex);
        
    iIndex = Entity_SkipCommaAfter("entity", iIndex);
    
        sName = KSE_GetTokenStrValueOf(iIndex);
    
    iIndex = Entity_SkipCommaAfter("name", iIndex);
    
        iIdx = KSE_GetTokenNumValueOf(iIndex);
    
    iIndex = Entity_SkipCloseParenthesisAfter("return", iIndex);
    //EXECUTE SCRIPT =====================================================================
    //TODO assign instance name and parent Entity index
    
	return iIndex;
}

int CreateNewEntity() {
	iEntityCtr = kseEntity.size();
	if (iEntityCtr == 0) {
		typeEntity l_Entity;
		kseEntity.push_back(l_Entity);
		++iEntityCtr;
	}
	
	for (unsigned int i = 0; i < iEntityCtr; ++i) {
		if (kseEntity[i].bUsed == false) {
			kseEntity[i].bUsed = true;
			return i;
		}
	}
	////if it didnt, add new one
	typeEntity l_Entity;
		l_Entity.bUsed = true;
	kseEntity.push_back(l_Entity);
	++iEntityCtr;
	
	return iEntityCtr;
}

int CreateNewEntityInstance() {
	iEntityInstanceCtr = kseEntityInstance.size();
	if (iEntityInstanceCtr == 0) {
		typeEntityInstance l_EntityInstance;
		kseEntityInstance.push_back(l_EntityInstance);
		++iEntityInstanceCtr;
	}
	
	for (unsigned int i = 0; i < iEntityInstanceCtr; ++i) {
		if (kseEntityInstance[i].bUsed == false) {
			kseEntityInstance[i].bUsed = true;
			return i;
		}
	}
	
	//if it didnt, add new one
	typeEntityInstance l_EntityInstance;
		l_EntityInstance.bUsed = true;
	kseEntityInstance.push_back(l_EntityInstance);
	++iEntityInstanceCtr;
	
	return iEntityInstanceCtr;
}

unsigned long EntityLoad(unsigned long &iIndex) {
	string sEntity;
	
	iIndex = Entity_SkipOpenParenthesisAfter("Load", iIndex);    //look for       (
		
		sEntity = KSE_GetTokenStrValueOf(iIndex);
	
	iIndex = Entity_SkipCloseParenthesisAfter("entity", iIndex);
	//EXECUTE SCRIPT =====================================================================
	//Engine_RunEntityScript sEntity, sEntity, "InitEntity"
	Engine_RunEntityScript(sEntity, sEntity, "");
	//, ksExt string = ".ks"
	//add entity to map
	
	return iIndex;
}

void Engine_RunEntityScript(string flName, string fxName, string ksExt) {
	//function wrapper for entity files
	Engine_RunScript(flName, fxName);
}

unsigned long EntityUnload(unsigned long &iIndex) {
	string sEntity;
	
	iIndex = Entity_SkipOpenParenthesisAfter("Unload", iIndex);    //look for       (
		
		sEntity = KSE_GetTokenStrValueOf(iIndex);
	
	iIndex = Entity_SkipCloseParenthesisAfter("entity", iIndex);
	//EXECUTE SCRIPT =====================================================================
	Engine_RunEntityScript(sEntity, "FreeEntity");
	//add entity to map
	
	return iIndex;
}

unsigned long EntitySetMoveUp(unsigned long &iIndex) {
	int iIdx;
	int iVal;
	
	iIndex = Entity_SkipOpenParenthesisAfter("SetMoveUp", iIndex);    //look for       (
	
		iIdx = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = Entity_SkipCommaAfter("entity", iIndex);
	//////EXECUTE SCRIPT =====================================================================
		iVal = KSE_GetTokenNumValueOf(iIndex);
	
	vector<int> tmpTiles;
	if (kseEntity[iIdx].iAnmt_UpTiles.size() > 0) { kseEntity[iIdx].iAnmt_UpTiles.clear(); }
	do {
		iIndex = Entity_SkipCommaAfter("data", iIndex);
		
		tmpTiles.push_back(iVal);
		
			iVal = KSE_GetTokenNumValueOf(iIndex);
		
		//here is how to sneak in a series of tokens
		//sneak to the next token and equate
		//#idea is that setting an animation should only be ended by a ')'
			iIndex = GetNextIndex(iIndex);
			if (kseToken[iIndex].sToken == kseCLOSE_PAREN) {
				iIndex = GetPrevIndex(iIndex);
				break;
			}
			iIndex = GetPrevIndex(iIndex);
	} while (true);
	tmpTiles.push_back(iVal);
	
	for (unsigned int i = 0; i < tmpTiles.size(); ++i) {
	   kseEntity[iIdx].iAnmt_UpTiles.push_back(tmpTiles[i]);
	}
	
	return Entity_SkipCloseParenthesisAfter("data", iIndex);
}

unsigned long EntitySetMoveDown(unsigned long &iIndex) {
	int iIdx;
	int iVal;
	
	iIndex = Entity_SkipOpenParenthesisAfter("SetMoveDown", iIndex);    //look for       (
	
		iIdx = KSE_GetTokenNumValueOf(iIndex);
		
	iIndex = Entity_SkipCommaAfter("entity", iIndex);
	//////EXECUTE SCRIPT =====================================================================
	iVal = KSE_GetTokenNumValueOf(iIndex);
	
	vector<int> tmpTiles;
	if (kseEntity[iIdx].iAnmt_DownTiles.size() > 0) { kseEntity[iIdx].iAnmt_DownTiles.clear(); }
	do {
		iIndex = Entity_SkipCommaAfter("data", iIndex);
		
		tmpTiles.push_back(iVal);
		
			iVal = KSE_GetTokenNumValueOf(iIndex);
		
		//here is how to sneak in a series of tokens
		//sneak to the next token and equate
		//#idea is that setting an animation should only be ended by a //)//
			iIndex = GetNextIndex(iIndex);
		if (kseToken[iIndex].sToken == kseCLOSE_PAREN) {
			iIndex = GetPrevIndex(iIndex);
			break;
		}
			iIndex = GetPrevIndex(iIndex);
	} while(true);
	
	tmpTiles.push_back(iVal);
	
	for (unsigned int i = 0; i < tmpTiles.size(); ++i) {
		kseEntity[iIdx].iAnmt_DownTiles.push_back(tmpTiles[i]);
	}
	
	iIndex = Entity_SkipCloseParenthesisAfter("data", iIndex);
	
	return iIndex;
}

unsigned long EntitySetMoveLeft(unsigned long &iIndex) {
	int iIdx;
	int iVal;
	
	iIndex = Entity_SkipOpenParenthesisAfter("SetMoveLeft", iIndex);    //look for       (
	
		iIdx = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = Entity_SkipCommaAfter("entity", iIndex);
	//////EXECUTE SCRIPT =====================================================================
		iVal = KSE_GetTokenNumValueOf(iIndex);
	
	vector<int> tmpTiles;
	if (kseEntity[iIdx].iAnmt_LeftTiles.size() > 0) { kseEntity[iIdx].iAnmt_LeftTiles.clear(); }
	do {
		iIndex = Entity_SkipCommaAfter("data", iIndex);
		
		tmpTiles.push_back(iVal);
		
			iVal = KSE_GetTokenNumValueOf(iIndex);
		
		//here is how to sneak in a series of tokens
		//sneak to the next token and equate
		//#idea is that setting an animation should only be ended by a //)//
			iIndex = GetNextIndex(iIndex);
			if (kseToken[iIndex].sToken == kseCLOSE_PAREN) {
				iIndex = GetPrevIndex(iIndex);
				break;
			}
			iIndex = GetPrevIndex(iIndex);
	} while (true);
	tmpTiles.push_back(iVal);
	
	for (unsigned int i = 0; i < tmpTiles.size(); ++i) {
	   kseEntity[iIdx].iAnmt_LeftTiles.push_back(tmpTiles[i]);
	}
		
	iIndex = Entity_SkipCloseParenthesisAfter("data", iIndex);
	
	return iIndex;
}

unsigned long EntitySetMoveRight(unsigned long &iIndex) {
	int iIdx;
	int iVal;
	
	iIndex = Entity_SkipOpenParenthesisAfter("SetMoveRight", iIndex);    //look for       (
	
		iIdx = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = Entity_SkipCommaAfter("entity", iIndex);
	//////EXECUTE SCRIPT =====================================================================
		iVal = KSE_GetTokenNumValueOf(iIndex);
	
	vector<int> tmpTiles;
	if (kseEntity[iIdx].iAnmt_RightTiles.size() > 0) { kseEntity[iIdx].iAnmt_RightTiles.clear(); }
	do {
		iIndex = Entity_SkipCommaAfter("data", iIndex);
		
		tmpTiles.push_back(iVal);
		
			iVal = KSE_GetTokenNumValueOf(iIndex);
		
		//here is how to sneak in a series of tokens
		//sneak to the next token and equate
		//#idea is that setting an animation should only be ended by a //)//
			iIndex = GetNextIndex(iIndex);
			if (kseToken[iIndex].sToken == kseCLOSE_PAREN) {
				iIndex = GetPrevIndex(iIndex);
				break;
			}
			iIndex = GetPrevIndex(iIndex);
	} while (true);
	tmpTiles.push_back(iVal);
	
	for (unsigned int i = 0; i < tmpTiles.size(); ++i) {
	   kseEntity[iIdx].iAnmt_RightTiles.push_back(tmpTiles[i]);
	}
	
	iIndex = Entity_SkipCloseParenthesisAfter("data", iIndex);
	
	return iIndex;
}

void Engine_EntityChangeDirection(int entity, kseDIRECTION dDir) {
	if (kseMap[kseMAP_CURRENT_RENDER].Entities[entity].bUsed == true) {
		kseMap[kseMAP_CURRENT_RENDER].Entities[entity].iDirection = dDir;
	}
}

//_____________________________________________________________________________
unsigned long Entity_SkipOpenParenthesisAfter(string sWhat, unsigned long &iIndex) {
	cEntityTxt = "Entity:(" + sWhat;
	
	return KSE_SkipOpenParenthesisAfter(cEntityTxt, iIndex);
}

unsigned long Entity_SkipCommaAfter(string sWhat, unsigned long &iIndex) {
	cEntityTxt = cEntityTxt + sWhat;
		iIndex = KSE_SkipCommaAfter(cEntityTxt, iIndex);
	cEntityTxt = cEntityTxt + ", ";
	
	return iIndex;
}

unsigned long Entity_SkipCloseParenthesisAfter(string sWhat, unsigned long &iIndex) {
	cEntityTxt = cEntityTxt + sWhat;
		iIndex = KSE_SkipCloseParenthesisAfter(cEntityTxt, iIndex);
	cEntityTxt = "";
	
	return iIndex;
}
