//translated this 18.06.12 by mjmendozaIV
#include "../../kage.hpp"
#include "../../kageExterns.hpp"

#include <iostream>
#include <fstream>
const int kseFILE_MAX = 254;
string kseFILE[kseFILE_MAX];								 //contains file content
const string kseFILEDIV = "FyLeDiVYThEr";

struct typeKSE_File {
	string _filename;
	string _content;
	bool _used;
	bool _IN;
	bool _OUT;
	std::ifstream _infile;
	std::ofstream _outfile;
	unsigned long _lineNumber;
	unsigned long _lineMax;
	bool isOpen() {
		if (_IN && _OUT) {
			return _infile.is_open() && _outfile.is_open(); // [QuixiePP] err? handle better!
		} else if (_IN) {
			return _infile.is_open();
		} else if (_OUT) {
			return _outfile.is_open();
		} else {
			return false;
		}
	};
};
typeKSE_File kseFILEQPP[kseFILE_MAX];

int FreeFile() {
	for (int i = 0; i < kseFILE_MAX; ++i) {
		if (kseFILEQPP[i]._used == false) {
			kseFILEQPP[i]._used = true;
			return i;
		}
	}
	return kseFILE_MAX - 1;
}
void Close(int p_file) {
	if (kseFILEQPP[p_file]._used == true) {
		kseFILEQPP[p_file]._used = false;
		kseFILEQPP[p_file]._infile.close();
		kseFILEQPP[p_file]._outfile.close();
	}
}
void Close() { //close all files
	for (int i = 0; i < kseFILE_MAX; ++i) {
		if (kseFILEQPP[i]._used == true) {
			kseFILEQPP[i]._used = false;
			kseFILEQPP[i]._infile.close();
			kseFILEQPP[i]._outfile.close();
		}
	}
}

unsigned long SynFile(unsigned long &iIndex) {
	iIndex = GetNearestTokenIndex(kseCOLON, "File", iIndex);   //look for		:
	iIndex = GetNextIndex(iIndex);
	if (kseToken[iIndex].sToken == "Open") {
		return FileOpen(iIndex);
	} else if (kseToken[iIndex].sToken == "Close") {
			return FileClose(iIndex);
	} else if (kseToken[iIndex].sToken == "CloseAll") {
			return FileCloseAll(iIndex);
	} else if (kseToken[iIndex].sToken == "Write") {
			return FileWrite(iIndex);
	} else if (kseToken[iIndex].sToken == "Read") {
			return FileRead(iIndex);
	} else if (kseToken[iIndex].sToken == "Copy") {
			return File_Copy(iIndex);
	} else if (kseToken[iIndex].sToken == "Exists") {
			return File__Exists(iIndex);
#ifdef QUIXIE_CGI
	} else if (kseToken[iIndex].sToken == "MoveUploaded") {
			return FileMoveUploaded(iIndex);
#endif
	} else {
			Engine_Message(KSE_GetErrFileSrc(iIndex) + "(  " + KSE_GetToken(iIndex) + "  ) is not in File Class.", "SYNTAX ERROR AT LINE " + Str(kseToken[iIndex].iLine));
			Engine_Exit();
	}
	//to be implemented once KS is ready for production release
	//return GetNearestTokenIndex(kseSEMICOLON, kseCLOSE_PAREN, SynFile );   //look for		;
	return ULONG_MAX;
}

void fileIO_error(int p_error, unsigned long iIndex, int iFileHandler, string sFilePath) {
	if (p_error == 1) {
		Engine_Message(KSE_GetErrFileSrc(iIndex) + "Unable to open: (" + Str(iFileHandler) + ") " + sFilePath, "LOGIC ERROR AT LINE " + Str(kseToken[iIndex].iLine));
	} else if (p_error == 53) {
		Engine_Message(KSE_GetErrFileSrc(iIndex) + "Unable to find the file.", "LOGIC ERROR AT LINE " + Str(kseToken[iIndex].iLine));
	} else if (p_error == 54) {
		Engine_Message(KSE_GetErrFileSrc(iIndex) + "Unable to write on a READ-acessed file.", "LOGIC ERROR AT LINE " + Str(kseToken[iIndex].iLine));
	} else if (p_error == 55) {
		Engine_Message(KSE_GetErrFileSrc(iIndex) + "File, [" + sFilePath + "], is already opened.", "LOGIC ERROR AT LINE " + Str(kseToken[iIndex].iLine));
	} else {
		UnknownErrMsg("File:Open", iIndex);
	}
	Engine_Exit();
}
unsigned long FileOpen(unsigned long &iIndex) {
	string sFilePath;
	int iMethod;
	int iHandler;
	int iFileHandler;
	int iLen;
	
	//CHECK SYNTAX ==============================================================
	++iIndex;
	iIndex = LookFor(kseOPEN_PAREN, "Open", iIndex); //look for	   (
	
		sFilePath = KSE_GetTokenStrValueOf(iIndex);
	
	++iIndex;
	iIndex = LookFor(kseCOMMA, "Filename parameter", iIndex); //look for	   ,
	
		iIndex = GetNextIndex(iIndex);
		iMethod = iIndex;
	
	++iIndex;
	iIndex = LookFor(kseCOMMA, "Access Method", iIndex);   //look for	   ,
	
		iIndex = GetNextIndex(iIndex);
		iHandler = iIndex;
	
	++iIndex;
	if (kseToken[iMethod].sToken == kseRANDOM) {
		iIndex = LookFor(kseCOMMA, "Byte-length parameter", iIndex);   //look for	   ,
		
		iIndex = GetNextIndex(iIndex);
		
		if (IsNumeric(kseToken[iIndex].sToken)) {
			iLen = CInt(kseToken[iIndex].sToken);
		} else if (IsTokenNum(iIndex)) {
			iLen = CInt(GetNumValue(iIndex));
		} else {
			Engine_Message(KSE_GetErrFileSrc(iIndex) + "Expecting a numeric value for (  Byte-length parameter  ) but got (  " + KSE_GetToken(iIndex) + "  ) instead.", "SYNTAX ERROR AT LINE " + kseToken[iIndex].iLine);
			Engine_Exit();
		}
		
		++iIndex;
	}
	iIndex = LookFor(kseCLOSE_PAREN, "File Handler", iIndex); //look for	   )
	//EXECUTE SCRIPT =============================================================
	iFileHandler = FreeFile();
	SetNumValue(iHandler, CDbl(iFileHandler), "", LOCK_IT);
	
	//how was the file accessed?
	kseFILE[iFileHandler] = kseToken[iMethod].sToken;
	
	//use proper slash before checking files
	sFilePath = Replace(sFilePath, "\\", kseSLASH);
	
	//im looking for colon because of 'C:\'
	if (InStr(1, sFilePath, kseCOLON) > 0) {
		//make sure to correct relative path
		sFilePath = sKonsolPath + kseSLASH + sFilePath;
	}
// [QuixiePP] to be fully implemented later
	if (kseToken[iMethod].sToken == kseREAD) {
		if (fileExists(sFilePath) == false) {
			fileIO_error(53, iIndex, iFileHandler, sFilePath); //unable to find file
		}
		kseFILEQPP[iFileHandler]._IN = true;
		kseFILEQPP[iFileHandler]._infile.open(sFilePath);
		if (kseFILEQPP[iFileHandler]._infile.is_open()) {
			//file ready for reading!
		} else {
			fileIO_error(1, iIndex, iFileHandler, sFilePath);
		}
	} else if (kseToken[iMethod].sToken == kseWRITE) {
		kseFILEQPP[iFileHandler]._IN = false;
		kseFILEQPP[iFileHandler]._outfile.open(sFilePath);
		if (kseFILEQPP[iFileHandler]._outfile.is_open()) {
			//file ready for writing!
		} else {
			fileIO_error(1, iIndex, iFileHandler, sFilePath);
		}
	} else if (kseToken[iMethod].sToken == kseAPPEND) {
//		Open sFilePath For Append #iFileHandler
	} else if (kseToken[iMethod].sToken == kseRANDOM) {
//		//# idea is to, only OPEN the file when it needs to write
//		kseFILE[iFileHandler] = kseToken[iMethod].sToken + kseFILEDIV + sFilePath + kseFILEDIV + iLen;
//		//Open sFilePath For Random #iFileHandler Len = iLen
	} else {
		Engine_Message(KSE_GetErrFileSrc(iMethod) + "(  " + KSE_GetToken(iMethod) + "  ) is not an Access Method; Expecting (  READ/WRITE/APPEND/WREAD  ).", "SYNTAX ERROR AT LINE " + Str(kseToken[iMethod].iLine));
		Engine_Exit();
	}
	return iIndex;
}

unsigned long FileClose(unsigned long &iIndex) {
	unsigned long iHandler;
	int iFileHandler;
	//CHECK SYNTAX ==============================================================
	++iIndex;
	iIndex = LookFor(kseOPEN_PAREN, "Close", iIndex); //look for	   (
	
	iIndex = GetNextIndex(iIndex);
	iHandler = iIndex;
	
	++iIndex;
	iIndex = LookFor(kseCLOSE_PAREN, "File Handler", iIndex); //look for	   )
	//EXECUTE SCRIPT =============================================================
	if (IsNumeric(kseToken[iHandler].sToken)) {
		iFileHandler = CInt(kseToken[iHandler].sToken);
	} else if (IsTokenNum(iHandler)) {
		iFileHandler = CInt(GetNumValue(iHandler));
	} else {
		Engine_Message(KSE_GetErrFileSrc(iIndex) + "Expecting a numeric value for (  File Handler  ).", "SYNTAX ERROR AT LINE " + Str(kseToken[iIndex].iLine));
		Engine_Exit();
	}
	
	SetNumValue(iHandler, 0, "", UNLOCK_IT);
// [QuixiePP] to be implemented later
//	Close #iFileHandler
	
	kseFILE[iFileHandler] = "";
	
	return iIndex;
}

unsigned long FileCloseAll(unsigned long &iIndex) {
//	int iHandler;
//	int iFileHandler;
	//CHECK SYNTAX ==============================================================
	++iIndex;
	iIndex = LookFor(kseOPEN_PAREN, "Close", iIndex); //look for	   (
	
	++iIndex;
	iIndex = LookFor(kseCLOSE_PAREN, "CloseAll(", iIndex); //look for	   )
	//EXECUTE SCRIPT =============================================================
	Close();
	
	for (int i = 0; i < kseFILE_MAX; ++i) {
		kseFILE[i] = "";
	}
	
	return iIndex;
}

void FileCopy(string srce_file, string dest_file) {
	std::ifstream srce(srce_file.c_str(), std::ios::binary);
	std::ofstream dest(dest_file.c_str(), std::ios::binary);
	dest << srce.rdbuf();
}
#ifdef QUIXIE_CGI
	unsigned long FileMoveUploaded(unsigned long &iIndex) {
		string sSrc;
		string sDest;
		int i;
		//On Error GoTo ptrErr
		//CHECK SYNTAX ==============================================================
		++iIndex;
		iIndex = LookFor(kseOPEN_PAREN, "MoveUploaded", iIndex); //look for	   (
		
			sSrc = KSE_GetTokenStrValueOf(iIndex);
		
		++iIndex;
		iIndex = LookFor(kseCOMMA, "Name", iIndex); //look for	   ,
		
			sDest = KSE_GetTokenStrValueOf(iIndex);
		
		++iIndex;
		iIndex = LookFor(kseCLOSE_PAREN, "Path", iIndex); //look for	   )
		//EXECUTE SCRIPT =============================================================
		for (i = 0; i < iUploadedFileCtr; ++i) {
			if (kseUploadedFile[i].sFileID = sSrc) {
				sSrc = kseUploadedFile[i].sTempname;
				i = iUploadedFileCtr + 1;
			}
		}
		if (fileExists(sSrc)) {
			FileCopy(sSrc, sDest);
		}
		return iIndex;
	}
#endif

unsigned long FileWrite(unsigned long &iIndex) {
	string sWrite;
//	int iHandler;
	int iFileHandler;
	int iPtr;
	//On Error GoTo ptrErr
	//CHECK SYNTAX ==============================================================
	++iIndex;
	iIndex = LookFor(kseOPEN_PAREN, "Write", iIndex); //look for	   (
	
		sWrite = KSE_GetTokenStrValueOf(iIndex);
	
	++iIndex;
	iIndex = LookFor(kseCOMMA, "string parameter", iIndex); //look for	   ,
	
		iFileHandler = KSE_GetTokenNumValueOf(iIndex);
	
	++iIndex;
	if (Left(kseFILE[iFileHandler], kseRANDOM.length()) == kseRANDOM) {
		iIndex = LookFor(kseCOMMA, "File Handler", iIndex); //look for	   ,
		
			iPtr = KSE_GetTokenNumValueOf(iIndex);
		
		++iIndex;
		iIndex = LookFor(kseCLOSE_PAREN, "Pointer parameter", iIndex); //look for	   )
	} else {
		iIndex = LookFor(kseCLOSE_PAREN, "File Handler", iIndex); //look for	   )
	}
	//EXECUTE SCRIPT =============================================================
// [QuixiePP] to be implemented later
	if (Left(kseFILE[iFileHandler], kseRANDOM.length()) == kseRANDOM) {
//		vector<string> sFileInfo;
//		int iExcess;
//		string sContent;
//		string sPrevText;
//		int iLen;
//		
//		Split(kseFILE[iFileHandler), kseFILEDIV, sFileInfo);
//		iLen = CInt(sFileInfo[2]);
//		
//		//get data
//		if (fileExists(sFileInfo[1]) == true) {
//			std::ifstream ifsFileWrite;
//			ifsFileWrite.open(sFileInfo[1], ios::in | ios::binary);
//				iExcess = LOF(iFileHandler) % iLen;
//				if (LOF(iFileHandler) >= iExcess) {
//					sContent = Input(LOF(iFileHandler) - iExcess, iFileHandler);
//				}
//			ifsFileWrite.cloese();
//		}
//		//process data
//		if (sWrite.length() >= iLen) {
//			sWrite = Left(sWrite, iLen);
//		} else {
//			sWrite = sWrite + String(CLng(iLen - Int(sWrite.length())), " ");
//		}
//		if (iPtr != 0) {
//			sPrevText = Mid(sContent, (iLen * (iPtr - 1)) + 1, iLen);
//			sContent = Replace(sContent, sPrevText, sWrite);
//		} else {
//			sContent += sWrite;
//		}
//		//save data
//		open sFileInfo[1] For Output #iFileHandler
//			Print #iFileHandler, sContent
//		close #iFileHandler
	} else if (Left(kseFILE[iFileHandler], kseRANDOM.length()) == kseWRITE) {
		std::cout << "\t\tFileWrite ? " << iIndex << " | " << sWrite << std::endl;
		if (kseFILEQPP[iFileHandler]._outfile.is_open()) {
			kseFILEQPP[iFileHandler]._outfile << sWrite << std::endl;
		} else {
			//fileIO_error(54, iIndex, iFileHandler, sFilePath);
		}
//		Print #iFileHandler, sWrite
	} else {
		fileIO_error(54, iIndex, iFileHandler, kseFILEQPP[iFileHandler]._filename);
	}
	
	return iIndex;

	//UnknownErrMsg("File:Write", iIndex);
}

void fileRead_error(int p_error, unsigned long iIndex) {
	if (p_error == 54) {
		Engine_Message(KSE_GetErrFileSrc(iIndex) + "Cannot read to a WRITE-acessed file.", "SYNTAX ERROR AT LINE " + Str(kseToken[iIndex].iLine));
	} else if (p_error == 62) {
		Engine_Message(KSE_GetErrFileSrc(iIndex) + "Already reached End Of File.", "SYNTAX ERROR AT LINE " + Str(kseToken[iIndex].iLine));
	} else {
		UnknownErrMsg("File:Read", iIndex);
	}
	Engine_Exit();
}
unsigned long FileRead(unsigned long &iIndex) {
	string sRead;
	unsigned long iValHandler;
	int iFileHandler;
	int iPtr;
	
	//CHECK SYNTAX ==============================================================
	++iIndex;
	iIndex = LookFor(kseOPEN_PAREN, "Read", iIndex); //look for	   (
	
	iIndex = GetNextIndex(iIndex);
	iValHandler = iIndex;
	
	++iIndex;
	iIndex = LookFor(kseCOMMA, "return parameter", iIndex); //look for	   ,
	
		iFileHandler = KSE_GetTokenNumValueOf(iIndex);
	
	++iIndex;
	if (Left(kseFILE[iFileHandler], kseRANDOM.length()) == kseRANDOM) {
		iIndex = LookFor(kseCOMMA, "File Handler", iIndex); //look for	   ,
		
			iPtr = KSE_GetTokenNumValueOf(iIndex);
		
		++iIndex;
		iIndex = LookFor(kseCLOSE_PAREN, "Pointer parameter", iIndex); //look for	   )
	} else {
		iIndex = LookFor(kseCLOSE_PAREN, "File Handler", iIndex); //look for	   )
	}
	//EXECUTE SCRIPT =============================================================
// [QuixiePP] to be implemented later
	if (Left(kseFILE[iFileHandler], kseRANDOM.length()) == kseRANDOM) {
//		vector<string> sFileInfo;
//		int iExcess;
//		string sContent;
//		int iLen;
//		
//		Split(kseFILE[iFileHandler], kseFILEDIV, sFileInfo);
//		iLen = CInt(sFileInfo[2]);
//		
		//get data
//		if (fileExists(sFileInfo[1]) == true) {
//			if (Open(sFileInfo[1] For Input #iFileHandler) != 0) {
//				goto ptrErr:
//			}
//				iExcess = LOF(iFileHandler) % iLen
//				if (LOF(iFileHandler) >= iExcess) {
//					sContent = Input(LOF(iFileHandler) - iExcess, iFileHandler)
//				}
//			Close(iFileHandler)
//		}
		//process data
		if (iPtr == 0) {
			Engine_Message(KSE_GetErrFileSrc(iIndex - 2) + "Pointer parameter cannot have a value of (  0  ).", "SYNTAX ERROR AT LINE " + Str(kseToken[iIndex - 2].iLine));
			Engine_Exit();
		} else {
//			sRead = Mid(sContent, (iLen * (iPtr - 1)) + 1, iLen);
		}
	} else {
		if (kseFILEQPP[iFileHandler]._IN == false) {
			fileRead_error(54, iIndex);
		}
		unsigned long l_line_ctr = kseFILEQPP[iFileHandler]._lineMax;
		if (getline(kseFILEQPP[iFileHandler]._infile, sRead)) {
			++l_line_ctr;
			//for later access?
			kseFILEQPP[iFileHandler]._lineMax = l_line_ctr;
		} else {
			fileRead_error(62, iIndex);
		}
	}
	
	if (IsTokenStr(iValHandler)) {
		SetStrValue(iValHandler, sRead);
	} else if (IsTokenNum(iValHandler)) {
		SetNumValue(iValHandler, CDbl(sRead));
	} else if (IsTokenBool(iValHandler)) {
		SetBoolValue(iValHandler, CBool(sRead));
	} else {
		VarNotDeclared(KSE_GetToken(iIndex), "Variable", iIndex);
	}
	
	return iIndex;
}

unsigned long File_Copy(unsigned long &iIndex) {
	string sSource;
	string sDest;
	//CHECK SYNTAX ==============================================================
	++iIndex;
	iIndex = LookFor(kseOPEN_PAREN, "Copy", iIndex); //look for	   (
	
		sSource = KSE_GetTokenStrValueOf(iIndex);
	
	++iIndex;
	iIndex = LookFor(kseCOMMA, "Source File", iIndex); //look for	   )
	
		sDest = KSE_GetTokenStrValueOf(iIndex);
	
	++iIndex;
	iIndex = LookFor(kseCLOSE_PAREN, "Destination parameter", iIndex); //look for	   )
	//EXECUTE SCRIPT =============================================================
	
	
	if (Left(sDest, 1) == "\\") { sDest = Mid(sDest, 2); }
	
	if (InStr(1, sSource, "*") > 0) {
		Engine_Log("Warning: Copy one file at a time.");
	} else {
		FileCopy(sSource, sDest);
	}
	
	return iIndex;
//ptrErr:
	if (Err == 53) {
		Engine_Message("Unable to find the file.", "ERROR AT LINE " + Str(kseToken[iIndex].iLine));
	//} else if (Err == 62) {
	//	MsgBox("Already reached End Of File.", "SYNTAX ERROR AT LINE " + Str(kseToken[iIndex].iLine));
	} else {
		UnknownErrMsg("File:Copy", iIndex);
	}
	Engine_Exit(); return iIndex; //to silence warning
}

unsigned long File__Exists(unsigned long &iIndex) {
	string sFilePath;
	int iBool;
	
	
	//CHECK SYNTAX ==============================================================
	++iIndex;
	iIndex = LookFor(kseOPEN_PAREN, "Exists", iIndex); //look for	   (
	
	
		sFilePath = KSE_GetTokenStrValueOf(iIndex);
	
	++iIndex;
	iIndex = LookFor(kseCOMMA, "Filename parameter", iIndex); //look for	   ,
	
	iIndex = GetNextIndex(iIndex);
	iBool = iIndex;
		
	++iIndex;
	iIndex = LookFor(kseCLOSE_PAREN, "return", iIndex);   //look for	   ,
	//EXECUTE SCRIPT =============================================================
	
	
	if (fileExists(sFilePath) == 0) {
		SetBoolValue(iBool, false);
	} else {
		SetBoolValue(iBool, true);
	}
	
	return iIndex;
//ptrErr:
	UnknownErrMsg("File:Exists", iIndex);
	Engine_Exit(); return iIndex; //to silence warning
}

void UnknownErrMsg(string sSource, unsigned long &iIndex, string Erfx, string Ermx) {
	string tmpMod = Ermx;
	if (tmpMod != "Unknown") {
		tmpMod = Mid(tmpMod, Get__Path(tmpMod).length() + 2);
	}
	Engine_Message("Undocumented " + sSource + " Error\r\n" +
				   "Error No.:" + Str(Err) + "\r\n" +
				   "Source   : #" + Erl + " of " + tmpMod + "\r\n" +
				   "Function : " + Erfx, "Error at line " + Str(kseToken[iIndex].iLine));
}
