//translated this 18.06.10 by mjmendozaIV
#include "../../kage.hpp"
#include "../../kageExterns.hpp"

typeKey kseKey[256];

unsigned long SynKey(unsigned long &iIndex) {
	
	iIndex = GetNearestTokenIndex(kseCOLON, "Key", iIndex);   //look for		:
	iIndex = GetNextIndex(iIndex);
	if (kseToken[iIndex].sToken == "New") {
		return KeyNew(iIndex);
	} else if (kseToken[iIndex].sToken == "Free") {
		return KeyFree(iIndex);
	} else {
		Engine_Message(KSE_GetErrFileSrc(iIndex) + "(  " + KSE_GetToken(iIndex) + "  ) is not in Key Class.", "SYNTAX ERROR AT LINE " + Str(kseToken[iIndex].iLine));
		Engine_Exit();
	}
	return ULONG_MAX;
	//to be implemented once KonsolScript is ready for production release
	//return GetNearestTokenIndex(kseSEMICOLON, kseCLOSE_PARENTHESIS, SynKey)   //look for		;
}

unsigned long KeyNew(unsigned long &iIndex) {
	string sAsc;
	int iBool;
	int iKeyIdx;
	
	iIndex = Key_SkipOpenParenthesisAfter("New", iIndex);
	
		sAsc = KSE_GetTokenStrValueOf(iIndex);
		
	iIndex = Key_SkipCommaAfter("Key:New(ascii", iIndex);
		
	iBool = KSE_GetReturnIndexAndSkipCloseParenthesis("Key:New(", iIndex);
	//EXECUTE SCRIPT =====================================================================
	//normalize ASCII
	if (IsNumeric(sAsc)) {
		//user is setting direct ASCII value
		//make sure it's within limits
		iKeyIdx = CInt(sAsc) % 256;
		iKeyIdx = (iKeyIdx < 1) ? 1 : iKeyIdx;
	} else {
		iKeyIdx = CInt(stringToUpper(sAsc)[0]); //Asc
	}
	//register Key
	if (kseKey[iKeyIdx].IsAssigned == false) {
		kseKey[iKeyIdx].hdlrID = kseToken[iBool].sToken;   //assign vars name
		kseKey[iKeyIdx].IsAssigned = true;
		SetBoolValue(iBool, 0, "", LOCK_IT); //set default value of false
		
	} else {
		Engine_Log("Warning@" + kseSourceFiles[kseToken[iIndex].iSrc] + "(" + Str(kseToken[iIndex].iLine) + "): ASCII is already bound");
	}
	//====================================================================================
	return iIndex;
}

unsigned long KeyFree(unsigned long &iIndex) {
	bool iImageIndex;
	
	iIndex = Key_SkipOpenParenthesisAfter("Free", iIndex);
		//[QuixiePP] this is an obvious BUG!
		iImageIndex = KSE_GetTokenBoolValueOf(iIndex);
		SetBoolValue(iIndex, 0, "", UNLOCK_IT);
	
	iIndex = Key_SkipCloseParenthesisAfter("Free(keyhandler", iIndex);
	//EXECUTE SCRIPT =====================================================================
	
	kseKey[iIndex].IsAssigned = false;
	
	return iIndex;
}

void Key_Pressed(int iKeyIdx) {
	KSE_SetNum("lastpress",iKeyIdx);
	iKeyIdx = CInt(stringToUpper(Chr(iKeyIdx))[0]); //Asc?
	if (kseKey[iKeyIdx].IsAssigned == true) {
		SetBoolValue(-1, 1, kseKey[iKeyIdx].hdlrID, OVERRIDE_IT);
	}
}

void Key_UnPressed(int iKeyIdx) {
	KSE_SetNum("lastunpress",iKeyIdx);
	iKeyIdx = CInt(stringToUpper(Chr(iKeyIdx))[0]); //Asc?
	if (kseKey[iKeyIdx].IsAssigned == true) {
		SetBoolValue(-1, 0, kseKey[iKeyIdx].hdlrID, OVERRIDE_IT);
	}
}

//_____________________________________________________________________________
unsigned long Key_SkipOpenParenthesisAfter(string sWhat, unsigned long &iIndex) {
	return KSE_SkipOpenParenthesisAfter("Key:" + sWhat, iIndex);
}

unsigned long Key_SkipCommaAfter(string sWhat, unsigned long &iIndex) {
	return KSE_SkipCommaAfter("Key:" + sWhat, iIndex);
}

unsigned long Key_SkipCloseParenthesisAfter(string sWhat, unsigned long &iIndex) {
	return KSE_SkipCloseParenthesisAfter("Key:" + sWhat, iIndex);
}
