//translated this 17.09.30 by mjmendozaIV
#include "../../kage.hpp"
#include "../../kageExterns.hpp"

unsigned long SynKonsol(unsigned long &iIndex) {
	iIndex = GetNearestTokenIndex(kseCOLON, "Konsol", iIndex);			   //look for	   :
	iIndex = GetNextIndex(iIndex);
	
	if (kseToken[iIndex].sToken == "Log") {
		return KonsolLog(iIndex);
	} else if (kseToken[iIndex].sToken == "Message") {
		return KonsolMsg(iIndex);
	} else if (kseToken[iIndex].sToken == "SurfNet") {
		return KonsolSurfNet(iIndex);
	} else if (kseToken[iIndex].sToken == "Delay") {
		return KonsolDelay(iIndex);
	} else if (kseToken[iIndex].sToken == "Refresh") {
		return KonsolRefresh(iIndex);
	} else if (kseToken[iIndex].sToken == "RGB") {
		return KonsolRGB(iIndex);
	} else if (kseToken[iIndex].sToken == "RGBA") {
		return KonsolRGBA(iIndex);
	} else if (kseToken[iIndex].sToken == "Exit") {
		return KonsolExit(iIndex);					   //let KONSoLE end
	} else if (kseToken[iIndex].sToken == "ShowLog") {
		return KonsolShowLog(iIndex);					//let KONSoLE Log
	} else if (kseToken[iIndex].sToken == "About") {
		return KonsolAbout(iIndex);					  //let KONSoLE show About
	} else if (kseToken[iIndex].sToken == "FunctionExists") {
		return KonsolFunctionExists(iIndex);			  //let KONSoLE check if such function was declared
	} else if (kseToken[iIndex].sToken == "CallFunction") {
		return KonsolCallFunction(iIndex);
	//} else if (kseToken[iIndex].sToken ==  "Break") {
	//	++iIndex;								  //move index to next
	//	iIndex = LookFor(kseOPEN_PAREN, "Break", iIndex); //look for	   (
	//	++iIndex;								  //move index to next
	//	iIndex = LookFor(kseCLOSE_PAREN, "(", iIndex);   //look for	   )
	//	KonsolBreak();										  //let KONSoLE end
	//	return iIndex; // + 1
	} else if (kseToken[iIndex].sToken == "Asc") {
		return KonsolAsc(iIndex);						//let KONSoLE convert character to number
	} else if (kseToken[iIndex].sToken == "Chr") {
		return KonsolChr(iIndex);						//let KONSoLE convert number to character
	} else if (kseToken[iIndex].sToken == "IsNumeric") {
		return KonsolIsNumeric(iIndex);				  //let KONSoLE convert number to character
	} else if (kseToken[iIndex].sToken == "Run") {
		return KonsolRun(iIndex);						//let KONSoLE run external programs
	} else if (kseToken[iIndex].sToken == "GetVersion") {
		return KonsolGetVersion(iIndex);				 //let KONSoLE give current version
	} else if (kseToken[iIndex].sToken == "GetPath") {
		return KonsolGetPath(iIndex);					//let KONSoLE give current konsolscript path
	} else {
		Engine_Message(KSE_GetErrFileSrc(iIndex) + "(  " + kseToken[iIndex].sToken + "  ) is not in Konsol Class.", "SYNTAX ERROR AT LINE " + Str(kseToken[iIndex].iLine));
		Engine_Exit();
	}
	
	return iIndex;
}

unsigned long KonsolExit(unsigned long &iIndex) {
	iIndex = Konsol_SkipOpenParenthesisAfter("Exit", iIndex);
	
	iIndex = Konsol_SkipCloseParenthesisAfter("Exit(", iIndex);
	Engine_Log(string("Engine@") + kseNOW() + ":Exiting");
	Engine_Exit();
	
	return iIndex;
}

unsigned long KonsolRefresh(unsigned long &iIndex) {
	iIndex = Konsol_SkipOpenParenthesisAfter("Refresh", iIndex);
	
	iIndex = Konsol_SkipCloseParenthesisAfter("Refresh(,", iIndex);
	
	//temporarily pause app running by 1 millisecond
	#ifdef WIN32
		Sleep(1);
	#else
		usleep(1* 1000);
	#endif // win32
	return iIndex;
}


unsigned long KonsolAsc(unsigned long &iIndex) {
	unsigned long iRet;
	string sChar;
	
	iIndex = Konsol_SkipOpenParenthesisAfter("Asc", iIndex);
	
		sChar = KSE_GetTokenStrValueOf(iIndex);
		
	iIndex = Konsol_SkipCommaAfter("Asc(text", iIndex);
	
	iRet = KSE_GetReturnIndexAndSkipCloseParenthesis("Konsol:Asc(text,", iIndex);
	//EXECUTE SCRIPT ============================================================
	if (sChar.length() > 0) { sChar = Left(sChar, 1); }
	
	SetNumValue(iRet, ((sChar != "") ? (int)(sChar[0]) : -1));
	
	return iIndex;
}

unsigned long KonsolChr(unsigned long &iIndex) {
	unsigned long iRet;
	double iChar;
	string sChar;
	//CHECK SYNTAX ==============================================================
	iIndex = Konsol_SkipOpenParenthesisAfter("Chr", iIndex);
	
		iChar = CInt(KSE_GetTokenStrValueOf(iIndex));
		
	iIndex = Konsol_SkipCommaAfter("Chr(number", iIndex);
	
	iRet = KSE_GetReturnIndexAndSkipCloseParenthesis("Konsol:Chr(number,", iIndex);
	//EXECUTE SCRIPT ============================================================
	if (iChar < 0) { iChar = 0; }
	iChar = fmod(iChar, 256);
	
	sChar = string(new char((int)iChar));
	SetStrValue(iRet, sChar);
	
	return iIndex;
}

unsigned long KonsolRun(unsigned long &iIndex) {
	string sVal;
	string sApp;
	
	iIndex = Konsol_SkipOpenParenthesisAfter("Run", iIndex);
	
		sApp = KSE_GetTokenStrValueOf(iIndex);
	
	iIndex = Konsol_SkipCloseParenthesisAfter("Run(file", iIndex);
	
//	Shell(sApp); // [QuixiePP] enable later
	
	return iIndex;
}

unsigned long KonsolAbout(unsigned long &iIndex) {
	iIndex = Konsol_SkipOpenParenthesisAfter("About", iIndex);
	
	iIndex = Konsol_SkipCloseParenthesisAfter("About(", iIndex);
	
	//frmKONSoL_About.Show vbModal
	MsgBox("\r\nQuixie\r\nby KonsolScript Labs", sScreenCaption);
	return iIndex;
}

unsigned long KonsolShowLog(unsigned long &iIndex) {
	iIndex = Konsol_SkipOpenParenthesisAfter("ShowLog", iIndex);
	
	iIndex = Konsol_SkipCloseParenthesisAfter("ShowLog(", iIndex);
// [QuixiePP] enable later
//	Shell("Notepad " + sKonsolPath + kseSLASH + kseLOG_FILE);//, vbNormalFocus
	
	return iIndex;
}

unsigned long KonsolLog(unsigned long &iIndex) {
	string sLog;
	
	iIndex = Konsol_SkipOpenParenthesisAfter("Log", iIndex);
		
		sLog = KSE_GetTokenStrValueOf(iIndex);
		
	iIndex = Konsol_SkipCloseParenthesisAfter("Log(text", iIndex);
	//tell engine to log
	Engine_Log(sLog, 1);
	
	return iIndex;
}

unsigned long KonsolMsg(unsigned long &iIndex) {
	string sMessage;
	string sCaption;
	
	iIndex = Konsol_SkipOpenParenthesisAfter("Message", iIndex);
		
		sMessage = KSE_GetTokenStrValueOf(iIndex);
		
	iIndex = Konsol_SkipCommaAfter("Message(message", iIndex);
		
		sCaption = KSE_GetTokenStrValueOf(iIndex);
	
	iIndex = Konsol_SkipCloseParenthesisAfter("Message(prompt, title", iIndex);
	
	if (sCaption == "") { sCaption = " "; } //avoid showing the default caption, "Error"; it's for engine use only
	MsgBox(sMessage, sCaption);
	
	return iIndex;
}

unsigned long KonsolSurfNet(unsigned long &iIndex) {
	//Dim kseFORM Form
	//Set kseFORM = New frmKONSoL_Screen
	string sWebsite;
	
	iIndex = Konsol_SkipOpenParenthesisAfter("SurfNet", iIndex);
	
		sWebsite = KSE_GetTokenStrValueOf(iIndex);
	
	iIndex = Konsol_SkipCloseParenthesisAfter("SurfNet(website", iIndex);
	
	//ShellExecute kseFORM.hWnd, "open", sWebsite, vbNullString, vbNullString, kseSHOW_NORMAL
	
	//Unload kseFORM   //avoid unending application
	
	return iIndex;
}

unsigned long KonsolDelay(unsigned long &iIndex) {
	double iDelay;
	double iWait;
	
	iIndex = Konsol_SkipOpenParenthesisAfter("Delay", iIndex);
	
		iDelay = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = Konsol_SkipCloseParenthesisAfter("Delay(time", iIndex);
	
	iDelay = iDelay / 1000;
	iWait = iDelay + /*Timer*/0;  //[Quixie] enable later
	
	while (/*Timer*/0 < iWait) {
		KSE_DoEvents(0);
	}
	
	return iIndex;
}

unsigned long KonsolRGB(unsigned long &iIndex) {
	unsigned int iColorR;
	unsigned int iColorG;
	unsigned int iColorB;
	unsigned long iColor = 0;
	unsigned long iRet;
	
	iIndex = Konsol_SkipOpenParenthesisAfter("RGB", iIndex);
	
		iColorR = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = Konsol_SkipCommaAfter("RGB(red", iIndex);
	
		iColorG = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = Konsol_SkipCommaAfter("RGB(red, green", iIndex);
	
		iColorB = KSE_GetTokenNumValueOf(iIndex);
		
	iIndex = Konsol_SkipCommaAfter("RGB(red, green, blue", iIndex);
	
	iRet = KSE_GetReturnIndexAndSkipCloseParenthesis("Konsol:RGB(red, green, blue, return", iIndex);
	
	iColorR = iColorR % 256;
	iColorG = iColorG % 256;
	iColorB = iColorB % 256;
	
#ifdef QUIXIE_CAIRO
	iColor = KAGE_RGBA(iColorR, iColorG, iColorB, 255);
#endif	
	SetNumValue(iRet, CDbl(iColor));
	return iIndex;
}

unsigned long KonsolRGBA(unsigned long &iIndex) {
	unsigned int iColorR;
	unsigned int iColorG;
	unsigned int iColorB;
	unsigned int iColorA;
	unsigned long iColor = 0;
	unsigned long iRet;
	
	iIndex = Konsol_SkipOpenParenthesisAfter("RGBA", iIndex);
	
		iColorR = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = Konsol_SkipCommaAfter("RGBA(red", iIndex);
	
		iColorG = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = Konsol_SkipCommaAfter("RGBA(red, green", iIndex);
	
		iColorB = KSE_GetTokenNumValueOf(iIndex);
		
	iIndex = Konsol_SkipCommaAfter("RGBA(red, green, blue", iIndex);
	
		iColorA = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = Konsol_SkipCommaAfter("RGBA(red, green, blue, alpha", iIndex);
	
	iRet = KSE_GetReturnIndexAndSkipCloseParenthesis("Konsol:RGB(red, green, blue, alpha, return", iIndex);
	
	iColorR = iColorR % 256;
	iColorG = iColorG % 256;
	iColorB = iColorB % 256;
	iColorA = iColorA % 256;
	
#ifdef QUIXIE_CAIRO
	iColor = KAGE_RGBA(iColorR, iColorG, iColorB, iColorA);
#endif
	
	SetNumValue(iRet, CDbl(iColor));
	return iIndex;
}

unsigned long KonsolIsNumeric(unsigned long &iIndex) {
	int iRet;
	string sSource;
	
	iIndex = Konsol_SkipOpenParenthesisAfter("IsNumeric", iIndex);
	
		sSource = KSE_GetTokenStrValueOf(iIndex);
	
	iIndex = Konsol_SkipCommaAfter("IsNumeric(source", iIndex);
	
	iRet = KSE_GetReturnIndexAndSkipCloseParenthesis("Konsol:IsNumeric(source,", iIndex);
	//EXECUTE SCRIPT ==================================================================
	SetBoolValue(iRet, (IsNumeric(sSource)) ? true : false);
	
	return iIndex;
}

unsigned long KonsolGetVersion(unsigned long &iIndex) {
	int iVer;
	
	iIndex = Konsol_SkipOpenParenthesisAfter("GetVersion", iIndex);
	
	iVer = KSE_GetReturnIndexAndSkipCloseParenthesis("Konsol:GetVersion(", iIndex);
	//EXECUTE SCRIPT ==================================================================
	SetStrValue(iVer, sScreenVersion);
	
	return iIndex;
}

unsigned long KonsolGetPath(unsigned long &iIndex) {
	int iPt;
	
	iIndex = Konsol_SkipOpenParenthesisAfter("GetPath", iIndex);
	
	iPt = KSE_GetReturnIndexAndSkipCloseParenthesis("Konsol:GetPath(", iIndex);
	//EXECUTE SCRIPT ==================================================================
	SetStrValue(iPt, sKonsolPath);
	
	return iIndex;
}

unsigned long KonsolFunctionExists(unsigned long &iIndex) {
	
	string sFncName;
	unsigned long iName;
	//CHECK SYNTAX ===================================================================
	iIndex = Konsol_SkipOpenParenthesisAfter("FunctionExists", iIndex);
	
		sFncName = KSE_GetTokenStrValueOf(iIndex);
	
	iIndex = Konsol_SkipCommaAfter("FunctionExists(function_name", iIndex);
	
		iIndex = GetNextIndex(iIndex);
		iName = iIndex;
	
	iIndex = Konsol_SkipCloseParenthesisAfter("FunctionExists(function_name, return", iIndex);
	//EXECUTE SCRIPT ==================================================================
	unsigned long i;
	for (i = 0; i < iFunctionCtr; ++i) {
		if (kseFunction[i].fName == sFncName) {
			SetBoolValue(iName, true);
			break;
		}
	}
	
	if (i > iFunctionCtr) { SetBoolValue(iName, false); }
	
	return iIndex;
}

unsigned long KonsolCallFunction(unsigned long &iIndex) {
	string sFncName;
	//CHECK SYNTAX ===================================================================
	iIndex = Konsol_SkipOpenParenthesisAfter("CallFunction", iIndex);
	
		sFncName = KSE_GetTokenStrValueOf(iIndex);
	
	iIndex = Konsol_SkipCloseParenthesisAfter("CallFunction(function_name", iIndex);
	//EXECUTE SCRIPT ==================================================================
	unsigned long i;
	for (i = 0; i < iFunctionCtr; ++i) {
		if (kseFunction[i].fName == sFncName) {
			kseFunction[i].RunScript();
			break;
		}
	}
	
	if (i > iFunctionCtr) { Engine_Log("Warning: (  function " + sFncName + "  ) does not exists or is not accessible."); }
	
	return iIndex;
}

//_____________________________________________________________________________
unsigned long Konsol_SkipOpenParenthesisAfter(string sWhat, unsigned long &iIndex) {
	// wrapper of KSE_SkipOpenPar... for _Screen module
	// to shorten sWhat by placing "Konsol:" here
	return KSE_SkipOpenParenthesisAfter("Konsol:" + sWhat, iIndex);
}

unsigned long Konsol_SkipCommaAfter(string sWhat, unsigned long &iIndex) {
	// wrapper of KSE_SkipComma... for _Screen module
	// to shorten sWhat by placing "Konsol:" here
	return KSE_SkipCommaAfter("Konsol:" + sWhat, iIndex);
}

unsigned long Konsol_SkipCloseParenthesisAfter(string sWhat, unsigned long &iIndex) {
   // wrapper of KSE_SkipClosePar... for _Screen module
	// to shorten sWhat by placing "Konsol:" here
	return KSE_SkipCloseParenthesisAfter("Konsol:" + sWhat, iIndex);
}
