'translated this 09.23.07@11:57AM by mjmendozaIV
#Include Once "kageExterns.bi"
''
' Parser for KonsolScript's <b>Map</b> class.
'
' This enables KonsolScript to do tile-based game engine rendering.<br>
' TODO:
' <ul>
'  <li>lot's to do, i'll think of it and list them all later.
' </ul>
' @date 2008.01.29

''
' Used by engine for parsing and interpreting
'
' @return String
' @remarks None.
Dim Shared cMapTxt As String


''
' Parses and interprets KonsolScript's <b>Map</b> functions.
'
' @param    iIndex - Index of the parsed script
' @return   New index value of the parsed script.
' @remarks Needs more research and refining.
'<div class="KS">
' <b>KonsolScript Users:</b><br>
' <br><b>Description:</b><br>
' Map class currently contains the functions:
' <ul>
' <li><b><a href="kse_Map.MapAttachTileSet.html">AttachTileSet</a></b> - ...
' <li><b><a href="kse_Map.MapSetArea.html">SetArea</a></b> - ...
' <li><b><a href="kse_Map.MapSetLayers.html">SetLayers</a></b> - ...
' <li><b><a href="kse_Map.MapGenerate.html">Generate</a></b> - builds the defined map for rendering
' <li><b><a href="kse_Map.MapLoad.html">Load</a></b> - ...
' <li><b><a href="kse_Map.MapRender.html">Render</a></b> - renders a defined map.
' <li><b><a href="kse_Map.MapDegenerate.html">Degenerate</a></b> - ...
' <li><b><a href="kse_Map.MapDetachTileSet.html">DetachTileSet</a></b> - ...
' <li><b><a href="kse_Map.MapUnLoad.html">UnLoad</a></b> - ...
' <li><b><a href="kse_Map.MapSetEntityLayer.html">SetEntityLayer</a></b> - ...
' <li><b><a href="kse_Map.MapSetTriggerLayer.html">SetTriggerLayer</a></b> - ...
' <li><b><a href="kse_Map.MapSetObstructionLayer.html">SetObstructionLayer</a></b> - ...
' <li><b><a href="kse_Map.MapAttachEntity.html">AttachEntity</a></b> - ...
' <li><b><a href="kse_Map.MapNew.html">New</a></b> - ...
' </ul>
'</div>
Public Function SynMap(ByRef iIndex As Long) As Integer
	iIndex = GetNearestTokenIndex(kseCOLON, "Map", iIndex)   'look for    :
	iIndex = GetNextIndex(iIndex)
	Select Case kseToken(iIndex).sToken
		Case "AttachTileSet"
			Return MapAttachTileSet(iIndex)
		Case "SetArea"
			Return MapSetArea(iIndex)
		Case "SetLayers"
			Return MapSetLayers(iIndex)
		Case "Generate"
			Return MapGenerate(iIndex)
		Case "Load"
			Return MapLoad(iIndex)
		Case "Degenerate"
			Return MapDegenerate(iIndex)
		Case "DetachTileSet"
			Return MapDetachTileSet(iIndex)
		Case "Unload"
			Return MapUnload(iIndex)
		Case "SetEntityLayer"
			Return MapSetEntityLayer(iIndex)
		Case "SetObstructionLayer"
			Return MapSetObstructionLayer(iIndex)
		Case "SetTriggerLayer"
			Return MapSetTriggerLayer(iIndex)
		Case "New"
			Return MapNew(iIndex)
		Case Else
			Engine_Message KSE_GetErrFileSrc(iIndex) & "(  " & KSE_GetToken(iIndex) & "  ) is not in Map Class.", "SYNTAX ERROR AT LINE " & kseToken(iIndex).iLine
	End Select
	'to be implemented once KonsolScript is ready for production release
	'SynMap = GetNearestTokenIndex(kseSEMICOLON, kseCLOSE_PAREN, SynMap)   'look for    ;
End Function

Private Function MapAttachTileSet(ByRef iIndex As Long) As Integer
	Dim iIdx  As Integer
	Dim iMID As Integer
	
	iIndex = Map_SkipOpenParenthesisAfter("AttachTileSet", iIndex)
	
		iIdx = KSE_GetTokenNumValueOf(iIndex)
	
	iIndex = Map_SkipCommaAfter("AttachTileSet(tileset", iIndex)
	
		iMID = KSE_GetTokenNumValueOf(iIndex)
	
	iIndex = Map_SkipCloseParenthesisAfter("AttachTileSet(tileset, map", iIndex)
	'EXECUTE SCRIPT =====================================================================
	kseMap(iMID).iTileSet = iIdx
	'register the dimension for tile-based movement
	
	kseMap(iMID).MapDimension = kseTileSet(kseMap(iMID).iTileSet).iDimension
	
	Return iIndex
End Function

Private Function MapSetArea(ByRef iIndex As Long) As Integer
	Dim iWid  As Integer
	Dim iHgt  As Integer
	Dim iMID As Integer
	
	iIndex = Map_SkipOpenParenthesisAfter("SetArea", iIndex)
	
		iWid = KSE_GetTokenNumValueOf(iIndex)
	
	iIndex = Map_SkipCommaAfter("SetArea(width", iIndex)
	
		iHgt = KSE_GetTokenNumValueOf(iIndex)
	
	iIndex = Map_SkipCommaAfter("SetArea(width, height ", iIndex)
	
		iMID = KSE_GetTokenNumValueOf(iIndex)
	
	iIndex = Map_SkipCloseParenthesisAfter("SetArea(width, height, map", iIndex)
	'EXECUTE SCRIPT =====================================================================
	kseMap(iMID).iWidth = iWid
	kseMap(iMID).iHeight = iHgt
	
	'resize map-tile data
	If kseMap(iMID).iTileDataMax > 0 Then DeAllocate(kseMap(iMID).iTileData)
	kseMap(iMID).iTileDataMax = kseMap(iMID).iLayers * iWid * iHgt
	kseMap(iMID).iTileData = Allocate(kseMap(iMID).iTileDataMax*SizeOf(typeMapTile))
	
	Return iIndex
End Function

Private Function MapSetLayers(ByRef iIndex As Long) As Integer
	Dim iLyr As Integer
	Dim iMID As Integer
	
	iIndex = Map_SkipOpenParenthesisAfter("SetLayers", iIndex)
	
		iLyr = KSE_GetTokenNumValueOf(iIndex)
	
	iIndex = Map_SkipCommaAfter("SetLayers(layers ", iIndex)
	
		iMID = KSE_GetTokenNumValueOf(iIndex)
	
	iIndex = Map_SkipCloseParenthesisAfter("SetLayers(layers, map", iIndex)
	'EXECUTE SCRIPT =====================================================================
	kseMap(iMID).iLayers = iLyr
	
	If iLyr < 2 Then Engine_Message KSE_GetErrFileSrc(iIndex) & "There should at least be 2 Layers for a Map.", "Logic Error"
	
	If kseMap(iMID).iTileDataMax > 0 Then DeAllocate(kseMap(iMID).iTileData)
	kseMap(iMID).iTileDataMax = iLyr * kseMap(iMID).iWidth * kseMap(iMID).iHeight
	
	'resize map-tile data
	kseMap(iMID).iTileData = Allocate(kseMap(iMID).iTileDataMax*SizeOf(typeMapTile))
	kseMap(iMID).iLayer = Allocate(iLyr*SizeOf(Integer))
	
	Return iIndex
End Function

Private Function MapGenerate(ByRef iIndex As Long) As Integer
	Dim iMID As Integer
	
	iIndex = Map_SkipOpenParenthesisAfter("Generate", iIndex)
	
		iMID = KSE_GetTokenNumValueOf(iIndex)
	
	iIndex = Map_SkipCloseParenthesisAfter("Generate(map", iIndex)
	'EXECUTE SCRIPT =====================================================================
	
	Dim iTileSet As Long
	Dim iTileDim As Long
	Dim iTileCol As Integer
	Dim iTileRow As Integer
	Dim iTileX As Integer
	Dim iTileY As Integer
	Dim iTile As Long
	Dim iTileIdx As Integer
	
	'If kseMap(iMid).sName = "" Then
	'	Engine_Message KSE_GetErrFileSrc(iIndex) & "No Map was loaded.", "LOGIC ERROR AT LINE " & kseToken(iIndex).iLine
	'ElseIf kseMap(iMid).iTileSet = kseMAP_NO_TILESET Then
	'	Engine_Message KSE_GetErrFileSrc(iIndex) & "(  " & kseMap(iMid).sName & "  ) does not have a TileSet.", "LOGIC ERROR AT LINE " & kseToken(iIndex).iLine
	'End If
	'get TileSet data
	iTileSet = kseMap(iMID).iTileSet
		iTileDim = kseTileSet(iTileSet).iDimension
		iTileCol = kseTileSet(iTileSet).iCol
		iTileRow = kseTileSet(iTileSet).iRow
		iTileSet = kseTileSet(iTileSet).iPicture
	
	'extract tiles from TileSet
	iTileX = 1
	iTileY = 1
	iTileIdx = 0 ' arrays start from 0; index 0 is not used for any temp purposes
	If kseMap(iMID).iTileImgHdlrMax > 0 Then DeAllocate kseMap(iMID).iTileImgHdlr
	kseMap(iMID).iTileImgHdlr = Allocate((iTileRow * iTileCol) * SizeOf(Integer))
	kseMap(iMID).iTileImgHdlrMax = iTileRow * iTileCol
	
	Dim i As Integer
	Dim ii As Integer
	Dim iLyr As Integer
	
	For i = 1 To iTileRow
		For ii = 1 To iTileCol
			
			'queue another tile
			iTile = CreateNewImage()
			InitializeImage iTile, iTileDim, iTileDim
			
			#IfDef QUIXIE_CAIRO
				kseImg(iTile).imgCairo = Cairo_Image_Surface_Create_For_Data(kseImg(iTile).img, CAIRO_FORMAT_ARGB32, iTileDim, iTileDim, iTileDim*Len(Integer))
			#EndIf
			
			'extract a tile from tileset
			Engine_GrabRegion iTileX, _
							  iTileY, _
							  iTileDim, _
							  iTileDim, _
							  iTileSet, _
							  iTile
			
			kseMap(iMID).iTileImgHdlr[iTileIdx] = iTile
			
			iTileX = iTileX + iTileDim + 1
			iTileIdx = iTileIdx + 1
		Next
		iTileX = 1
		iTileY = iTileY + iTileDim + 1
	Next
	'added this  03.26.07 to optimize rendering speed
	'start creating the layer image
	Dim iTmpPicIdx As Long
	
	iTileX = 1
	iTileIdx = 0
	Dim iTileDataIdx As Integer
	
	For iLyr = 0 To kseMap(iMID).iLayers - 1
		If iLyr <> kseMap(iMID).iLayerEntity-1 And iLyr <> kseMap(iMID).iLayerObstruct-1 And iLyr <> kseMap(iMID).iLayerTrigger-1 Then
			iTileY = 1
			iTmpPicIdx = CreateNewImage()
			'initialize the null image to "single-tile area" * "tile-width and/or height"
			InitializeImage iTmpPicIdx, iTileDim * kseMap(iMID).iWidth, iTileDim * kseMap(iMID).iHeight
			
			'---+ [do the filling of pink]
			#IfDef QUIXIE_CAIRO
				kseImg(iTmpPicIdx).imgCairo = Cairo_Image_Surface_Create_For_Data(kseImg(iTmpPicIdx).img, CAIRO_FORMAT_ARGB32, iTileDim * kseMap(iMID).iWidth, iTileDim * kseMap(iMID).iHeight, iTileDim * kseMap(iMID).iWidth * Len(Integer))
			#Else
				Line kseImg(iTmpPicIdx).img,(0, 0)-(iTileDim * kseMap(iMID).iWidth, iTileDim * kseMap(iMID).iHeight), RGB(255, 0, 255), bf
			#EndIf
			'_________________________________________________________
			
			kseMap(iMID).iLayer[iLyr] = iTmpPicIdx
			
			For i = 1 To kseMap(iMID).iHeight
				For ii = 1 To kseMap(iMID).iWidth
					If kseMap(iMID).iTileData[iTileIdx].bStatic = 1 _
							And kseMap(iMID).iTileData[iTileIdx].iIdx > 0 Then
						'paint tile to layer
						
						iTileDataIdx = kseMap(iMID).iTileData[iTileIdx].iIdx
						
						Engine_BlitToRegion kseMap(iMID).iTileImgHdlr[iTileDataIdx - 1], _
											 iTileX - 1, _
											 iTileY - 1, _
											 CInt(iTileDim), _
											 CInt(iTileDim), _
											 0, _
											 kseMap(iMID).iLayer[iLyr], _
											 CInt(kseImg(kseMap(iMID).iLayer[iLyr]).imgWidth), _
											 CInt(kseImg(kseMap(iMID).iLayer[iLyr]).imgHeight)
					End If
					iTileX = iTileX + iTileDim
					iTileIdx = iTileIdx + 1
				Next
				iTileX = 1
				iTileY = iTileY + iTileDim
			Next
		Else
			iTileIdx = iTileIdx + (kseMap(iMID).iWidth * kseMap(iMID).iHeight)
		End If
	Next
	kseMap(iMID).Map = CreateNewImage()
	InitializeImage kseMap(iMID).Map, iTileDim * kseMap(iMID).iWidth, iTileDim * kseMap(iMID).iHeight
	#IfDef QUIXIE_CAIRO
		kseImg(kseMap(iMID).Map).imgCairo = Cairo_Image_Surface_Create_For_Data(kseImg(kseMap(iMID).Map).img, CAIRO_FORMAT_ARGB32, iTileDim * kseMap(iMID).iWidth, iTileDim * kseMap(iMID).iHeight, iTileDim * kseMap(iMID).iWidth * Len(Integer))
	#EndIf
	
	kseMap(iMID).Entities = Allocate(kseMap(iMID).EntitiesCtr*SizeOf(typeEntity))
	kseMap(iMID).EntitiesCtr = kseMap(iMID).EntitiesCtr + 1
	
	Return iIndex
End Function

''
' <b>Map:Load</b> - loads the map and calls the file's map contructor.
'
' @param    iIndex - Index of the parsed script
' @return   New index value of the parsed script.
' @remarks None.
'<div class="KS">
' <b>KonsolScript Users:</b><br>
' <br><b>Description:</b><br>
' Loads the map and calls the file's map contructor..<br>
' <br><br><b>Parameters:</b><br>
' <ul>
'  <li>String <b>map_filename</b> - filename of the map file without dot-KS.
' </ul>
' <b>Usage:</b><br>
' <pre>
'  //provided that myMap.ks exists
'  Map:Load("myMap")
'</pre>
'</div>
Private Function MapLoad(ByRef iIndex As Long) As Integer
	iIndex = Map_SkipOpenParenthesisAfter("Load", iIndex)
	trace("mapload 1")
		sMapName = KSE_GetTokenStrValueOf(iIndex)
	trace("mapload 2")
	iIndex = Map_SkipCloseParenthesisAfter("Load(map_name", iIndex)
	trace("mapload 3")
	'EXECUTE SCRIPT =====================================================================
	Engine_RunMapScript sMapName 'call the constructor
	Return iIndex
End Function

Public Sub Engine_NormalizeEntityLocation()
	Dim iMID As Integer
	iMID = kseMAP_CURRENT_RENDER
	Dim X As Integer
	Dim XX As Integer
	Dim Y As Integer
	Dim YY As Integer
	For i As Integer = 1 To kseMap(iMID).EntitiesCtr - 1
		X = kseMap(iMID).Entities[i].iX
		XX = (X Mod kseMap(iMID).MapDimension)
		kseMap(iMID).Entities[i].iX = X - XX
		
		Y = kseMap(iMID).Entities[i].iY
		YY = (Y Mod kseMap(iMID).MapDimension)
		kseMap(iMID).Entities[i].iY = Y - YY
	Next
End Sub

'I think Map:Generate and Degenerate should not be exposed to users -- should be automatic on Game:Load/Unload
Private Function MapDegenerate(ByRef iIndex As Long) As Integer
	Dim iMID As Integer
	iIndex = Map_SkipOpenParenthesisAfter("Degenerate", iIndex)
	
		iMID = KSE_GetTokenNumValueOf(iIndex)
	
	iIndex = Map_SkipCloseParenthesisAfter("Degenerate(map", iIndex)
	'EXECUTE SCRIPT =====================================================================
	
	Dim iTileIdx As Integer
	
	iTileIdx = 1
	For i As Integer = 1 To kseMap(iMID).iHeight
		For ii As Integer = 1 To kseMap(iMID).iWidth
			UnloadImage CLng(kseMap(iMID).iTileImgHdlr[iTileIdx])
			
			iTileIdx = iTileIdx + 1
		Next
	Next
	
	kseMap(iMID).sName = ""
	
	'clear used data
	If kseMap(iMID).iTileImgHdlrMax > 0 Then
		DeAllocate kseMap(iMID).iTileImgHdlr
		kseMap(iMID).iTileImgHdlrMax = 0
	EndIf
	
	Return iIndex
End Function

Private Function MapDetachTileSet(ByRef iIndex As Long) As Integer
	Dim iMID As Integer
	
	iIndex = Map_SkipOpenParenthesisAfter("DetachTileSet", iIndex)
	
		iMID = KSE_GetTokenNumValueOf(iIndex)
	
	iIndex = Map_SkipCloseParenthesisAfter("DetachTileSet(map", iIndex)
	'EXECUTE SCRIPT =====================================================================
	kseMap(iMID).iTileSet = kseMAP_NO_TILESET
	
	Return iIndex
End Function

Private Function MapUnload(ByRef iIndex As Long) As Integer
'stops rendering
	Dim iMID As Integer
	iIndex = Map_SkipOpenParenthesisAfter("Unload", iIndex)
	
		iMID = KSE_GetTokenNumValueOf(iIndex)
	
	iIndex = Map_SkipCloseParenthesisAfter("Unload(map", iIndex)
	'EXECUTE SCRIPT =====================================================================
	kseMap(iMID).bRender = 0
	kseMap(iMID).bRendering = 0
	
	Return iIndex
End Function

'Public Sub Engine_LocateEntityOnMap(ByRef iEntity As Integer, iMapID As Integer = -1)
'	If iMapID = -1 Then iMapID = asd
'	'use this to move to new location
'	Dim iIdx As Integer
'	'NOTE:get the tile thru entitylayer and the x,y coordination of entity
'	iIdx = ((iMapEntityLayer - 1) * iMapWidth * iMapHeight) + _
'		   (kseEntity(iEntity).iY * iMapHeight) + _
'		   kseEntity(iEntity).iX
'
'	'check if it was the same entity; this is to avoid misuse of this function
'	If kseMap(iMapID).iTileData(iIdx).iEntityIdx = kseMAP_NO_ENTITY Then
'		kseMap(iMapID).iTileData(iIdx).iEntityIdx = iEntity + 1 'i added 1 to avoid value 0; 0 will be use for 'NO ENTITY' flag
'	End If
'End Sub
'
'Public Sub Engine_RelocateEntityOnMap(ByRef iEntity As Integer)
'	'use this to remove from old location
'	Dim iIdx As Integer
'	'NOTE:get the tile thru entitylayer and the x,y coordination of entity
'	iIdx = ((iMapEntityLayer - 1) * iMapWidth * iMapHeight) + _
'		   (kseEntity(iEntity).iY * iMapHeight) + _
'		   kseEntity(iEntity).iX
'
'	'check if it was the same entity; this is to avoid misuse of this function
'	If kseMap(iMID).iTileData(iIdx).iEntityIdx = iEntity + 1 Then
'		kseMap(iMID).iTileData(iIdx).iEntityIdx = 0 '0 will be use for 'NO ENTITY' flag
'	End If
'End Sub

Private Function MapSetEntityLayer(ByRef iIndex As Long) As Integer
	Dim iLyr As Integer
	Dim iMID As Integer
	iIndex = Map_SkipOpenParenthesisAfter("SetEntityLayer", iIndex)
	
		iLyr = KSE_GetTokenNumValueOf(iIndex)
	
	iIndex = Map_SkipCommaAfter("layer", iIndex)
	
		iMID = KSE_GetTokenNumValueOf(iIndex)
	
	iIndex = Map_SkipCloseParenthesisAfter("map", iIndex)
	'EXECUTE SCRIPT =====================================================================
	kseMap(iMID).iLayerEntity = iLyr
	
	Return iIndex
End Function

Private Function MapSetObstructionLayer(ByRef iIndex As Long) As Integer
	Dim iLyr  As Integer
	Dim iMID As Integer
	
	iIndex = Map_SkipOpenParenthesisAfter("SetObstructionLayer", iIndex)
	
		iLyr = KSE_GetTokenNumValueOf(iIndex)
	
	iIndex = Map_SkipCommaAfter("SetObstructionLayer(layer", iIndex)
	
		iMID = KSE_GetTokenNumValueOf(iIndex)
	
	iIndex = Map_SkipCloseParenthesisAfter("SetObstructionLayer(layer, map", iIndex)
	'EXECUTE SCRIPT =====================================================================
	kseMap(iMID).iLayerObstruct = iLyr
	
	Return iIndex
End Function

Private Function MapSetTriggerLayer(ByRef iIndex As Long) As Integer
	Dim iLyr  As Integer
	Dim iMID As Integer
	
	iIndex = Map_SkipOpenParenthesisAfter("SetTriggerLayer", iIndex)
	
		iLyr = KSE_GetTokenNumValueOf(iIndex)
	
	iIndex = Map_SkipCommaAfter("layer", iIndex)
	
		iMID = KSE_GetTokenNumValueOf(iIndex)
	
	iIndex = Map_SkipCloseParenthesisAfter("map", iIndex)
	'EXECUTE SCRIPT =====================================================================
	kseMap(iMID).iLayerTrigger = iLyr
	
	Return iIndex
End Function

Private Function MapNew(ByRef iIndex As Long) As Integer
	Dim sImagePath As String
	Dim iNum As Integer
	Dim iImageIndex  As Integer
	Dim iMapIdx  As Integer
	'change API to Map:New(width, height, layers, return)
	'-- or --
	'change API to Map:New(width, height, return)
	'change API to Layer:Add(map, ...)
	iIndex = Map_SkipOpenParenthesisAfter("New", iIndex)
	
	iNum = KSE_GetReturnIndexAndSkipCloseParenthesis("(", iIndex)
	'EXECUTE SCRIPT =====================================================================
	iMapIdx = CreateNewMap()
	kseMap(iMapIdx).sName = sMapName 'when Map:Load("mymap") is called, inside function 'mymap', Map:New is expected, thus setting the "mymap" to map name is then expected.
	SetNumValue iNum, CDbl(iMapIdx), , LOCK_IT
	'====================================================================================
	Return iIndex
End Function

Private Function MapFree(ByRef iIndex As Long) As Integer
	'frees up *all* map-used memory
	Dim sMap As String
	
	iIndex = Map_SkipOpenParenthesisAfter("Free", iIndex)
	
		sMap = KSE_GetTokenStrValueOf(iIndex)
		SetNumValue iIndex, 0, , UNLOCK_IT
	
	iIndex = Map_SkipCloseParenthesisAfter("Free(map", iIndex)
	'EXECUTE SCRIPT =====================================================================
	Engine_RunMapScript "FreeMap"
	'add entity to map
	
	Return iIndex
End Function

Private Function CreateNewMap() As Integer
	If iMapCtr = 0 Then
		iMapCtr = iMapCtr + 1
		ReDim Preserve kseMap(iMapCtr+1) As typeMap
	EndIf
	' index 0 is for map checking
	For i As Integer = 1 To iMapCtr
		If kseMap(i).bUsed = 0 Then
			kseMap(i).bUsed = 1
			Return i
		End If
	Next
	
	'if it didnt, add new one
	iMapCtr = iMapCtr + 1
	ReDim Preserve kseMap(iMapCtr+1) As typeMap
	
	kseMap(iMapCtr).bUsed = 1
	
	Return iMapCtr
End Function

'_____________________________________________________________________________
Private Function Map_SkipOpenParenthesisAfter(sWhat As String, ByRef iIndex As Long) As Integer
	cMapTxt = "Map:" & sWhat
	Return KSE_SkipOpenParenthesisAfter(cMapTxt, iIndex)
End Function

Private Function Map_SkipCommaAfter(sWhat As String, ByRef iIndex As Long) As Integer
	cMapTxt = cMapTxt & sWhat
	iIndex = KSE_SkipCommaAfter(cMapTxt, iIndex)
	cMapTxt = cMapTxt & ", "
	Return iIndex
End Function

Private Function Map_SkipCloseParenthesisAfter(sWhat As String, ByRef iIndex As Long) As Integer
	cMapTxt = cMapTxt & sWhat
	iIndex = KSE_SkipCloseParenthesisAfter(cMapTxt, iIndex)
	cMapTxt = ""
	Return iIndex
End Function
