//translated this 18.06.10 by mjmendozaIV
#include "../../kage.hpp"
#include "../../kageExterns.hpp"
////
// Parser for KonsolScript's <b>Map</b> class.
//
// This enables KonsolScript to do tile-based game engine rendering.<br>
// TODO:
// <ul>
//  <li>lot's to do, i//ll think of it and list them all later.
// </ul>
// @date 2008.01.29

////
// Used by engine for parsing and interpreting
//
// @return String
// @remarks None.
string /*shared*/ cMapTxt;


////
// Parses and interprets KonsolScript's <b>Map</b> functions.
//
// @param    iIndex - Index of the parsed script
// @return   New index value of the parsed script.
// @remarks Needs more research and refining.
//<div class="KS">
// <b>KonsolScript Users:</b><br>
// <br><b>Description:</b><br>
// Map class currently contains the functions:
// <ul>
// <li><b><a href="kse_Map.MapAttachTileSet.html">AttachTileSet</a></b> - ...
// <li><b><a href="kse_Map.MapSetArea.html">SetArea</a></b> - ...
// <li><b><a href="kse_Map.MapSetLayers.html">SetLayers</a></b> - ...
// <li><b><a href="kse_Map.MapGenerate.html">Generate</a></b> - builds the defined map for rendering
// <li><b><a href="kse_Map.MapLoad.html">Load</a></b> - ...
// <li><b><a href="kse_Map.MapRender.html">Render</a></b> - renders a defined map.
// <li><b><a href="kse_Map.MapDegenerate.html">Degenerate</a></b> - ...
// <li><b><a href="kse_Map.MapDetachTileSet.html">DetachTileSet</a></b> - ...
// <li><b><a href="kse_Map.MapUnLoad.html">UnLoad</a></b> - ...
// <li><b><a href="kse_Map.MapSetEntityLayer.html">SetEntityLayer</a></b> - ...
// <li><b><a href="kse_Map.MapSetTriggerLayer.html">SetTriggerLayer</a></b> - ...
// <li><b><a href="kse_Map.MapSetObstructionLayer.html">SetObstructionLayer</a></b> - ...
// <li><b><a href="kse_Map.MapAttachEntity.html">AttachEntity</a></b> - ...
// <li><b><a href="kse_Map.MapNew.html">New</a></b> - ...
// </ul>
//</div>
unsigned long SynMap(unsigned long &iIndex) {
	iIndex = GetNearestTokenIndex(kseCOLON, "Map", iIndex);   //look for    :
	iIndex = GetNextIndex(iIndex);
	if (kseToken[iIndex].sToken == "AttachTileSet") {
		return MapAttachTileSet(iIndex);
	} else if (kseToken[iIndex].sToken == "SetArea") {
		return MapSetArea(iIndex);
	} else if (kseToken[iIndex].sToken == "SetLayers") {
		return MapSetLayers(iIndex);
	} else if (kseToken[iIndex].sToken == "Generate") {
		return MapGenerate(iIndex);
	} else if (kseToken[iIndex].sToken == "Load") {
		return MapLoad(iIndex);
	} else if (kseToken[iIndex].sToken == "Degenerate") {
		return MapDegenerate(iIndex);
	} else if (kseToken[iIndex].sToken == "DetachTileSet") {
		return MapDetachTileSet(iIndex);
	} else if (kseToken[iIndex].sToken == "Unload") {
		return MapUnload(iIndex);
	} else if (kseToken[iIndex].sToken == "SetEntityLayer") {
		return MapSetEntityLayer(iIndex);
	} else if (kseToken[iIndex].sToken == "SetObstructionLayer") {
		return MapSetObstructionLayer(iIndex);
	}else if (kseToken[iIndex].sToken == "SetTriggerLayer") {
		return MapSetTriggerLayer(iIndex);
	} else if (kseToken[iIndex].sToken == "New") {
		return MapNew(iIndex);
	} else {
		Engine_Message(KSE_GetErrFileSrc(iIndex) + "(  " + KSE_GetToken(iIndex) + "  ) is not in Map Class.", "SYNTAX ERROR AT LINE " + Str(kseToken[iIndex].iLine));
	}
	//to be implemented once KonsolScript is ready for production release
	//SynMap = GetNearestTokenIndex(kseSEMICOLON, kseCLOSE_PAREN, SynMap)   //look for    ;
	return ULONG_MAX;
}

unsigned long MapAttachTileSet(unsigned long &iIndex) {
	int iIdx;
	int iMID;
	
	iIndex = Map_SkipOpenParenthesisAfter("AttachTileSet", iIndex);
	
		iIdx = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = Map_SkipCommaAfter("AttachTileSet(tileset", iIndex);
	
		iMID = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = Map_SkipCloseParenthesisAfter("AttachTileSet(tileset, map", iIndex);
	//EXECUTE SCRIPT =====================================================================
	kseMap[iMID].iTileSet = iIdx;
	//register the dimension for tile-based movement
	
	kseMap[iMID].MapDimension = kseTileSet[kseMap[iMID].iTileSet].iDimension;
	
	return iIndex;
}

unsigned long MapSetArea(unsigned long &iIndex) {
	int iWid;
	int iHgt;
	int iMID;
	
	iIndex = Map_SkipOpenParenthesisAfter("SetArea", iIndex);
	
		iWid = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = Map_SkipCommaAfter("SetArea(width", iIndex);
	
		iHgt = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = Map_SkipCommaAfter("SetArea(width, height ", iIndex);
	
		iMID = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = Map_SkipCloseParenthesisAfter("SetArea(width, height, map", iIndex);
	//EXECUTE SCRIPT =====================================================================
	kseMap[iMID].iWidth = iWid;
	kseMap[iMID].iHeight = iHgt;
	
	//resize map-tile data
	if (kseMap[iMID].iTileDataMax > 0) { kseMap[iMID].iTileData.clear(); }
	kseMap[iMID].iTileDataMax = kseMap[iMID].iLayers * iWid * iHgt;
	for (int i = 0; i < kseMap[iMID].iTileDataMax; ++i) {
		//kseMap[iMID].iTileData = Allocate(kseMap[iMID].iTileDataMax*sizeof(typeMapTile));
		typeMapTile l_tmp;
		kseMap[iMID].iTileData.push_back(l_tmp);
	}
	
	return iIndex;
}

unsigned long MapSetLayers(unsigned long &iIndex) {
	int iLyr;
	int iMID;
	
	iIndex = Map_SkipOpenParenthesisAfter("SetLayers", iIndex);
	
		iLyr = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = Map_SkipCommaAfter("SetLayers(layers ", iIndex);
	
		iMID = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = Map_SkipCloseParenthesisAfter("SetLayers(layers, map", iIndex);
	//EXECUTE SCRIPT =====================================================================
	kseMap[iMID].iLayers = iLyr;
	
	if (iLyr < 2) { Engine_Message(KSE_GetErrFileSrc(iIndex) + "There should at least be 2 Layers for a Map.", "Logic Error"); }
	
	if (kseMap[iMID].iTileDataMax > 0) { kseMap[iMID].iTileData.clear(); }
	kseMap[iMID].iTileDataMax = iLyr * kseMap[iMID].iWidth * kseMap[iMID].iHeight;
	
	//resize map-tile data
	for (int i = 0; i < kseMap[iMID].iTileDataMax; ++i) {
		//kseMap[iMID].iTileData = Allocate(kseMap[iMID].iTileDataMax*sizeof(typeMapTile));
		typeMapTile l_tmp;
		kseMap[iMID].iTileData.push_back(l_tmp);
		//kseMap[iMID].iLayer = Allocate(iLyr*sizeof(int));
		kseMap[iMID].iLayer.push_back(0);
	}
	
	return iIndex;
}

unsigned long MapGenerate(unsigned long &iIndex) {
	int iMID;
	
	iIndex = Map_SkipOpenParenthesisAfter("Generate", iIndex);
	
		iMID = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = Map_SkipCloseParenthesisAfter("Generate(map", iIndex);
	//EXECUTE SCRIPT =====================================================================
	
	long iTileSet;
	long iTileDim;
	int iTileCol;
	int iTileRow;
	int iTileX;
	int iTileY;
	long iTile;
	int iTileIdx;
	
	//if (kseMap[iMid].sName == "") {
	//	Engine_Message(KSE_GetErrFileSrc(iIndex) + "No Map was loaded.", "LOGIC ERROR AT LINE " + kseToken[iIndex].iLine);
	//} else if (kseMap[iMid].iTileSet = kseMAP_NO_TILESET) {
	//	Engine_Message(KSE_GetErrFileSrc(iIndex) + "(  " + kseMap[iMid].sName + "  ) does not have a TileSet.", "LOGIC ERROR AT LINE " + kseToken[iIndex].iLine);
	//}
	//get TileSet data
	iTileSet = kseMap[iMID].iTileSet;
		iTileDim = kseTileSet[iTileSet].iDimension;
		iTileCol = kseTileSet[iTileSet].iCol;
		iTileRow = kseTileSet[iTileSet].iRow;
		iTileSet = kseTileSet[iTileSet].iPicture; //[QuixiePP] <-- huh?
	
	//extract tiles from TileSet
	iTileX = 1;
	iTileY = 1;
	iTileIdx = 0; // arrays start from 0; index 0 is not used for any temp purposes
	if (kseMap[iMID].iTileImgHdlrMax > 0) { kseMap[iMID].iTileImgHdlr.clear(); }
//	kseMap[iMID].iTileImgHdlr = Allocate((iTileRow * iTileCol) * sizeof(Integer)); //[QuixiePP] will use push_back on for loop in line 216
	kseMap[iMID].iTileImgHdlrMax = iTileRow * iTileCol;
	
	int i;
	int ii;
	int iLyr;
	
	for (i = 1; i < iTileRow; ++i) {
		for (ii = 1; ii < iTileCol; ++ii) {
			
			//queue another tile
			iTile = CreateNewImage();
			InitializeImage(iTile, iTileDim, iTileDim);
			
			#ifdef QUIXIE_CAIRO
				kseImg[iTile].imgCairo = cairo_image_surface_create_for_data(kseImg[iTile].img, CAIRO_FORMAT_ARGB32, iTileDim, iTileDim, iTileDim*sizeof(int));
			#endif
			
			//extract a tile from tileset
			Engine_GrabRegion(iTileX,
							  iTileY,
							  iTileDim,
							  iTileDim,
							  iTileSet,
							  iTile);
			
			//			kseMap[iMID].iTileImgHdlr[iTileIdx] = iTile;
			kseMap[iMID].iTileImgHdlr.push_back(iTile);
			
			iTileX = iTileX + iTileDim + 1;
			++iTileIdx;
		}
		iTileX = 1;
		iTileY = iTileY + iTileDim + 1;
	}
	//added this  03.26.07 to optimize rendering speed
	//start creating the layer image
	long iTmpPicIdx;
	
	iTileX = 1;
	iTileIdx = 0;
	int iTileDataIdx;
	
	for (iLyr = 0; i < kseMap[iMID].iLayers - 1; ++iLyr) {
		if (iLyr != kseMap[iMID].iLayerEntity-1 && iLyr != kseMap[iMID].iLayerObstruct-1 && iLyr != kseMap[iMID].iLayerTrigger-1) {
			iTileY = 1;
			iTmpPicIdx = CreateNewImage();
			//initialize the null image to "single-tile area" * "tile-width and/or height"
			InitializeImage(iTmpPicIdx, iTileDim * kseMap[iMID].iWidth, iTileDim * kseMap[iMID].iHeight);
			
			//---+ [do the filling of pink]
			#ifdef QUIXIE_CAIRO
				kseImg[iTmpPicIdx].imgCairo = cairo_image_surface_create_for_data(kseImg[iTmpPicIdx].img, CAIRO_FORMAT_ARGB32, iTileDim * kseMap[iMID].iWidth, iTileDim * kseMap[iMID].iHeight, iTileDim * kseMap[iMID].iWidth * sizeof(int));
			#else
//				Line kseImg[iTmpPicIdx].img,(0, 0)-(iTileDim * kseMap[iMID].iWidth, iTileDim * kseMap[iMID].iHeight), RGB(255, 0, 255), bf //[QuixiePP] revisit!
			#endif
			//_________________________________________________________
			
			kseMap[iMID].iLayer[iLyr] = iTmpPicIdx;
			
			for (i = 1; i < kseMap[iMID].iHeight; ++i) {
				for (ii = 1; ii < kseMap[iMID].iWidth; ++ii) {
					if (kseMap[iMID].iTileData[iTileIdx].bStatic == true
							&& kseMap[iMID].iTileData[iTileIdx].iIdx > 0) {
						//paint tile to layer
						
						iTileDataIdx = kseMap[iMID].iTileData[iTileIdx].iIdx;
						
						Engine_BlitToRegion(kseMap[iMID].iTileImgHdlr[iTileDataIdx - 1],
											 iTileX - 1,
											 iTileY - 1,
											 CInt(iTileDim),
											 CInt(iTileDim),
											 0,
											 kseMap[iMID].iLayer[iLyr],
											 CInt(kseImg[kseMap[iMID].iLayer[iLyr]].imgWidth),
											 CInt(kseImg[kseMap[iMID].iLayer[iLyr]].imgHeight));
					}
					iTileX = iTileX + iTileDim;
					++iTileIdx;
				}
				iTileX = 1;
				iTileY = iTileY + iTileDim;
			}
		} else {
			iTileIdx = iTileIdx + (kseMap[iMID].iWidth * kseMap[iMID].iHeight);
		}
	}
	kseMap[iMID].Map = CreateNewImage();
	InitializeImage(kseMap[iMID].Map, iTileDim * kseMap[iMID].iWidth, iTileDim * kseMap[iMID].iHeight);
	#ifdef QUIXIE_CAIRO
		kseImg[kseMap[iMID].Map].imgCairo = cairo_image_surface_create_for_data(kseImg[kseMap[iMID].Map].img, CAIRO_FORMAT_ARGB32, iTileDim * kseMap[iMID].iWidth, iTileDim * kseMap[iMID].iHeight, iTileDim * kseMap[iMID].iWidth * sizeof(int));
	#endif
	
	//kseMap[iMID].Entities = Allocate(kseMap[iMID].EntitiesCtr * sizeof(typeEntity));
	kseMap[iMID].Entities.clear();
	typeEntity l_foo;
	for (i = 1; i < kseMap[iMID].EntitiesCtr; ++i) {
		kseMap[iMID].Entities.push_back(l_foo);
	}
	++kseMap[iMID].EntitiesCtr;
	
	return iIndex;
}

////
// <b>Map:Load</b> - loads the map and calls the file's map contructor.
//
// @param    iIndex - Index of the parsed script
// @return   New index value of the parsed script.
// @remarks None.
//<div class="KS">
// <b>KonsolScript Users:</b><br>
// <br><b>Description:</b><br>
// Loads the map and calls the file's map contructor..<br>
// <br><br><b>Parameters:</b><br>
// <ul>
//  <li>string <b>map_filename</b> - filename of the map file without dot-KS.
// </ul>
// <b>Usage:</b><br>
// <pre>
//  //provided that myMap.ks exists
//  Map:Load("myMap")
//</pre>
//</div>
unsigned long MapLoad(unsigned long &iIndex) {
	iIndex = Map_SkipOpenParenthesisAfter("Load", iIndex);
	trace("mapload 1");
		sMapName = KSE_GetTokenStrValueOf(iIndex);
	trace("mapload 2");
	iIndex = Map_SkipCloseParenthesisAfter("Load(map_name", iIndex);
	trace("mapload 3");
	//EXECUTE SCRIPT =====================================================================
	Engine_RunMapScript(sMapName); //call the constructor
	return iIndex;
}

void Engine_NormalizeEntityLocation() {
	int iMID = kseMAP_CURRENT_RENDER;
	int X;
	int XX;
	int Y;
	int YY;
	for (int i = 1; i < kseMap[iMID].EntitiesCtr - 1; ++i) {
		X = kseMap[iMID].Entities[i].iX;
		XX = (X % kseMap[iMID].MapDimension);
		kseMap[iMID].Entities[i].iX = X - XX;
		
		Y = kseMap[iMID].Entities[i].iY;
		YY = (Y % kseMap[iMID].MapDimension);
		kseMap[iMID].Entities[i].iY = Y - YY;
	}
}

//I think Map:Generate and Degenerate should not be exposed to users -- should be automatic on Game:Load/Unload
unsigned long MapDegenerate(unsigned long &iIndex) {
	int iMID;
	iIndex = Map_SkipOpenParenthesisAfter("Degenerate", iIndex);
	
		iMID = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = Map_SkipCloseParenthesisAfter("Degenerate(map", iIndex);
	//EXECUTE SCRIPT =====================================================================
	
	int iTileIdx = 1;
	for (int i = 1; i < kseMap[iMID].iHeight; ++i) {
		for (int ii = 1; ii < kseMap[iMID].iWidth; ++ii) {
			UnloadImage(CULng(kseMap[iMID].iTileImgHdlr[iTileIdx]));
			
			++iTileIdx;
		}
	}
	
	kseMap[iMID].sName = "";
	
	//clear used data
	if (kseMap[iMID].iTileImgHdlrMax > 0) {
		kseMap[iMID].iTileImgHdlr.clear();
		kseMap[iMID].iTileImgHdlrMax = 0;
	}
	
	return iIndex;
}

unsigned long MapDetachTileSet(unsigned long &iIndex) {
	int iMID;
	
	iIndex = Map_SkipOpenParenthesisAfter("DetachTileSet", iIndex);
	
		iMID = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = Map_SkipCloseParenthesisAfter("DetachTileSet(map", iIndex);
	//EXECUTE SCRIPT =====================================================================
	kseMap[iMID].iTileSet = kseMAP_NO_TILESET;
	
	return iIndex;
}

unsigned long MapUnload(unsigned long &iIndex) {
//stops rendering; and should automatically call Map_Degenerate?
	int iMID;
	iIndex = Map_SkipOpenParenthesisAfter("Unload", iIndex);
	
		iMID = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = Map_SkipCloseParenthesisAfter("Unload(map", iIndex);
	//EXECUTE SCRIPT =====================================================================
	kseMap[iMID].bRender = false;
	kseMap[iMID].bRendering = false;
	
	return iIndex;
}

//void Engine_LocateEntityOnMap(iEntity &int, int iMapID = -1) {
//	if (iMapID = -1) { iMapID = asd; }
//	//use this to move to new location
//	//NOTE:get the tile thru entitylayer and the x,y coordination of entity
//	int iIdx = ((iMapEntityLayer - 1) * iMapWidth * iMapHeight) +
//		   (kseEntity[iEntity].iY * iMapHeight) +
//		   kseEntity[iEntity].iX;
//
//	//check if it was the same entity; this is to avoid misuse of this function
//	if (kseMap[iMapID].iTileData(iIdx].iEntityIdx == kseMAP_NO_ENTITY) {
//		kseMap[iMapID].iTileData(iIdx].iEntityIdx = iEntity + 1; //i added 1 to avoid value 0; 0 will be use for //NO ENTITY// flag
//	}
//}
//
//void Engine_RelocateEntityOnMap(&int iEntity) {
//	//use this to remove from old location
//	//NOTE:get the tile thru entitylayer and the x,y coordination of entity
//	int iIdx = ((iMapEntityLayer - 1) * iMapWidth * iMapHeight) +
//		   (kseEntity[iEntity].iY * iMapHeight) +
//		   kseEntity[iEntity].iX;
//
//	//check if it was the same entity; this is to avoid misuse of this function
//	if (kseMap[iMID].iTileData(iIdx].iEntityIdx == iEntity + 1) {
//		kseMap[iMID].iTileData(iIdx].iEntityIdx = 0; //0 will be use for //NO ENTITY// flag
//	}
//}

unsigned long MapSetEntityLayer(unsigned long &iIndex) {
	int iLyr;
	int iMID;
	iIndex = Map_SkipOpenParenthesisAfter("SetEntityLayer", iIndex);
	
		iLyr = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = Map_SkipCommaAfter("layer", iIndex);
	
		iMID = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = Map_SkipCloseParenthesisAfter("map", iIndex);
	//EXECUTE SCRIPT =====================================================================
	kseMap[iMID].iLayerEntity = iLyr;
	
	return iIndex;
}

unsigned long MapSetObstructionLayer(unsigned long &iIndex) {
	int iLyr;
	int iMID;
	
	iIndex = Map_SkipOpenParenthesisAfter("SetObstructionLayer", iIndex);
	
		iLyr = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = Map_SkipCommaAfter("SetObstructionLayer(layer", iIndex);
	
		iMID = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = Map_SkipCloseParenthesisAfter("SetObstructionLayer(layer, map", iIndex);
	//EXECUTE SCRIPT =====================================================================
	kseMap[iMID].iLayerObstruct = iLyr;
	
	return iIndex;
}

unsigned long MapSetTriggerLayer(unsigned long &iIndex) {
	int iLyr;
	int iMID;
	
	iIndex = Map_SkipOpenParenthesisAfter("SetTriggerLayer", iIndex);
	
		iLyr = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = Map_SkipCommaAfter("layer", iIndex);
	
		iMID = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = Map_SkipCloseParenthesisAfter("map", iIndex);
	//EXECUTE SCRIPT =====================================================================
	kseMap[iMID].iLayerTrigger = iLyr;
	
	return iIndex;
}

unsigned long MapNew(unsigned long &iIndex) {
	string sImagePath;
	int iNum;
	int iMapIdx;
	//change API to Map:New(width, height, layers, return)
	//-- or --
	//change API to Map:New(width, height, return)
	//change API to Layer:Add(map, ...)
	iIndex = Map_SkipOpenParenthesisAfter("New", iIndex);
	
	iNum = KSE_GetReturnIndexAndSkipCloseParenthesis("(", iIndex);
	//EXECUTE SCRIPT =====================================================================
	iMapIdx = CreateNewMap();
	kseMap[iMapIdx].sName = sMapName; //when Map:Load("mymap") is called, inside function 'mymap', Map:New is expected, thus setting the "mymap" to map name is then expected.
	SetNumValue(iNum, CDbl(iMapIdx), "", LOCK_IT);
	//====================================================================================
	return iIndex;
}

unsigned long MapFree(unsigned long &iIndex) {
	//frees up *all* map-used memory
	string sMap;
	
	iIndex = Map_SkipOpenParenthesisAfter("Free", iIndex);
	
		sMap = KSE_GetTokenStrValueOf(iIndex);
		SetNumValue(iIndex, 0, "", UNLOCK_IT);
	
	iIndex = Map_SkipCloseParenthesisAfter("Free(map", iIndex);
	//EXECUTE SCRIPT =====================================================================
	Engine_RunMapScript("FreeMap");
	//add entity to map
	
	return iIndex;
}

unsigned long CreateNewMap() {
	iMapCtr = kseMap.size();
	if (iMapCtr == 0) {
		typeMap l_map;
		kseMap.push_back(l_map);
		++iMapCtr;
	}
	
	for (unsigned long i = 0; i < iMapCtr; ++i) {
		if (kseMap[i].bUsed == false) {
			kseMap[i].bUsed = true;
			return i;
		}
	}
	
	//if it didnt, add new one
	typeMap l_map;
		l_map.bUsed = true;
	kseMap.push_back(l_map);
	
	++iMapCtr;
	
	return iMapCtr;
}

//_____________________________________________________________________________
unsigned long Map_SkipOpenParenthesisAfter(string sWhat, unsigned long &iIndex) {
	cMapTxt = "Map:" + sWhat;
	return KSE_SkipOpenParenthesisAfter(cMapTxt, iIndex);
}

unsigned long Map_SkipCommaAfter(string sWhat, unsigned long &iIndex) {
	cMapTxt = cMapTxt + sWhat;
	iIndex = KSE_SkipCommaAfter(cMapTxt, iIndex);
	cMapTxt = cMapTxt + ", ";
	return iIndex;
}

unsigned long Map_SkipCloseParenthesisAfter(string sWhat, unsigned long &iIndex) {
	cMapTxt = cMapTxt + sWhat;
	iIndex = KSE_SkipCloseParenthesisAfter(cMapTxt, iIndex);
	cMapTxt = "";
	return iIndex;
}
