
#Include Once "kageExterns.bi"

Declare Sub ServerThread(ByVal As Any Ptr)

#Define MAX_CLIENTS 32

Type CLIENT
	As FDSOCKET hClient
	As Any Ptr  hThread
	As Integer  blnExit
End Type
'todo: make client array size resizable (ReDim)
Dim Shared As CLIENT Clients(MAX_CLIENTS-1)
Dim Shared As Integer g_clientCtr

Dim Shared As FDSOCKET    hEngineConn
Dim Shared As SOCKADDR_IN Server, Client
Dim Shared As Integer     g_ret, addrsize, g_index
Dim Shared As String      net_sMsg
Dim Shared As String      net_statMsg
Dim Shared As String      net_errMsg
Dim Shared As Integer     bNetConnState

Const MSG_TYPE_EXIT = 101
Const MSG_TYPE_SERVERFULL = 102

Const MSG_INDEX_TYPE = 0
Const MSG_INDEX_SENDER = 1
Const MSG_INDEX_RECEIVER = 2
Const MSG_INDEX_MESSAGE = 3

Enum NETCONN_STATE
	NETCONN_CLOSE =  0 ' Uninitialized.    
	NETCONN_INIT  =  1 ' Connection is initialized
	NETCONN_OPEN  =  2 ' Connection is currently in use
	NETCONN_EXIT  =  3 ' Force exit Connection
End Enum

Sub Engine_ServerStart(pAny As Any Ptr)
	Server.sin_addr = INADDR_ANY
	g_ret = NetBind(hEngineConn, @Server, SizeOf(SOCKADDR_IN))
	If g_ret < 0 Then
		Engine_Log "Socket Port-bind Error", 1
		bNetConnState = NETCONN_CLOSE
		Exit Sub
	End If
	
	g_ret = NetListen(hEngineConn, 3)
	If g_ret < 0 Then
		Engine_Log "Socket Listen Error", 1
		bNetConnState = NETCONN_CLOSE
		Exit Sub
	End If
	Dim As Integer l_clientMax = Cast(Integer, pAny) - 1 '1 is reserved for server
	g_clientCtr = 0
	bNetConnState = NETCONN_OPEN
	While bNetConnState <> NETCONN_EXIT
		addrsize = SizeOf(SOCKADDR_IN)
		'If g_clientCtr < l_clientMax Then
			'g_ret = NetAccept(hEngineConn, @Client, @addrsize)
			g_ret = NetAccept(hEngineConn, 0, 0)
			
			If g_ret > -1 Then
				net_statMsg = "server: accept"
				If g_clientCtr < (MAX_CLIENTS - 1) Then
					' get next free client
					g_index = 0
					While Clients(g_index).hClient <> 0
						g_index += 1
					Wend
					Clients(g_index).hClient = g_ret
					Clients(g_index).hThread = ThreadCreate(@Engine_ServerStartThread, Cast(Any Ptr, g_index))
					g_clientCtr += 1
					net_statMsg = "server: connections=" & Str(g_clientCtr)
				Else
					net_errMsg = "Server Full Error"
					Engine_Log net_errMsg, 1
					Engine_Send(net_errMsg, MSG_TYPE_SERVERFULL)
				End If
			ElseIf g_ret = WSAEWOULDBLOCK Then
				'it's okay
			ElseIf g_ret = -1 Then
				'possible case:
				' * engine closed
				' * TODO: list as you go along
			Else
				Engine_Log "g_ret " & g_ret, 1
				net_errMsg = "Server Accept Error"
				Engine_Log net_errMsg, 1
				bNetConnState = NETCONN_EXIT
			End If
		'EndIf
		
		Sleep 2
	Wend
	
	bNetConnState = NETCONN_CLOSE
	
	net_statMsg = "Server Close"
End Sub

' for use by Engine_ServerStart
Sub Engine_ServerStartThread(ByVal lpany As Any Ptr)
	Dim As Integer l_ret, l_index = Cast(Integer, lpAny)
	Dim sData As String
	Dim sDataCopy As String
	Dim bData As Byte
	Dim sMsg() As String
	Dim sMsgTrim() As String
	Dim i As Integer
	Dim lngMsgType As Long          'A value indicating the type of message this is
	net_statMsg = "connected client(" & l_index & ")"
	Clients(l_index).blnExit = 0
	While Clients(l_index).blnExit = 0 Or bNetConnState <> NETCONN_EXIT
		l_ret = NetReceiveString(Clients(l_index).hClient, sData)
		If l_ret < 1 Then
			'sData = "thread: l_ret<1"
			'Clients(l_index).blnExit = 1
		Else
			Engine_Log "sData " & sData, 1
			sDataCopy = sData
			
			While sData <> ""
				Split sData, Chr(2), sMsg()
				
				Split sMsg(MSG_INDEX_MESSAGE), Chr(3), sMsgTrim()
				
				sMsg(MSG_INDEX_MESSAGE) = sMsgTrim(0)
				
				lngMsgType = CLng(sMsg(MSG_INDEX_TYPE))
				
				If lngMsgType > 2400 Then
					bData = 1
					lngMsgType = lngMsgType - 2400
				EndIf
				
				If CLng(sMsg(MSG_INDEX_RECEIVER)) = 0 Or CLng(sMsg(MSG_INDEX_RECEIVER)) = kseNet.playerID Then
					sData = sMsg(MSG_INDEX_SENDER) & Chr(2) & sMsg(MSG_INDEX_MESSAGE) 'removed sMsg(2); message is for receiver 
					'TODO: get sender info; lngMsgType should be the index of the user who sent data/msg
					If bData Then
						sNetData = sNetData & kseVARSEPARATOR & "KSNET" & kseVALUESEP & lngMsgType & Chr(2) & sData
						Engine_NetDataPush(lngMsgType, CInt(sMsg(MSG_INDEX_SENDER)), kseNet.playerID, sMsg(MSG_INDEX_MESSAGE))
					Else
						sNetMsg = sNetMsg & kseVARSEPARATOR & "KSNET" & kseVALUESEP & lngMsgType & Chr(2) & sData
						Engine_NetDataPush(lngMsgType, CInt(sMsg(MSG_INDEX_SENDER)), kseNet.playerID, sMsg(MSG_INDEX_MESSAGE))
					End If
				EndIf
				
				
				'TODO: only send copies to fellow Clients every once in a while -- not always
					If CInt(sMsg(MSG_INDEX_TYPE)) <> MSG_TYPE_EXIT Then
						For i = 0 To MAX_CLIENTS - 1
							If Clients(i).hThread <> 0  And i <> l_index Then
								Engine_Send(sMsg(MSG_INDEX_MESSAGE), CInt(sMsg(MSG_INDEX_TYPE)),Clients(i).hClient) ' 4 is _3 Chr(2) and 1 Chr(3)_
							End If
						Next
					End If
				
				If iGotMessage > 0 Then kseFunction(iGotMessage).RunScript()
				
				sData = Mid(sDataCopy, _
								Len(sMsg(MSG_INDEX_TYPE)) + _
								Len(sMsg(MSG_INDEX_SENDER)) + _
								Len(sMsg(MSG_INDEX_RECEIVER)) + _
								Len(sMsg(MSG_INDEX_MESSAGE)) + 5) ' 3 Chr(2) and 1 Chr(3) and 1 offset
				
				sDataCopy = sData
			Wend
			
			net_statMsg = "thread:(" & Str(l_index) &") got a message " & sData
			If InStr(sData,"exit") Then
				Clients(l_index).blnExit = 1
				NetClose Clients(l_index).hClient
				bNetConnState = NETCONN_EXIT
'			Else
'				net_statMsg = "thread:(" & Str(l_index) &") send ok"
'				Engine_Send("ok", 102,Clients(l_index).hClient)
			End If
		End If
	Wend
	net_statMsg = "disconnected client(" & l_index & ")"
	NetClose Clients(l_index).hClient
	Clients(l_index).hClient = 0
	g_clientCtr -= 1
End Sub

Sub Engine_ClientStart(pAny As Any Ptr)
	Dim As Integer l_ret
	Dim sData As String
	Dim sDataCopy As String
	Dim bData As Byte
	Dim sMsgTrim() As String
	Dim sMsg() As String
	Dim lngMsgType As Long          'A value indicating the type of message this is
	bNetConnState = NETCONN_OPEN
	While bNetConnState <> NETCONN_CLOSE
'ChiSock
'		kseNet.sockMain.get(sData)
'fbNet
		l_ret = NetReceiveString(hEngineConn, sData)
		If (l_ret < 0) Then
			'bNetConnState = NETCONN_EXIT
		Else
		Engine_Log "sData " & sData, 1
			sDataCopy = sData
			While sData <> ""
				Split sData, Chr(2), sMsg()
				
				Split sMsg(MSG_INDEX_MESSAGE), Chr(3), sMsgTrim()
				
				sMsg(MSG_INDEX_MESSAGE) = sMsgTrim(0)
				
				lngMsgType = CLng(sMsg(MSG_INDEX_TYPE))
				
				If lngMsgType > 2400 Then
					bData = 1
					lngMsgType = lngMsgType - 2400
				EndIf
				
				If CLng(sMsg(MSG_INDEX_RECEIVER)) = 0 Or CLng(sMsg(MSG_INDEX_RECEIVER)) = kseNet.playerID Then
					sData = sMsg(MSG_INDEX_SENDER) & Chr(2) & sMsg(MSG_INDEX_MESSAGE) 'removed sMsg(2); message is for receiver
					'TODO: get sender info; lngMsgType should be the index of the user who sent data/msg
					If bData Then
						sNetData = sNetData & kseVARSEPARATOR & "KSNET" & kseVALUESEP & lngMsgType & Chr(2) & sData
						Engine_NetDataPush(lngMsgType, CInt(sMsg(MSG_INDEX_SENDER)), kseNet.playerID, sMsg(MSG_INDEX_MESSAGE))
					Else
						sNetMsg = sNetMsg & kseVARSEPARATOR & "KSNET" & kseVALUESEP & lngMsgType & Chr(2) & sData
						Engine_NetDataPush(lngMsgType, CInt(sMsg(MSG_INDEX_SENDER)), kseNet.playerID, sMsg(MSG_INDEX_MESSAGE))
					End If
				EndIf
				
				sData = Mid(sDataCopy, _
								Len(sMsg(MSG_INDEX_TYPE)) + _
								Len(sMsg(MSG_INDEX_SENDER)) + _
								Len(sMsg(MSG_INDEX_RECEIVER)) + _
								Len(sMsg(MSG_INDEX_MESSAGE)) + 5) ' 3 Chr(2) and 1 Chr(3) and 1 offset
				
				sDataCopy = sData
				
				If CInt(sMsg(MSG_INDEX_TYPE)) = MSG_TYPE_EXIT Then
					If iGotDisconnected > 0 Then kseFunction(iGotDisconnected).RunScript()
				Else
					If iGotMessage > 0 Then kseFunction(iGotMessage).RunScript()
				EndIf
			Wend
		End If
	Wend
End Sub

''
' Used by engine for parsing and interpreting
'
' @return String
' @remarks None.
Dim cNetTxt As String

''
' Holds lists of players currently in network
'
' @return String
' @remarks None.
ReDim lstPlayer() As String

''
' Holds lists of messages queued for manual fetching
'
' @return String
' @remarks If you plan to implement KonsolScript in other language (C/C++), use linked list instead.
Dim Shared sNetMsg As String
Type typeNetMsg
	sMsg As String
	iSender As Integer
	iReceiver As Integer
	
	bUsed As Byte
End Type

''
' Holds lists of game-data-messages queued for manual fetching
'
' @return String
' @remarks If you plan to implement KonsolScript in other language (C/C++), use linked list instead.
Dim Shared sNetData As String

Dim Shared kseNetData() As typeNetData
Dim Shared kseNetData_count As Long

''
' Parses and interprets KonsolScript's <b>Net</b> functions.
'
' @param    iIndex - Index of the parsed script
' @return   New index value of the parsed script.
' @remarks None.
'<div class="KS">
' <b>KonsolScript Users:</b><br>
' <br><b>Description:</b><br>
' Net class currently contains the functions:
' <ul>
' <li><b><a href="modKONSoL_Net.NetHost.html">Host</a></b> - hosts a connection.
' <li><b><a href="modKONSoL_Net.NetJoin.html">Join</a></b> - joins a server.
' <li><b><a href="modKONSoL_Net.NetSend.html">Send</a></b> - sends message to all.
' <li><b><a href="modKONSoL_Net.NetSendData.html">SendData</a></b> - sends a game-data.
' <li><b><a href="modKONSoL_Net.NetSendTo.html">SendTo</a></b> - sends message to a player.
' <li><b><a href="modKONSoL_Net.NetCheck.html">Check</a></b> - checks network connection.
' <li><b><a href="modKONSoL_Net.NetGetMessage.html">GetMessage</a></b> - retrieves one queued message at a time.
' <li><b><a href="modKONSoL_Net.NetGetData.html">GetData</a></b> - retrieves one queued data at a time.
' </ul>
'</div>
Public Function SynNet(iIndex As Long) As Integer
	iIndex = GetNearestTokenIndex(kseCOLON, "Net", iIndex)   'look for        :
	iIndex = GetNextIndex(iIndex)
	Select Case kseToken(iIndex).sToken
		Case "Quit"
			Return NetQuit(iIndex)
		Case "Host"
			Return NetHost(iIndex)
		Case "Join"
			Return NetJoin(iIndex)
		Case "Send"
			Return NetSend(iIndex)
		Case "SendTo"
			Return NetSendTo(iIndex)
		Case "Check"
			Return NetCheck(iIndex)
		Case "GetData"
			Return NetGetData(iIndex)
		Case "GetMessage"
			Return NetGetMessage(iIndex)
		Case Else
			Engine_Message KSE_GetErrFileSrc(iIndex) & "(  " & KSE_GetToken(iIndex) & "  ) is not in Net Class.", "ERROR AT LINE " & kseToken(iIndex).iLine, True
	End Select
End Function

''
' <b>Net:Quit</b> - disconnects from network.
'
' @param    iIndex - Index of the parsed script
' @return   New index value of the parsed script.
' @remarks  None.
'<div class="KS">
' <b>KonsolScript Users:</b><br>
' <br><b>Description:</b><br>
' After hosting/joining a network, disconnect by using <b>Net:Quit</b>.
' <br><br><b>Parameters:</b><br>
' <ul>
'  <li>None.
' </ul>
' <b>Usage:</b><br>
' <pre>
' //provided we have made a connection
' Net:Quit()
' </pre>
'</div>
Private Function NetQuit(iIndex As Long) As Integer
	iIndex = Net_SkipOpenParenthesisAfter("Quit", iIndex)
	iIndex = Net_SkipCloseParenthesisAfter("(", iIndex)
	'EXECUTE SCRIPT ========================================
'ChiSock
'	If kseNet.sockMain.Close() <> chi.SOCKET_OK Then
'		'TODO: uninitialize connection object
'		kseNet.Connected = 0
'	EndIf
	Engine_NetQuit
	
	Return iIndex
End Function

''
' <b>Net:Host</b> - hosts a connection.
'
' @param    iIndex - Index of the parsed script
' @return   New index value of the parsed script.
' @remarks None.
'<div class="KS">
' <b>KonsolScript Users:</b><br>
' <br><b>Description:</b><br>
' Hosts a connection.<br>
' No need to have any buffer -- just a <b>Boolean</b> variable to check the success.
' <br><br><b>Parameters:</b><br>
' <ul>
'  <li>String <b>host_player_name</b> - name to use in the network game.
'  <li>Number <b>max_players</b> - maximum allowed players.
'  <li>String <b>session_name</b> - name of the session to join at.
'  <li>Boolean <b>return</b> - a return variable that will have a value depending on the success of attempting to join a network.
' </ul>
' <b>Usage:</b><br>
' <pre>
'  Var:Boolean got_connection;
'  Net:Host("im_ur_host", 5, "my_session", got_connection)
'  while (got_connection EQ true) {
'    Net:Check()
'  }
' </pre>
' <b>Parameter : </b>
'</div>
Private Function NetHost(iIndex As Long) As Integer
	Dim iBool As Integer
	Dim sess_name As String
	Dim pName As String
	Dim iMaxPlayer As Integer
	
	iIndex = Net_SkipOpenParenthesisAfter("Host", iIndex)
	
		pName = KSE_GetTokenStrValueOf(iIndex)
	
	iIndex = Net_SkipCommaAfter("host_player_name", iIndex)
	
		iMaxPlayer = KSE_GetTokenNumValueOf(iIndex)
	
	iIndex = Net_SkipCommaAfter("max_members", iIndex)
	
		sess_name = KSE_GetTokenStrValueOf(iIndex)
	
	iIndex = Net_SkipCommaAfter("session_name", iIndex)
	
		iIndex = GetNextIndex(iIndex)
			iBool = iIndex
	
	iIndex = Net_SkipCloseParenthesisAfter("return", iIndex)
	'EXECUTE SCRIPT ========================================
	With kseNet
		.playerName = pName
		.hMaxplayer = iMaxPlayer
		.hSessName = sess_name
		
		If Engine_Host() = 1 Then
			SetBoolValue iBool, 1
		Else
			SetBoolValue iBool, 0
		End If
	End With
	
	Return iIndex
End Function

''
' <b>Net:Check</b> - checks network connection.
'
' @param    iIndex - Index of the parsed script
' @return   New index value of the parsed script.
' @remarks  Checking network connection is only when connected.
'<div class="KS">
' <b>KonsolScript Users:</b><br>
' <br><b>Description:</b><br>
' Placing <b>Net:Check</b> on a loop will repeatedly monitor our connection. In case someone sent a message, then it fires the <b>_onReceive</b> listener function.
' <br><br><b>Parameters:</b><br>
' <ul>
'  <li>None.
' </ul>
' <b>Usage:</b><br>
' <pre>
' //main loop
' while (game_not_over EQ true) {
'   //provided we have made a connection
'   Net:Check()
' }
'</pre>
'</div>
Private Function NetCheck(iIndex As Long) As Integer
	iIndex = Net_SkipOpenParenthesisAfter("Check", iIndex)
	iIndex = Net_SkipCloseParenthesisAfter("(", iIndex)
	'EXECUTE SCRIPT ===================================
	On Error GoTo ptrErr
'ChiSock	
'	If kseNet.Connected = 1 Then Engine_CheckConnection()
	
	Return iIndex
ptrErr:
	trace("Failed at Net:Check")
End Function

''
' <b>Net:Join</b> - joins a server.
'
' @param    iIndex - Index of the parsed script
' @return   New index value of the parsed script.
' @remarks None.
'<div class="KS">
' <b>KonsolScript Users:</b><br>
' <br><b>Description:</b><br>
' Joins a server.<br>
' No need to have any buffer -- just a <b>Boolean</b> variable to check the success.
' <br><br><b>Parameters:</b><br>
' <ul>
'  <li>String <b>client_player_name</b> - name to use in the network game.
'  <li>String <b>session_name</b> - name of the session to join at.
'  <li>String <b>host_pc</b> - name or IP of the computer hosting a network game.
'  <li>Boolean <b>return</b> - a return variable that will have a value depending on the success of attempting to join a network.
' </ul>
' <b>Usage:</b><br>
' <pre>
'  Var:Boolean got_connection;
'  Net:Join("im_a_client", "my_session", "host_pc", got_connection)
'  while (got_connection EQ true) {
'    Net:Check()
'  }
' </pre>
'</div>
Private Function NetJoin(iIndex As Long) As Integer
	Dim iBool As Integer
	Dim pName As String
	Dim session_name As String
	Dim host_name As String
	iIndex = Net_SkipOpenParenthesisAfter("Join", iIndex)
	
		pName = KSE_GetTokenStrValueOf(iIndex)
	
	iIndex = Net_SkipCommaAfter("client_player_name", iIndex)
	
		session_name = KSE_GetTokenStrValueOf(iIndex)
	
	iIndex = Net_SkipCommaAfter("session_name", iIndex)
	
		host_name = KSE_GetTokenStrValueOf(iIndex)
	
	iIndex = Net_SkipCommaAfter("host", iIndex)
	
		iIndex = GetNextIndex(iIndex)
			iBool = iIndex
	
	iIndex = Net_SkipCloseParenthesisAfter("return", iIndex)
	'EXECUTE SCRIPT ========================================
	'connect to host
	With kseNet
		.playerName = pName
		.hSessName = session_name
		.IP = host_name
		If Engine_Join(host_name, kseNET_PORT) Then
			SetBoolValue iBool, 1
		Else
			SetBoolValue iBool, 0
		End If
	End With
	Return iIndex
End Function

''
' <b>Net:Send</b> - sends message to all.
'
' @param    iIndex - Index of the parsed script
' @return   New index value of the parsed script.
' @remarks None.
'<div class="KS">
' <b>KonsolScript Users:</b><br>
' <br><b>Description:</b><br>
' Send a message to all players.
' <br><br><b>Parameters:</b><br>
' <ul>
'  <li>String <b>message</b> - message to send.
'  <li>Boolean <b>return</b> - returns <b>true</b> if message was successfully sent, and <b>false</b> otherwise.
' </ul>
' <b>Usage:</b><br>
' <pre>
'  Var:Boolean sent;
'  //after successful hosting/joining a game
'  Net:Send("Hello!",sent)
'  if (sent EQ true) {
'    Konsol:Log("Message sent")
'  }
' </pre>
'</div>
Private Function NetSend(iIndex As Long) As Integer
	Dim sMsg As String
	Dim iBool As Integer
	iIndex = Net_SkipOpenParenthesisAfter("Send", iIndex)
	
		sMsg = KSE_GetTokenStrValueOf(iIndex)
	
	iIndex = Net_SkipCommaAfter("msg", iIndex)
	
		iIndex = GetNextIndex(iIndex)
			iBool = iIndex
	
	iIndex = Net_SkipCloseParenthesisAfter("return", iIndex)
	'EXECUTE SCRIPT ========================================
	
	If kseNet.Hosting = 1 Then
		Dim i As Integer
		For i = 0 To MAX_CLIENTS - 1
			If Clients(i).hThread <> 0 Then
				Engine_Send(sMsg, 100,Clients(i).hClient) ' 4 is _3 Chr(2) and 1 Chr(3)_
			End If
		Next
	Else
		SetBoolValue iBool, Engine_Send(sMsg, 100)
	EndIf
	
	Return iIndex
End Function

''
' <b>Net:SendTo</b> - sends message to a player.
'
' @param    iIndex - Index of the parsed script
' @return   New index value of the parsed script.
' @remarks None.
'<div class="KS">
' <b>KonsolScript Users:</b><br>
' <br><b>Description:</b><br>
' Send a message to specific player.
' <br><br><b>Parameters:</b><br>
' <ul>
'  <li>String <b>message</b> - message to send.
'  <li>String <b>player_name</b> - name of player to send message to.
'  <li>Boolean <b>return</b> - returns <b>true</b> if message was successfully sent, and <b>false</b> otherwise.
' </ul>
' <b>Usage:</b><br>
' <pre>
'  Var:Boolean sent;
'  //after successful hosting/joining a game
'  Net:SendTo("Hello!","player_name",sent)
'  if (sent EQ true) {
'    Konsol:Log("Message sent")
'  }
' </pre>
'</div>
Private Function NetSendTo(iIndex As Long) As Integer
	Dim sMsg As String
	Dim player_name As String
	Dim iBool As Integer
	iIndex = Net_SkipOpenParenthesisAfter("SendTo", iIndex)
	
		player_name = KSE_GetTokenStrValueOf(iIndex)
	
	iIndex = Net_SkipCommaAfter("client_player_name", iIndex)
	
		sMsg = KSE_GetTokenStrValueOf(iIndex)
	
	iIndex = Net_SkipCommaAfter("msg", iIndex)
	
		iIndex = GetNextIndex(iIndex)
			iBool = iIndex
	
	iIndex = Net_SkipCloseParenthesisAfter("return", iIndex)
	'EXECUTE SCRIPT ========================================
	'TODO: improve by, get index of player and use it as second parameter
	SetBoolValue iBool, Engine_Send("@" & player_name & "-" & sMsg)
	
	Return iIndex
End Function

''
' <b>Net:GetMessage</b> - retrieves data from message buffer.
'
' @param    iIndex - Index of the parsed script
' @return   New index value of the parsed script.
' @remarks None.
'<div class="KS">
' <b>KonsolScript Users:</b><br>
' <br><b>Description:</b><br>
' This is different than other functions. All parameters are required to be declared variables.
' <br><br><b>Parameters:</b><br>
' <ul>
'  <li>String <b>player</b> - returns name of sender.
'  <li>String <b>message</b> - returns any message received.
'  <li>String <b>return</b> - returns <b>true</b> if message is not empty, and <b>false</b> otherwise.
' </ul>
' <b>Usage:</b><br>
' <pre>
'  //provided there is already a connection
'  function mygame_onReceive() {
'    Var:String sender,msg;
'    Var:Boolean got_message;
'    Net:GetMessage(sender,msg,got_message)
'
'    if (got_message EQ true) {
'      //display the retrieved message
'      Screen:PrintString(sender + " : " + msg)
'
'      //it is recommended to write your own function
'      //that will display the message that suits your game
'    }
'  }
' </pre>
'</div>
Private Function NetGetMessage(iIndex As Long) As Integer
	Dim sMsg As String
	Dim iPlr As Integer
	Dim iMsg As Integer
	Dim iBool As Integer
	
	iIndex = Net_SkipOpenParenthesisAfter("GetMessage", iIndex)
	
		iIndex = GetNextIndex(iIndex)
			iPlr = iIndex
	
	iIndex = Net_SkipCommaAfter("player", iIndex)
	
		iIndex = GetNextIndex(iIndex)
			iMsg = iIndex
	
	iIndex = Net_SkipCommaAfter("message", iIndex)
	
		iIndex = GetNextIndex(iIndex)
			iBool = iIndex
	
	iIndex = Net_SkipCloseParenthesisAfter("return", iIndex)
	'EXECUTE SCRIPT ========================================
	SetStrValue iPlr, ""
	SetStrValue iMsg, ""
	SetBoolValue iBool, 0
	On Error GoTo ptrErr
	If kseNetData_count > 0 Then
		Dim tmpNetData As typeNetData
		tmpNetData = Engine_NetDataPop()
		SetStrValue iPlr, Str(tmpNetData.fromID)
		SetStrValue iMsg, tmpNetData.content
		SetBoolValue iBool, 1
	EndIf
/'
	Dim sDataRaw() As String
	Dim sData() As String
	Dim sMsgs() As String
	
	Split sNetMsg, kseVARSEPARATOR, sDataRaw()
	If UBound(sDataRaw) > 0 Then
		If sDataRaw(1) <> "" Then
			Split sDataRaw(1), kseVALUESEP, sData()
			If sData(0) <> "" Or sData(0) = "KSNET" Then
				Split sData(1), Chr(2), sMsgs()
				If UBound(sMsgs) > 0 Then
					SetStrValue iPlr, sMsgs(1)
					SetStrValue iMsg, sMsgs(2)
					SetBoolValue iBool, 1
					'remove retrieved message from buffer
					sNetMsg = Mid(sNetMsg, Len(kseVARSEPARATOR & sDataRaw(1)) + 1)
				End If
			End If
		End If
	End If
'/	
	Return iIndex
ptrErr:
	trace("Failed at Net:GetMessage")
End Function

''
' <b>Net:SendData</b> - sends game data.
'
' @param    iIndex - Index of the parsed script
' @return   New index value of the parsed script.
' @remarks None.
'<div class="KS">
' <b>KonsolScript Users:</b><br>
' <br><b>Description:</b><br>
' Send a message to all players.
' <br><br><b>Parameters:</b><br>
' <ul>
'  <li>Number <b>code</b> - a non-zero, positive value as type of message. Whatever value it is, this depends on your game.
'  <li>String <b>message</b> - message to send (not necessarily a textual message, it can be numeric).
'  <li>Boolean <b>return</b> - returns <b>true</b> if data was successfully sent, and <b>false</b> otherwise.
' </ul>
' <b>Usage:</b><br>
' <pre>
'  Var:Boolean sent;
'  //after successful hosting/joining a game
'  Net:SendData("Hello!",sent)
'  if (sent EQ true) {
'    Konsol:Log("Message sent")
'  }
' </pre>
'</div>
Private Function NetSendData(iIndex As Long) As Integer
	Dim sMsg As String
	Dim iCode As Double
	Dim iBool As Integer
	iIndex = Net_SkipOpenParenthesisAfter("SendData", iIndex)
	
		iCode = KSE_GetTokenNumValueOf(iIndex)
	
	iIndex = Net_SkipCommaAfter("code", iIndex)
	
		sMsg = KSE_GetTokenStrValueOf(iIndex)
	
	iIndex = Net_SkipCommaAfter("msg", iIndex)
	
		iIndex = GetNextIndex(iIndex)
			iBool = iIndex
	
	iIndex = Net_SkipCloseParenthesisAfter("return", iIndex)
	'EXECUTE SCRIPT ========================================
	If iCode > 0 Then
		'SetBoolValue(iBool, Engine_Send(sMsg, iCode + 2400))  'original
		SetBoolValue(iBool, Engine_Send(sMsg, CLng(Str(iCode + 2400)))) 'stupid code just to let FBC generate C codes 
	Else
		SetBoolValue iBool, 0
	End If
	
	Return iIndex
End Function

''
' <b>Net:GetData</b> - retrieves data from message buffer.
'
' @param    iIndex - Index of the parsed script
' @return   New index value of the parsed script.
' @remarks None.
'<div class="KS">
' <b>KonsolScript Users:</b><br>
' <br><b>Description:</b><br>
' This is different than other functions. All parameters are required to be declared variables.
' <br><br><b>Parameters:</b><br>
' <ul>
'  <li>String <b>player</b> - returns name of sender.
'  <li>Number <b>code</b> - returns the type of message.
'  <li>String <b>message</b> - returns any message received.
'  <li>String <b>return</b> - returns <b>true</b> if message is not empty, and <b>false</b> otherwise.
' </ul>
' <b>Usage:</b><br>
' <pre>
'  //provided there is already a connection
'  function mygame_onReceiveData() {
'    Var:String sender,data;
'    Var:Number code;
'    Var:Boolean got_data;
'    Net:GetData(sender,data,got_data)
'
'    if (got_data EQ true) {
'      //react on the data received based on the code
'      if (code EQ 1) { //the sender chooses a character
'        if (data EQ "ck") {
'          //sender chooses Creek
'        } else if (data EQ "dk") {
'          //sender chooses Dork
'        }
'      } else if (code EQ 2) { //the sender chooses a map
'        if (data EQ "ph") {
'          //sender chooses Philippines
'        } else if (data EQ "us") {
'          //sender chooses America
'        }
'      } else { //handles unknown data
'        Konsol:Log(sender + " is sending unknown data: " + data)
'      }
'    }
'  }
' </pre>
'</div>
Private Function NetGetData(iIndex As Long) As Integer
	Dim sMsg As String
	Dim iPlr As Integer
	Dim iCode As Integer
	Dim iMsg As Integer
	Dim iBool As Integer
	iIndex = Net_SkipOpenParenthesisAfter("GetData", iIndex)
	
		iIndex = GetNextIndex(iIndex)
			iPlr = iIndex
	
	iIndex = Net_SkipCommaAfter("player", iIndex)
	
		iIndex = GetNextIndex(iIndex)
			iCode = iIndex
	
	iIndex = Net_SkipCommaAfter("code", iIndex)
	
		iIndex = GetNextIndex(iIndex)
			iMsg = iIndex
	
	iIndex = Net_SkipCommaAfter("message", iIndex)
	
		iIndex = GetNextIndex(iIndex)
			iBool = iIndex
	
	iIndex = Net_SkipCloseParenthesisAfter("return", iIndex)
	'EXECUTE SCRIPT ========================================
	Dim sData() As String
	Dim sMsgRaw() As String
	Dim sMsgs() As String
	
	Split sNetData, kseVARSEPARATOR, sData()
	If UBound(sData) > 0 Then
		If sData(1) <> "" Then
			Split sData(1), kseVALUESEP, sMsgRaw()
			
			If sMsgRaw(1) <> "" Then
				Split sMsgRaw(1), Chr(2), sMsgs()
				
				If sMsgs(0) <> "" Then
					SetStrValue iPlr, sMsgs(0)
					SetStrValue iCode, sMsgs(1)
					SetStrValue iMsg, sMsgs(2)
					SetBoolValue iBool, 1
					'remove retrieved data from buffer
					sNetData = Mid(sNetData, Len(kseVARSEPARATOR & sData(1)) + 1)
				End If
			End If
		End If
	End If
	
	SetBoolValue iBool, 0
	
	Return iIndex
End Function

''
' <b>Net:ListClientName</b> - retrieves all client's name in an array.
'
' @param    iIndex - Index of the parsed script
' @return   New index value of the parsed script.
' @remarks None.
'<div class="KS">
' <b>KonsolScript Users:</b><br>
' <br><b>Description:</b><br>
' Retrieves all client's name in a comma-separated string.
' <br><br><b>Parameters:</b><br>
' <ul>
'  <li>String <b>return</b> - contains comma-separated player names.
' </ul>
' <b>Usage:</b><br>
' <pre>
'  Var:Boolean sent;
'  Var:String playerList;
'  //after successful hosting/joining a game
'  Net:ListClientName(playerList)
' </pre>
'</div>
Private Function NetListClientName(iIndex As Long) As Integer
	Dim iStr As Integer
	iIndex = Net_SkipOpenParenthesisAfter("ListClientName", iIndex)
	iIndex = GetNextIndex(iIndex)
	iStr = iIndex
	iIndex = Net_SkipCloseParenthesisAfter("return", iIndex)
	'EXECUTE SCRIPT ========================================
	'set string-value with the comma-separated-player_name
	Return iIndex
End Function

''
' (<b>Dev API</b>) Net-class' wrapper for skipping open parenthesis.
'
' @param    sWhat - an open parenthesis should be written next to what text?
' @param    iIndex - Index of the parsed script
' @return   New index value of the parsed script.
' @remarks  Benchmark if organizing is worth the speed.
Private Function Net_SkipOpenParenthesisAfter(sWhat As String, iIndex As Long) As Integer
	cNetTxt = "Net:" & sWhat
	Return KSE_SkipOpenParenthesisAfter(cNetTxt, iIndex)
End Function

''
' (<b>Dev API</b>) Net-class' wrapper for skipping a comma.
'
' @param    sWhat - a comma should be written next to what text?
' @param    iIndex - Index of the parsed script
' @return   New index value of the parsed script.
' @remarks  Benchmark if organizing is worth the speed.
Private Function Net_SkipCommaAfter(sWhat As String, iIndex As Long) As Integer
	cNetTxt = cNetTxt & sWhat
	iIndex = KSE_SkipCommaAfter(cNetTxt, iIndex)
	cNetTxt = cNetTxt & ", "
	Return iIndex
End Function

''
' (<b>Dev API</b>) Net-class' wrapper for skipping close parenthesis.
'
' @param    sWhat - a close parenthesis should be written next to what text?
' @param    iIndex - Index of the parsed script
' @return   New index value of the parsed script.
' @remarks  Benchmark if organizing is worth the speed.
Private Function Net_SkipCloseParenthesisAfter(sWhat As String, iIndex As Long) As Integer
	cNetTxt = cNetTxt & sWhat
	iIndex = KSE_SkipCloseParenthesisAfter(cNetTxt, iIndex)
	cNetTxt = ""
	Return iIndex
End Function

''
' (<b>Dev API</b>) Initializes connection list.
'
' @return   Returns <b>True</b> if no error occured, and <b>False</b>, otherwise.
Private Function Engine_InitConnectionList() As Byte
'	Dim lConnCtr As Long   'How many different service providers are there?
'	Dim i As Long
'	On Error GoTo ptrErr
'	'Enumerate the connections
'	Set oEnumConn = DPLAY.GetDPEnumConnections("", DPCONNECTION_DIRECTPLAY)
'	'Determine the number of connections available
'	lConnCtr = oEnumConn.GetCount
'	Dim sConn As String
'	For i = 1 To lConnCtr
'		sConn = oEnumConn.GetName(i)
'		If sConn = kseSUPPORTED_DPLAY Then kseNet.TCP_IP = i
'	Next i
	
	Return 1
'ptrErr:
End Function

''
' (<b>Dev API</b>) Lists sessions.
'
' @return   Returns <b>True</b> if no error occured, and <b>False</b>, otherwise.
Private Function Engine_ListSessions() As Byte
	Dim iSessCtr As Integer                'How many sessions are available?
	Dim i As Integer
'	Dim oSessData As DirectPlaySessionData 'How is a session described?
	If Not (Engine_InitConnection()) Then Exit Function
	
'	On Error GoTo ptrErr
'	'Make a new SessionData object
'	Set oSessData = DPLAY.CreateSessionData
'	'Fill this object with the criterea we would like to use to descriminate sessions during enumeration
'	oSessData.SetGuidApplication APP_GUID
'	oSessData.SetSessionPassword ""
'	'Enumerate sessions with the current connection
'	Set oEnumSess = DPLAY.GetDPEnumSessions(oSessData, 0, DPENUMSESSIONS_AVAILABLE)
	Return 1
'ptrErr:
'    Engine_Log "@Net:(ListSess) " & Err.Number & " - " & Err.Description
End Function

''
' (<b>Dev API</b>) Updates player list.
'
' @return   Returns name of lastest player who joined.
' @remarks  This is called by Engine_CheckConnection when a player joined/quited.
Private Function Engine_UpdatePlayers() As String
	Dim i As Integer
	Dim strPlayerName As String
	Dim intPlayersWaiting As Integer
'	Dim oEnumPlayers As DirectPlayEnumPlayers
'	Dim oSessData As DirectPlaySessionData
'	On Error GoTo ptrErr
'	'Get the EnumPlayers object
'	Set oEnumPlayers = DPLAY.GetDPEnumPlayers("", 0)
'	'Determine how many players it contains
'	intPlayersWaiting = oEnumPlayers.GetCount
'	'Create a session data object
'	Set oSessData = DPLAY.CreateSessionData
'	'Get the current session data
'	DPLAY.GetSessionDesc oSessData
'	'Engine_UpdatePlayers = intPlayersWaiting
'	'For every player in the session, extract the short name, and add to a listbox
'	ReDim lstPlayer(intPlayersWaiting + 1) As String
'	For i = 1 To intPlayersWaiting
'	    lstPlayer(i) = oEnumPlayers.GetShortName(i)
'	    If i = 1 Then Engine_UpdatePlayers = lstPlayer(1)
'	Next
	Return ""
'ptrErr:
'	MsgBox "Engine_UpdatePlayers Error." & vbCrLf & Err.Description
End Function

''
' (<b>Dev API</b>) Checks received messages.
'
' @remarks  This is called by engine when <b>Net:Check</b> is used in the script.
Private Sub Engine_CheckConnection()
	Dim lngFromPlayerID As Long     'ID of player that message is from
	Dim lngToPlayerID As Long       'ID of player to whom message was sent
	Dim lngMsgType As Long          'A value indicating the type of message this is
'	Dim dpMsg As DirectPlayMessage  'An object that contains all message data
	Dim lngMsgCount As Long         'How many messages are in the queue?
	Dim strFromPlayerName As String 'What is the short name of the player who sent the message?
	Dim strChatText As String       'The chat text string
	'Handle errors that may occur if the session or player have not yet been created
/'	On Error GoTo ptrErr
'	'Find out how many messages are waiting for the player indicated by lngPlayerID
'	lngMsgCount = DPLAY.GetMessageCount(kseNet.playerID)
'	'Allow normal error handling to continue
'	On Error GoTo 0
'	'Process each message sequentially
'	Do While lngMsgCount > 0
'	    'Receive the message, and assign the "To" and "From" ID's
'	    Set dpMsg = DPLAY.Receive(lngFromPlayerID, lngToPlayerID, DPRECEIVE_ALL)
'	    'Read the first LONG from the message to determine the type
'	    lngMsgType = dpMsg.ReadLong()
'	    'Decrease the number of messages by one (we've just read one)
'	    lngMsgCount = lngMsgCount - 1
'	    'Check if this message was sent by the system
'	    If lngFromPlayerID = DPID_SYSMSG Then
'	        'Take action depending on the type of system message sent
'	        Select Case lngMsgType
'	            'If a player has joined
'	            Case DPSYS_DESTROYPLAYERORGROUP
'	                Debug.Print "last player " & Engine_UpdatePlayers
'	                Engine_RunScript , kseNet.hSessName & "_onClientQuit"
'	            Case DPSYS_CREATEPLAYERORGROUP
'	                Debug.Print "last player " & Engine_UpdatePlayers
'	                Engine_RunScript , kseNet.hSessName & "_onClientJoin"
'	            Case DPSYS_HOST
'	                'hosting transfered to this player
'	                kseNet.Hosting = True
'	            Case Else
'	                Debug.Print "DPSYS_xxx = " & lngMsgType
'	                    'DPSYS_CREATEPLAYERORGROUP     =  3
'	                    'DPSYS_DESTROYPLAYERORGROUP    =  5
'	                    'DPSYS_ADDPLAYERTOGROUP        =  7
'	                    'DPSYS_DELETEPLAYERFROMGROUP   = 33 (&H21)
'	                    'DPSYS_SESSIONLOST             = 49 (&H31)
'	                    'DPSYS_HOST                    =257 (&H101)
'	                    'DPSYS_SETPLAYERORGROUPDATA    =258 (&H102)
'	                    'DPSYS_SETPLAYERORGROUPNAME    =259 (&H103)
'	                    'DPSYS_SETSESSIONDESC          =260 (&H104)
'	                    'DPSYS_ADDGROUPTOGROUP         =261 (&H105)
'	                    'DPSYS_DELETEGROUPFROMGROUP    =262 (&H106)
'	                    'DPSYS_SECUREMESSAGE           =263 (&H107)
'	                    'DPSYS_STARTSESSION            =264 (&H108)
'	                    'DPSYS_CHAT                    =265 (&H109)
'	                    'DPSYS_SETGROUPOWNER           =266 (&H10A)
'	                    'DPSYS_SENDCOMPLETE            =269 (&H10D)
'	                    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'	                    'DPLSYS_CONNECTIONSETTINGSREAD =  1
'	                    'DPLSYS_DPLAYCONNECTFAILED     =  2
'	                    'DPLSYS_DPLAYCONNECTSUCCEEDED  =  3
'	                    'DPLSYS_APPTERMINATED          =  4
'	                    'DPLSYS_SETPROPERTY            =  5
'	                    'DPLSYS_SETPROPERTYRESPONSE    =  6
'	                    'DPLSYS_GETPROPERTY            =  7
'	                    'DPLSYS_GETPROPERTYRESPONSE    =  8
'	                    'DPLSYS_NEWSESSIONHOST         =  9
'	                    'DPLSYS_NEWCONNECTIONSETTINGS  = 10
'	        End Select
'	    'If not sent by system, this must be an application-defined message
'	    Else
'	        'Take action depending on the type of application message
'	        Select Case lngMsgType
'	            'If we've recieved chat text, apply it
'	            Case 0
'	                'IMPROVE THIS ONE; remember Net:SendTo
'	                If lngToPlayerID = kseNet.playerID Then
'	                    sNetMsg = sNetMsg & kseVARSEPARATOR & DPLAY.GetPlayerFriendlyName(lngFromPlayerID) & kseVALUESEP & dpMsg.ReadString
'	                    Engine_RunScript , kseNet.hSessName & "_onReceive"
'	                End If
'	            Case 1
'	                'do kicking here :D
'	            Case Else
'	                If lngMsgType > 2400 Then
'	                    'im removing 2400, see NetSendData
'	                    lngMsgType = lngMsgType - 2400
'	                    sNetData = sNetData & kseVARSEPARATOR & DPLAY.GetPlayerFriendlyName(lngFromPlayerID) & kseVALUESEP & lngMsgType & kseVALUESEP & dpMsg.ReadString
'								Dim sData As String
'	                    sNetData = sNetData & kseVARSEPARATOR & DPLAY.GetPlayerFriendlyName(lngFromPlayerID) & kseVALUESEP & lngMsgType & kseVALUESEP & kseNet.sockMain.get(sData)
'	                    Engine_RunScript , kseNet.hSessName & "_onReceiveData"
'	                End If
'	        End Select
'	    End If
'	Loop
'	'Exit before the error code
'	Exit Sub
'ptrErr:
'	Engine_Log "Warning: Net is not initialized"
'/
	'TODO: to be called from Threads as per fbNet implementation
'ChiSock
'	If kseNet.sockMain.is_closed() = TRUE then
'		kseNet.Connected = 0
'	Else
'		'
'		Exit Sub
'	End If
End Sub

''
' (<b>Dev API</b>) Hosts a game
'
' @return   Returns <b>True</b> if successfully hosted a game, and <b>False</b>, otherwise.
' @remarks  This is called by engine through <b>Net:Host</b>.
Private Function Engine_Host() As Byte
'	Dim oSessionData As DirectPlaySessionData 'How is the session described?
	kseNet.Connected = 0
	kseNet.Hosting = 1
	
	Engine_InitConnectionList()
	If Engine_InitConnection() = 0 Then Return 0
	
''	Set oSessionData = DPLAY.CreateSessionData
''	oSessionData.SetMaxPlayers IIf(kseNet.hMaxplayer < 2, 2, kseNet.hMaxplayer)
''	oSessionData.SetSessionName kseNet.hSessName
''	oSessionData.SetGuidApplication APP_GUID
'	'TODO: allow migration of the host
'	
'	'Create (and join) session.
'	Call DPLAY.Open(oSessionData, DPOPEN_CREATE)
'	'add host in this session -- assign name
'	kseNet.playerID = DPLAY.CreatePlayer(kseNet.playerName, "", 0, 0)
	kseNet.hMaxplayer = IIf(kseNet.hMaxplayer < 2, 2, kseNet.hMaxplayer)
	Dim As Any Ptr threadMain = ThreadCreate(@Engine_ServerStart, Cast(Any Ptr, kseNet.hMaxplayer))
	While bNetConnState = NETCONN_INIT
		Sleep 1 'wait for engine to fully open or close-due-to-error
	Wend
	If bNetConnState = NETCONN_CLOSE Then
		Return 0
	EndIf
	kseNet.Connected = 1
'ChiSock	
'	l_ret = kseNet.sockMain.UDP_server(kseNET_PORT)', kseNet.hMaxplayer
'	If ( l_ret ) Then
'		'print translate_error( iStat )
'		Engine_Log "Socket unavailable", 1
'	EndIf
	
	Return 1
End Function

Private Sub Engine_NetQuit()
	If bNetConnState <> NETCONN_CLOSE Then
		If kseNet.Hosting = 1 Then
			'if server
			bNetConnState = NETCONN_EXIT
'			While bNetConnState <> NETCONN_CLOSE
				Sleep 1
'			Wend
			
			Dim i As Integer
			If g_clientCtr > 0 Then
				For i = 0 To MAX_CLIENTS - 1
					Clients(i).blnExit = 1
				Next
			End If
			  
			For i = 0 To MAX_CLIENTS - 1
				If Clients(i).hThread <> 0 Then
					If Clients(i).hThread <> 0 Then
						Engine_Send("", MSG_TYPE_EXIT, Clients(i).hClient)
						NetClose Clients(i).hClient
					EndIf
					ThreadWait(Clients(i).hThread)
				End If
			Next
		Else
			'if client
			Engine_Send("", MSG_TYPE_EXIT, hEngineConn)
			
		EndIf
		NetClose hEngineConn
'		bNetConnState = NETCONN_CLOSE
	EndIf
End Sub

''
' (<b>Dev API</b>) Joins a server.
'
' @return   Returns <b>1</b> if successfully joined a game, and <b>0</b>, otherwise.
' @remarks  This is called by engine through <b>Net:Join</b>.
Private Function Engine_Join(serverName As String, port As Integer) As Byte
	kseNet.Connected = 0
	kseNet.Hosting = 0
	
	If Engine_InitConnection() = 0 Then Return 0
		
	Dim serverIP As Integer
	serverIP = Engine_ParseIP(serverName)
	Engine_Log "serverIP " & serverIP,1
	If serverIP = 0 Then
		'is it the server's computer name?
'ChiSock
'		If kseNet.sockMain.UDP_client(serverName, port) <> chi.SOCKET_OK Then Return 0
'fbNet -- TODO
		Return 0
	Else
'		If kseNet.sockMain.UDP_client(serverIP, port) <> chi.SOCKET_OK Then Return 0
'fbNet
		Server.sin_addr = inet_addr(serverName)
	EndIf
	
	g_ret = NetConnect(hEngineConn, @Server, SizeOf(SOCKADDR_IN))
	
	If g_ret < 0 Then
		NetClose hEngineConn
		Engine_Log "Socket Connect Error",1
		bNetConnState = NETCONN_CLOSE
		Return 0
	End If
	
	Dim As Any Ptr threadMain = ThreadCreate(@Engine_ClientStart, 0)
	
	While bNetConnState = NETCONN_INIT
		Sleep 1 'wait for engine to fully open or close-due-to-error
	Wend
	
	If bNetConnState = NETCONN_CLOSE Then
		Return 0
	EndIf
	
	Engine_Log "         Connected",1
	kseNet.Connected = 1
	'TODO: register client to host then get host info
	
	
	'-------------  DX7 implementation from FreeKE sources
	Engine_InitConnectionList()
'	Engine_ListSessions
'	Dim oSessData As DirectPlaySessionData 'How is the session described?
'	On Error GoTo ptrErr
'	Dim i As Long
'	Dim ii As Long
'	ii = oEnumSess.GetCount
'	For i = 1 To ii
'		'Get the session data from the selected item
'		Set oSessData = oEnumSess.GetItem(i)
'		If oSessData.GetSessionName = kseNet.hSessName Then
'			'Join the session
'			kseNet.hMaxplayer = oSessData.GetMaxPlayers
'			Call DPLAY.Open(oSessData, DPOPEN_JOIN)
'			kseNet.playerID = DPLAY.CreatePlayer(kseNet.playerName, "Player", 0, 0)
'			Return 1
'		End If
'	Next
	Return 1
'ptrErr:
'	Engine_Log "@Net:(Join) " & Err.Number & " - " & Err.Description
End Function

''
' (<b>Dev API</b>) Sends a message.
'
' @param sMsg - Message to send.
' @param MsgTYPE - should it be a textual message or engine command (kick)
' @return   Always returns <b>True</b> if it has hosted/joined a network.
' @remarks  This is called by engine through <b>Net:Send</b> and <b>Net:SendTo</b>.<br>
Private Function Engine_Send(sMsg As String, MsgTYPE As Long = 0, pTo As FDSOCKET = -1) As Byte
'	On Error GoTo ptrErr
'	Dim dpMsg As DirectPlayMessage  'Create message object
'	Set dpMsg = DPLAY.CreateMessage
'	dpMsg.WriteLong MsgTYPE
'	'Write the chat text
'	dpMsg.WriteString sMsg
'	'Send the message
'	DPLAY.SendEx kseNet.playerID, DPID_ALLPLAYERS, DPSEND_GUARANTEED, dpMsg, 0, 0, 0
	If kseNet.Connected = 1 Then
		If (pTo = -1) Then
			g_ret = NetSendString(hEngineConn, MsgTYPE & Chr(2) & kseNet.playerID & Chr(2) & "0" & Chr(2) & sMsg & Chr(3))
		Else
			g_ret = NetSendString(pTo, MsgTYPE & Chr(2) & kseNet.playerID & Chr(2) & "0" & Chr(2) & sMsg & Chr(3))
		EndIf
		If g_ret > -1 Then
			Return 1
		Else
			net_errMsg = "Socket Send Error " & g_ret & ": " & sMsg
			Engine_Log net_errMsg, 1
			'fail connection here?
			Return 0
		End If
'ChiSock
'		kseNet.sockMain.put(MsgTYPE & Chr(2) & kseNet.playerID & Chr(2) & DPID_ALLPLAYERS & Chr(2) & sMsg)
'		kseNet.sockMain.put(MsgTYPE & Chr(2) & sender-LAN-id   & Chr(2) & send-to-who     & Chr(2) & sMsg)
'		If (kseNet.sockMain.put(MsgTYPE & Chr(2) & kseNet.playerID & Chr(2) & "0" & Chr(2) & sMsg) = FALSE) Then
'			Return 0
'		Else
'			Return 1
'		EndIf
	Else
		Return 0
	End If
'ptrErr:
'	Engine_Log "@Net:(Send) " & Err.Number & " - " & Err.Description
End Function

''
' (<b>Dev API</b>) Initializes connection.
'
' @return   Returns <b>True</b> if successfully created connection, and <b>False</b>, otherwise.
Private Function Engine_InitConnection() As Byte
'	On Error GoTo ptrErr
	'Initialize TCP/IP connection
	bNetConnState = NETCONN_INIT
	hEngineConn = NetSocket(AF_INET, SOCK_STREAM, 0)'SOCK_DGRAM
	If hEngineConn < 0 Then
		Engine_Log "Socket Create Error", 1
		bNetConnState = NETCONN_CLOSE
		Return 0
	End If
	Server.sin_family = AF_INET
	Server.sin_port   = htons(kseNET_PORT)'2310
	If kseNet.Hosting Then
'		Set DPLAY_Address = oEnumConn.GetAddress(kseNet.TCP_IP)
		'todo: clear player list, etc
	Else
'		Set DPLAY_Address = DPLAY_Lobby.CreateINetAddress(kseNet.IP, kseNET_PORT)
		'todo: get player list
	End If
	
'	'Initialize this address
'	Call DPLAY.InitializeConnection(DPLAY_Address)
	
	Return 1
'ptrErr:
End Function

Private Sub Engine_DisableJoin()
'	Dim oSessData As DirectPlaySessionData
'	Set oSessData = DPLAY.CreateSessionData
'	DPLAY.GetSessionDesc oSessData
'	'add rule
'	oSessData.SetFlags oSessData.GetFlags Or DPSESSION_JOINDISABLED
'	DPLAY.SetSessionDesc oSessData
End Sub

Private Function Engine_ParseIP(sIP As String) As Integer
	Dim IP() As String
	Split sIP, ".", IP()
	
	If UBound(IP) = 4 Then
		dim intIP as integer
		Return val(IP(0)) or (val(IP(1)) shl 8) or (val(IP(2)) shl 16) or (val(IP(3)) shl 24)
	Else
		Return 0
	EndIf
End Function

Private Function Engine_NetDataPush(iMsgType As Integer, iFromID As Integer, iToID As Integer, sContent As String) As Byte
	ReDim Preserve kseNetData(kseNetData_count) As typeNetData
	
	With kseNetData(kseNetData_count)
		.msgType = iMsgType
		.fromID  = iFromID
		.toID    = iToID
		.content = sContent
	End With
	
	kseNetData_count = kseNetData_count + 1
	
	Return 1
End Function

Private Function Engine_NetDataPop() As typeNetData
	Dim tmpNetData As typeNetData
	
	With tmpNetData
		.msgType = kseNetData(0).msgType
		.fromID  = kseNetData(0).fromID
		.toID    = kseNetData(0).toID
		.content = kseNetData(0).content
	End With
	
	For i As Integer = 0 To kseNetData_count - 2 'for i = 0 to 0, makes 1 loop which should not be
		With kseNetData(i)
			.msgType = kseNetData(i+1).msgType
			.fromID  = kseNetData(i+1).fromID
			.toID    = kseNetData(i+1).toID
			.content = kseNetData(i+1).content
		End With
	Next
	
	kseNetData_count = kseNetData_count - 1
	Redim Preserve kseNetData(kseNetData_count) As typeNetData
	
	Return tmpNetData
End Function
