
#include "../../kageExterns.hpp"

void ServerThread(void *);

#define MAX_CLIENTS 32

struct CLIENT {
	FDSOCKET hClient;
	void * hThread;
	int blnExit;
};
//todo: make client array size resizable (ReDim)
CLIENT /*shared*/ Clients[MAX_CLIENTS-1];
int /*shared*/ g_clientCtr;

/*shared*/ FDSOCKET    hEngineConn;
/*shared*/ SOCKADDR_IN Server, Client;
/*shared*/ int     g_ret, addrsize, g_index;
/*shared*/ string      net_sMsg;
/*shared*/ string      net_statMsg;
/*shared*/ string      net_errMsg;
/*shared*/ int     bNetConnState;

const MSG_TYPE_EXIT = 101
const MSG_TYPE_SERVERFULL = 102

const MSG_INDEX_TYPE = 0
const MSG_INDEX_SENDER = 1
const MSG_INDEX_RECEIVER = 2
const MSG_INDEX_MESSAGE = 3

enum NETCONN_STATE {
	NETCONN_CLOSE =  0, // Uninitialized.    
	NETCONN_INIT  =  1, // Connection is initialized
	NETCONN_OPEN  =  2, // Connection is currently in use
	NETCONN_EXIT  =  3 // Force exit Connection
};

void Engine_ServerStart(void *pAny) {
	Server.sin_addr = INADDR_ANY;
	g_ret = NetBind(hEngineConn, &Server, sizeof(SOCKADDR_IN));
	if (g_ret < 0) {
		Engine_Log("Socket Port-bind Error", 1);
		bNetConnState = NETCONN_CLOSE;
		return;
	}
	
	g_ret = NetListen(hEngineConn, 3);
	if (g_ret < 0) {
		Engine_Log("Socket Listen Error", 1);
		bNetConnState = NETCONN_CLOSE;
		return;
	}
	int l_clientMax = Cast(Integer, pAny) - 1; //1 is reserved for server
	g_clientCtr = 0;
	bNetConnState = NETCONN_OPEN;
	while (bNetConnState != NETCONN_EXIT) {
		addrsize = sizeof(SOCKADDR_IN);
		//if (g_clientCtr < l_clientMax) {
			//g_ret = NetAccept(hEngineConn, @Client, @addrsize)
			g_ret = NetAccept(hEngineConn, 0, 0);
			
			if (g_ret > -1) {
				net_statMsg = "server: accept";
				if (g_clientCtr < (MAX_CLIENTS - 1)) {
					// get next free client
					g_index = 0;
					while (Clients(g_index].hClient != 0) {
						++g_index;
					}
					Clients(g_index].hClient = g_ret;
					Clients(g_index].hThread = ThreadCreate(&Engine_ServerStartThread, Cast(Any Ptr, g_index));
					++g_clientCtr;
					net_statMsg = "server: connections=" + Str(g_clientCtr);
				} else {
					net_errMsg = "Server Full Error";
					Engine_Log(net_errMsg, 1);
					Engine_Send(net_errMsg, MSG_TYPE_SERVERFULL);
				}
			} else if (g_ret == WSAEWOULDBLOCK) {
				//it's okay
			} else if (g_ret = -1) {
				//possible case:
				// * engine closed
				// * TODO: list as you go along
			} else {
				Engine_Log("g_ret " + g_ret, 1);
				net_errMsg = "Server Accept Error";
				Engine_Log(net_errMsg, 1);
				bNetConnState = NETCONN_EXIT;
			}
		//}
		
		sleep(2);
	}
	
	bNetConnState = NETCONN_CLOSE;
	
	net_statMsg = "Server Close";
}

// for use by Engine_ServerStart
void Engine_ServerStartThread(void *lpany) {
	int l_ret, l_index = Cast(int, lpAny);
	string sData;
	string sDataCopy;
	bool bData;
	vector<string> sMsg;
	vector<string> sMsgTrim;
	int i;
	long lngMsgstruct;          //A value indicating the type of message this is
	net_statMsg = "connected client(" + l_index + ")";
	Clients(l_index].blnExit = 0;
	while (Clients(l_index].blnExit == 0 || bNetConnState != NETCONN_EXIT) {
		l_ret = NetReceiveString(Clients(l_index].hClient, sData);
		if (l_ret < 1) {
			//sData = "thread: l_ret<1";
			//Clients(l_index].blnExit = 1;
		} else {
			Engine_Log("sData " + sData, 1);
			sDataCopy = sData;
			
			while (sData != "") {
				sMsg = split(sData, Chr(2));
				
				sMsgTrim = split(sMsg[MSG_INDEX_MESSAGE], Chr(3));
				
				sMsg[MSG_INDEX_MESSAGE] = sMsgTrim[0];
				
				lngMsgstruct = CLng(sMsg[MSG_INDEX_TYPE])
				
				if (lngMsgstruct > 2400) {
					bData = true;
					lngMsgstruct = lngMsgstruct - 2400;
				}
				
				if (CLng(sMsg[MSG_INDEX_RECEIVER]) == 0 || CLng(sMsg[MSG_INDEX_RECEIVER]) == kseNet.playerID) {
					sData = sMsg[MSG_INDEX_SENDER] + Chr(2) + sMsg[MSG_INDEX_MESSAGE]; //removed sMsg(2); message is for receiver 
					//TODO: get sender info; lngMsgstruct should be the index of the user who sent data/msg
					if (bData == true) {
						sNetData = sNetData + kseVARSEPARATOR + "KSNET" + kseVALUESEP + lngMsgstruct + Chr(2) + sData;
						Engine_NetDataPush(lngMsgType, CInt(sMsg[MSG_INDEX_SENDER]), kseNet.playerID, sMsg[MSG_INDEX_MESSAGE]);
					} else {
						sNetMsg = sNetMsg + kseVARSEPARATOR + "KSNET" + kseVALUESEP + lngMsgstruct + Chr(2) + sData;
						Engine_NetDataPush(lngMsgType, CInt(sMsg[MSG_INDEX_SENDER]), kseNet.playerID, sMsg[MSG_INDEX_MESSAGE]);
					}
				}
				
				
				//TODO: only send copies to fellow Clients every once in a while -- not always
					if (CInt(sMsg[MSG_INDEX_TYPE]) != MSG_TYPE_EXIT) {
						for (i = 0; i < MAX_CLIENTS - 1; ++i) {
							if (Clients[i].hThread != 0  && i != l_index) {
								Engine_Send(sMsg[MSG_INDEX_MESSAGE], CInt(sMsg[MSG_INDEX_TYPE]),Clients[i].hClient); // 4 is _3 Chr(2) and 1 Chr(3)_
							}
						}
					}
				
				if (iGotMessage > 0) { kseFunction[iGotMessage].RunScript(); }
				
				sData = Mid(sDataCopy,
								sMsg[MSG_INDEX_TYPE    ].length() +
								sMsg[MSG_INDEX_SENDER  ].length() +
								sMsg[MSG_INDEX_RECEIVER].length() +
								sMsg[MSG_INDEX_MESSAGE ].length() + 5); // 3 Chr(2) and 1 Chr(3) and 1 offset
				
				sDataCopy = sData;
			}
			
			net_statMsg = "thread:(" + Str(l_index) &") got a message " + sData;
			if (InStr(sData,"exit")) {
				Clients(l_index].blnExit = true;
				NetClose(Clients(l_index].hClient);
				bNetConnState = NETCONN_EXIT;
//			} else {
//				net_statMsg = "thread:(" + Str(l_index) &") send ok";
//				Engine_Send("ok", 102,Clients(l_index].hClient);
			}
		}
	}
	net_statMsg = "disconnected client(" + l_index + ")";
	NetClose(Clients(l_index].hClient);
	Clients(l_index].hClient = 0;
	--g_clientCtr;
}

void Engine_ClientStart(void pAny) {
	int l_ret;
	string sData;
	string sDataCopy;
	bool bData;
	vector<string> sMsgTrim;
	vector<string> sMsg;
	long lngMsgstruct;          //A value indicating the type of message this is
	bNetConnState = NETCONN_OPEN;
	while (bNetConnState != NETCONN_CLOSE) {
//ChiSock
//		kseNet.sockMain.get(sData)
//fbNet
		l_ret = NetReceiveString(hEngineConn, sData);
		if ((l_ret < 0) {
			//bNetConnState = NETCONN_EXIT
		} else {
		Engine_Log("sData " + sData, 1);
			sDataCopy = sData;
			while (sData != "") {
				sMsg = split(sData, Chr(2));
				
				sMsgTrim = split(sMsg[MSG_INDEX_MESSAGE], Chr(3));
				
				sMsg[MSG_INDEX_MESSAGE] = sMsgTrim[0];
				
				lngMsgstruct = CLng(sMsg[MSG_INDEX_TYPE]);
				
				if (lngMsgstruct > 2400) {
					bData = true;
					lngMsgstruct = lngMsgstruct - 2400;
				}
				
				if (CLng(sMsg[MSG_INDEX_RECEIVER]) == 0 || CLng(sMsg[MSG_INDEX_RECEIVER]) == kseNet.playerID) {
					sData = sMsg[MSG_INDEX_SENDER] + Chr(2) + sMsg[MSG_INDEX_MESSAGE] //removed sMsg(2); message is for receiver
					//TODO: get sender info; lngMsgstruct should be the index of the user who sent data/msg
					if (bData) {
						sNetData = sNetData + kseVARSEPARATOR + "KSNET" + kseVALUESEP + lngMsgstruct + Chr(2) + sData;
						Engine_NetDataPush(lngMsgType, CInt(sMsg[MSG_INDEX_SENDER]), kseNet.playerID, sMsg[MSG_INDEX_MESSAGE]);
					} else {
						sNetMsg = sNetMsg + kseVARSEPARATOR + "KSNET" + kseVALUESEP + lngMsgstruct + Chr(2) + sData;
						Engine_NetDataPush(lngMsgType, CInt(sMsg[MSG_INDEX_SENDER]), kseNet.playerID, sMsg[MSG_INDEX_MESSAGE]);
					}
				}
				
				sData = Mid(sDataCopy,
								sMsg[MSG_INDEX_TYPE    ].length() +
								sMsg[MSG_INDEX_SENDER  ].length() +
								sMsg[MSG_INDEX_RECEIVER].length() +
								sMsg[MSG_INDEX_MESSAGE ].length() + 5); // 3 Chr(2) and 1 Chr(3) and 1 offset
				
				sDataCopy = sData;
				
				if (CInt(sMsg[MSG_INDEX_TYPE]) == MSG_TYPE_EXIT) {
					if (iGotDisconnected > 0) { kseFunction[iGotDisconnected].RunScript(); }
				} else {
					if (iGotMessage > 0) { kseFunction[iGotMessage].RunScript(); }
				}
			}
		}
	}
}

////
// Used by engine for parsing and interpreting
//
// @return String
// @remarks None.
string cNetTxt;

////
// Holds lists of players currently in network
//
// @return String
// @remarks None.
vector<string> lstPlayer;

////
// Holds lists of messages queued for manual fetching
//
// @return String
// @remarks If you plan to implement KonsolScript in other language (C/C++), use linked list instead.
string /*shared*/ sNetMsg;
struct typeNetMsg {
	string sMsg;
	int iSender;
	int iReceiver;
	
	bool bUsed;
};

////
// Holds lists of game-data-messages queued for manual fetching
//
// @return String
// @remarks If you plan to implement KonsolScript in other language (C/C++), use linked list instead.
string /*shared*/ sNetData;

vector<typeNetData> /*shared*/ kseNetData;
long /*shared*/ kseNetData_count;

////
// Parses and interprets KonsolScript's <b>Net</b> functions.
//
// @param    iIndex - Index of the parsed script
// @return   New index value of the parsed script.
// @remarks None.
//<div class="KS">
// <b>KonsolScript Users:</b><br>
// <br><b>Description:</b><br>
// Net class currently contains the functions:
// <ul>
// <li><b><a href="modKONSoL_Net.NetHost.html">Host</a></b> - hosts a connection.
// <li><b><a href="modKONSoL_Net.NetJoin.html">Join</a></b> - joins a server.
// <li><b><a href="modKONSoL_Net.NetSend.html">Send</a></b> - sends message to all.
// <li><b><a href="modKONSoL_Net.NetSendData.html">SendData</a></b> - sends a game-data.
// <li><b><a href="modKONSoL_Net.NetSendTo.html">SendTo</a></b> - sends message to a player.
// <li><b><a href="modKONSoL_Net.NetCheck.html">Check</a></b> - checks network connection.
// <li><b><a href="modKONSoL_Net.NetGetMessage.html">GetMessage</a></b> - retrieves one queued message at a time.
// <li><b><a href="modKONSoL_Net.NetGetData.html">GetData</a></b> - retrieves one queued data at a time.
// </ul>
//</div>
unsigned long SynNet(long &iIndex) {
	iIndex = GetNearestTokenIndex(kseCOLON, "Net", iIndex);   //look for        :
	iIndex = GetNextIndex(iIndex);
	switch (kseToken[iIndex].sToken) {
		case "Quit":
			return NetQuit(iIndex);
		case "Host":
			return NetHost(iIndex);
		case "Join":
			return NetJoin(iIndex);
		case "Send":
			return NetSend(iIndex);
		case "SendTo":
			return NetSendTo(iIndex);
		case "Check":
			return NetCheck(iIndex);
		case "GetData":
			return NetGetData(iIndex);
		case "GetMessage":
			return NetGetMessage(iIndex);
		default:
			Engine_Message(KSE_GetErrFileSrc(iIndex) + "(  " + KSE_GetToken(iIndex) + "  ) is not in Net Class.", "ERROR AT LINE " + kseToken[iIndex].iLine, true);
	}
}

////
// <b>Net:Quit</b> - disconnects from network.
//
// @param    iIndex - Index of the parsed script
// @return   New index value of the parsed script.
// @remarks  None.
//<div class="KS">
// <b>KonsolScript Users:</b><br>
// <br><b>Description:</b><br>
// After hosting/joining a network, disconnect by using <b>Net:Quit</b>.
// <br><br><b>Parameters:</b><br>
// <ul>
//  <li>None.
// </ul>
// <b>Usage:</b><br>
// <pre>
// //provided we have made a connection
// Net:Quit()
// </pre>
//</div>
int NetQuit(long &iIndex) {
	iIndex = Net_SkipOpenParenthesisAfter("Quit", iIndex);
	iIndex = Net_SkipCloseParenthesisAfter("(", iIndex);
	//EXECUTE SCRIPT ========================================
//ChiSock
//	if (kseNet.sockMain.Close() != chi.SOCKET_OK) {
//		//TODO: uninitialize connection object
//		kseNet.Connected = 0
//	}
	Engine_NetQuit();
	
	return iIndex;
}

////
// <b>Net:Host</b> - hosts a connection.
//
// @param    iIndex - Index of the parsed script
// @return   New index value of the parsed script.
// @remarks None.
//<div class="KS">
// <b>KonsolScript Users:</b><br>
// <br><b>Description:</b><br>
// Hosts a connection.<br>
// No need to have any buffer -- just a <b>Boolean</b> variable to check the success.
// <br><br><b>Parameters:</b><br>
// <ul>
//  <li>string <b>host_player_name</b> - name to use in the network game.
//  <li>Number <b>max_players</b> - maximum allowed players.
//  <li>string <b>session_name</b> - name of the session to join at.
//  <li>Boolean <b>return</b> - a return variable that will have a value depending on the success of attempting to join a network.
// </ul>
// <b>Usage:</b><br>
// <pre>
//  Var:Boolean got_connection;
//  Net:Host("im_ur_host", 5, "my_session", got_connection)
//  while (got_connection EQ true) {
//    Net:Check()
//  }
// </pre>
// <b>Parameter : </b>
//</div>
int NetHost(long &iIndex) {
	int iBool;
	string sess_name;
	string pName;
	int iMaxPlayer;
	
	iIndex = Net_SkipOpenParenthesisAfter("Host", iIndex);
	
		pName = KSE_GetTokenStrValueOf(iIndex);
	
	iIndex = Net_SkipCommaAfter("host_player_name", iIndex);
	
		iMaxPlayer = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = Net_SkipCommaAfter("max_members", iIndex);
	
		sess_name = KSE_GetTokenStrValueOf(iIndex);
	
	iIndex = Net_SkipCommaAfter("session_name", iIndex);
	
		iIndex = GetNextIndex(iIndex);
			iBool = iIndex;
	
	iIndex = Net_SkipCloseParenthesisAfter("return", iIndex);
	//EXECUTE SCRIPT ========================================
	
		kseNet.playerName = pName;
		kseNet.hMaxplayer = iMaxPlayer;
		kseNet.hSessName = sess_name;
		
		if (Engine_Host() == true) {
			SetBoolValue(iBool, 1);
		} else {
			SetBoolValue(iBool, 0);
		}
	
	
	return iIndex;
}

////
// <b>Net:Check</b> - checks network connection.
//
// @param    iIndex - Index of the parsed script
// @return   New index value of the parsed script.
// @remarks  Checking network connection is only when connected.
//<div class="KS">
// <b>KonsolScript Users:</b><br>
// <br><b>Description:</b><br>
// Placing <b>Net:Check</b> on a loop will repeatedly monitor our connection. In case someone sent a message, then it fires the <b>_onReceive</b> listener function.
// <br><br><b>Parameters:</b><br>
// <ul>
//  <li>None.
// </ul>
// <b>Usage:</b><br>
// <pre>
// //main loop
// while (game_not_over EQ true) {
//   //provided we have made a connection
//   Net:Check()
// }
//</pre>
//</div>
int NetCheck(long &iIndex) {
	iIndex = Net_SkipOpenParenthesisAfter("Check", iIndex);
	iIndex = Net_SkipCloseParenthesisAfter("(", iIndex);
	//EXECUTE SCRIPT ===================================

//ChiSock	
//	if (kseNet.Connected == 1) { Engine_CheckConnection(); }
	
	return iIndex;
ptrErr:
	trace("Failed at Net:Check");
}

////
// <b>Net:Join</b> - joins a server.
//
// @param    iIndex - Index of the parsed script
// @return   New index value of the parsed script.
// @remarks None.
//<div class="KS">
// <b>KonsolScript Users:</b><br>
// <br><b>Description:</b><br>
// Joins a server.<br>
// No need to have any buffer -- just a <b>Boolean</b> variable to check the success.
// <br><br><b>Parameters:</b><br>
// <ul>
//  <li>string <b>client_player_name</b> - name to use in the network game.
//  <li>string <b>session_name</b> - name of the session to join at.
//  <li>string <b>host_pc</b> - name or IP of the computer hosting a network game.
//  <li>Boolean <b>return</b> - a return variable that will have a value depending on the success of attempting to join a network.
// </ul>
// <b>Usage:</b><br>
// <pre>
//  Var:Boolean got_connection;
//  Net:Join("im_a_client", "my_session", "host_pc", got_connection)
//  while (got_connection EQ true) {
//    Net:Check()
//  }
// </pre>
//</div>
int NetJoin(long &iIndex) {
	int iBool;
	string pName;
	string session_name;
	string host_name;
	iIndex = Net_SkipOpenParenthesisAfter("Join", iIndex);
	
		pName = KSE_GetTokenStrValueOf(iIndex);
	
	iIndex = Net_SkipCommaAfter("client_player_name", iIndex);
	
		session_name = KSE_GetTokenStrValueOf(iIndex);
	
	iIndex = Net_SkipCommaAfter("session_name", iIndex);
	
		host_name = KSE_GetTokenStrValueOf(iIndex);
	
	iIndex = Net_SkipCommaAfter("host", iIndex);
	
		iIndex = GetNextIndex(iIndex);
			iBool = iIndex;
	
	iIndex = Net_SkipCloseParenthesisAfter("return", iIndex);
	//EXECUTE SCRIPT ========================================
	//connect to host
	
		kseNet.playerName = pName;
		kseNet.hSessName = session_name;
		kseNet.IP = host_name;
		if (Engine_Join(host_name, kseNET_PORT)) {
			SetBoolValue(iBool, 1);
		} else {
			SetBoolValue(iBool, 0);
		}
	
	return iIndex;
}

////
// <b>Net:Send</b> - sends message to all.
//
// @param    iIndex - Index of the parsed script
// @return   New index value of the parsed script.
// @remarks None.
//<div class="KS">
// <b>KonsolScript Users:</b><br>
// <br><b>Description:</b><br>
// Send a message to all players.
// <br><br><b>Parameters:</b><br>
// <ul>
//  <li>string <b>message</b> - message to send.
//  <li>Boolean <b>return</b> - returns <b>true</b> if message was successfully sent, and <b>false</b> otherwise.
// </ul>
// <b>Usage:</b><br>
// <pre>
//  Var:Boolean sent;
//  //after successful hosting/joining a game
//  Net:Send("Hello!",sent)
//  if (sent EQ true) {
//    Konsol:Log("Message sent")
//  }
// </pre>
//</div>
int NetSend(long &iIndex) {
	string sMsg;
	int iBool;
	iIndex = Net_SkipOpenParenthesisAfter("Send", iIndex);
	
		sMsg = KSE_GetTokenStrValueOf(iIndex);
	
	iIndex = Net_SkipCommaAfter("msg", iIndex);
	
		iIndex = GetNextIndex(iIndex);
			iBool = iIndex;
	
	iIndex = Net_SkipCloseParenthesisAfter("return", iIndex);
	//EXECUTE SCRIPT ========================================
	
	if (kseNet.Hosting == true) {
		for (int i = 0; i < MAX_CLIENTS - 1; ++i) {
			if (Clients[i].hThread != 0) {
				Engine_Send(sMsg, 100,Clients[i].hClient); // 4 is _3 Chr(2) and 1 Chr(3)_
			}
		}
	} else {
		SetBoolValue(iBool, Engine_Send(sMsg, 100));
	}
	
	return iIndex;
}

////
// <b>Net:SendTo</b> - sends message to a player.
//
// @param    iIndex - Index of the parsed script
// @return   New index value of the parsed script.
// @remarks None.
//<div class="KS">
// <b>KonsolScript Users:</b><br>
// <br><b>Description:</b><br>
// Send a message to specific player.
// <br><br><b>Parameters:</b><br>
// <ul>
//  <li>string <b>message</b> - message to send.
//  <li>string <b>player_name</b> - name of player to send message to.
//  <li>Boolean <b>return</b> - returns <b>true</b> if message was successfully sent, and <b>false</b> otherwise.
// </ul>
// <b>Usage:</b><br>
// <pre>
//  Var:Boolean sent;
//  //after successful hosting/joining a game
//  Net:SendTo("Hello!","player_name",sent)
//  if (sent EQ true) {
//    Konsol:Log("Message sent")
//  }
// </pre>
//</div>
int NetSendTo(long &iIndex) {
	string sMsg;
	string player_name;
	int iBool;
	iIndex = Net_SkipOpenParenthesisAfter("SendTo", iIndex);
	
		player_name = KSE_GetTokenStrValueOf(iIndex);
	
	iIndex = Net_SkipCommaAfter("client_player_name", iIndex);
	
		sMsg = KSE_GetTokenStrValueOf(iIndex);
	
	iIndex = Net_SkipCommaAfter("msg", iIndex);
	
		iIndex = GetNextIndex(iIndex);
			iBool = iIndex;
	
	iIndex = Net_SkipCloseParenthesisAfter("return", iIndex);
	//EXECUTE SCRIPT ========================================
	//TODO: improve by, get index of player and use it as second parameter
	SetBoolValue(iBool, Engine_Send("@" + player_name + "-" + sMsg));
	
	return iIndex;
}

////
// <b>Net:GetMessage</b> - retrieves data from message buffer.
//
// @param    iIndex - Index of the parsed script
// @return   New index value of the parsed script.
// @remarks None.
//<div class="KS">
// <b>KonsolScript Users:</b><br>
// <br><b>Description:</b><br>
// This is different than other functions. All parameters are required to be declared variables.
// <br><br><b>Parameters:</b><br>
// <ul>
//  <li>string <b>player</b> - returns name of sender.
//  <li>string <b>message</b> - returns any message received.
//  <li>string <b>return</b> - returns <b>true</b> if message is not empty, and <b>false</b> otherwise.
// </ul>
// <b>Usage:</b><br>
// <pre>
//  //provided there is already a connection
//  function mygame_onReceive() {
//    Var:string sender,msg;
//    Var:Boolean got_message;
//    Net:GetMessage(sender,msg,got_message)
//
//    if (got_message EQ true) {
//      //display the retrieved message
//      Screen:PrintString(sender + " : " + msg)
//
//      //it is recommended to write your own function
//      //that will display the message that suits your game
//    }
//  }
// </pre>
//</div>
int NetGetMessage(long &iIndex) {
	string sMsg;
	int iPlr;
	int iMsg;
	int iBool;
	
	iIndex = Net_SkipOpenParenthesisAfter("GetMessage", iIndex);
	
		iIndex = GetNextIndex(iIndex);
			iPlr = iIndex;
	
	iIndex = Net_SkipCommaAfter("player", iIndex);
	
		iIndex = GetNextIndex(iIndex);
			iMsg = iIndex;
	
	iIndex = Net_SkipCommaAfter("message", iIndex);
	
		iIndex = GetNextIndex(iIndex);
			iBool = iIndex;
	
	iIndex = Net_SkipCloseParenthesisAfter("return", iIndex);
	//EXECUTE SCRIPT ========================================
	SetStrValue(iPlr, "");
	SetStrValue(iMsg, "");
	SetBoolValue(iBool, 0);

	if (kseNetData_count > 0) {
		typeNetData tmpNetData = Engine_NetDataPop();
		SetStrValue(iPlr, Str(tmpNetData.fromID));
		SetStrValue(iMsg, tmpNetData.content);
		SetBoolValue(iBool, true);
	}
///
	vector<string> sDataRaw;
	vector<string> sData;
	vector<string> sMsgs;
	
	sDataRaw = split(sNetMsg, kseVARSEPARATOR);
	if (sDataRaw.size() > 0) {
		if (sDataRaw[1] != "") {
			sData = split(sDataRaw(1), kseVALUESEP);
			if (sData[0] != "" || sData[0] == "KSNET") {
				sMsgs = split(sData[1], Chr(2));
				if (sMsgs.size() > 0) {
					SetStrValue(iPlr, sMsgs[1]);
					SetStrValue(iMsg, sMsgs[2]);
					SetBoolValue(iBool, true);
					//remove retrieved message from buffer
					sNetMsg = Mid(sNetMsg, kseVARSEPARATOR.length() + sDataRaw(1)) + 1);
				}
			}
		}
	}
///	
	return iIndex;
ptrErr:
	trace("Failed at Net:GetMessage");
}

////
// <b>Net:SendData</b> - sends game data.
//
// @param    iIndex - Index of the parsed script
// @return   New index value of the parsed script.
// @remarks None.
//<div class="KS">
// <b>KonsolScript Users:</b><br>
// <br><b>Description:</b><br>
// Send a message to all players.
// <br><br><b>Parameters:</b><br>
// <ul>
//  <li>Number <b>code</b> - a non-zero, positive value as type of message. Whatever value it is, this depends on your game.
//  <li>string <b>message</b> - message to send (not necessarily a textual message, it can be numeric].
//  <li>Boolean <b>return</b> - returns <b>true</b> if data was successfully sent, and <b>false</b> otherwise.
// </ul>
// <b>Usage:</b><br>
// <pre>
//  Var:Boolean sent;
//  //after successful hosting/joining a game
//  Net:SendData("Hello!",sent)
//  if (sent EQ true) {
//    Konsol:Log("Message sent")
//  }
// </pre>
//</div>
int NetSendData(long &iIndex) {
	string sMsg;
	double iCode;
	int iBool;
	iIndex = Net_SkipOpenParenthesisAfter("SendData", iIndex);
	
		iCode = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = Net_SkipCommaAfter("code", iIndex);
	
		sMsg = KSE_GetTokenStrValueOf(iIndex);
	
	iIndex = Net_SkipCommaAfter("msg", iIndex);
	
		iIndex = GetNextIndex(iIndex);
			iBool = iIndex;
	
	iIndex = Net_SkipCloseParenthesisAfter("return", iIndex);
	//EXECUTE SCRIPT ========================================
	if (iCode > 0) {
		//SetBoolValue(iBool, Engine_Send(sMsg, iCode + 2400))  //original
		SetBoolValue(iBool, Engine_Send(sMsg, CLng(Str(iCode + 2400)))); //stupid code just to let FBC generate C codes 
	} else {
		SetBoolValue(iBool, false);
	}
	
	return iIndex;
}

////
// <b>Net:GetData</b> - retrieves data from message buffer.
//
// @param    iIndex - Index of the parsed script
// @return   New index value of the parsed script.
// @remarks None.
//<div class="KS">
// <b>KonsolScript Users:</b><br>
// <br><b>Description:</b><br>
// This is different than other functions. All parameters are required to be declared variables.
// <br><br><b>Parameters:</b><br>
// <ul>
//  <li>string <b>player</b> - returns name of sender.
//  <li>Number <b>code</b> - returns the type of message.
//  <li>string <b>message</b> - returns any message received.
//  <li>string <b>return</b> - returns <b>true</b> if message is not empty, and <b>false</b> otherwise.
// </ul>
// <b>Usage:</b><br>
// <pre>
//  //provided there is already a connection
//  function mygame_onReceiveData() {
//    Var:string sender,data;
//    Var:Number code;
//    Var:Boolean got_data;
//    Net:GetData(sender,data,got_data)
//
//    if (got_data EQ true) {
//      //react on the data received based on the code
//      if (code EQ 1) { //the sender chooses a character
//        if (data EQ "ck") {
//          //sender chooses Creek
//        } else if (data EQ "dk") {
//          //sender chooses Dork
//        }
//      } else if (code EQ 2) { //the sender chooses a map
//        if (data EQ "ph") {
//          //sender chooses Philippines
//        } else if (data EQ "us") {
//          //sender chooses America
//        }
//      } else { //handles unknown data
//        Konsol:Log(sender + " is sending unknown data: " + data)
//      }
//    }
//  }
// </pre>
//</div>
int NetGetData(long &iIndex) {
	string sMsg;
	int iPlr;
	int iCode;
	int iMsg;
	int iBool;
	iIndex = Net_SkipOpenParenthesisAfter("GetData", iIndex);
	
		iIndex = GetNextIndex(iIndex);
			iPlr = iIndex;
	
	iIndex = Net_SkipCommaAfter("player", iIndex);
	
		iIndex = GetNextIndex(iIndex);
			iCode = iIndex;
	
	iIndex = Net_SkipCommaAfter("code", iIndex);
	
		iIndex = GetNextIndex(iIndex);
			iMsg = iIndex;
	
	iIndex = Net_SkipCommaAfter("message", iIndex);
	
		iIndex = GetNextIndex(iIndex);
			iBool = iIndex;
	
	iIndex = Net_SkipCloseParenthesisAfter("return", iIndex);
	//EXECUTE SCRIPT ========================================
	vector<string> sData;
	vector<string> sMsgRaw;
	vector<string> sMsgs;
	
	sData = split(sNetData, kseVARSEPARATOR);
	if (sData.size() > 0) {
		if (sData[1] != "") {
			sMsgRaw = split(sData[1], kseVALUESEP);
			
			if (sMsgRaw[1] != "") {
				sMsgs = split(sMsgRaw[1], Chr(2));
				
				if (sMsgs[0] != "") {
					SetStrValue(iPlr, sMsgs[0]);
					SetStrValue(iCode, sMsgs[1]);
					SetStrValue(iMsg, sMsgs[2]);
					SetBoolValue(iBool, true);
					//remove retrieved data from buffer
					sNetData = Mid(sNetData, kseVARSEPARATOR.length() + sData[1]) + 1);
				}
			}
		}
	}
	
	SetBoolValue(iBool, false);
	
	return iIndex;
}

////
// <b>Net:ListClientName</b> - retrieves all client's name in an array.
//
// @param    iIndex - Index of the parsed script
// @return   New index value of the parsed script.
// @remarks None.
//<div class="KS">
// <b>KonsolScript Users:</b><br>
// <br><b>Description:</b><br>
// Retrieves all client's name in a comma-separated string.
// <br><br><b>Parameters:</b><br>
// <ul>
//  <li>string <b>return</b> - contains comma-separated player names.
// </ul>
// <b>Usage:</b><br>
// <pre>
//  Var:Boolean sent;
//  Var:string playerList;
//  //after successful hosting/joining a game
//  Net:ListClientName(playerList)
// </pre>
//</div>
int NetListClientName(long &iIndex) {
	int iStr;
	iIndex = Net_SkipOpenParenthesisAfter("ListClientName", iIndex);
	iIndex = GetNextIndex(iIndex);
	iStr = iIndex;
	iIndex = Net_SkipCloseParenthesisAfter("return", iIndex);
	//EXECUTE SCRIPT ========================================
	//set string-value with the comma-separated-player_name
	return iIndex;
}

////
// (<b>Dev API</b>) Net-class// wrapper for skipping open parenthesis.
//
// @param    sWhat - an open parenthesis should be written next to what text?
// @param    iIndex - Index of the parsed script
// @return   New index value of the parsed script.
// @remarks  Benchmark if organizing is worth the speed.
int Net_SkipOpenParenthesisAfter(string sWhat, long &iIndex) {
	cNetTxt = "Net:" + sWhat;
	return KSE_SkipOpenParenthesisAfter(cNetTxt, iIndex);
}

////
// (<b>Dev API</b>) Net-class// wrapper for skipping a comma.
//
// @param    sWhat - a comma should be written next to what text?
// @param    iIndex - Index of the parsed script
// @return   New index value of the parsed script.
// @remarks  Benchmark if organizing is worth the speed.
int Net_SkipCommaAfter(string sWhat, long &iIndex) {
	cNetTxt = cNetTxt + sWhat;
	iIndex = KSE_SkipCommaAfter(cNetTxt, iIndex);
	cNetTxt = cNetTxt + ", ";
	return iIndex;
}

////
// (<b>Dev API</b>) Net-class// wrapper for skipping close parenthesis.
//
// @param    sWhat - a close parenthesis should be written next to what text?
// @param    iIndex - Index of the parsed script
// @return   New index value of the parsed script.
// @remarks  Benchmark if organizing is worth the speed.
int Net_SkipCloseParenthesisAfter(string sWhat, long &iIndex) {
	cNetTxt = cNetTxt + sWhat;
	iIndex = KSE_SkipCloseParenthesisAfter(cNetTxt, iIndex);
	cNetTxt = "";
	return iIndex;
}

////
// (<b>Dev API</b>) Initializes connection list.
//
// @return   Returns <b>True</b> if no error occured, and <b>False</b>, otherwise.
bool Engine_InitConnectionList() {
//	long lConnCtr;   //How many different service providers are there?
//	long i;
//
//	//Enumerate the connections
//	Set oEnumConn = DPLAY.GetDPEnumConnections("", DPCONNECTION_DIRECTPLAY);
//	//Determine the number of connections available
//	lConnCtr = oEnumConn.GetCount;
//	string sConn;
//	for (i = 1; i < lConnCtr; ++i) {
//		sConn = oEnumConn.GetName(i);
//		if (sConn == kseSUPPORTED_DPLAY) { kseNet.TCP_IP = i; }
//	} i
	
	return true;
//ptrErr:
}

////
// (<b>Dev API</b>) Lists sessions.
//
// @return   Returns <b>True</b> if no error occured, and <b>False</b>, otherwise.
bool Engine_ListSessions() {
	int iSessCtr;                //How many sessions are available?
	int i;
//	DirectPlaySessionData oSessData; //How is a session described?
	if (!(Engine_InitConnection()) { return false; }
	
//
//	//Make a new SessionData object
//	Set oSessData = DPLAY.CreateSessionData;
//	//Fill this object with the criterea we would like to use to descriminate sessions during enumeration
//	oSessData.SetGuidApplication(APP_GUID);
//	oSessData.SetSessionPassword("");
//	//Enumerate sessions with the current connection
//	Set oEnumSess = DPLAY.GetDPEnumSessions(oSessData, 0, DPENUMSESSIONS_AVAILABLE);
	return true;
//ptrErr:
//    Engine_Log("@Net:(ListSess) " + Err.Number + " - " + Err.Description);
}

////
// (<b>Dev API</b>) Updates player list.
//
// @return   Returns name of lastest player who joined.
// @remarks  This is called by Engine_CheckConnection when a player joined/quited.
string Engine_UpdatePlayers() {
	int i;
	string strPlayerName;
	int intPlayersWaiting;
//	DirectPlayEnumPlayers oEnumPlayers;
//	DirectPlaySessionData oSessData;
//
//	//Get the EnumPlayers object
//	Set oEnumPlayers = DPLAY.GetDPEnumPlayers("", 0);
//	//Determine how many players it contains
//	intPlayersWaiting = oEnumPlayers.GetCount();
//	//Create a session data object
//	Set oSessData = DPLAY.CreateSessionData;
//	//Get the current session data
//	DPLAY.GetSessionDesc oSessData;
//	//Engine_UpdatePlayers = intPlayersWaiting;
//	//For every player in the session, extract the short name, and add to a listbox
//	string lstPlayer[intPlayersWaiting + 1];
//	for (i = 1; i < intPlayersWaiting; ++i) {
//	    lstPlayer[i] = oEnumPlayers.GetShortName(i);
//	    if (i == 1) { Engine_UpdatePlayers = lstPlayer[1];
//	}
	return "";
//ptrErr:
//	MsgBox("Engine_UpdatePlayers Error." + "\r\n" + Err.Description);
}

////
// (<b>Dev API</b>) Checks received messages.
//
// @remarks  This is called by engine when <b>Net:Check</b> is used in the script.
void Engine_CheckConnection() {
	long lngFromPlayerID;     //ID of player that message is from
	long lngToPlayerID;       //ID of player to whom message was sent
	long lngMsgstruct;          //A value indicating the type of message this is
//	dpMsg DirectPlayMessage  //An object that contains all message data
	long lngMsgCount;         //How many messages are in the queue?
	string strFromPlayerName; //What is the short name of the player who sent the message?
	string strChatText;       //The chat text string
	//Handle errors that may occur if the session or player have not yet been created
//
//	//Find out how many messages are waiting for the player indicated by lngPlayerID
//	lngMsgCount = DPLAY.GetMessageCount(kseNet.playerID);
//	//Allow normal error handling to continue
//
//	//Process each message sequentially
//	while (lngMsgCount > 0) {
//	    //Receive the message, and assign the "To" and "From" ID//s
//	    Set dpMsg = DPLAY.Receive(lngFromPlayerID, lngToPlayerID, DPRECEIVE_ALL);
//	    //Read the first LONG from the message to determine the type
//	    lngMsgstruct = dpMsg.ReadLong();
//	    //Decrease the number of messages by one (we//ve just read one)
//	    --lngMsgCount;
//	    //Check if this message was sent by the system
//	    if (lngFromPlayerID == DPID_SYSMSG) {
//	        //Take action depending on the type of system message sent
//	        switch (lngMsgType) {
//	            //If a player has joined
//	            Case DPSYS_DESTROYPLAYERORGROUP:
//	                cout << "last player " << Engine_UpdatePlayers << endl;
//	                Engine_RunScript( , kseNet.hSessName + "_onClientQuit");
//					break;
//	            case DPSYS_CREATEPLAYERORGROUP:
//	                cout << "last player " + Engine_UpdatePlayers
//	                Engine_RunScript( , kseNet.hSessName + "_onClientJoin");
//					break;
//	            case DPSYS_HOST:
//	                //hosting transfered to this player
//	                kseNet.Hosting = true;
//	            default:
//	                cout << "DPSYS_xxx = " << lngMsgType << endl;
//	                    //DPSYS_CREATEPLAYERORGROUP     =   3
//	                    //DPSYS_DESTROYPLAYERORGROUP    =   5
//	                    //DPSYS_ADDPLAYERTOGROUP        =   7
//	                    //DPSYS_DELETEPLAYERFROMGROUP   =  33 (&H21)
//	                    //DPSYS_SESSIONLOST             =  49 (&H31)
//	                    //DPSYS_HOST                    = 257 (&H101)
//	                    //DPSYS_SETPLAYERORGROUPDATA    = 258 (&H102)
//	                    //DPSYS_SETPLAYERORGROUPNAME    = 259 (&H103)
//	                    //DPSYS_SETSESSIONDESC          = 260 (&H104)
//	                    //DPSYS_ADDGROUPTOGROUP         = 261 (&H105)
//	                    //DPSYS_DELETEGROUPFROMGROUP    = 262 (&H106)
//	                    //DPSYS_SECUREMESSAGE           = 263 (&H107)
//	                    //DPSYS_STARTSESSION            = 264 (&H108)
//	                    //DPSYS_CHAT                    = 265 (&H109)
//	                    //DPSYS_SETGROUPOWNER           = 266 (&H10A)
//	                    //DPSYS_SENDCOMPLETE            = 269 (&H10D)
//	                    //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//	                    //DPLSYS_CONNECTIONSETTINGSREAD =   1
//	                    //DPLSYS_DPLAYCONNECTFAILED     =   2
//	                    //DPLSYS_DPLAYCONNECTSUCCEEDED  =   3
//	                    //DPLSYS_APPTERMINATED          =   4
//	                    //DPLSYS_SETPROPERTY            =   5
//	                    //DPLSYS_SETPROPERTYRESPONSE    =   6
//	                    //DPLSYS_GETPROPERTY            =   7
//	                    //DPLSYS_GETPROPERTYRESPONSE    =   8
//	                    //DPLSYS_NEWSESSIONHOST         =   9
//	                    //DPLSYS_NEWCONNECTIONSETTINGS  =  10
//	        }
//	    //If not sent by system, this must be an application-defined message
//	    } else {
//	        //Take action depending on the type of application message
//	        switch (lngMsgType) {
//	            //If we//ve recieved chat text, apply it
//	            case 0:
//	                //IMPROVE THIS ONE; remember Net:SendTo
//	                if (lngToPlayerID == kseNet.playerID) {
//	                    sNetMsg = sNetMsg + kseVARSEPARATOR + DPLAY.GetPlayerFriendlyName(lngFromPlayerID) + kseVALUESEP + dpMsg.ReadString;
//	                    Engine_RunScript( , kseNet.hSessName + "_onReceive");
//	                }
//					break;
//	            case 1:
//	                //do kicking here :D
//					break;
//	            default:
//	                if (lngMsgstruct > 2400) {
//	                    //im removing 2400, see NetSendData
//	                    lngMsgstruct = lngMsgstruct - 2400;
//	                    sNetData = sNetData + kseVARSEPARATOR + DPLAY.GetPlayerFriendlyName(lngFromPlayerID) + kseVALUESEP + lngMsgstruct + kseVALUESEP + dpMsg.ReadString;
//								string sData;
//	                    sNetData = sNetData + kseVARSEPARATOR + DPLAY.GetPlayerFriendlyName(lngFromPlayerID) + kseVALUESEP + lngMsgstruct + kseVALUESEP + kseNet.sockMain.get(sData);
//	                    Engine_RunScript( , kseNet.hSessName + "_onReceiveData");
//	                }
//	        }
//	    }
//	}
//	//Exit before the error code
//	return;
//ptrErr:
//	Engine_Log("Warning: Net is not initialized");
///
	//TODO: to be called from Threads as per fbNet implementation
//ChiSock
//	if (kseNet.sockMain.is_closed() == true) {
//		kseNet.Connected = 0;
//	} else {
//		//
//		return;
//	}
}

////
// (<b>Dev API</b>) Hosts a game
//
// @return   Returns <b>True</b> if successfully hosted a game, and <b>False</b>, otherwise.
// @remarks  This is called by engine through <b>Net:Host</b>.
bool Engine_Host() {
//	oSessionData DirectPlaySessionData //How is the session described?
	kseNet.Connected = 0;
	kseNet.Hosting = true;
	
	Engine_InitConnectionList();
	if (Engine_InitConnection() == 0) { return false; }
	
////	Set oSessionData = DPLAY.CreateSessionData
////	oSessionData.SetMaxPlayers IIf(kseNet.hMaxplayer < 2, 2, kseNet.hMaxplayer)
////	oSessionData.SetSessionName kseNet.hSessName
////	oSessionData.SetGuidApplication APP_GUID
//	//TODO: allow migration of the host
//	
//	//Create (and join) session.
//	Call DPLAY.Open(oSessionData, DPOPEN_CREATE)
//	//add host in this session -- assign name
//	kseNet.playerID = DPLAY.CreatePlayer(kseNet.playerName, "", 0, 0)
	kseNet.hMaxplayer = IIf(kseNet.hMaxplayer < 2, 2, kseNet.hMaxplayer);
	void *threadMain = ThreadCreate(&Engine_ServerStart, Cast(Any Ptr, kseNet.hMaxplayer));
	while (bNetConnState == NETCONN_INIT) {
		sleep(1); //wait for engine to fully open or close-due-to-error
	}
	if (bNetConnState == NETCONN_CLOSE) {
		return false;
	}
	kseNet.Connected = true;
//ChiSock
//	l_ret = kseNet.sockMain.UDP_server(kseNET_PORT);//, kseNet.hMaxplayer
//	if ( l_ret ) {
//		//cout << translate_error( iStat ) << endl;
//		Engine_Log("Socket unavailable", 1);
//	}
	
	return true;
}

void Engine_NetQuit() {
	if (bNetConnState != NETCONN_CLOSE) {
		if (kseNet.Hosting == true) {
			//if server
			bNetConnState = NETCONN_EXIT;
//			while (bNetConnState != NETCONN_CLOSE) {
				sleep(1);
//			}
			
			int i;
			if (g_clientCtr > 0) {
				for (i = 0; i < MAX_CLIENTS - 1; ++i) {
					Clients[i].blnExit = true;
				}
			}
			  
			for (i = 0; i < MAX_CLIENTS - 1; ++i) {
				if (Clients[i].hThread != 0) {
					if (Clients[i].hThread != 0) {
						Engine_Send("", MSG_TYPE_EXIT, Clients[i].hClient);
						NetClose(Clients[i].hClient);
					}
					ThreadWait(Clients[i].hThread);
				}
			}
		} else {
			//if client
			Engine_Send("", MSG_TYPE_EXIT, hEngineConn);
			
		}
		NetClose(hEngineConn);
//		bNetConnState = NETCONN_CLOSE;
	}
}

////
// (<b>Dev API</b>) Joins a server.
//
// @return   Returns <b>1</b> if successfully joined a game, and <b>0</b>, otherwise.
// @remarks  This is called by engine through <b>Net:Join</b>.
bool Engine_Join(string serverName, int port) {
	kseNet.Connected = 0;
	kseNet.Hosting = 0;
	
	if (Engine_InitConnection() == false) { return false; }
		
	int serverIP = Engine_ParseIP(serverName);
	Engine_Log("serverIP " + serverIP,1);
	if (serverIP == 0) {
		//is it the server's computer name?
//ChiSock
//		if (kseNet.sockMain.UDP_client(serverName, port) != chi.SOCKET_OK) { return false; }
//fbNet -- TODO
		return 0
	} else {
//		if (kseNet.sockMain.UDP_client(serverIP, port) != chi.SOCKET_OK) { return false; }
//fbNet
		Server.sin_addr = inet_addr(serverName);
	}
	
	g_ret = NetConnect(hEngineConn, &Server, sizeof(SOCKADDR_IN));
	
	if (g_ret < 0) {
		NetClose(hEngineConn)
		Engine_Log("Socket Connect Error",1);
		bNetConnState = NETCONN_CLOSE;
		return false;
	}
	
	void *threadMain = ThreadCreate(&Engine_ClientStart, 0);
	
	while (bNetConnState == NETCONN_INIT) {
		sleep(1); //wait for engine to fully open or close-due-to-error
	}
	
	if (bNetConnState == NETCONN_CLOSE) {
		return false;
	}
	
	Engine_Log("         Connected",1);
	kseNet.Connected = true;
	//TODO: register client to host then get host info
	
	
	//-------------  DX7 implementation from FreeKE sources
	Engine_InitConnectionList();
//	Engine_ListSessions();
//	DirectPlaySessionData oSessData; //How is the session described?
//
//	long i;
//	long ii = oEnumSess.GetCount;
//	for (i = 1; i < ii; ++i) {
//		//Get the session data from the selected item
//		Set oSessData = oEnumSess.GetItem(i);
//		if (oSessData.GetSessionName == kseNet.hSessName) {
//			//Join the session
//			kseNet.hMaxplayer = oSessData.GetMaxPlayers;
//			Call DPLAY.Open(oSessData, DPOPEN_JOIN);
//			kseNet.playerID = DPLAY.CreatePlayer(kseNet.playerName, "Player", 0, 0);
//			return true;
//		}
//	}
	return true;
//ptrErr:
//	Engine_Log("@Net:(Join) " + Err.Number + " - " + Err.Description);
}

////
// (<b>Dev API</b>) Sends a message.
//
// @param sMsg - Message to send.
// @param MsgTYPE - should it be a textual message or engine command (kick)
// @return   Always returns <b>True</b> if it has hosted/joined a network.
// @remarks  This is called by engine through <b>Net:Send</b> and <b>Net:SendTo</b>.<br>
bool Engine_Send(string sMsg, long MsgTYPE, FDSOCKET pTo) {
//	On Error GoTo ptrErr
//	dpMsg DirectPlayMessage  //Create message object
//	Set dpMsg = DPLAY.CreateMessage
//	dpMsg.WriteLong MsgTYPE
//	//Write the chat text
//	dpMsg.Writestring sMsg
//	//Send the message
//	DPLAY.SendEx kseNet.playerID, DPID_ALLPLAYERS, DPSEND_GUARANTEED, dpMsg, 0, 0, 0
	if (kseNet.Connected == true) {
		if (pTo = -1) {
			g_ret = NetSendString(hEngineConn, MsgTYPE + Chr(2) + kseNet.playerID + Chr(2) + "0" + Chr(2) + sMsg + Chr(3));
		} else {
			g_ret = NetSendString(pTo, MsgTYPE + Chr(2) + kseNet.playerID + Chr(2) + "0" + Chr(2) + sMsg + Chr(3));
		}
		if (g_ret > -1) {
			return true;
		} else {
			net_errMsg = "Socket Send Error " + g_ret + ": " + sMsg;
			Engine_Log(net_errMsg, 1);
			//fail connection here?
			return false;
		}
//ChiSock
//		kseNet.sockMain.put(MsgTYPE + Chr(2) + kseNet.playerID + Chr(2) + DPID_ALLPLAYERS + Chr(2) + sMsg);
//		kseNet.sockMain.put(MsgTYPE + Chr(2) + sender-LAN-id   + Chr(2) + send-to-who     + Chr(2) + sMsg);
//		if ((kseNet.sockMain.put(MsgTYPE + Chr(2) + kseNet.playerID + Chr(2) + "0" + Chr(2) + sMsg) == false) {
//			return false;
//		} else {
//			return true;
//		}
	} else {
		return false;
	}
//ptrErr:
//	Engine_Log("@Net:(Send) " + Err.Number + " - " + Err.Description);
}

////
// (<b>Dev API</b>) Initializes connection.
//
// @return   Returns <b>True</b> if successfully created connection, and <b>False</b>, otherwise.
bool Engine_InitConnection() {

	//Initialize TCP/IP connection
	bNetConnState = NETCONN_INIT;
	hEngineConn = NetSocket(AF_INET, SOCK_STREAM, 0); //SOCK_DGRAM
	if (hEngineConn < 0) {
		Engine_Log("Socket Create Error", 1);
		bNetConnState = NETCONN_CLOSE;
		return false;
	}
	Server.sin_family = AF_INET;
	Server.sin_port   = htons(kseNET_PORT); //2310
	if (kseNet.Hosting == true) {
//		Set DPLAY_Address = oEnumConn.GetAddress(kseNet.TCP_IP);
		//todo: clear player list, etc
	} else {
//		Set DPLAY_Address = DPLAY_Lobby.CreateINetAddress(kseNet.IP, kseNET_PORT);
		//todo: get player list
	}
	
//	//Initialize this address
//	Call DPLAY.InitializeConnection(DPLAY_Address);
	
	return true;
//ptrErr:
}

void Engine_DisableJoin() {
//	DirectPlaySessionData oSessData
//	Set oSessData = DPLAY.CreateSessionData;
//	DPLAY.GetSessionDesc(oSessData);
//	//add rule
//	oSessData.SetFlags(oSessData.GetFlags || DPSESSION_JOINDISABLED);
//	DPLAY.SetSessionDesc(oSessData);
}

int Engine_ParseIP(string sIP) {
	vector<string> IP;
	IP = split(sIP, ".");
	
	if (IP.size() = 4) {
		int intIP;
		return val(IP[0]) || (val(IP[1]) << 8) || (val(IP[2]) << 16) || (val(IP[3]) << 24);
	} else {
		return 0;
	}
}

bool Engine_NetDataPush(int iMsgType, int iFromID, int iToID, string sContent) {
	typeNetData fooNetData;
	
	
		fooNetData.msgstruct = iMsgType;
		fooNetData.fromID  = iFromID;
		fooNetData.toID    = iToID;
		fooNetData.content = sContent;
	
	typeNetData.push_back(fooNetData);
	++kseNetData_count;
	
	return true;
}

typeNetData Engine_NetDataPop() {
	typeNetData tmpNetData;
	
	
		tmpNetData.msgstruct = kseNetData[0].msgType;
		tmpNetData.fromID  = kseNetData[0].fromID;
		tmpNetData.toID    = kseNetData[0].toID;
		tmpNetData.content = kseNetData[0].content;
	
	
	for (int i = 0; i <kseNetData_count - 2; ++i) { //for i = 0 to 0, makes 1 loop which should not be
		
			kseNetData[i].msgstruct = kseNetData[i+1].msgType;
			kseNetData[i].fromID  = kseNetData[i+1].fromID;
			kseNetData[i].toID    = kseNetData[i+1].toID;
			kseNetData[i].content = kseNetData[i+1].content;
		
	}
	
	--kseNetData_count;
	kseNetData.pop();// or was it pop_back?
	
	return tmpNetData;
}
