'translated this 09.23.07@3:16PM by mjmendozaIV
#Include Once "kageExterns.bi"

Public Function SynSound(ByRef iIndex As Long) As Integer

	On Error GoTo ptrErr

	iIndex = GetNearestTokenIndex(kseCOLON, "Sound", iIndex)   'look for		:
	iIndex = GetNextIndex(iIndex)
	Select Case kseToken(iIndex).sToken
		Case "Load"
			Return SoundLoad(iIndex)
		Case "Play"
			Return SoundPlay(iIndex)
		Case "Stop"
			Return SoundStop(iIndex)
		Case "Pause"
			Return SoundPause(iIndex)
		Case "SetLoop"
			Return SoundSetLoop(iIndex)
		Case "SetVolume"
			Return SoundSetVolume(iIndex)
		Case "SetPan"
			Return SoundSetPan(iIndex)
		Case "GetLoop"
			Return SoundGetLoop(iIndex)
		Case "GetVolume"
			Return SoundGetVolume(iIndex)
		Case "GetPan"
			Return SoundGetPan(iIndex)
		Case "GetStatus"
			Return SoundGetStatus(iIndex)
		Case "Free"
			Return SoundFree(iIndex)
		Case Else
			Engine_Message KSE_GetErrFileSrc(iIndex) & "(  " & KSE_GetToken(iIndex) & "  ) is not in Sound Class.", "SYNTAX ERROR AT LINE " & kseToken(iIndex).iLine
			Engine_Exit
	End Select
	Exit Function
ptrErr:
	Engine_ErrMsg Err, "[Sound-Class]"
	Engine_Message SND_LOGIC_ERR, "LOGIC ERROR AT LINE " & kseToken(iIndex).iLine
	Engine_Exit
End Function

Private Function SoundLoad(ByRef iIndex As Long) As Integer
	Dim sSoundPath As String
	Dim iNum As Integer
	Dim iSoundIndex  As Integer
	
	iIndex = Sound_SkipOpenParenthesisAfter("Load", iIndex)
		
		sSoundPath = KSE_GetTokenStrValueOf(iIndex)
	
	iIndex = Sound_SkipCommaAfter("Load(filename", iIndex)
	
	iIndex = GetNextIndex(iIndex)
		iNum = iIndex
	
	iIndex = iIndex + 1										'move index to next
	iIndex = LookFor(kseCLOSE_PAREN, "Handler parameter", iIndex) 'look for	   )
	'EXECUTE SCRIPT =====================================================================
	iSoundIndex = LoadNewSound(sSoundPath)
	
	SetNumValue iNum, CDbl(iSoundIndex)', , LOCK_IT
	
	Return iIndex
End Function

Private Function SoundPlay(ByRef iIndex As Long) As Integer
	Dim iSnd As Long
	
	iIndex = Sound_SkipOpenParenthesisAfter("Play", iIndex)
		
		iSnd = KSE_GetTokenNumValueOf(iIndex)
		
	iIndex = Sound_SkipCloseParenthesisAfter("Play(sound handler", iIndex)
	'EXECUTE SCRIPT =====================================================================
	
	On Error GoTo ptrErr
		With kseSnd(iSnd)
			If .inUse = 1 And .isLoad = 1 Then
				Dim isPaused As FBSBOOLEAN
				fbs_Get_SoundPaused(.hSound, @isPaused)
				If isPaused Then
					fbs_Set_SoundPaused(.hSound, False)
				Else
					Dim iLoop As Integer
					If .isLoop Then
						iLoop = IIf(.isLoop, 2147483647, 0)
					Else
						iLoop = 1
					EndIf
					fbs_Play_Sound(.hSound, iLoop)
				EndIf
				
				' wait on first sample
				While fbs_Get_PlayingSounds() = 0
					Sleep 10
				Wend
			Else
				Engine_Log SND_LOGIC_ERR
			End If
		End With
		
		Return iIndex
ptrErr:
	Engine_ErrMsg Err, "Sound:Play"
	Engine_Exit
End Function

Private Function SoundPause(ByRef iIndex As Long) As Integer
	Dim iSnd As Long
	
	iIndex = Sound_SkipOpenParenthesisAfter("Pause", iIndex)
		
		iSnd = KSE_GetTokenNumValueOf(iIndex)
		
	iIndex = Sound_SkipCloseParenthesisAfter("Pause(sound handler", iIndex)
	'EXECUTE SCRIPT =====================================================================
	
	On Error GoTo ptrErr
		With kseSnd(iSnd)
			If .inUse = 1 And .isLoad = 1 Then
				Dim paused As FBSBOOLEAN
				fbs_Set_SoundPaused(.hSound, True) 
			Else
				Engine_Log SND_LOGIC_ERR
			End If
		End With
		
		Return iIndex
ptrErr:
	Engine_ErrMsg Err, "Sound:Pause"
	Engine_Exit
End Function

Private Function SoundStop(ByRef iIndex As Long) As Integer
	Dim iSnd As Long
	
	iIndex = Sound_SkipOpenParenthesisAfter("Stop", iIndex)
		
		iSnd = KSE_GetTokenNumValueOf(iIndex)
		
	iIndex = Sound_SkipCloseParenthesisAfter("Stop(sound handler", iIndex)
	'EXECUTE SCRIPT =====================================================================
	
	On Error GoTo ptrErr
		With kseSnd(iSnd)
			If .inUse = 1 And .isLoad = 1 Then
				Dim lpStart As FBS_SAMPLE ptr 
				fbs_Set_SoundPaused(.hSound, True) 'pauses the sound "but not restart"
				fbs_Get_SoundPointers(.hSound, @lpStart) 'get start position
				fbs_Set_SoundPointers(.hSound, ,lpStart) 'then set play-pointer to start
			Else
				Engine_Log SND_LOGIC_ERR
			End If
		End With
		
		Return iIndex
ptrErr:
	Engine_ErrMsg Err, "Sound:Stop"
	Engine_Exit
End Function

Private Function SoundSetLoop(ByRef iIndex As Long) As Integer
	Dim iVal As Integer
	Dim iNum As Integer
	
	iIndex = Sound_SkipOpenParenthesisAfter("SetLoop", iIndex)
		
		iVal = KSE_GetTokenNumValueOf(iIndex)
	
	iIndex = Sound_SkipCommaAfter("SetLoop(value", iIndex)
	
		iNum = KSE_GetTokenNumValueOf(iIndex)
		
	iIndex = Sound_SkipCloseParenthesisAfter("SetLoop(value, handler", iIndex)
	'EXECUTE SCRIPT =====================================================================
	With kseSnd(iNum)
		If .inUse = 1 And .isLoad = 1 Then
			'1 means not looped, 2^31 or 2147483648 is maximum loop count as stated in fbsound
			.isLoop = IIf(iVal > 0, 1, 0)
			iVal = IIf(.isLoop = 1, 2147483647, 1)
			
			fbs_Set_SoundLoops(.hSound, iVal)
			fbs_Set_SoundPaused(.hSound, True)
		Else
			Engine_Log SND_LOGIC_ERR
			.isLoop = False
		End If
	End With

	Return iIndex
End Function

Private Function SoundGetLoop(ByRef iIndex As Long) As Integer
	Dim iHdr As Long
	Dim iNum As Integer
	
	iIndex = Sound_SkipOpenParenthesisAfter("GetLoop", iIndex)
		
		iHdr = KSE_GetTokenNumValueOf(iIndex)
	
	iIndex = Sound_SkipCommaAfter("GetLoop(handler", iIndex)
	
	iIndex = GetNextIndex(iIndex)
		iNum = iIndex
	
	iIndex = iIndex + 1										'move index to next
	iIndex = LookFor(kseCLOSE_PAREN, "GetLoop(handler, return", iIndex) 'look for	   )
	'EXECUTE SCRIPT =====================================================================
	With kseSnd(iHdr)
		If .inUse = 1 And .isLoad = 1 Then
			Dim iLoop As Integer
			If fbs_Get_SoundLoops(.hSound, @iLoop) Then
				SetBoolValue iNum, CByte(IIf(iLoop > 0, 1, 0))
			EndIf
		Else
			Engine_Log SND_LOGIC_ERR
		End If
	End With

	Return iIndex
End Function

Private Function SoundSetVolume(ByRef iIndex As Long) As Integer
	Dim iVal As Integer
	Dim iNum As Integer
	
	iIndex = Sound_SkipOpenParenthesisAfter("SetVolume", iIndex)
		
		iVal = KSE_GetTokenNumValueOf(iIndex)
	
	iIndex = Sound_SkipCommaAfter("SetVolume(value", iIndex)
	
		iNum = KSE_GetTokenNumValueOf(iIndex)
		
	iIndex = Sound_SkipCloseParenthesisAfter("SetVolume(value, handler", iIndex)
	'EXECUTE SCRIPT =====================================================================
	With kseSnd(iNum)
		If .inUse = 1 And .isLoad = 1 Then
			'regulate volume value
			If iVal < 0 Then iVal = 0
			iVal = IIf(iVal > 200, 200, iVal)
			iVal = iVal / 100 'fbs_Set_SoundVolume accepts 0 as muted and 2 as loud thus 200 / 100 is 2.
			'set volume
			fbs_Set_SoundVolume(.hSound, iVal)
		Else
			Engine_Log SND_LOGIC_ERR
		End If
	End With

	Return iIndex
End Function

Private Function SoundGetVolume(ByRef iIndex As Long) As Integer
	Dim iHdr As Long
	Dim iNum As Integer
	
	iIndex = Sound_SkipOpenParenthesisAfter("GetVolume", iIndex)
		
		iHdr = KSE_GetTokenNumValueOf(iIndex)
	
	iIndex = Sound_SkipCommaAfter("GetVolume(handler", iIndex)
	
	iIndex = GetNextIndex(iIndex)
		iNum = iIndex
	
	iIndex = iIndex + 1										'move index to next
	iIndex = LookFor(kseCLOSE_PAREN, "GetVolume(handler, return", iIndex) 'look for	   )
	'EXECUTE SCRIPT =====================================================================
	With kseSnd(iHdr)
		If .inUse = 1 And .isLoad = 1 Then
			Dim volume As Single
			If fbs_Get_SoundVolume(.hSound, @volume) Then
				SetNumValue iNum, CDbl(volume * 100)
			Else
				SetNumValue iNum, -1
			EndIf
		Else
			Engine_Log SND_LOGIC_ERR
			SetNumValue iNum, -1
		End If
	End With

	Return iIndex
End Function

Private Function SoundSetPan(ByRef iIndex As Long) As Integer
	Dim iVal As Integer
	Dim iNum As Integer
	
	iIndex = Sound_SkipOpenParenthesisAfter("SetPan", iIndex)
		
		iVal = KSE_GetTokenNumValueOf(iIndex)
	
	iIndex = Sound_SkipCommaAfter("SetPan(value", iIndex)
	
		iNum = KSE_GetTokenNumValueOf(iIndex)
		
	iIndex = Sound_SkipCloseParenthesisAfter("SetPan(value, handler", iIndex)
	'EXECUTE SCRIPT =====================================================================
	With kseSnd(iNum)
		If .inUse = 1 And .isLoad = 1 Then
			If iVal > 100 Then iVal = 100
			If iVal < -100 Then iVal = -100
			iVal = iVal / 100 'fbs_Get_SoundPan requires iVal to be anywhere from -1.0 to +1.0.
			
			fbs_Set_SoundPan(.hSound, iVal)
		Else
			Engine_Log SND_LOGIC_ERR
		End If
	End With

	Return iIndex
End Function

Private Function SoundGetPan(ByRef iIndex As Long) As Integer
	Dim iHdr As Long
	Dim iNum As Integer
	
	iIndex = Sound_SkipOpenParenthesisAfter("GetPan", iIndex)
		
		iHdr = KSE_GetTokenNumValueOf(iIndex)
	
	iIndex = Sound_SkipCommaAfter("GetPan(handler", iIndex)
	
	iIndex = GetNextIndex(iIndex)
		iNum = iIndex
	
	iIndex = iIndex + 1										'move index to next
	iIndex = LookFor(kseCLOSE_PAREN, "GetPan(handler, return", iIndex) 'look for	   )
	'EXECUTE SCRIPT =====================================================================
	With kseSnd(iHdr)
		If .inUse = 1 And .isLoad = 1 Then
			Dim sPan As Single
			If fbs_Get_SoundPan(.hSound, @sPan) Then
				sPan = sPan * 100
				SetNumValue iNum, CDbl(sPan)
			Else
				SetNumValue iNum, 0
			EndIf
		Else
			Engine_Log SND_LOGIC_ERR
		End If
	End With

	Return iIndex
End Function

Private Function SoundGetStatus(ByRef iIndex As Long) As Integer
	Dim iHdr As Long
	Dim iNum As Integer
	Dim iStat As Double
	
	iIndex = Sound_SkipOpenParenthesisAfter("GetStatus", iIndex)
		
		iHdr = KSE_GetTokenNumValueOf(iIndex)
	
	iIndex = Sound_SkipCommaAfter("GetStatus(handler", iIndex)
	
	iIndex = GetNextIndex(iIndex)
		iNum = iIndex
	
	iIndex = iIndex + 1										'move index to next
	iIndex = LookFor(kseCLOSE_PAREN, "GetStatus(handler, return", iIndex) 'look for	   )
	'EXECUTE SCRIPT =====================================================================
	With kseSnd(iHdr)
		If .inUse = 1 And .isLoad = 1 Then
			If fbs_Get_PlayingSounds() Then
				SetNumValue iNum, 1
			Else
				SetNumValue iNum, 0
			EndIf
		Else
			Engine_Log SND_LOGIC_ERR
			SetNumValue iNum, -1
		End If
	End With

	Return iIndex
End Function


Private Function SoundFree(ByRef iIndex As Long) As Integer
	Dim iSnd As Integer
	
	iIndex = Sound_SkipOpenParenthesisAfter("Free", iIndex)
		
		iSnd = KSE_GetTokenNumValueOf(iIndex)
		SetNumValue iIndex, 0, , UNLOCK_IT
	
	iIndex = Sound_SkipCloseParenthesisAfter("Free(handler", iIndex)
	'EXECUTE SCRIPT =====================================================================
	If kseSnd(iSnd).inUse = 1 Then UnloadSound CLng(iSnd)
	
	Return iIndex
End Function


'_____________________________________________________________________________

Private Function Sound_SkipOpenParenthesisAfter(sWhat As String, ByRef iIndex As Long) As Integer
	' wrapper of KSE_SkipOpenPar... for _Sound module
	' to shorten sWhat by placing "Sound:" here
	Return KSE_SkipOpenParenthesisAfter("Sound:" & sWhat, iIndex)
End Function

Private Function Sound_SkipCommaAfter(sWhat As String, ByRef iIndex As Long) As Integer
	' wrapper of KSE_SkipComma... for _Sound module
	' to shorten sWhat by placing "Sound:" here
	Return KSE_SkipCommaAfter("Sound:" & sWhat, iIndex)
End Function

Private Function Sound_SkipCloseParenthesisAfter(sWhat As String, ByRef iIndex As Long) As Integer
	' wrapper of KSE_SkipClosePar... for _Sound module
	' to shorten sWhat by placing "Sound:" here
	Return KSE_SkipCloseParenthesisAfter("Sound:" & sWhat, iIndex)
End Function

