//translated this 18.06.10 by mjmendozaIV
#include "../../kage.hpp"
#include "../../kageExterns.hpp"

unsigned long SynSpriteSet(unsigned long &iIndex) {
	iIndex = GetNearestTokenIndex(kseCOLON, "SpriteSet", iIndex);   //look for		:
	iIndex = GetNextIndex(iIndex);
	
	if (kseToken[iIndex].sToken == "New") {
		return SpriteSetNew(iIndex);
	} else if (kseToken[iIndex].sToken == "SetDimension") {
		return SpriteSetSetDimension(iIndex);
	} else if (kseToken[iIndex].sToken == "SetColumn") {
		return SpriteSetSetColumn(iIndex);
	} else if (kseToken[iIndex].sToken == "SetRow") {
		return SpriteSetSetRow(iIndex);
	} else if (kseToken[iIndex].sToken == "Free") {
			return SpriteSetFree(iIndex);
	} else {
		Engine_Message(KSE_GetErrFileSrc(iIndex) + "(  " + KSE_GetToken(iIndex) + "  ) is not in SpriteSet Class.", "SYNTAX ERROR AT LINE " + Str(kseToken[iIndex].iLine));
		Engine_Exit();
	}
	return ULONG_MAX;
}

unsigned long SpriteSetNew(unsigned long &iIndex) {
	string sImagePath;
	int iNum;
	int iImageIndex;
	int iSpriteIdx;
	
	iIndex = SpriteSet_SkipOpenParenthesisAfter("New", iIndex);
	
		sImagePath = KSE_GetTokenStrValueOf(iIndex);
	
	iIndex = SpriteSet_SkipCommaAfter("New(filename ", iIndex);
	
		iIndex = GetNextIndex(iIndex);
			iNum = iIndex;
	
	iIndex = SpriteSet_SkipCloseParenthesisAfter("New(filename, handler", iIndex);
	//EXECUTE SCRIPT =====================================================================
	
	iImageIndex = LoadNewImage(sImagePath);
	iSpriteIdx = CreateNewSprite();
	
	kseSprite[iSpriteIdx].iPicture = iImageIndex;
	
	SetNumValue(iNum, CDbl(iSpriteIdx), "", LOCK_IT);
	
	return iIndex;
}

unsigned long SpriteSetSetDimension(unsigned long &iIndex) {
	int iWid;
	int iHgt;
	int iSpriteIdx;
	
	iIndex = SpriteSet_SkipOpenParenthesisAfter("SetDimension", iIndex);
		
		iWid = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = SpriteSet_SkipCommaAfter("SetDimension(width", iIndex);
	
		iHgt = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = SpriteSet_SkipCommaAfter("SetDimension(width, height", iIndex);
	
		iSpriteIdx = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = SpriteSet_SkipCloseParenthesisAfter("SetDimension(width, height, handler", iIndex);
	//EXECUTE SCRIPT =====================================================================
	kseSprite[iSpriteIdx].iHgt = iHgt;
	kseSprite[iSpriteIdx].iWid = iWid;

	return iIndex;
}

unsigned long SpriteSetSetColumn(unsigned long &iIndex) {
	int iVal;
	int iSpriteIdx;
	
	iIndex = SpriteSet_SkipOpenParenthesisAfter("SetColumn", iIndex);
		
		iVal = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = SpriteSet_SkipCommaAfter("SetColumn(value", iIndex);
	
		iSpriteIdx = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = SpriteSet_SkipCloseParenthesisAfter("SetColumn(value, handler", iIndex);
	//EXECUTE SCRIPT =====================================================================
	kseSprite[iSpriteIdx].iCol = iVal;

	return iIndex;
}

unsigned long SpriteSetSetRow(unsigned long &iIndex) {
	int iVal;
	int iSpriteIdx;
	
	iIndex = SpriteSet_SkipOpenParenthesisAfter("SetRow", iIndex);
	
		iVal = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = SpriteSet_SkipCommaAfter("SetRow(value", iIndex);
	
		iSpriteIdx = KSE_GetTokenNumValueOf(iIndex);
	
	iIndex = SpriteSet_SkipCloseParenthesisAfter("SetRow(value, handler", iIndex); //look for	   )
	//EXECUTE SCRIPT =====================================================================
	kseSprite[iSpriteIdx].iRow = iVal;
	
	return iIndex;
}

int CreateNewSprite() {
	iSpriteCtr = kseSprite.size();
	if (iSpriteCtr == 0) {
		typeSprite l_sprite;
		kseSprite.push_back(l_sprite);
		++iSpriteCtr;
	}
	for (int i  = 0; i < iSpriteCtr; ++i) {
		if (kseSprite[i].bUsed == false) {
			kseSprite[i].bUsed = true;
			return i;
		}
	}
	////if it didnt, add new one
	typeSprite l_sprite;
		l_sprite.bUsed = true;
	kseSprite.push_back(l_sprite);
	++iSpriteCtr;
	
	return iSpriteCtr;
}

unsigned long SpriteSetFree(unsigned long &iIndex) {
	int iSpriteIdx;
	
	iIndex = SpriteSet_SkipOpenParenthesisAfter("Free", iIndex);
		
		iSpriteIdx = KSE_GetTokenNumValueOf(iIndex);
		SetNumValue(iIndex, 0, "", UNLOCK_IT);
	
	iIndex = SpriteSet_SkipCloseParenthesisAfter("Free(handler", iIndex);
	//EXECUTE SCRIPT =====================================================================
	kseSprite[iSpriteIdx].bUsed = false;
	UnloadImage(CULng(iSpriteIdx));

	return iIndex;
}

//_____________________________________________________________________________
unsigned long SpriteSet_SkipOpenParenthesisAfter(string sWhat, unsigned long &iIndex) {
	// wrapper of KSE_SkipOpenPar... for _SpriteSet module
	// to shorten sWhat by placing "SpriteSet:" here
	return KSE_SkipOpenParenthesisAfter("SpriteSet:" + sWhat, iIndex);
}

unsigned long SpriteSet_SkipCommaAfter(string sWhat, unsigned long &iIndex) {
	// wrapper of KSE_SkipComma... for _SpriteSet module
	// to shorten sWhat by placing "SpriteSet:" here
	return KSE_SkipCommaAfter("SpriteSet:" + sWhat, iIndex);
}

unsigned long SpriteSet_SkipCloseParenthesisAfter(string sWhat, unsigned long &iIndex) {
	// wrapper of KSE_SkipClosePar... for _SpriteSet module
	// to shorten sWhat by placing "SpriteSet:" here
	return KSE_SkipCloseParenthesisAfter("SpriteSet:" + sWhat, iIndex);
}
