//translated this 17.09.27 by mjmendozaIV
#include "../../kage.hpp"
#include "../../kageExterns.hpp"

unsigned long SynString(unsigned long &iIndex) {
	
	iIndex = GetNearestTokenIndex(kseCOLON, "String", iIndex);   //look for		:
	iIndex = GetNextIndex(iIndex);
	
	if (kseToken[iIndex].sToken == "ToUpper") {
		return StringToUpper(iIndex);					//let KONSoLE convert string to upper case
	} else if (kseToken[iIndex].sToken == "ToLower") {
		return StringToLower(iIndex);					//let KONSoLE convert string to lower case
	} else if (kseToken[iIndex].sToken == "Dup") {
		return StringDuplicate(iIndex);
	} else if (kseToken[iIndex].sToken == "Split") {
		return StringSplit(iIndex);
	} else if (kseToken[iIndex].sToken == "Left") {
		return StringLeft(iIndex);
	} else if (kseToken[iIndex].sToken == "Right") {
		return StringRight(iIndex);
	} else if (kseToken[iIndex].sToken == "Mid") {
		return StringMid(iIndex);
	} else if (kseToken[iIndex].sToken == "Len") {
		return StringLen(iIndex);
	} else if (kseToken[iIndex].sToken == "Reverse") {
		return StringReverse(iIndex);
	} else if (kseToken[iIndex].sToken == "Trim") {
		return StringTrim(iIndex);
	} else if (kseToken[iIndex].sToken == "Replace") {
		return StringReplace(iIndex);
	} else {
		Engine_Message(KSE_GetErrFileSrc(iIndex) + "(  " + KSE_GetToken(iIndex) + "  ) is not in string Class.", "SYNTAX ERROR AT LINE " + Str(kseToken[iIndex].iLine));
		Engine_Exit();
	}
	return ULONG_MAX;
}

unsigned long StringToUpper(unsigned long &iIndex) {
	string sVal;
	string sSource;
	unsigned long iNum;
	
	++iIndex;								  //move index to next
	iIndex = LookFor(kseOPEN_PAREN, "ToUpper", iIndex); //look for	   (
	
		sSource = KSE_GetTokenStrValueOf(iIndex);						 //get token index
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseCOMMA, "Source parameter", iIndex); //look for	   ,
	
	iNum = CheckReturnAndCloseParenthesis(iIndex);
	//===================================================================
	sVal = stringToUpper(sSource);
	SetStrValue(iNum, sVal);
	
	return iIndex;
}

unsigned long StringToLower(unsigned long &iIndex) {
	string sVal;
	string sSource;
	unsigned long iNum;
	
	++iIndex;								  //move index to next
	iIndex = LookFor(kseOPEN_PAREN, "ToLower", iIndex); //look for	   (
	
		sSource = KSE_GetTokenStrValueOf(iIndex);
		
	++iIndex;										//move index to next
	iIndex = LookFor(kseCOMMA, "Source parameter", iIndex); //look for	   ,
	
	iNum = CheckReturnAndCloseParenthesis(iIndex);
	//===================================================================
	sVal = LCase(sSource);
	SetStrValue(iNum, sVal);
	
	return iIndex;
}

unsigned long StringLeft(unsigned long &iIndex) {
	double iLen;
	unsigned long iNum;
	string sSource;
	string sVal;
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseOPEN_PAREN, "Left", iIndex);	  //look for	   (
	
		sSource = KSE_GetTokenStrValueOf(iIndex);
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseCOMMA, "Source parameter", iIndex);	  //look for	   )
	
		iLen = KSE_GetTokenNumValueOf(iIndex);
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseCOMMA, "Length parameter", iIndex);	 //look for	   ,
	
	iNum = CheckReturnAndCloseParenthesis(iIndex);
	//get string left===================================================================
	sVal = Left(sSource, iLen);
	
	SetStrValue(iNum, sVal);
	
	return iIndex;
}

unsigned long StringRight(unsigned long &iIndex) {
	
	double iLen;
	unsigned long iNum;
	string sSource;
	string sVal;
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseOPEN_PAREN, "Right", iIndex);	  //look for	   (
	
		sSource = KSE_GetTokenStrValueOf(iIndex);
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseCOMMA, "Source parameter", iIndex);	  //look for	   ,
	
		iLen = KSE_GetTokenNumValueOf(iIndex);
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseCOMMA, "Length parameter", iIndex);	 //look for	   ,
	
	iNum = CheckReturnAndCloseParenthesis(iIndex);
	//get string right==================================================================
	
	sVal = Right(sSource, iLen);
	
	SetStrValue(iNum, sVal);
	
	return iIndex;
}

unsigned long StringMid(unsigned long &iIndex) {
//=====================================================================================
//String:Mid(str SourceString, Num Start, Num Length, StringVarExpression)
//-------------------------------------------------------------------------------------
//   Var:Number(myString)	 //declare myString
//   String:Mid("Hello!", 1, 3, myString)
//=====================================================================================
	string sSource;
	double iStart;
	double iLen;
	unsigned long iNum;
	
	string sVal;
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseOPEN_PAREN, "Mid", iIndex);		//look for	   (
	
		sSource = KSE_GetTokenStrValueOf(iIndex);
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseCOMMA, "Source parameter", iIndex);	  //look for	   )
	
		iStart = KSE_GetTokenNumValueOf(iIndex);
	
	if (iStart < 0) {
		Engine_Message(KSE_GetErrFileSrc(iIndex) + "String:Mid Error:" + "\r\n" +
					   "Cannot have a negative starting value.", "SYNTAX ERROR AT LINE " + kseToken[iIndex].iLine);
		Engine_Exit();
	}
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseCOMMA, "Start parameter", iIndex);	 //look for	   ,
	
		iLen = KSE_GetTokenNumValueOf(iIndex);
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseCOMMA, "Length parameter", iIndex);	 //look for	   ,
	
	iNum = CheckReturnAndCloseParenthesis(iIndex);
	//get string mid====================================================================
	if (iStart < 1) { iStart = 1; }
	//if negative, user takes all -- except where it started
	if (iLen < 0) { iLen = sSource.length() - iStart; }
	sVal = Mid(sSource, iStart, iLen);
	
	SetStrValue(iNum, sVal);
	
	return iIndex;
}

unsigned long StringLen(unsigned long &iIndex) {
//=====================================================================================
//String:Len(string Source, Number Return)
//-------------------------------------------------------------------------------------
//   Var:Number(myNumber)	 //declare myNumber
//	 String:Len("Hello!", myNumber) //get length of myString
//=====================================================================================
	string sExp;
	double iLen;
	unsigned long iNum;
	string sSource;
	++iIndex;								  //move index to next
	iIndex = LookFor(kseOPEN_PAREN, "Len", iIndex);   //look for	   (
	
		sSource = KSE_GetTokenStrValueOf(iIndex);
	
	++iIndex;								  //move index to next
	iIndex = LookFor(kseCOMMA, "string source parameter", iIndex); //look for	   )
	
	iNum = CheckReturnAndCloseParenthesis(iIndex);
	//get string len====================================================================
	iLen = sSource.length();
	
	SetNumValue(iNum, iLen);
	
	return iIndex;
}

unsigned long StringSplit(unsigned long &iIndex) {
	string sSource;
	string sDelim;
	unsigned long iArr;
	//syntax:
	//--------------
	// String:Split(data, myArray)
	//
	//CHECK SYNTAX ===================================================================
	++iIndex;										//move index to next
	iIndex = LookFor(kseOPEN_PAREN, "Split", iIndex);	   //look for	   (
	
		sSource = KSE_GetTokenStrValueOf(iIndex);
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseCOMMA, "Source string parameter", iIndex);	  //look for	   ,
	
		sDelim = KSE_GetTokenStrValueOf(iIndex);
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseCOMMA, "Delimiter string parameter", iIndex);	 //look for	   ,
	
		iIndex = GetNextIndex(iIndex);
		iArr = iIndex;
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseCLOSE_PAREN, "array", iIndex); //look for	  )
	
	//EXECUTE SCRIPT ===================================================================
	vector<string> aVals;
	int iValsLen;
	Engine_Log("? A " + sSource, 1);
	aVals = split(sSource, sDelim);
	
	vector<string> ArrList;
	kSplit(kseToken[iArr].sToken, kseMINUS_SIGN, ArrList);
	Engine_Log("? B", 1);
	if (ArrList[0] == "A") {
		int i;
		int j = -1;
		
			int k = 0;
			int arrLen;
			
			if (kseArray[Val(ArrList[1])]._split == true) {
				arrLen = kseArray[Val(ArrList[1])]._realSize;
			} else {
				arrLen = kseArray[Val(ArrList[1])].iSize;
			}
			iValsLen = aVals.size();
			if (iValsLen > arrLen) {
				kseArray[Val(ArrList[1])]._split = true;
				if (arrLen > 16) {
					kseArray[Val(ArrList[1])]._realSize = (arrLen - (arrLen % 16)) / arrLen * 16; // create batch of 16 arrays
				} else {
					kseArray[Val(ArrList[1])]._realSize = 16;
				}
				trace("? B " + kseArray[Val(ArrList[1])]._realSize + "|" + arrLen);
				kseArray[Val(ArrList[1])].iVal.clear(); // [QuixiePP] do we need to check if previously created Array content should be freed?
				do {
					trace("? Bb " + k);
					kseArray[Val(ArrList[1])].iVal.push_back(ULONG_MAX);
				//	j = ReAllocate(kseArray[Val(ArrList[1])].iVal, kseArray[Val(ArrList[1])]._realSize);
				//	if (j != 0) {
				//		k = 50;
				//	} else {
						++k;
				//	}
				} while (k < 50);
				//for (i = kseArray[Val(ArrList[1])].iSize; i < kseArray[Val(ArrList[1])]._realSize - 1; ++i) {
				//	kseArray[Val(ArrList[1])].iVal[i] = -1;
				//}
			}
			trace("? Bbb " + j);
			for (i = 0; i < iValsLen - 1; ++i) {
				trace("? Bc " + i);
				if (kseArray[Val(ArrList[1])].bUDT == true) {
					//cannot have a string-delimited-UDT // [QuixiePP] err? re-evaluate!
				} else {
					switch (kseArray[Val(ArrList[1])].iType) {
						case kseVALUE_ISTOKENNUM:
							kseArray[Val(ArrList[1])].iVal[i] = KSE_DeclareNum(kseArray[Val(ArrList[1])].sName + "[" + Str(i) + "]", CDbl(aVals[i]));
							break;
						case kseVALUE_ISTOKENSTR:
							trace("? Bd " + .sName + "[" + Str(i) + "] | " + aVals[i]);
							kseArray[Val(ArrList[1])].iVal[i] = KSE_DeclareStr(kseArray[Val(ArrList[1])].sName + "[" + Str(i) + "]", aVals[i]);
							trace("? Be " + .iVal[i]);
							break;
						case kseVALUE_ISTOKENBOOL:
							kseArray[Val(ArrList[1])].iVal[i] = KSE_DeclareBool(kseArray[Val(ArrList[1])].sName + "[" + Str(i) + "]", ((CDbl(aVals[i]) > 0) ? true : false));
					}
					trace("? Bf");
				}
				trace("? Bg");
			}
			
			if (j != 0) {
				kseArray[Val(ArrList[1])].iSize = iValsLen;
				Engine_Log("? C " + j, 1);
				for (i = 0; i < iValsLen-1; ++i) {
					if (kseArray[Val(ArrList[1])].bUDT == true) {
						//cannot have a string-delimited-UDT // [QuixiePP] err? re-evaluate!
					} else {
						Engine_Log("? D " + i, 1);
						switch (kseArray[Val(ArrList[1])].iType) {
							case kseVALUE_ISTOKENNUM:
								SetVarNumValue(kseArray[Val(ArrList[1])].iVal[i], CDbl(aVals[i]));
								break;
							case kseVALUE_ISTOKENSTR:
						Engine_Log("? Da " + aVals[i], 1);
						Engine_Log("? Db " + kseArray[Val(ArrList[1])].iVal[i], 1);
								SetVarStrValue(kseArray[Val(ArrList[1])].iVal[i], aVals[i]);
						Engine_Log("? Dc", 1);
								break;
							case kseVALUE_ISTOKENBOOL:
								SetVarBoolValue(kseArray[Val(ArrList[1])].iVal[i], ((CDbl(aVals[i]) > 0) ? true : false));
						}
						trace("? Dd");
					}
					trace("? De");
				}
			}
		
	} else {
		Engine_Message(KSE_GetErrFileSrc(iArr) + "(  " + KSE_GetToken(iArr) + "  ) is not an Array.", "LOGIC ERROR AT LINE " + kseToken[iArr].iLine);
		Engine_Exit();
	}
	//TODO: create an array that user can access
	
	return iIndex;
}

unsigned long StringDuplicate(unsigned long &iIndex) {
	string sSource;
	int lVal;
	string sVal;
	unsigned long iNum;
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseOPEN_PAREN, "Dup", iIndex);	   //look for	   (
	
		sSource = KSE_GetTokenStrValueOf(iIndex);
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseCOMMA, "Source parameter", iIndex);	  //look for	   ,
	
		lVal = KSE_GetTokenNumValueOf(iIndex);
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseCOMMA, "Copy parameter", iIndex);	 //look for	   ,
	
	iNum = CheckReturnAndCloseParenthesis(iIndex);
	//duplicate string ===================================================================
	
	sVal = String(lVal, sSource);
	
	SetStrValue(iNum, sVal);
	
	return iIndex;
}

unsigned long StringReverse(unsigned long &iIndex) {
	unsigned long iNum;
	string sSource;
	string sVal;
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseOPEN_PAREN, "Reverse", iIndex);	  //look for	   (
	
		sSource = KSE_GetTokenStrValueOf(iIndex);
		
	++iIndex;										//move index to next
	iIndex = LookFor(kseCOMMA, "Source parameter", iIndex);	  //look for	   )
	
	iNum = CheckReturnAndCloseParenthesis(iIndex);
	//get string left===================================================================
	sVal = StrReverse(sSource);
	
	SetStrValue(iNum, sVal);
	
	return iIndex;
}

unsigned long StringTrim(unsigned long &iIndex) {
	unsigned long iNum;
	string sSource;
	string sVal;
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseOPEN_PAREN, "Trim", iIndex);	  //look for	   (
	
		sSource = KSE_GetTokenStrValueOf(iIndex);
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseCOMMA, "Source parameter", iIndex);	  //look for	   )
	
	iNum = CheckReturnAndCloseParenthesis(iIndex);
	//get string left===================================================================
	sVal = Trim(sSource);
	
	SetStrValue(iNum, sVal);
	
	return iIndex;
}

unsigned long StringReplace(unsigned long &iIndex) {
	unsigned long iNum;
	string sFind;
	string sReplace;
	string sSource;
	string sVal;
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseOPEN_PAREN, "Replace", iIndex);	  //look for	   ("
	
	iIndex = GetNextIndex(iIndex);
	
		sFind = KSE_GetTokenStrValueOf(iIndex);
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseCOMMA, "Find parameter", iIndex);	  //look for	   ,
	
	iIndex = GetNextIndex(iIndex);
	
		sReplace = KSE_GetTokenStrValueOf(iIndex);
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseCOMMA, "Replace parameter", iIndex);	  //look for	   ,
	
		sSource = KSE_GetTokenStrValueOf(iIndex);
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseCOMMA, "Source parameter", iIndex);	  //look for	   )
	
	iNum = CheckReturnAndCloseParenthesis(iIndex);
	//get string left===================================================================
	sVal = Replace(sSource, sFind, sReplace);
	
	SetStrValue(iNum, sVal);
	
	return iIndex;
}
