//translated this 18.06.10 by mjmendozaIV
#include "../../kage.hpp"
#include "../../kageExterns.hpp"

unsigned long SynTileSet(unsigned long &iIndex) {
	iIndex = GetNearestTokenIndex(kseCOLON, "TileSet", iIndex);   //look for		:
	iIndex = GetNextIndex(iIndex);
	if (kseToken[iIndex].sToken == "New") {
		return TileSetNew(iIndex);
	} else if (kseToken[iIndex].sToken == "SetDimension") {
			return TileSetSetDimension(iIndex); //TODO: make it param of TileSet:New; then deprecate this
	} else if (kseToken[iIndex].sToken == "SetColumn") {
			return TileSetSetColumn(iIndex); //TODO: make it param of TileSet:New; then deprecate this
	} else if (kseToken[iIndex].sToken == "SetRow") {
			return TileSetSetRow(iIndex); //TODO: make it param of TileSet:New; then deprecate this
	} else if (kseToken[iIndex].sToken == "Free") {
		return TileSetFree(iIndex);
	} else {
		Engine_Message(KSE_GetErrFileSrc(iIndex) + "(  " + KSE_GetToken(iIndex) + "  ) is not in TileSet Class.", "SYNTAX ERROR AT LINE " + Str(kseToken[iIndex].iLine));
		Engine_Exit();
	}
	return ULONG_MAX;
}

unsigned long TileSetNew(unsigned long &iIndex) {
	string sImagePath;
	int iNum;
	int iImageIndex;
	int iTileSetIdx;
	
	++iIndex;								  //move index to next
	iIndex = LookFor(kseOPEN_PAREN, "TileSet:New", iIndex);  //look for	   (
		
	iIndex = GetNextIndex(iIndex);
		sImagePath = GetTokenStrValue(iIndex);
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseCOMMA, "TileSet:New(filename ", iIndex); //look for	   ,
	
	iIndex = GetNextIndex(iIndex);
	iNum = iIndex;
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseCLOSE_PAREN, "TileSet:New(filename, handler ", iIndex); //look for	   )
	//EXECUTE SCRIPT =====================================================================
	iImageIndex = LoadNewImage(sImagePath);
	
	iTileSetIdx = CreateNewTileSet();
	
	kseTileSet[iTileSetIdx].iPicture = iImageIndex;
	
	SetNumValue(iNum, CDbl(iTileSetIdx), "", LOCK_IT);

	return iIndex;
}

unsigned long TileSetSetDimension(unsigned long &iIndex) {
	double iVal;
	int iTileSetIdx;
	
	++iIndex;								  //move index to next
	iIndex = LookFor(kseOPEN_PAREN, "TileSet:SetDimension", iIndex);  //look for	   (
		
	iIndex = GetNextIndex(iIndex);
		iVal = GetTokenNumValue(iIndex);
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseCOMMA, "TileSet:SetDimension(value ", iIndex); //look for	   ,
	
	iIndex = GetNextIndex(iIndex);
		iTileSetIdx = GetTokenNumValue(iIndex);
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseCLOSE_PAREN, "TileSet:SetDimension(value, handler ", iIndex); //look for	   )
	//EXECUTE SCRIPT =====================================================================
	kseTileSet[iTileSetIdx].iDimension = iVal;

	return iIndex;
}

unsigned long TileSetSetColumn(unsigned long &iIndex) {
	double iVal;
	int iTileSetIdx;
	
	++iIndex;								  //move index to next
	iIndex = LookFor(kseOPEN_PAREN, "TileSet:SetColumn", iIndex);  //look for	   (
		
	iIndex = GetNextIndex(iIndex);
		iVal = GetTokenNumValue(iIndex);
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseCOMMA, "TileSet:SetColumn(value ", iIndex); //look for	   ,
	
	iIndex = GetNextIndex(iIndex);
		iTileSetIdx = GetTokenNumValue(iIndex);
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseCLOSE_PAREN, "TileSet:SetColumn(value, handler ", iIndex); //look for	   )
	//EXECUTE SCRIPT =====================================================================
	kseTileSet[iTileSetIdx].iCol = iVal;

	return iIndex;
}

unsigned long TileSetSetRow(unsigned long &iIndex) {
	double iVal;
	int iTileSetIdx;
	
	++iIndex;								  //move index to next
	iIndex = LookFor(kseOPEN_PAREN, "TileSet:SetRow", iIndex);  //look for	   (
		
	iIndex = GetNextIndex(iIndex);
		iVal = GetTokenNumValue(iIndex);
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseCOMMA, "TileSet:SetRow(value ", iIndex); //look for	   ,
	
	iIndex = GetNextIndex(iIndex);
		iTileSetIdx = GetTokenNumValue(iIndex);
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseCLOSE_PAREN, "TileSet:SetRow(value, handler ", iIndex); //look for	   )
	//EXECUTE SCRIPT =====================================================================
	kseTileSet[iTileSetIdx].iRow = iVal;

	return iIndex;
}

int CreateNewTileSet() {
	iTileSetCtr = kseTileSet.size();
	if (iTileSetCtr == 0) {
		typeTileSet l_tileSet;
		kseTileSet.push_back(l_tileSet);
		++iTileSetCtr;
	}
	for (int i  = 0; i < iTileSetCtr; ++i) {
		if (kseTileSet[i].bUsed == false) {
			kseTileSet[i].bUsed = true;
			return i;
		}
	}
	////if it didnt, add new one
	typeTileSet l_tileSet;
		l_tileSet.bUsed = true;
	kseTileSet.push_back(l_tileSet);
	++iTileSetCtr;
	
	return iTileSetCtr;
}

unsigned long TileSetFree(unsigned long &iIndex) {
	string sVal;
	int iTileSetIdx;
	
	++iIndex;								  //move index to next
	iIndex = LookFor(kseOPEN_PAREN, "TileSet:Free", iIndex);  //look for	   (
		
		iTileSetIdx = KSE_GetTokenNumValueOf(iIndex);
		SetNumValue(iIndex, 0, "", UNLOCK_IT);
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseCLOSE_PAREN, "TileSet:SetRow(handler ", iIndex); //look for	   )
	//EXECUTE SCRIPT =====================================================================
	kseTileSet[iTileSetIdx].bUsed = false;
	UnloadImage(CULng(iTileSetIdx));

	return iIndex;
}
