//translated this 18.06.10 by mjmendozaIV
#include "../../kage.hpp"
#include "../../kageExterns.hpp"

bool bRenderGraphics;

void Main() {
//	clsKONSol_SQLite l_sqlite;
//	kseSQLite.push_back(l_sqlite);
	Engine_Associate();
	
	Engine_GetParams();
	
	#ifdef QUIXIE_CGI
		KSE_DeclareEnvirons();
	#endif
	iCrntFunc = kseNOT_ON_FUNCTION;	  //set that no function(in KS source file) is being used yet
	
	Engine_Configure();
	Engine_Log(string("Engine@") + kseNOW() + string(":Configuring"));	 //always place this line after Engine_Configure,
													//since engine_log should be config'ed first
	#ifndef QUIXIE_CGI
		InitializeMedia();							//place this after engine configuration
	#endif
													//->it uses the ..._Log which is dependent on ..._Configure
	Engine_Log(string("Engine@") + kseNOW() + string(":Initializing"));
	Engine_Initialize();
	
	Engine_Log(string("Engine@") + kseNOW() + string(":Parsing"));
	bREAD_ESCAPE_CHARS = true;
		
	ProcessScript_Parse(sKONSoL);
	
	if (sReleaseMode != "1") {
		Engine_Log(string("Engine@") + kseNOW() + string(":Compiling"));
		ProcessScript_CleanUp();		  //remove all comments for faster parsing
		ProcessScript_Statement_Include();
		ProcessScript_Refresh();
		ProcessScript_ReadCompiled();
		ProcessScript_Parse(sKONSoL);
	}
	bKONSoLE_DeclaringVar = true;
		Engine_Log(string("Engine@") + kseNOW() + string(":Defining"));
		ProcessScript_Statement_Define();
		Engine_Log(string("Engine@") + kseNOW() + string(":Declaring Built-In Variables"));
		DeclareKONSoL_Built_In_Vars();
		Engine_Log(string("Engine@") + kseNOW() + string(":Creating Table Look-Up"));
		Engine_TableLookUp_Create();
		Engine_Log(string("Engine@") + kseNOW() + string(":Implementing Table Look-Up"));
		Engine_TableLookUp_Implement();
	bKONSoLE_DeclaringVar = false;
	Engine_Log(string("Engine@") + kseNOW() + string(":Checking Syntax"));
	bKONSoLE_Reading = false;		//temporary disable reading of [escape chars] in quotes
		//forgot the reason why bKONSoLE_Reading is set to false
		//kse_String_Equation->SynQuotes is causing a bug with string value of
		//      "hello \"there\"!"
		//caused by the line: (bKONSoLE_Reading || bREAD_ESCAPE_CHARS)
		//That is why I'm setting 
			bREAD_ESCAPE_CHARS = true;
			
		ProcessScript_CheckSyntax();  //-- to be fully implemented once KonsolScript is stable
		KSE_PairParenthesis();
	bKONSoLE_Reading = true;			//resume reading of [quotes]
	Engine_Log(string("Engine@") + kseNOW() + string(":Running"));
		
	#ifndef QUIXIE_CGI
		Engine_ScreenShow();							//engine now defaults to showing the screen
	#endif
	
	Engine_Run();
	
	if (LCase(Right(sStartScript, 3)) == ".kh") { Engine_CompileHeader(); }
	
	Engine_Log(string("Engine@") + kseNOW() + string(":Exiting"));
	Engine_Exit();
	
	//MsgBox("Good to Go!", "KONSoLE" -- do not delete; for trivia :P);
	return;
}

void DeclareKONSoL_Built_In_Vars() {
	#ifndef QUIXIE_CGI
		VAR_B1 = KSE_DeclareBool("B1", false);
		VAR_B2 = KSE_DeclareBool("B2", false);
		VAR_B3 = KSE_DeclareBool("B3", false);
		VAR_B4 = KSE_DeclareBool("B4", false);
		VAR_BU = KSE_DeclareBool("BU", false);
		VAR_BD = KSE_DeclareBool("BD", false);
		VAR_BL = KSE_DeclareBool("BL", false);
		VAR_BR = KSE_DeclareBool("BR", false);
		VAR_LMB = KSE_DeclareBool("LMB", false);
		VAR_MMB = KSE_DeclareBool("MMB", false);
		VAR_RMB = KSE_DeclareBool("RMB", false);
		
		VAR_LASTPRESS = KSE_DeclareNum("lastpress", 256);
		VAR_LASTUNPRESS = KSE_DeclareNum("lastunpress", 256);
		VAR_SCREENWIDTH = KSE_DeclareNum("screenwidth", 640, 1);
		VAR_SCREENHEIGHT = KSE_DeclareNum("screenheight", 480, 1);
		KSE_DeclareNum("textwidth", 10, 1);     //:ksSCREEN.TextWidth("A"), true
		KSE_DeclareNum("textheight", 12, 1);    //:ksSCREEN.TextHeight("A"), true 
		KSE_DeclareNum("cursorX", 0, 1);
		KSE_DeclareNum("cursorY", 0, 1);
		VAR_MOUSEX = KSE_DeclareNum("mouseX", 0, 1);
		VAR_MOUSEY = KSE_DeclareNum("mouseY", 0, 1);
		KSE_DeclareNum("state", 0, 1);
	#endif
}

unsigned long KSE_GetUDTIdx(string udtName) {
	for (unsigned long i = 0; i < kseUDT.size(); ++i) {
		if (kseUDT[i].udtName == udtName) {
			return i;
		}
	}
	return -1;
}

unsigned long KSE_DeclareUDT_Instance(unsigned int udtIdx, string udtInstanceName) {
	typeUDT_Instance l_UDT_Instance;
		l_UDT_Instance.sName = udtInstanceName;
		for (unsigned long i = 0; i < kseUDT[udtIdx].udtPocketName.size(); ++i) {
			if (kseUDT[udtIdx].udtPocketTypeID[i] == kseVALUE_ISTOKENNUM) {
				l_UDT_Instance.iVal.push_back(KSE_DeclareNum(l_UDT_Instance.sName + "." + kseUDT[udtIdx].udtPocketName[i], 0));
			} else if (kseUDT[udtIdx].udtPocketTypeID[i] == kseVALUE_ISTOKENBOOL) {
				l_UDT_Instance.iVal.push_back(KSE_DeclareBool(l_UDT_Instance.sName + "." + kseUDT[udtIdx].udtPocketName[i], false));
			} else if (kseUDT[udtIdx].udtPocketTypeID[i] == kseVALUE_ISTOKENSTR) {
				l_UDT_Instance.iVal.push_back(KSE_DeclareStr(l_UDT_Instance.sName + "." + kseUDT[udtIdx].udtPocketName[i], ""));
			}
		}
		l_UDT_Instance.bUsed = true;           //it is being used, right?
		l_UDT_Instance.sFunc = kseNULL_STRING;
	//	l_UDT_Instance.lFunc = -1 //global
		l_UDT_Instance.bArgs = false;
		l_UDT_Instance.udtIdx = udtIdx;
		l_UDT_Instance.bProtect = true;        //do not let users know about this one; they did not declare the array as one-by-one -- we did
		
	kseUDT_Instance.push_back(l_UDT_Instance);
	
	return kseUDT_Instance.size()-1;
}

unsigned long KSE_DeclareNum(string sVarName, double nValue, bool bReadOnly, bool bAppArg, bool bProtect, string sFunc, unsigned long lFunc) {
	iVarNumCtr = kseVarNum.size();
	if (iVarNumCtr != 0) {
		for (unsigned long i = 0; i < iVarNumCtr; ++i) {
			if (kseVarNum[i].sName == sVarName) {
				kseVarNum[i].nVal = nValue;          //get the value
				kseVarNum[i].bUsed = true;           //it is being used, right?
				kseVarNum[i].sFunc = sFunc;
				kseVarNum[i].lFunc = -1; //global
				kseVarNum[i].bReadOnly = bReadOnly;  //should it be readonly access
				kseVarNum[i].bAppArg = bAppArg;
	//				kseVarNum[i].bProtect = bProtect;
				return i;
			}
		}
	}
	
	typeVarNum l_varNum;
		l_varNum.sName = sVarName;       //store the name
		l_varNum.nVal = nValue;          //get the value
		l_varNum.bUsed = true;           //it is being used, right?
		l_varNum.sFunc = sFunc;
		l_varNum.lFunc = -1; //global
		l_varNum.bReadOnly = bReadOnly;  //should it be readonly access
		l_varNum.bAppArg = bAppArg;
		l_varNum.bProtect = bProtect;
		
	kseVarNum.push_back(l_varNum);
	
	unsigned long iID = iVarNumCtr++;
	sKONSoLE_LastDeclaredVarName = "N-" + Str(iID) + "-" + sVarName;
	return iID;
}

unsigned long KSE_DeclareBool(string sVarName, bool bValue, bool bReadOnly, bool bAppArg, bool bProtect) {
	iVarBoolCtr = kseVarBool.size();
	if (iVarBoolCtr != 0) {
		for (unsigned long i = 0; i < iVarBoolCtr; ++i) {
			if (kseVarBool[i].sName == sVarName) {
				kseVarBool[i].bVal = bValue;          //get the value
				kseVarBool[i].bUsed = true;           //it is being used, right?
				kseVarBool[i].sFunc = kseNULL_STRING;
				kseVarBool[i].lFunc = -1; //global
				kseVarBool[i].bReadOnly = bReadOnly;  //should it be readonly access
				kseVarBool[i].bAppArg = bAppArg;
//				kseVarBool[i].bProtect = bProtect;
				return i;
			}
		}
	}
	
	typeVarBool l_varBool;
		l_varBool.sName = sVarName;				   //store the name
		l_varBool.bVal = bValue;					  //get the value
		l_varBool.bUsed = true;					   //it is being used, right?
		l_varBool.sFunc = kseNULL_STRING;
		l_varBool.lFunc = -1; //global
		l_varBool.bReadOnly = bReadOnly;			  //should it be readonly access
		l_varBool.bAppArg = bAppArg;
		l_varBool.bProtect = bProtect;
	
	kseVarBool.push_back(l_varBool);
	
	unsigned int iID = iVarBoolCtr++;
	
	return iID;
}

unsigned long KSE_DeclareStr(string sVarName, string sValue, bool bReadOnly, bool bAppArg, bool bProtect) {
	iVarStrCtr = kseVarStr.size();
	if (iVarStrCtr != 0) {
		for (unsigned long i = 0; i < iVarStrCtr - 1; ++i) {
			if (kseVarStr[i].sName == sVarName) {
				kseVarStr[i].sVal = sValue;          //get the value
				kseVarStr[i].bUsed = true;           //it is being used, right?
				kseVarStr[i].sFunc = kseNULL_STRING;
				kseVarStr[i].lFunc = -1; //global
				kseVarStr[i].bReadOnly = bReadOnly;  //should it be readonly access
				kseVarStr[i].bAppArg = bAppArg;
//					kseVarStr[i].bProtect = bProtect;
				trace("KSE_DeclareStrA " + i);
				return i;
			}
		}
	}
	
	typeVarStr l_varStr;
	
	
	
		l_varStr.sName = sVarName;       //store the name
		l_varStr.sVal = sValue;          //get the value
		l_varStr.bUsed = true;           //it is being used, right?
		l_varStr.sFunc = kseNULL_STRING;
		l_varStr.lFunc = -1; //global
		l_varStr.bReadOnly = bReadOnly;  //should it be readonly access
		l_varStr.bAppArg = bAppArg;
//		l_varStr.bProtect = bProtect;
	
	kseVarStr.push_back(l_varStr);
	
	unsigned long iID = iVarStrCtr++;
	trace("KSE_DeclareStrB " + iID);
	return iID;
}

string GetPrevToken(unsigned long iIndex) {
	unsigned long ii;
	unsigned long iTmp = iIndex - 1;
	for (ii = iTmp; ii > 0; --ii) {
		if (kseToken[ii].sToken != kseSPACE) {
			return kseToken[ii].sToken;
		}
	}
	return kseNULL_STRING;
}

unsigned long GetPrevIndex(unsigned long iIndex) {
	for (unsigned long ii = iIndex - 1; ii > 0; --ii) {
		if (kseToken[ii].sToken != kseSPACE) {
			return ii;
		}
	}
	return 0;
}

void DeclareKONSoL_Built_In_Constants() {
	//#  =========================================================================
	//#  WARNING!!!
	//#  -------------------------------------------------------------------------
	//#  Do not delete this non-used sub procedure. -- MJ
	//#
	//#  I know, someday, I'll be looking to where I placed the code where all
	//#  built-it constants that the engine uses are written.
	//#
	//#  This is meant for future guide just in case, I got fed up with this
	//#  program and suddenly felt like continuing anyway.
	//#
	//#  Anyways, I placed it in ProcessScript_CleanUp() to avoid multi-looping
	//#  =========================================================================
}

void KSE_SetNum(string sVarName, double dValue) {
	for (unsigned long i = 0; i < iVarNumCtr; ++i) {
		if (kseVarNum[i].sName == sVarName && kseVarNum[i].sFunc == kseNULL_STRING) {
			kseVarNum[i].nVal = dValue;
			return;
		}
	}
}

void KSE_SetStr(string sVarName, string sValue) {
	for (unsigned long i = 0; i < iVarStrCtr - 1; ++i) {
		if (kseVarStr[i].sName == sVarName && kseVarStr[i].sFunc == kseNULL_STRING) {
			kseVarStr[i].sVal = sValue;
			return;
		}
	}
}

void KSE_SetBool(string sVarName, bool bValue) {
	for (unsigned long i = 0; i < iVarBoolCtr - 1; ++i) {
		if (kseVarBool[i].sName == sVarName && kseVarBool[i].sFunc == kseNULL_STRING) {
			kseVarBool[i].bVal = bValue;
			return;
		}
	}
}

double KSE_GetNum(string sVarName) {
	for (unsigned long i = 0; i < iVarNumCtr; ++i) {
		if (kseVarNum[i].sName == sVarName && kseVarNum[i].sFunc == kseNULL_STRING) {
			return kseVarNum[i].nVal;
		}
	}
	return 0.0;
}

string KSE_GetStr(string sVarName) {
	for (unsigned long i = 0; i < iVarStrCtr - 1; ++i) {
		if (kseVarStr[i].sName == sVarName && kseVarStr[i].sFunc == kseNULL_STRING) {
			return kseVarStr[i].sVal;
		}
	}
	return "";
}

bool KSE_GetBool(string sVarName) {
	for (unsigned long i = 0; i < iVarBoolCtr - 1; ++i) {
		if (kseVarBool[i].sName == sVarName && kseVarBool[i].sFunc == kseNULL_STRING) {
			return kseVarBool[i].bVal;
		}
	}
	return false;
}

bool fbIsAlpha(string sChr) {
	//IsAlpha = sChr Like "[_A-Za-z]"
	if (       (sChr[0] >= 'a' && sChr[0] <= 'z')
			|| (sChr[0] >= 'A' && sChr[0] <= 'Z')
			|| sChr[0] == '_') {
		return true;
   }
   
   return false;
}

unsigned long LookFor(string sWhatWord, string sPreviousWord, unsigned long iStartIndex) {
//	trace "LookFor A lSkip(" + Str(iStartIndex) + ") " + kseToken[iStartIndex].lSkip + " sToken " + kseToken[iStartIndex].sToken
//	if (kseToken[iStartIndex].lSkip != 0) { Return kseToken[iStartIndex].lSkip
	
	for (unsigned long i = iStartIndex; i < iTokenCtr; ++i) {
		//LookFor is an independent token-specific finder.
		//KSE_SkipVoidTokens is an independent white-space skipper
		//GetNextIndex is an independent non-white-space and not-token-specific finder 
		//NOTE: Do not use GetNextIndex or KSE_SkipVoidTokens in this function
		if (kseToken[i].sToken == sWhatWord) {
			//register and exit the loop
//			kseToken[iStartIndex].lSkip = i;
//			trace("LookFor B lSkip(" + Str(iStartIndex) + ") " + kseToken[iStartIndex].lSkip + " sToken " + kseToken[iStartIndex].sToken);
			return i;
		} else if (kseToken[i].sToken != kseSPACE && kseToken[i].sToken != kseTAB && kseToken[i].sToken != kseNULL_STRING) {
			Engine_Message(KSE_GetErrFileSrc(i) + "Expecting (  " + sWhatWord + "  ) before (  " + KSE_GetToken(i) + "  )." + "\r\n" +
						   String(61, kseMINUS_SIGN) + "\r\n" +
						   "Your code is:	   " + sPreviousWord + KSE_GetToken(i) + "\r\n" +
						   "Code should be:	 " + sPreviousWord + sWhatWord, "SYNTAX ERROR AT LINE " + Str(kseToken[i].iLine));
			Engine_Exit();
		}
	}
	return 0;
}

unsigned long GetNextIndex(unsigned long p_index) {
	//# idea is to return the next token index which does not contain a [space] or [tab]
	//Return KSE_SkipVoidTokens(p_index + 1)
	unsigned long l_index;
	unsigned long l_searchIndex;
	l_index = p_index + 1;
	l_searchIndex = l_index;
	unsigned long l_tmpIdx;
	if (kseToken[l_index].lSkipNull > 0) {
		return kseToken[l_index].lSkipNull;
	} else {
		l_tmpIdx = l_index;
	}

	do {
		if (kseToken[l_searchIndex].sToken != kseTAB
				&& kseToken[l_searchIndex].sToken != kseSPACE
				&& kseToken[l_searchIndex].sToken != kseNULL_STRING) {
			kseToken[l_tmpIdx].lSkipNull = l_searchIndex;
	  	return l_searchIndex;
	  	} else {
			++l_searchIndex;
		}
	} while (l_searchIndex < iTokenCtr);
	--l_searchIndex;
	if (kseToken[l_searchIndex].iLine == 0) { l_searchIndex = l_index; }
	return l_searchIndex;
}

unsigned long GetNearestTokenIndex(string sWhatWord, string sPreviousWord, unsigned long iStartIndex, bool bPromptErr) {
	//# idea is to return the nearest token index which contains ANYTHING
	//to be used for a strict syntax like
	//-----------------------------------
	//	   Var:Number myNumber;
	//instead of
	//----------
	//	   Var   :   Number myNumber;
	//
	
	if (kseToken[iStartIndex + 1].lSkip > 0) {
		//trace("*kseToken[" + (iStartIndex + 1) + "].lSkip = " + kseToken[iStartIndex + 1].lSkip);
		return kseToken[iStartIndex + 1].lSkip;
	}
	unsigned long i;
	for (i = iStartIndex + 1; i < iTokenCtr; ++i) {
		//See LookFor to know why not to use GetNextIndex or KSE_SkipVoidTokens
		if (kseToken[i].sToken == sWhatWord) {
			//register and exit the loop
			kseToken[iStartIndex + 1].lSkip = i;
			return i;
		} else if (bPromptErr == true) {
			goto ptrErr;
		} else if (bPromptErr == false) {
			break;
		}
	}
	if (bPromptErr == false) {
		return i;
	}
ptrErr:
	if (kseToken[i].iLine == 0) {
		//corrected error prompting when syntax is wrong because scripts are not finish
		Engine_Message(KSE_GetErrFileSrc(1 - 1) + "Expecting (  //" + sPreviousWord + sWhatWord + "//  ) but just got (  //" + sPreviousWord + "//  ) only." + "\r\n" +
					   "Tip: try to finish your script first.", "SYNTAX ERROR AT LINE " + kseToken[i - 1].iLine);
	} else {
		Engine_Message("Expecting (  " + sWhatWord + "  ) just after (  " + sPreviousWord + "  ) but got (  " + KSE_GetToken(i) + "  ) instead.", "SYNTAX ERROR AT LINE " + kseToken[i].iLine);
	}
	Engine_Exit();
	return 0;
}

unsigned long SynComment(unsigned long &iIndex, int p_paren) {
	string sToken;
	unsigned long iLine;
	unsigned long i;
	
	//# idea is to remove "readable" comments
	// to reduce confusion
	kseToken[iIndex].sToken = kseNULL_STRING;
	++iIndex;
	iLine = kseToken[iIndex].iLine;
	
	if (kseToken[iIndex].sToken == kseFORWARD_SLASH) {
		for (i = iIndex; i < iTokenCtr; ++i) {
			if (iLine < kseToken[i].iLine) {
				break;
			} else {
				//# idea is to remove "readable" comments
				// to reduce confusion
				kseToken[i].sToken = kseNULL_STRING;
			}
		}
		
		return i - 1;
	} else if (kseToken[iIndex].sToken == kseASTERISK) {
		for (i = iIndex; i < iTokenCtr; ++i) {
			if (kseToken[i].sToken == kseASTERISK) {
				if (kseToken[i + 1].sToken == kseFORWARD_SLASH) {
					//# idea is to remove "readable" comments
					// to reduce confusion
					kseToken[i].sToken = kseNULL_STRING;
					kseToken[i + 1].sToken = kseSPACE;
					break;
				}
			}
			
			//totally remove comments out, but try to maintain line numbering
			if (iLine < kseToken[i].iLine) {
				iLine = kseToken[i].iLine;
				kseToken[i].sToken = kseSPACE;
			} else {
				//# idea is to remove "readable" comments
				// to reduce confusion
				kseToken[i].sToken = kseNULL_STRING;
			}
		}
		
		if (i > iTokenCtr) {
			Engine_Message(KSE_GetErrFileSrc(i - 2) + "Expecting (  */  ) before (  " + KSE_GetToken(i - 2) + "  ).", "SYNTAX ERROR AT LINE " + Str(kseToken[i - 2].iLine));
			Engine_Exit();
		}
		
		return i + 1;
	} else if (p_paren > 0) {
		//possibly not needed anymore -- mj 120327
		return iIndex; //it's okay -- this allows division inside function calls
	} else {
		Engine_Message(KSE_GetErrFileSrc(iIndex) + "Expecting (  //comment-statement  ) but got (  " + KSE_GetToken(iIndex) + "  ) instead.", "SYNTAX ERROR AT LINE " + Str(kseToken[iIndex].iLine));
		Engine_Exit();
	}
	return 0;
}

unsigned long CheckReturnAndCloseParenthesis(unsigned long &iIndex) {
	iIndex = GetNextIndex(iIndex);
	unsigned long l_retIndex = iIndex;
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseCLOSE_PAREN, "Return parameter", iIndex); //look for	   )
	return l_retIndex;
}

unsigned long KSE_GetReturnIndexAndSkipCloseParenthesis(string sAfterWhat, unsigned long &iIndex) {
	iIndex = GetNextIndex(iIndex);
	unsigned long tmpxxx = iIndex;
	
	++iIndex;										//move index to next
	iIndex = LookFor(kseCLOSE_PAREN, sAfterWhat + "Return parameter", iIndex); //look for	   )
	return tmpxxx;
}

bool IsTokenFunction(unsigned long &iIndex) {
//trace("IsTokenFunction " + iIndex + " " + kseToken[iIndex].sToken);
	//to be used when compiling is done
	vector<string> sArrName;
	//get the name of the user-function
	kSplit(kseToken[iIndex].sToken, kseMINUS_SIGN, sArrName);
	
	if (sArrName.size() > 0 && sArrName[0] == TAG_USER_FUNCTION) {
		if (IsNumeric(sArrName[1])) {
			//cout << "> " + kseSourceFiles[kseToken[iIndex].iSrc]
			//bool sLeft;
			//int iLeft;
			//sLeft = 
			if (kseFunction[Val(sArrName[1])].sFile == kseSourceFiles[kseToken[iIndex].iSrc]) {
				//if callee is from the same file as called, its ok
				return true;
			} else if (kseFunction[Val(sArrName[1])].bAccess == true) {
				//if callee is from different file as called,
				//check for accessibility, if public, its ok
				return true;
			}
		}
	}
	return false;
}

bool IsTokenFunction2(unsigned long &iIndex) {
//trace("IsTokenFunction2")
	//to be used while compiling
	for (unsigned long i = 0; i < iFunctionCtr - 1; ++i) {
		if (kseFunction[i].fName == kseToken[iIndex].sToken) {
			//Print "> " + kseSourceFiles[kseToken[iIndex].iSrc)
			if (kseFunction[i].sFile == kseSourceFiles[kseToken[iIndex].iSrc]) {
				//if callee is from the same file as called, its ok
				return true;
			} else if (kseFunction[i].bAccess == true) {
				//if callee is from different file as called,
				//check for accessibility, if public, its ok
				return true;
			}
		}
	}
	return false;
}

unsigned long SynCallFunction(unsigned long &iIndex) {
	vector<string> sArrName;
	
	//get the name of the user-function
	kSplit(kseToken[iIndex].sToken, kseMINUS_SIGN, sArrName);
	
	if (sArrName[0] == TAG_USER_FUNCTION) {
//trace "SynCallFunction A " + kseToken[iIndex].sToken
		if (IsNumeric(sArrName[1])) {
			kseToken[iIndex].lPtr = CULng(sArrName[1]);
			iIndex = kseFunction[Val(sArrName[1])].CheckParameter(CULng(sArrName[1]), iIndex);
			kseFunction[Val(sArrName[1])].RunScript();
			return iIndex;
		}
	}

		Engine_Message(KSE_GetErrFileSrc(iIndex) + "(  " + KSE_GetToken(iIndex) + "  ) is not a Function.", "SYNTAX ERROR AT LINE " + kseToken[iIndex].iLine);
		Engine_Exit();
	return 0;
}

unsigned long JIO_SynCallFunction(unsigned long &iIndex) {
	unsigned long l_tmpIdx = iIndex;
	
	iIndex = kseFunction[kseToken[l_tmpIdx].lPtr].CheckParameter(kseToken[l_tmpIdx].lPtr, iIndex);
	kseFunction[kseToken[l_tmpIdx].lPtr].RunScript();
	
	return iIndex;
}

string SynCallFunction2(unsigned long &iIndex) {
	//  In the script,
	//
	//		   Var:Number x;
	//		   x = 2 + GetPercent(8, 24);
	//
	//  it is already possible for GetPercent, a user-function, return a number
	//  that will be added to //2// which will be assigned to value of //x//.
	//============================================================================
	vector<string> sArrName;
	
	//get the name of the user-function
	kSplit(kseToken[iIndex].sToken, kseMINUS_SIGN, sArrName);
	
	if (sArrName[0] == TAG_USER_FUNCTION) {
		if (IsNumeric(sArrName[1])) {
			//make sure that the function returns a value; not Void Function
			if (kseFunction[Val(sArrName[1])].fType > 0) {
				iIndex = kseFunction[Val(sArrName[1])].CheckParameter2(CInt(sArrName[1]), iIndex);
			} else {
				Engine_Message(KSE_GetErrFileSrc(iIndex) + "(  " + KSE_GetToken(iIndex) + "  ) is a Void Function.", "SYNTAX ERROR AT LINE " + kseToken[iIndex].iLine);
			}
			
			kseFunction[Val(sArrName[1])].RunScript(true);
			return sTmpRetParVar;
		}
	}
		Engine_Message(KSE_GetErrFileSrc(iIndex) + "(  " + KSE_GetToken(iIndex) + "  ) is not a User-defined Function.", "SYNTAX ERROR AT LINE " + kseToken[iIndex].iLine);
		Engine_Exit();
	return "";
}

bool KSE_IsNegativeValue(unsigned long &iIndex) {
	if (kseToken[iIndex].sToken == kseMINUS_SIGN
			&& IsNumeric(kseToken[iIndex + 1].sToken) == 1) {
		return true;
	}
	return false;
}

double KSE_GetNegativeValue(unsigned long &iIndex) {
	++iIndex;								//skip MINUS sign
	return Val("-" + kseToken[iIndex].sToken);	//get negative value
	//return 0 - GetNumValueAt(iIndex);
}

string KSE_GetToken(unsigned long iIndex) {
	//#idea is to change technical err_msg due to table look-up
	string sNumName;
	vector<string> TokenList;
	Split(kseToken[iIndex].sToken, kseMINUS_SIGN, TokenList);
	if (TokenList.size() > 1) {
		return TokenList[2];
	} else {
		return kseToken[iIndex].sToken;
	}
}

unsigned long KSE_SkipOptAfter(unsigned long lCommand, string sWhat, string sPrev, unsigned long &iStartIndex) {
    ++iStartIndex;
	unsigned long i = KSE_SkipVoidTokens(iStartIndex);

	if (kseToken[i].lCmd == lCommand) {
		return i;
	} else if (kseToken[i].sToken == sWhat) {
		kseToken[i].lCmd = lCommand;
		return i;
	} else {
		Engine_Message(KSE_GetErrFileSrc(i) + "Expecting (  " + sWhat + "  ) after (  " + sPrev + "  ) but got (  " + KSE_GetToken(i) + "  ) instead." + "\r\n" +
		              String(61, kseMINUS_SIGN) + "\r\n" +
		              "Your code is   :  " + sPrev + KSE_GetToken(i) + "\r\n" +
		              "Code should be :  " + sPrev + sWhat, "SYNTAX ERROR AT LINE " + Str(kseToken[i].iLine), true);
	}
	return 0;
}

unsigned long KSE_SkipOpenParenthesisAfter(string sWhat, unsigned long &iIndex) {
	return LookFor(kseOPEN_PAREN, sWhat, iIndex+1);  //look for		 )
}

unsigned long KSE_SkipCommaAfter(string sWhat, unsigned long &iIndex) {
	return LookFor(kseCOMMA, sWhat, iIndex+1);			 //look for		 ,
}

unsigned long KSE_SkipCloseParenthesisAfter(string sWhat, unsigned long &iIndex) {
	return LookFor(kseCLOSE_PAREN, sWhat, iIndex+1); //look for		 )
}
//---------------------------------------------------------------------------------------------
unsigned long KSE_SkipOpenCurlAfter(string sWhat, unsigned long &iIndex) {
	return KSE_SkipOptAfter(kseOPT_OPEN_CURL, "{", sWhat, iIndex);
}

unsigned long KSE_SkipCloseCurlAfter(string sWhat, unsigned long &iIndex) {
	return KSE_SkipOptAfter(kseOPT_CLOSE_CURL, "}", sWhat, iIndex);
}

unsigned long KSE_SkipSemiColonAfter(string sWhat, unsigned long &iIndex) {
	return KSE_SkipOptAfter(kseOPT_SEMICOLON, ";", sWhat, iIndex);
}

unsigned long KSE_SkipColonAfter(string sWhat, unsigned long &iIndex) {
	return KSE_SkipOptAfter(kseOPT_COLON, ":", sWhat, iIndex);
}

unsigned long KSE_SkipEqualSignAfter(string sWhat, unsigned long &iIndex) {
	return KSE_SkipOptAfter(kseVALUE_OPT_EQUAL_SIGN, "=", sWhat, iIndex);
}
//---------------------------------------------------------------------------------------------
bool KSE_GetTokenBoolValueOf(unsigned long &iIndex) {
	iIndex = GetNextIndex(iIndex);
	
	return GetTokenBoolValue(iIndex);
}

double KSE_GetTokenNumValueOf(unsigned long &iIndex, bool ArrayMode) {
	//iIndex = GetNextIndex(iIndex);
	return GetVal(iIndex, false, true, ArrayMode);   // GetTokenNumValue(iIndex)
}

string KSE_GetTokenStrValueOf(unsigned long &iIndex) {
	return GetStrVal(iIndex, true, false); //GetTokenStrValue(iIndex)
}

bool GetTokenBoolValue(unsigned long &iIndex) {
	if (IsNumeric(kseToken[iIndex].sToken)) {
		return CBool(kseToken[iIndex].sToken);
	} else if (IsTokenNum(iIndex)) {
		return CBool(GetNumValue(iIndex));
	} else if (IsTokenBool(iIndex)) {
		return GetBoolValue(iIndex);
	} else if (IsTokenStr(iIndex)) {
		return CBool(GetStrValue(iIndex));
#ifdef CLASS_ARRAY
	} else if (IsTokenArray(iIndex)) {
		return CBool(ArrGetNum(iIndex));
#endif
	} else if (KSE_IsNegativeValue(iIndex)) {
		return CBool(KSE_GetNegativeValue(iIndex));
	} else {
		VarNotDeclared(KSE_GetToken(iIndex), "Boolean", iIndex);
	}
	return false;
}

double GetTokenNumValue(unsigned long &iIndex) {
//	trace("   GetTokenNumValue " + iIndex + " | " + kseToken[iIndex].sToken + " | " + kseToken[iIndex].lCmd);
	if (IsNumeric(kseToken[iIndex].sToken)) {
		kseToken[iIndex].lCmd = kseVALUE_ISNUMERIC;
		kseToken[iIndex].dValue = Val(kseToken[iIndex].sToken);
		return kseToken[iIndex].dValue;
	} else if (IsTokenNum(iIndex)) {
		kseToken[iIndex].lCmd = kseVALUE_ISTOKENNUM;
		return GetNumValue(iIndex);
	//} else if (IsTokenBool(iIndex)) {
	//	return GetBoolValue(iIndex);
	//} else if (IsTokenStr(iIndex)) {
	//	return GetStrValue(iIndex);
#ifdef CLASS_ARRAY
	} else if (IsTokenArray(iIndex)) {
		kseToken[iIndex].lCmd = kseVALUE_ISTOKENARRAY;
		return ArrGetNum(iIndex);
#endif
	} else if (kseToken[iIndex].lCmd == kseVALUE_ISNUMERIC) {
		kseToken[iIndex].dValue = Val(kseToken[iIndex].sToken);
	} else if (kseToken[iIndex].lCmd == kseVALUE_ISTOKENNUM) {
		return GetNumValue(iIndex);
#ifdef CLASS_ARRAY
	} else if (kseToken[iIndex].lCmd == kseVALUE_ISTOKENARRAY) {
		return ArrGetNum(iIndex);
#endif
	} else if (KSE_IsNegativeValue(iIndex)) {
		return KSE_GetNegativeValue(iIndex);
	} else {
		VarNotDeclared(KSE_GetToken(iIndex), "Number", iIndex);
	}
	return 0.0;
}

double JIO_GetTokenNumValue(unsigned long &iIndex) {
	//trace "JIO_GetTokenNumValue " + iIndex + " | " + kseToken[iIndex].sToken + " | " + kseToken[iIndex].lCmd 
	if (kseToken[iIndex].lCmd == kseVALUE_ISNUMERIC) {
		return kseToken[iIndex].dValue;
	} else if (kseToken[iIndex].lCmd == kseVALUE_ISTOKENNUM) {
		return JIO_GetNumValue(iIndex);
	//} else if (IsTokenBool(iIndex)) {
	//	GetTokenNumValue = GetBoolValue(iIndex);
	//} else if (IsTokenStr(iIndex)) {
	//	GetTokenNumValue = GetStrValue(iIndex);
#ifdef CLASS_ARRAY
	} else if (kseToken[iIndex].lCmd == kseVALUE_ISTOKENARRAY) {
		return ArrGetNum(iIndex);
#endif
	} else if (KSE_IsNegativeValue(iIndex)) {
		return KSE_GetNegativeValue(iIndex);
	} else {
//		trace("nah!");
		VarNotDeclared(KSE_GetToken(iIndex), "Number", iIndex);
	}
//	trace("...");
	return 0.0;
}

string GetTokenStrValue(unsigned long &iIndex) {
	trace("GetTokenStrValue x " + iIndex);
	if (IsNumeric(kseToken[iIndex].sToken)) {
//		trace("GetTokenStrValue 1");
		return kseToken[iIndex].sToken;
	} else if (IsTokenNum(iIndex)) {
//		trace("GetTokenStrValue 2");
		return Str(GetNumValue(iIndex));
	} else if (kseToken[iIndex].sToken == kseDOUBLE_QUOTES) {
//		trace("GetTokenStrValue 3");
		iIndex = SynQuotes(iIndex);
		//get the string value
		return GetTempString();
	} else if (IsTokenBool(iIndex)) {
//		trace("GetTokenStrValue 4");
		return Str(GetBoolValue(iIndex));
	} else if (IsTokenStr(iIndex)) {
//		trace("GetTokenStrValue 5");
		return GetStrValue(iIndex);
	} else if (IsTokenArray(iIndex)) {
//		trace("GetTokenStrValue 6");
		return Str(ArrGetNum(iIndex));
	} else if (KSE_IsNegativeValue(iIndex)) {
//		trace("GetTokenStrValue 7");
		return Str(KSE_GetNegativeValue(iIndex));
	} else {
//		trace("GetTokenStrValue 8");
		VarNotDeclared(KSE_GetToken(iIndex), "String", iIndex);
	}
	return "";
}

string KSE_GetErrFileSrc(unsigned long iIndex) {
	string sTmpMsg1;
	string sTmpMsg2;
	
	if (iIndex == 0) {
	   sTmpMsg1 = "Error from ~?~";
	} else {
	   sTmpMsg1 = "Error from " + kseSourceFiles[kseToken[iIndex].iSrc];
	}
	
	if (bKONSoLE_DeclaringVar == false) {
		if (iCrntFunc != kseNOT_ON_FUNCTION) {
			sTmpMsg2 = " (  function " + kseFunction[iCrntFunc].fName + "  ) ";
		} else {
			sTmpMsg2 = "";
		}
	}
	return sTmpMsg1 + sTmpMsg2 + ":" + "\r\n";
}

#ifdef WIN32
#include <windows.h>
#else
#include <unistd.h>
#endif // win32
void KSE_DoEvents(bool bSleep) {
	if (iOverClock < 1 && bSleep == true) {
	// Keep the FPS value within fpslimit (borrowed from fbscroll].
		//TODO: [QuixiePP] implement FreeBASIC's Timer
		sleepintvl = CInt((stt + frameintvl - /*Timer*/0)*1000.0);
		if (sleepintvl > 1) {
			//sleep(sleepintvl, 1);
			#ifdef WIN32
				//Sleep(sleepintvl);
				std::this_thread::sleep_for(std::chrono::milliseconds(sleepintvl));
			#else
				usleep(sleepintvl* 1000);
			#endif // win32
		} else {
			#ifdef WIN32
				//Sleep(1);
				std::this_thread::sleep_for(std::chrono::milliseconds(1));
			#else
				usleep(1* 1000);
			#endif // win32
			//sleep(1, 1);
		}
		stt = /*Timer*/0;
	}
}
