#include "../../kage.hpp"
#include "../../kageExterns.hpp"

unsigned long KSE_Execute(unsigned long &i) {
	bool l_execute = true;
	while (l_execute == true) {
		if (kseToken[i].iLine > 0) {
			i = KSE_SkipVoidTokens(i);
//			trace("i " + i + " " + kseToken[i].sToken);
			
			switch (kseToken[i].lCmd) {
			#ifdef CLASS_VAR
				case kseCLASS_VAR:
					i = SynVar(i);
					break;
			#endif
			#ifdef CLASS_ARRAY
				case kseCLASS_ARRAY:
					i = SynArray(i);
					break;
			#endif
			#ifdef CLASS_MATH
				case kseCLASS_MATH:
					i = JIO_SynMath(i);
					break;
			#endif
			#ifdef CLASS_KEY
				case kseCLASS_KEY:
					i = SynKey(i);
					break;
			#endif
			#ifdef CLASS_KONSOL
				case kseCLASS_KONSOL:
					i = SynKonsol(i);
					break;
			#endif
			#ifdef CLASS_SCREEN
				case kseCLASS_SCREEN:
					i = JIO_SynScreen(i);
					break;
			#endif
			#ifdef CLASS_GAME
				case kseCLASS_GAME:
					i = SynGame(i);
					break;
			#endif
			#ifdef CLASS_MAP
				case kseCLASS_MAP:
					i = SynMap(i);
					break;
			#endif
			#ifdef CLASS_TILESET
				case kseCLASS_TILESET:
					i = SynTileSet(i);
					break;
			#endif
			#ifdef CLASS_ENTITY
				case kseCLASS_ENTITY:
					i = SynEntity(i);
					break;
			#endif
			#ifdef CLASS_SPRITESET
				case kseCLASS_SPRITESET:
					i = SynSpriteSet(i);
					break;
			#endif
			#ifdef CLASS_TIME
				case kseCLASS_TIME:
					i = SynTime(i);
					break;
			#endif
			#ifdef CLASS_LAYER
				case kseCLASS_LAYER:
					i = SynLayer(i);
					break;
			#endif
			#ifdef CLASS_MOUSE
				case kseCLASS_MOUSE:
					i = SynMouse(i);
					break;
			#endif
			#ifdef CLASS_DRAW
			 	case kseCLASS_DRAW:
					i = JIO_SynDraw(i);
					break;
			#endif
			#ifdef CLASS_IMAGE
				case kseCLASS_IMAGE:
					i = JIO_SynImage(i);
					break;
			#endif
			#ifdef CLASS_SOUND
				case kseCLASS_SOUND:
					i = SynSound(i);
					break;
			#endif
			#ifdef CLASS_STRING
				case kseCLASS_STRING:
					i = SynString(i);
					break;
			#endif
			#ifdef CLASS_FILE
				case kseCLASS_FILE:
					i = SynFile(i);
					break;
			#endif
			#ifdef CLASS_NET
				case kseCLASS_NET:
					i = SynNet(i);
					break;
			#endif
			#ifdef CLASS_MYSQL
				case kseCLASS_MYSQL:
					i = SynMySQL(i);
					break;
			#endif
			#ifdef CONTROL_FOR
				case kseCONTROL_FOR:
					i = JIO_SynFor(i);
					break;
			#endif
			#ifdef CONTROL_IF
				case kseCONTROL_IF:
					i = SynIf(i);
					break;
			#endif
			#ifdef CONTROL_WHILE
				case kseCONTROL_WHILE:
					i = JIO_SynWhile(i);
					break;
			#endif
				case kseCONTROL_RETURN:
					i = kseFunction[iCrntFunc].SynLocalReturn(i);
					break;
				case kseCONTROL_ELSE:
					i = SynElse(i);		//!!! good only for non-SynIf
				case kseOPT_CLOSE_CURL:
					l_execute = false;
					--i;
					break;		 //!!! good for SynWhile/SynFor/SynIf
				case kseVALUE_ISTOKENFUNCTION:
					i = JIO_SynCallFunction(i);
					break;
				case kseVALUE_ISTOKENBOOL:
					i = DirectSetBool(i);
					break;
				case kseVALUE_ISTOKENNUM:
//					trace "<jio_dsn i=""" + i + """>"
					i = JIO_DirectSetNum(i);
//					trace "i=""" + i + """</jio_dsn>"
					break;
				case kseVALUE_ISTOKENSTR:
					i = DirectSetStr(i);
					break;
				case kseVALUE_ISTOKENUDT:
					i = JIO_DirectSetUDT(i);
					break;
				case kseVALUE_ISTOKENARRAY:
					i = JIO_DirectSetArray(i);
					break;
				default:
					if (kseToken[i].sToken == "Var") {
						kseToken[i].lCmd = kseCLASS_VAR;
						i = SynVar(i);
					} else if (kseToken[i].sToken == "Array") {
						kseToken[i].lCmd = kseCLASS_ARRAY;
						i = SynArray(i);
					} else if (kseToken[i].sToken == "Math") {
						kseToken[i].lCmd = kseCLASS_MATH;
						i = SynMath(i);
					#ifdef CLASS_KEY
					} else if (kseToken[i].sToken == "Key") {
						kseToken[i].lCmd = kseCLASS_KEY;
						i = SynKey(i);
					#endif
					} else if (kseToken[i].sToken == "Konsol") {
						kseToken[i].lCmd = kseCLASS_KONSOL;
						i = SynKonsol(i);
					#ifdef CLASS_SCREEN
					} else if (kseToken[i].sToken == "Screen") {
						kseToken[i].lCmd = kseCLASS_SCREEN;
						i = SynScreen(i);
					#endif
					#ifdef CLASS_GAME
					} else if (kseToken[i].sToken == "Game") {
						kseToken[i].lCmd = kseCLASS_GAME;
						i = SynGame(i);
					#endif
					#ifdef CLASS_MAP
					} else if (kseToken[i].sToken == "Map") {
						kseToken[i].lCmd = kseCLASS_MAP;
						i = SynMap(i);
					#endif
					#ifdef CLASS_TILESET
					} else if (kseToken[i].sToken == "TileSet") {
						kseToken[i].lCmd = kseCLASS_TILESET;
						i = SynTileSet(i);
					#endif
					#ifdef CLASS_ENTITY
					} else if (kseToken[i].sToken == "Entity") {
						kseToken[i].lCmd = kseCLASS_ENTITY;
						i = SynEntity(i);
					#endif
					#ifdef CLASS_SPRITESET
					} else if (kseToken[i].sToken == "SpriteSet") {
						kseToken[i].lCmd = kseCLASS_SPRITESET;
						i = SynSpriteSet(i);
					#endif
					#ifdef CLASS_TIME
					} else if (kseToken[i].sToken == "Time") {
						kseToken[i].lCmd = kseCLASS_TIME;
						i = SynTime(i);
					#endif
					#ifdef CLASS_LAYER
					} else if (kseToken[i].sToken == "Layer") {
						kseToken[i].lCmd = kseCLASS_LAYER;
						i = SynLayer(i);
					#endif
					#ifdef CLASS_MOUSE
					} else if (kseToken[i].sToken == "Mouse") {
						kseToken[i].lCmd = kseCLASS_MOUSE;
						i = SynMouse(i);
					#endif
					#ifdef CLASS_DRAW
					} else if (kseToken[i].sToken == "Draw") {
						kseToken[i].lCmd = kseCLASS_DRAW;
						i = SynDraw(i);
					#endif
					#ifdef CLASS_IMAGE
					} else if (kseToken[i].sToken == "Image") {
						kseToken[i].lCmd = kseCLASS_IMAGE;
						i = SynImage(i);
					#endif
					#ifdef CLASS_SOUND
					} else if (kseToken[i].sToken == "Sound") {
						kseToken[i].lCmd = kseCLASS_SOUND;
						i = SynSound(i);
					#endif
					} else if (kseToken[i].sToken == "String") {
						kseToken[i].lCmd = kseCLASS_STRING;
						i = SynString(i);
					#ifdef CLASS_FILE
					} else if (kseToken[i].sToken == "File") {
						kseToken[i].lCmd = kseCLASS_FILE;
						i = SynFile(i);
					#endif
					#ifdef CLASS_NET
					} else if (kseToken[i].sToken == "Net") {
						kseToken[i].lCmd = kseCLASS_NET;
						i = SynNet(i);
					#endif
					#ifdef CLASS_MYSQL
					} else if (kseToken[i].sToken == "MySQL") {
						kseToken[i].lCmd = kseCLASS_MYSQL;
						i = SynMySQL(i);
					#endif
					} else if (kseToken[i].sToken == "for") {
						kseToken[i].lCmd = kseCONTROL_FOR;
						i = SynFor(i);
					} else if (kseToken[i].sToken == "if") {
						kseToken[i].lCmd = kseCONTROL_IF;
						i = SynIf(i);
					} else if (kseToken[i].sToken == "while") {
						kseToken[i].lCmd = kseCONTROL_WHILE;
						i = SynWhile(i);
					} else if (kseToken[i].sToken == "return") {
						kseToken[i].lCmd = kseCONTROL_RETURN;
						i = kseFunction[iCrntFunc].SynLocalReturn(i);
					} else if (kseToken[i].sToken == "else") {
						kseToken[i].lCmd = kseCONTROL_ELSE;
						i = SynElse(i);		//!!! good only for non-SynIf
//parser already takes care of lCmd [QuixiePP] seems not!
					} else if (kseToken[i].sToken == kseCLOSE_CURL) {
//						case kseCLOSE_CURL
						kseToken[i].lCmd = kseOPT_CLOSE_CURL;
						l_execute = false;
						--i;
						break;		 //!!! good for SynWhile/SynFor  [QuixiePP] and `function'?
					} else {
							if (IsTokenFunction(i)) {
								kseToken[i].lCmd = kseVALUE_ISTOKENFUNCTION;
								i = SynCallFunction(i);
							} else if (IsTokenBool(i)) {
								kseToken[i].lCmd = kseVALUE_ISTOKENBOOL;
								i = DirectSetBool(i);
							} else if (IsTokenNum(i)) { 
								kseToken[i].lCmd = kseVALUE_ISTOKENNUM;
//					trace "<_dsn i=""" + i + """>";
								i = DirectSetNum(i);
//					trace "i=""" + i + """</_dsn>"
							} else if (IsTokenStr(i)) {
								kseToken[i].lCmd = kseVALUE_ISTOKENSTR;
								i = DirectSetStr(i);
							} else if (IsTokenUDT(i)) {
								kseToken[i].lCmd = kseVALUE_ISTOKENUDT;
								i = DirectSetUDT(i);
							} else if (IsTokenArray(i)) {
								kseToken[i].lCmd = kseVALUE_ISTOKENARRAY;
								i = DirectSetArray(i);
							} else {
								Engine_Message(KSE_GetErrFileSrc(i) + "Unexpected `" + KSE_GetToken(i) + "'.", "SYNTAX ERROR AT LINE " + Str(kseToken[i].iLine));
							}
					}
			}
		}
		++i;
		if (i >= iTokenCtr) {
			l_execute = false;
		}
	}
	
	return i;
}

unsigned long JIO_KSE_Execute(unsigned long &i) {
	bool l_execute = true;
	while (l_execute == true) {
		if (kseToken[i].iLine > 0) {
			i = KSE_SkipVoidTokens(i);
			
			switch (kseToken[i].lCmd) {
			#ifdef CLASS_VAR
				case kseCLASS_VAR:
					i = SynVar(i);
					break;
			#endif
			#ifdef CLASS_ARRAY
				case kseCLASS_ARRAY:
					i = SynArray(i);
					break;
			#endif
			#ifdef CLASS_MATH
				case kseCLASS_MATH:
					i = JIO_SynMath(i);
					break;
			#endif
			#ifdef CLASS_KEY
				case kseCLASS_KEY:
					i = SynKey(i);
					break;
			#endif
			#ifdef CLASS_KONSOL
				case kseCLASS_KONSOL:
					i = SynKonsol(i);
					break;
			#endif
			#ifdef CLASS_SCREEN
				case kseCLASS_SCREEN:
					i = JIO_SynScreen(i);
					break;
			#endif
			#ifdef CLASS_GAME
				case kseCLASS_GAME:
					i = SynGame(i);
					break;
			#endif
			#ifdef CLASS_MAP
			 	case kseCLASS_MAP:
					i = SynMap(i);
					break;
			#endif
			#ifdef CLASS_TILESET
			 	case kseCLASS_TILESET:
					i = SynTileSet(i);
					break;
			#endif
			#ifdef CLASS_ENTITY
				case kseCLASS_ENTITY:
					i = SynEntity(i);
					break;
			#endif
			#ifdef CLASS_SPRITESET
				case kseCLASS_SPRITESET:
					i = SynSpriteSet(i);
					break;
			#endif
			#ifdef CLASS_TIME
				case kseCLASS_TIME:
					i = SynTime(i);
					break;
			#endif
			#ifdef CLASS_LAYER
				case kseCLASS_LAYER:
					i = SynLayer(i);
					break;
			#endif
			#ifdef CLASS_MOUSE
				case kseCLASS_MOUSE:
					i = SynMouse(i);
					break;
			#endif
			#ifdef CLASS_DRAW
				case kseCLASS_DRAW:
					i = JIO_SynDraw(i);
					break;
			#endif
			#ifdef CLASS_IMAGE
				case kseCLASS_IMAGE:
					i = JIO_SynImage(i);
					break;
			#endif
			#ifdef CLASS_SOUND
				case kseCLASS_SOUND:
					i = SynSound(i);
					break;
			#endif
			#ifdef CLASS_STRING
				case kseCLASS_STRING:
					i = SynString(i);
					break;
			#endif
			#ifdef CLASS_FILE
				case kseCLASS_FILE:
					i = SynFile(i);
					break;
			#endif
			#ifdef CLASS_NET
				case kseCLASS_NET:
					i = SynNet(i);
					break;
			#endif
			#ifdef CLASS_MYSQL
				case kseCLASS_MYSQL:
					i = SynMySQL(i);
					break;
			#endif
			#ifdef CONTROL_FOR
				case kseCONTROL_FOR:
					i = JIO_SynFor(i);
					break;
			#endif
			#ifdef CONTROL_IF
				case kseCONTROL_IF:
					i = SynIf(i);
					break;
			#endif
			#ifdef CONTROL_WHILE
				case kseCONTROL_WHILE:
					i = JIO_SynWhile(i);
					break;
			#endif
				case kseCONTROL_RETURN:
					i = kseFunction[iCrntFunc].SynLocalReturn(i);
					break;
				case kseCONTROL_ELSE:
					i = SynElse(i);		//!!! good only for non-SynIf
					break;
				case kseOPT_CLOSE_CURL:
					l_execute = false;
					--i;
					break;		 //!!! good for SynFor
				case kseVALUE_ISTOKENFUNCTION:
					i = JIO_SynCallFunction(i);
					break;
				case kseVALUE_ISTOKENBOOL:
					i = DirectSetBool(i);
					break;
				case kseVALUE_ISTOKENNUM:
//					trace "<jio_dsnb i=""" + i + """>"
								i = JIO_DirectSetNum(i);
//					trace "i=""" + i + """</jio_dsnb>"
					break;
				case kseVALUE_ISTOKENSTR:
					i = DirectSetStr(i);
					break;
				case kseVALUE_ISTOKENUDT:
					i = JIO_DirectSetUDT(i);
					break;
				case kseVALUE_ISTOKENARRAY:
					i = JIO_DirectSetArray(i);
					break;
				default:
					if (kseToken[i].sToken == "Var") {
					#ifdef CLASS_VAR
						kseToken[i].lCmd = kseCLASS_VAR;
						i = SynVar(i);
					#endif
					#ifdef CLASS_ARRAY
					} else if (kseToken[i].sToken == "Array") {
						kseToken[i].lCmd = kseCLASS_ARRAY;
						i = SynArray(i);
					#endif
					#ifdef CLASS_MATH
					} else if (kseToken[i].sToken == "Math") {
						kseToken[i].lCmd = kseCLASS_MATH;
						i = SynMath(i);
					#endif
					#ifdef CLASS_KEY
					} else if (kseToken[i].sToken == "Key") {
						kseToken[i].lCmd = kseCLASS_KEY;
						i = SynKey(i);
					#endif
					#ifdef CLASS_KONSOL
					} else if (kseToken[i].sToken == "Konsol") {
						kseToken[i].lCmd = kseCLASS_KONSOL;
						i = SynKonsol(i);
					#endif
					#ifdef CLASS_SCREEN
					} else if (kseToken[i].sToken == "Screen") {
						kseToken[i].lCmd = kseCLASS_SCREEN;
						i = SynScreen(i);
					#endif
					#ifdef CLASS_GAME
					} else if (kseToken[i].sToken == "Game") {
						kseToken[i].lCmd = kseCLASS_GAME;
						i = SynGame(i);
					#endif
					#ifdef CLASS_MAP
					} else if (kseToken[i].sToken == "Map") {
						kseToken[i].lCmd = kseCLASS_MAP;
						i = SynMap(i);
					#endif
					#ifdef CLASS_TILESET
					} else if (kseToken[i].sToken == "TileSet") {
						kseToken[i].lCmd = kseCLASS_TILESET;
						i = SynTileSet(i);
					#endif
					#ifdef CLASS_ENTITY
					} else if (kseToken[i].sToken == "Entity") {
						kseToken[i].lCmd = kseCLASS_ENTITY;
						i = SynEntity(i);
					#endif
					#ifdef CLASS_SPRITESET
					} else if (kseToken[i].sToken == "SpriteSet") {
						kseToken[i].lCmd = kseCLASS_SPRITESET;
						i = SynSpriteSet(i);
					#endif
					#ifdef CLASS_TIME
					} else if (kseToken[i].sToken == "Time") {
						kseToken[i].lCmd = kseCLASS_TIME;
						i = SynTime(i);
					#endif
					#ifdef CLASS_LAYER
					} else if (kseToken[i].sToken == "Layer") {
						kseToken[i].lCmd = kseCLASS_LAYER;
						i = SynLayer(i);
					#endif
					#ifdef CLASS_MOUSE
					} else if (kseToken[i].sToken == "Mouse") {
						kseToken[i].lCmd = kseCLASS_MOUSE;
						i = SynMouse(i);
					#endif
					#ifdef CLASS_DRAW
					} else if (kseToken[i].sToken == "Draw") {
						kseToken[i].lCmd = kseCLASS_DRAW;
						i = SynDraw(i);
					#endif
					#ifdef CLASS_IMAGE
					} else if (kseToken[i].sToken == "Image") {
						kseToken[i].lCmd = kseCLASS_IMAGE;
						i = SynImage(i);
					#endif
					#ifdef CLASS_SOUND
					} else if (kseToken[i].sToken == "Sound") {
						kseToken[i].lCmd = kseCLASS_SOUND;
						i = SynSound(i);
					#endif
					#ifdef CLASS_STRING
					} else if (kseToken[i].sToken == "String") {
						kseToken[i].lCmd = kseCLASS_STRING;
						i = SynString(i);
					#endif
					#ifdef CLASS_FILE
					} else if (kseToken[i].sToken == "File") {
						kseToken[i].lCmd = kseCLASS_FILE;
						i = SynFile(i);
					#endif
					#ifdef CLASS_NET
					} else if (kseToken[i].sToken == "Net") {
						kseToken[i].lCmd = kseCLASS_NET;
						i = SynNet(i);
					#endif
					#ifdef CLASS_MYSQL
					} else if (kseToken[i].sToken == "MySQL") {
						kseToken[i].lCmd = kseCLASS_MYSQL;
						i = SynMySQL(i);
					#endif
					#ifdef CONTROL_FOR
					} else if (kseToken[i].sToken == "for") {
						kseToken[i].lCmd = kseCONTROL_FOR;
						i = SynFor(i);
					#endif
					#ifdef CONTROL_IF
					} else if (kseToken[i].sToken == "if") {
						kseToken[i].lCmd = kseCONTROL_IF;
						i = SynIf(i);
					#endif
					#ifdef CONTROL_WHILE
					} else if (kseToken[i].sToken == "while") {
						kseToken[i].lCmd = kseCONTROL_WHILE;
						i = SynWhile(i);
					#endif
					} else if (kseToken[i].sToken == "return") {
						kseToken[i].lCmd = kseCONTROL_RETURN;
						i = kseFunction[iCrntFunc].SynLocalReturn(i);
					} else if (kseToken[i].sToken == "else") {
						kseToken[i].lCmd = kseCONTROL_ELSE;
						i = SynElse(i);		//!!! good only for non-SynIf
					} else if (kseToken[i].sToken == kseCLOSE_CURL) {
						kseToken[i].lCmd = kseOPT_CLOSE_CURL;
						l_execute = false;
						--i;
						break;		 //!!! good for SynWhile/SynFor
					} else {
							if (IsTokenFunction(i)) {
								kseToken[i].lCmd = kseVALUE_ISTOKENFUNCTION;
								i = SynCallFunction(i);
							} else if (IsTokenBool(i)) {
								kseToken[i].lCmd = kseVALUE_ISTOKENBOOL;
								i = DirectSetBool(i);
							} else if (IsTokenNum(i)) { 
								kseToken[i].lCmd = kseVALUE_ISTOKENNUM;
//					trace "<_dsnb i=""" + i + """>"
								i = DirectSetNum(i);
//					trace "i=""" + i + """</_dsnb>"
							} else if (IsTokenStr(i)) {
								kseToken[i].lCmd = kseVALUE_ISTOKENSTR;
								i = DirectSetStr(i);
							} else if (IsTokenUDT(i)) {
								kseToken[i].lCmd = kseVALUE_ISTOKENUDT;
								i = DirectSetUDT(i);
							} else if (IsTokenArray(i)) {
								kseToken[i].lCmd = kseVALUE_ISTOKENARRAY;
								i = DirectSetArray(i);
							} else {
//								trace("?here?");
								Engine_Message(KSE_GetErrFileSrc(i) + "Unexpected `" + KSE_GetToken(i) + "//.", "SYNTAX ERROR AT LINE " + kseToken[i].iLine);
							}
						}
						//Engine_Message(KSE_GetErrFileSrc(i) + "Unexpected (	" + KSE_GetToken(i) + "	].", "SYNTAX ERROR AT LINE " + kseToken[i].iLine);
			}
		}
		++i;
		if (i >= iTokenCtr) {
			l_execute = false;
		}
	}
	
	return i;
}
