'translated this 09.23.07@9:42AM by mjmendozaIV
#Include Once "kageExterns.bi"
#LibPath "lib/fbsound/lib"
#Include "../../lib/fbsound/inc/fbsound.bi"


	'//----- for TGA support ------
	#Include "../../lib/tgaloader.bi"
	'----------------------------//

#Define	WARNING_INVALID_IMAGE "Quixie Warning!: Invalid image resource. "

Public Sub InitializeMedia()
	InitializeImageBuffer()
	InitializeSoundBuffer()
	
'	Exit Sub
'	
'	Engine_Message "Unable to initialize Media."
'	Engine_Exit
End Sub

Public Sub InitializeImageBuffer()
	Redim Preserve kseImg(kseImg_count) As typeImage   'set to have at least one image for 'screen'
	
	quixieSCREEN = CreateNewImage  'set to have at least one image for 'screen'
	' create the buffer
	InitializeImage(quixieSCREEN, 640, 480)
	With kseImg(quixieSCREEN)
		.iForeColor = 16777215
		.IFillColor = RGBA(0,0,0,0)
	End With
	
'	Exit Sub
'	
'	Engine_Message "Unable to initialize graphics engine."
'	Engine_Exit
End Sub

Private Sub InitializeSoundBuffer()
	Redim Preserve kseSnd(kseSnd_count) As typeSound   'set to have at least one sound for avoiding error
	
	' only if not same as exe path
	fbs_Set_PlugPath(exepath & "/fbsound/")
	fbs_Init()
	
'	Exit Sub
'	
'	Engine_Log "Quixie Error: Unable to initialize sound engine."
End Sub

Public Function CreateNewSound() As Long
	'try to make one
	For i As Integer = 0 To kseSnd_count
		If kseSnd(i).inUse = 0 Then
			kseSnd(i).inUse = 1
			Return i
		End If
	Next
	'if it didnt, add new one
	kseSnd_count = kseSnd_count + 1
	Redim Preserve kseSnd(kseSnd_count) As typeSound
	kseSnd(kseSnd_count).inUse = 1
	Return kseSnd_count
End Function

Public Function CreateNewImage() As Long
	Dim tmpImgIdx As Integer
	tmpImgIdx = -1
	'try to allocate one
	For i As Integer  = 0 To kseImg_count
		If kseImg(i).inUse = 0 Then
			tmpImgIdx = i
			Exit For
		End If
	Next
	
	If tmpImgIdx < 0 Then
		'if it didnt, create new one
		kseImg_count = kseImg_count + 1
		Redim Preserve kseImg(kseImg_count+1) As typeImage
		
		tmpImgIdx = kseImg_count
	EndIf
	
	With kseImg(tmpImgIdx)
		.x = 0
		.y = 0
		.scaleX = 100
		.scaleY = 100
		.iAlpha = 255
		.rotation = 0
		.bTransparent = 1
		.vectorX = 0
		.vectorY = 0
		
		.inUse = 1
	End With
'	Engine_Log " L" & vbTab  & vbTab & tmpImgIdx, 1
	Return tmpImgIdx
End Function

Public Sub InitializeImage(allocIndex As Long, Wid As Long, Hgt As Long)
	With kseImg(allocIndex)
	   .imgHeight = Hgt
		.imgWidth = Wid
		.vectorX = 0
		.vectorY = 0
		#IfDef QUIXIE_CAIRO
			.img = ImageCreate(Wid, Hgt, RGBA(0, 0, 0, 0), 32)
			'.imgCairo = Cairo_Image_Surface_Create_For_Data(.img, CAIRO_FORMAT_ARGB32, Wid, Hgt, Wid*Len(Integer))
		#Else
			.img = ImageCreate(Wid, Hgt, RGBA(0, 0, 0, 0), 32)
		#EndIf
	End With
End Sub

#IfDef QUIXIE_CAIRO
	'for use exclusively by LoadNewImage -- made a function to shorten LoadNewImage's code
	Private Sub Engine_LoadNewImage_CairoFix(tmpImg As Long, targetImg As Long)
		kseImg(tmpImg).imgCairo = Cairo_Image_Surface_Create_For_Data(kseImg(tmpImg).img, CAIRO_FORMAT_ARGB32, kseImg(tmpImg).imgWidth, kseImg(tmpImg).imgHeight + 1, kseImg(tmpImg).imgWidth * Len(Integer))
			
			Engine_GrabRegion 8, 0, kseImg(tmpImg).imgWidth - 8, kseImg(tmpImg).imgHeight, tmpImg, targetImg
			CairoPut kseImg(targetImg).imgCairo, kseImg(tmpImg).imgWidth - 8, -1, kseImg(tmpImg).imgCairo, 1, 1, 0, 0, 0, 1, 255
		UnloadImage tmpImg
	End Sub
#EndIf

Public Function LoadNewImage(sImagePath As String) As Long
	Dim allocIndex As Long
'	Engine_Log "L--------------- " & sImagePath, 1
	allocIndex = CreateNewImage()
	#IfDef QUIXIE_CAIRO
		Dim As Long localImg
	#EndIf
	
	Dim resExt As String
	With kseImg(allocIndex)
		'use proper slash before checking files
		sImagePath = Replace(sImagePath, "\", kseSLASH)
		
		resExt = Right(sImagePath, 4)
		#IfDef QUIXIE_CAIRO
			If resExt <> ".png" Then
				localImg = CreateNewImage()
			EndIf
		#EndIf
		
		'im looking for colon because of 'C:\'
		If InStr(1, sImagePath, kseCOLON) = 0 Then
			'to avoid loading a different picture,
			'first, look for the image on users current ks script path
			If Dir(sKonsolPath & kseSLASH & sImagePath) <> "" Then
				sImagePath = sKonsolPath & kseSLASH & sImagePath
			ElseIf Dir(App_Path & kseSLASH & "image" & kseSLASH & sImagePath) <> "" Then
			'then, look for the image on Quixie's path & \image\ directory
				sImagePath = App_Path & kseSLASH & "image" & kseSLASH & sImagePath
			End If
		Else
			'check if user is loading image from internet (http, ftp, etc...)
			ReDim link_() as String
			If InStr(sImagePath, "://") > 0 Then
				Split sImagePath, "://", link_()
				sImagePath = LoadNewResourceFromNet(link_(1))
			End If
		End If
		
		#IfNDef QUIXIE_CGI
			Dim As UInteger wid, hgt
			If resExt = ".png" Then
				#IfDef QUIXIE_CAIRO
					Dim As cairo_surface_t Ptr image
						.imgCairo = cairo_image_surface_create_from_png(sImagePath)
				#EndIf
				
				png_dimensions( sImagePath, wid, hgt )
				InitializeImage allocIndex, wid, hgt
				.img = png_load( sImagePath, PNG_TARGET_FBNEW )
				'Dim As Fb.IMAGE ptr tmp_png = png_load( sImagePath, PNG_TARGET_FBNEW )
				'png_dimensions( sImagePath, wid, hgt )
				'InitializeImage allocIndex, wid, hgt
				'If tmp_png = 0 Then
				'	Engine_Log "Unable to load " & sImagePath, 1
				'Else
				'	Put .img, (0, 0), tmp_png, PSet'Alpha
				'EndIf
			ElseIf resExt = ".jpg" Then
				Dim As Any ptr tmp_jpg = jpegget(sImagePath)
				jpeg_dimensions( sImagePath, wid, hgt )
				InitializeImage allocIndex, wid, hgt
				If jpegerr Then
					Engine_Log "Unable to load " & sImagePath, 1
				Else
					Put .img, (0, 0), tmp_jpg, PSet
				EndIf
				
				#IfDef QUIXIE_CAIRO
					.imgCairo = Cairo_Image_Surface_Create_For_Data(.img, CAIRO_FORMAT_ARGB32, wid, hgt, wid*Len(Integer))
					
					InitializeImage localImg, wid, hgt
						Put kseImg(localImg).img, (0, 0),tmp_jpg, PSet
							Engine_LoadNewImage_CairoFix localImg, allocIndex
					'ImageDestroy .img
				#EndIf
			ElseIf resExt = ".bmp" Then
				Dim As Integer load_image_file = FreeFile
				Open sImagePath For Binary Access Read As #load_image_file
				  Get #load_image_file, 19, wid
				  Get #load_image_file, 23, hgt
				Close #load_image_file
				
				InitializeImage allocIndex, wid, hgt
				BLoad sImagePath, .img
				#IfDef QUIXIE_CAIRO
					.imgCairo = Cairo_Image_Surface_Create_For_Data(.img, CAIRO_FORMAT_ARGB32, wid, hgt, wid*Len(Integer))
					
					InitializeImage localImg, wid, hgt
						BLoad sImagePath, kseImg(localImg).img
							Engine_LoadNewImage_CairoFix localImg, allocIndex
					'ImageDestroy .img
				#EndIf
			ElseIf resExt = ".tga" Then
				Dim tmp_tga As Fb.IMAGE Ptr
				tmp_tga = tga_load(Strptr( sImagePath ))
				
				InitializeImage allocIndex, tmp_tga->Width, tmp_tga->Height
				Put .img, (0, 0), tmp_tga, PSet
				#IfDef QUIXIE_CAIRO
					.imgCairo = Cairo_Image_Surface_Create_For_Data(.img, CAIRO_FORMAT_ARGB32, tmp_tga->Width, tmp_tga->Height, tmp_tga->Width*Len(Integer))
					
					InitializeImage localImg, tmp_tga->Width, tmp_tga->Height
						Put kseImg(localImg).img, (0, 0), tmp_tga, PSet
							Engine_LoadNewImage_CairoFix localImg, allocIndex
					'ImageDestroy .img
				#EndIf
			Else
				#IfDef QUIXIE_DEBUG
					Engine_Message "Currently, Quixie does not support image file like" & vbCrLf & _
								"(  " & sImagePath & "  ).", "Image:Load Error"
				#EndIf
				Engine_Exit
			End If
		#EndIf
	End With
	#IfDef QUIXIE_CAIRO
		If resExt <> ".png" Then
			UnloadImage localImg
		EndIf
	#EndIf
	Return allocIndex
End Function

Public Function LoadNewSound(ByRef sSoundPath As String) As Long
	Dim hWave As Integer
	
	Dim allocIndex As Long
	allocIndex = CreateNewSound()
	
	'use proper slash before checking files
	sSoundPath = Replace(sSoundPath, "\", kseSLASH)
	Dim resExt As String
	resExt = Right(sSoundPath, 4)
	
	'check file existence
'		If Dir(sSoundPath) = "" Then
'		'im looking for colon because of 'C:\'
	If InStr(1, sSoundPath, kseCOLON) = 0 Then
		'to avoid loading a different picture,
		'first, look for the image on users current ks script path
		If Dir(sKonsolPath & kseSLASH & sSoundPath) <> "" Then
			sSoundPath = sKonsolPath & kseSLASH & sSoundPath
		ElseIf Dir(App_Path & kseSLASH & "sound" & kseSLASH & sSoundPath) <> "" Then
		'then, look for the image on Quixie's path & \sound\ directory
			sSoundPath = App_Path & kseSLASH & "sound" & kseSLASH & sSoundPath
		Else
			Engine_Message "Cannot find (  " & sSoundPath & "  )", "Sound:Load Error"
			Engine_Exit
		End If
	Else
		'check if user is loading image from internet (http, ftp, etc...)
		ReDim link_() as String
		If InStr(sSoundPath, "://") > 0 Then
			Split sSoundPath, "://", link_()
			sSoundPath = LoadNewResourceFromNet(link_(1))
		End If
	End If
	
	If resExt = ".wav" Then
		kseSnd(allocIndex).isLoad = fbs_Load_WAVFile(sSoundPath, @hWave)
	ElseIf resExt = ".mp3" Then
		kseSnd(allocIndex).isLoad = fbs_Load_MP3File(sSoundPath, @kseSnd(allocIndex).hWave)
	ElseIf resExt = ".ogg" Then
		kseSnd(allocIndex).isLoad = fbs_Load_OGGFile(sSoundPath,@kseSnd(allocIndex).hWave)
	Else
		#IfDef QUIXIE_DEBUG
			Engine_Message "Currently, Quixie does not support sound file like" & vbCrLf & _
								"(  " & sSoundPath & "  ).", "Sound:Load Error"
		#EndIf
		Engine_Exit
	End If
	
	If kseSnd(allocIndex).isLoad Then
		fbs_Create_Sound(hWave,@kseSnd(allocIndex).hSound)
		kseSnd(allocIndex).hWave = hWave
	End If
	
	Return allocIndex
End Function

Public Sub UnloadImage(iImageIndex As Long)
	Dim refCtr As UInteger
	With kseImg(iImageIndex)
		If .inUse = 1 Then
			'dump memory
			#IfDef QUIXIE_CAIRO
				If .imageDataCount > 0 Then
					KSE_Image_ClearData(iImageIndex)
				EndIf
				If .imgCairo <> 0 Then
						refCtr = Cairo_Surface_Get_Reference_Count (.imgCairo)
'Engine_Log vbTab & "U a" & vbTab & iImageIndex & " " & refCtr, 1
					If refCtr = 1 Then
'Engine_Log vbTab & "U b", 1
						Cairo_Surface_Destroy (.imgCairo)
					Else
						Exit Sub
					EndIf
				EndIf
			#EndIf
'Engine_Log vbTab & "  U" & vbTab & iImageIndex, 1
			If .img <> 0 Then ImageDestroy .img
			
			'refresh size to default (which depends on the picture)
			'  -- fixes unwanted picture resizing
			.imgHeight = 0
			.imgWidth = 0
			.vectorX = 0
			.vectorY = 0
			
			.inUse = 0   'flag to false
		EndIf
	End With
End Sub

Public Sub UnloadSound(iSoundIndex As Long)
	With kseSnd(iSoundIndex)
		fbs_Destroy_Wave(@kseSnd(iSoundIndex).hWave) 'dump WAV-used memory
		fbs_Destroy_Sound(@kseSnd(iSoundIndex).hSound) 'dump memory
		.isLoop = 0
		.isLoad = 0
		.inUse = 0   'flag to false
	End With
End Sub

#IfDef QUIXIE_CAIRO
	Public Sub CairoPut(Byval lpTarget As Cairo_Surface_T Ptr, _
	             Byval xPos  As Integer = 0, _
	             Byval yPos  As Integer = 0, _
	             Byval lpSource As Cairo_Surface_T Ptr , _
	             Byval xScale   As Single = 1, _
	             Byval yScale   As Single = 1, _
	             Byval Rotate   As Single = 0, _
	             Byval Mirror   As Integer = 0, _
	             Byval Flipp   As Integer = 0, _
	             Byval Trans    As Integer = 0, _
	             Byval alphavalue As Integer = 255, _
	             Byval pWid As Integer = -1, _
	             Byval pHgt As Integer = -1)
		Dim localContext As Cairo_T Ptr
		localContext = Cairo_Create (lpTarget)
			If Mirror = 1 Then
				xPos += pWid
			EndIf
			If Flipp = 1 Then
				yPos += pHgt
			EndIf
			
			If pWid >= 0 Then
				Cairo_Translate (localContext, xPos+0.5*pWid, yPos+0.5*pHgt)
			Else
				Cairo_Translate (localContext, xPos, yPos)
			EndIf
				Cairo_Rotate (localContext, Rotate * MATH_PI / 180)
				
			If pWid >= 0 Then
				Cairo_Translate (localContext, -0.5*pWid, -0.5*pHgt)							
			EndIf
				
			Cairo_Scale (localContext, xScale, yScale)
			
			Cairo_Set_Source_Surface (localContext, lpSource, 0, 0)
			
			If Trans = 1 Then
				Cairo_Paint (localContext)							
			Else
				Cairo_Paint_With_Alpha (localContext, alphavalue / 255)
			EndIf
		
		Cairo_Destroy (localContext)
	End Sub
	
	Public Function KSE_ImageData_Add(vectorType As Integer, thickness As Double, fillColor As typeColor, strokeColor As typeColor) As Integer
		Dim i As Integer
		Dim newIdx As Integer
		newIdx = -1
		For i = 0 To kseImg_DataCtr - 1
			With kseImg_Data(i)
				If .bUsed = 0 Then
					tmpIdx =i
					i = kseImg_DataCtr
				EndIf
			End With
		Next
		
		If newIdx < 0 Then
			kseImg_DataCtr = kseImg_DataCtr + 1
			ReDim Preserve kseImg_Data(kseImg_DataCtr) As typeImage_Data
			
			newIdx = kseImg_DataCtr - 1
		EndIf
		
		With kseImg_Data(newIdx)
			.vectorType = vectorType
			Select Case vectorType
				Case QUIXIE_CAIRO_DATA_TYPE_FILL
					.vectorCount = 0
				Case QUIXIE_CAIRO_DATA_TYPE_ENDFILL
					.vectorCount = 0
				Case QUIXIE_CAIRO_DATA_TYPE_STROKE
					.vectorCount = 0
				Case QUIXIE_CAIRO_DATA_TYPE_MOVE
					.vectorCount = 1
				Case QUIXIE_CAIRO_DATA_TYPE_LINE
					.vectorCount = 1
				Case QUIXIE_CAIRO_DATA_TYPE_CURVE_QUADRATIC
					.vectorCount = 2
				Case QUIXIE_CAIRO_DATA_TYPE_CURVE_CUBIC
					.vectorCount = 4
				Case QUIXIE_CAIRO_DATA_TYPE_IMAGE
					.vectorCount = 2 '1st is for X/Y, 2nd is for width/height  -- ?!?
			End Select
			.vectorX = Callocate(.vectorCount, SizeOf(Double))
			.vectorY = Callocate(.vectorCount, SizeOf(Double))
			
			If .vectorCount > 0 Then
				If 0 >= .vectorX Then Engine_Log "Unable to add image data", 1:End
			EndIf
			
			.thickness = thickness
			
			.strokeColor = strokeColor
			
			.fillColor = fillColor
			
			'lImg As Long 
			.bUsed = 1
		End With
		Return newIdx
	End Function
	
	Private Function ReDimIntegerPtr(destIntegerPtr As Integer Ptr, arrayCount As Integer, previousSize As Integer = -1) As Integer Ptr
		Dim localIntegerPtr As Integer Ptr
		localIntegerPtr = Callocate(arrayCount, SizeOf(Integer))
		If localIntegerPtr = 0 Then Print "Unable to Callocate" : End
		
		If previousSize < 0 Then previousSize = arrayCount - 1
		
		Dim i As Integer
		For i = 0 To arrayCount
			If i < previousSize Then
				localIntegerPtr[i] = destIntegerPtr[i]
			EndIf
		Next
		DeAllocate destIntegerPtr

		Return localIntegerPtr'destIntegerPtr
	End Function
	
	Public Sub KSE_ImageData_AddFill(fillColor As ULong, alphaValue As Single, destImg As Integer)
		With kseImg(destImg)
			.imageDataCount = .imageDataCount + 1
			If .imageDataCount = 1 Then
				.imageData = Allocate(.imageDataCount * sizeOf(Integer))
			Else
				.imageData = ReDimIntegerPtr(.imageData, .imageDataCount)
				'.imageData = Reallocate(.imageData, .imageDataCount)
			End If
			
			'If .imageData = 0 Then Engine_Log "Unable to create image data", 1 : End
			Dim localFillColor As typeColor
			
			localFillColor.R = RGBA_R(fillColor) / 255
			localFillColor.G = RGBA_G(fillColor) / 255
			localFillColor.B = RGBA_B(fillColor) / 255
			localFillColor.A = alphaValue / 255

 			.imageData[.imageDataCount - 1] = KSE_ImageData_Add(QUIXIE_CAIRO_DATA_TYPE_FILL, .thickness, localFillColor, .strokeColor)
			
			'.imageDataRendered = 0 '<-- no need to re-render any
		End With
	End Sub
	
	Public Sub KSE_ImageData_AddCloseFill(destImg As Integer)
		With kseImg(destImg)
			.imageDataCount = .imageDataCount + 1
			If .imageDataCount = 1 Then
				.imageData = Allocate(.imageDataCount * sizeOf(Integer))
			Else
				.imageData = ReDimIntegerPtr(.imageData, .imageDataCount)
			EndIf
			
			Dim fillColor As typeColor
			
			fillColor.R = 0
			fillColor.G = 0
			fillColor.B = 0
			fillColor.A = 0
			
			.imageData[.imageDataCount - 1] = KSE_ImageData_Add(QUIXIE_CAIRO_DATA_TYPE_ENDFILL, .thickness, fillColor, .strokeColor)
			
			'.imageDataRendered = 0 '<-- no need to re-render any
		End With
	End Sub

	Public Sub KSE_ImageData_AddStroke(thickness As Double, strokeColor As typeColor, destImg As Integer)
		With kseImg(destImg)
			.imageDataCount = .imageDataCount + 1
			If .imageDataCount = 1 Then
				.imageData = Allocate(.imageDataCount * sizeOf(Integer))
			Else
				.imageData = ReDimIntegerPtr(.imageData, .imageDataCount)
			EndIf
			
			.imageData[.imageDataCount - 1] = KSE_ImageData_Add(QUIXIE_CAIRO_DATA_TYPE_STROKE, thickness, .fillColor, strokeColor)
			
			'.imageDataRendered = 0 '<-- no need to re-render any
		End With
	End Sub
	
	Public Sub KSE_ImageData_AddMove(vX As Double, vY As Double, destImg As Integer)
		With kseImg(destImg)
			.imageDataCount = .imageDataCount + 1
			If .imageDataCount = 1 Then
				.imageData = Allocate(.imageDataCount * sizeOf(Integer))
			Else
				.imageData = ReDimIntegerPtr(.imageData, .imageDataCount)
			EndIf
			
			.imageData[.imageDataCount - 1] = KSE_ImageData_Add(QUIXIE_CAIRO_DATA_TYPE_MOVE, .thickness, .fillColor, .strokeColor)
			
			Dim tmpImgDataIndex As Integer
			tmpImgDataIndex = .imageData[.imageDataCount - 1]
			kseImg_Data(tmpImgDataIndex).vectorX[0] = vX
			kseImg_Data(tmpImgDataIndex).vectorY[0] = vY
			
			'.imageDataRendered = 0 '<-- no need to re-render any
		End With
	End Sub
	
	Public Sub KSE_ImageData_AddLine(vX As Double, vY As Double, destImg As Integer)
		With kseImg(destImg)
			.imageDataCount = .imageDataCount + 1
			If .imageDataCount = 1 Then
				.imageData = Allocate(1 * sizeOf(Integer))
			Else
				.imageData = ReDimIntegerPtr(.imageData, .imageDataCount)
			EndIf
			
			.imageData[.imageDataCount - 1] = KSE_ImageData_Add(QUIXIE_CAIRO_DATA_TYPE_LINE, .thickness, .fillColor, .strokeColor)
			
			Dim tmpImgDataIndex As Integer
			tmpImgDataIndex = .imageData[.imageDataCount - 1]
			
			kseImg_Data(tmpImgDataIndex).vectorX[0] = vX
			kseImg_Data(tmpImgDataIndex).vectorY[0] = vY
			
			.imageDataRendered = 0 'flag to re-render image's vector
		End With
	End Sub
	
	Public Sub KSE_ImageData_AddCurve(vX1 As Double, vY1 As Double, vX2 As Double, vY2 As Double, destImg As Integer, curveType As Integer)
		With kseImg(destImg)
			.imageDataCount = .imageDataCount + 1
			If .imageDataCount = 1 Then
				.imageData = Allocate(.imageDataCount * sizeOf(Integer))
			Else
				.imageData = ReDimIntegerPtr(.imageData, .imageDataCount)
			EndIf
			
			If .imageData = 0 Then Engine_Log "Unable to create image data", 1 : End
			
			.imageData[.imageDataCount - 1] = KSE_ImageData_Add(curveType, .thickness, .fillColor, .strokeColor)
			
			Dim tmpImgDataIndex As Integer
			tmpImgDataIndex = .imageData[.imageDataCount - 1]
			kseImg_Data(tmpImgDataIndex).vectorX[0] = vX1
			kseImg_Data(tmpImgDataIndex).vectorY[0] = vY1
			
			kseImg_Data(tmpImgDataIndex).vectorX[1] = vX2
			kseImg_Data(tmpImgDataIndex).vectorY[1] = vY2
			
			.imageDataRendered = 0 'flag to re-render image's vector
		End With
	End Sub
	
	Public Sub KSE_ImageData_AddCubic(vX1 As Double, vY1 As Double, vX2 As Double, vY2 As Double, destImg As Integer)
		KSE_ImageData_AddCurve(vX1, vY2, vX2, vY2, destImg, QUIXIE_CAIRO_DATA_TYPE_CURVE_CUBIC)
	End Sub
	
	Public Sub KSE_ImageData_AddQuadratic(vX1 As Double, vY1 As Double, vX2 As Double, vY2 As Double, destImg As Integer)
		KSE_ImageData_AddCurve(vX1, vY2, vX2, vY2, destImg, QUIXIE_CAIRO_DATA_TYPE_CURVE_QUADRATIC)
	End Sub
	
	/'old implementation of Cubic Curve which draws better but not compatible to Flash's Curve-rendering
	Public Sub KSE_ImageData_AddCubic(thickness As Double, fillColor As typeColor, strokeColor As typeColor, vX1 As Double, vY1 As Double, vX2 As Double, vY2 As Double, vX3 As Double, vY3 As Double, destImg As Integer)
		With kseImg(destImg)
			.imageDataCount = .imageDataCount + 1
			If .imageDataCount = 1 Then
				.imageData = Allocate(.imageDataCount * sizeOf(Integer))
			Else
				.imageData = ReDimIntegerPtr(.imageData, .imageDataCount)
			EndIf
			
			If .imageData = 0 Then Engine_Log "Unable to create image data", 1 : End
			
			.imageData[.imageDataCount - 1] = KSE_ImageData_Add(QUIXIE_CAIRO_DATA_TYPE_CURVE_CUBIC, thickness, fillColor, strokeColor)
			
			Dim tmpImgDataIndex As Integer
			tmpImgDataIndex = .imageData[.imageDataCount - 1]
			kseImg_Data(tmpImgDataIndex).vectorX[0] = vX1
			kseImg_Data(tmpImgDataIndex).vectorY[0] = vY1
			
			kseImg_Data(tmpImgDataIndex).vectorX[1] = vX2
			kseImg_Data(tmpImgDataIndex).vectorY[1] = vY2
			
			kseImg_Data(tmpImgDataIndex).vectorX[2] = vX3
			kseImg_Data(tmpImgDataIndex).vectorY[2] = vY3
			
			.imageDataRendered = 0 'flag to re-render image's vector
		End With
	End Sub'/
	
	'NOTE: will be called by KSE_Image_ClearData
	Private Sub KSE_ImageData_Clear(imgData As Integer)
		With kseImg_Data(imgData)
			DeAllocate(.vectorX)
			DeAllocate(.vectorY)
			
			'lImg As Long 
			.bUsed = 0
		End With
		kseImg_DataCtr = kseImg_DataCtr - 1
	End Sub
	
	'This will remove vector data of an image
	'NOTE: To be used only on Draw:Clear(myImg) command
	Public Sub KSE_Image_ClearData(destImg As Integer)
		With kseImg(destImg)
			If .inUse = 1 Then
				Dim i As Integer
				For i = 0 To .imageDataCount - 1
					KSE_ImageData_Clear(.imageData[i])
				Next
				.imageDataCount = 0
				DeAllocate(.imageData)
			End If
		End With
	End Sub
	
	'for use exclusively of KSE_Image_RenderData
	Private Sub KSE_Image_RenderDataStroke(destContext As Cairo_T Ptr, destImg As Integer)
		With kseImg(destImg)
			Cairo_Set_Source_RGBA (destContext, _
									.strokeColor.R, _
									.strokeColor.G, _
									.strokeColor.B, _
									.strokeColor.A)
				Cairo_Set_Line_Width (destContext, .thickness)
					Cairo_Set_Line_Cap (destContext, CAIRO_LINE_CAP_ROUND)
						Cairo_Stroke (destContext)
		End With
	End Sub
	
	Public Sub KSE_Image_RenderData(destImg As Integer)
		With kseImg(destImg)
			If .inUse = 1 Then
				Dim localContext As Cairo_T Ptr
					localContext = Cairo_Create (.imgCairo)
					
					Dim tmpImageData As typeImage_Data
					Dim i As Integer
					For i = 0 To .imageDataCount - 1
						tmpImageData = kseImg_Data(.imageData[i])
						If tmpImageData.bUsed = 1 Then 
							Select Case tmpImageData.vectorType
								Case QUIXIE_CAIRO_DATA_TYPE_FILL
									'trace "beginFill"
									.fillColor = tmpImageData.fillColor
									.fill = .fill + 1
								Case QUIXIE_CAIRO_DATA_TYPE_ENDFILL
									'trace "endFill"
									If .fill > 0 Then
										Cairo_Close_Path (localContext)
										
										Cairo_Set_Source_RGBA (localContext, _
																			.fillColor.R, _
																			.fillColor.G, _
																			.fillColor.B, _
																			.fillColor.A)
											Cairo_Fill_Preserve (localContext)
										KSE_Image_RenderDataStroke(localContext, destImg)
										
										'.fillColor = tmpImageData.fillColor
										.fill = .fill - 1
									EndIf
								Case QUIXIE_CAIRO_DATA_TYPE_STROKE
									.thickness = tmpImageData.thickness
									.strokeColor = tmpImageData.strokeColor
								Case QUIXIE_CAIRO_DATA_TYPE_MOVE
									Cairo_Move_To (localContext, tmpImageData.vectorX[0], tmpImageData.vectorY[0])
									
									.vectorX = tmpImageData.vectorX[0]
									.vectorY = tmpImageData.vectorY[0]
								Case QUIXIE_CAIRO_DATA_TYPE_LINE
									Cairo_Line_To (localContext, tmpImageData.vectorX[0], tmpImageData.vectorY[0])
									'KSE_Image_RenderDataStroke(localContext, destImg)
									
									.vectorX = tmpImageData.vectorX[0]
									.vectorY = tmpImageData.vectorY[0]
								Case QUIXIE_CAIRO_DATA_TYPE_CURVE_QUADRATIC
									'quad-to-cubic algo borrowed from Mono/Moonlight's moon_quad_curve_to
									Dim As Double x1 = tmpImageData.vectorX[0]
									Dim As Double y1 = tmpImageData.vectorY[0]
									Dim As Double x2 = tmpImageData.vectorX[1]
									Dim As Double y2 = tmpImageData.vectorY[1]
									Dim As Double x3 = x2
									Dim As Double y3 = y2
									
									x2 = x1 + (x2 - x1) / 3
									y2 = y1 + (y2 - y1) / 3
									x1 = .vectorX + 2 * (x1 - .vectorX) / 3
									y1 = .vectorY + 2 * (y1 - .vectorY) / 3
									
									Cairo_Curve_To (localContext, x1, y1, x2, y2, x3, y3)
									
									.vectorX = x3
									.vectorY = y3
								Case QUIXIE_CAIRO_DATA_TYPE_CURVE_CUBIC
									'4
									Cairo_Curve_To (localContext, _
													.vectorX, .vectorY, _
													tmpImageData.vectorX[0], tmpImageData.vectorY[0], _
													tmpImageData.vectorX[1], tmpImageData.vectorY[1])
									'KSE_Image_RenderDataStroke(localContext, destImg)
									
									.vectorX = tmpImageData.vectorX[1]
									.vectorY = tmpImageData.vectorY[1]
								Case QUIXIE_CAIRO_DATA_TYPE_IMAGE
									'2 '1st is for X/Y, 2nd is for width/height  -- ?!?
							End Select
						End If
					Next
				Cairo_Destroy (localContext)
			End If
		End With
	End Sub
#EndIf

' by D.J.Peters (Joshy)
' a put, scale, rotate hack for the new ImageHeader format.
'MultiPut [destination],[xmidpos],[ymidpos],source,[xScale],[yScale],[Mirror],[Flip],[Trans],[Custom],[Param]
' Small changes/additions by counting_pine (2007/04/27)
' Mirror and Flip parameters added by Cleber de Mattos Casali (2008/08/18)
' Alpha from D.J. Peters added by RayBritton (2008/11/07)
' Alpha Channel added by creek23 (Mj Mendoza IV) (2011/09/03)

'#define UseRad 'if not then Rotate are in degrees

Public Sub MultiPut(Byval lpTarget As Any Ptr= 0, _
						 Byval xMidPos  As Integer= 0, _
						 Byval yMidPos  As Integer= 0, _
						 Byval lpSource As Any Ptr   , _
						 Byval xScale   As Single = 1, _
						 Byval yScale   As Single = 1, _
						 Byval Rotate   As Single = 0, _
						 Byval Mirror   As Integer = 0, _
						 Byval Flipp    As Integer = 0, _
						 Byval Trans    As Integer= 0, _
						 Byval alphavalue As Integer = 255, _
						 Byval alphachannel As Integer = 1, _
						 Byval Custom As Function(Byval Src As Uinteger, Byval Dest As Uinteger, Byval Param As Any Ptr = 0) As Uinteger = 0, _
						 Byval Param As Any Ptr = 0)
	
	If (screenptr=0) Or (lpSource=0) Then Exit Sub
	
	If xScale < 0.001 Then xScale=0.001
	If yScale < 0.001 Then yScale=0.001
	
	Dim As Integer MustLock,MustRotate
	
	'variables for the alpha blending
		Dim As Uinteger srb = Any
		Dim As Uinteger drb = Any
		Dim As Uinteger  rb = Any
		Dim As Uinteger sr = Any, sg = Any, sb = Any, sa = Any, sa2 = Any
		Dim As Uinteger dr = Any, dg = Any, db = Any, da = Any, da2 = Any
		Dim As Uinteger  r = Any,  g = Any,  b = Any,  a = Any
		Dim As Uinteger sc = Any 'source (alpha) channel
	
	If lpTarget= 0 Then MustLock	=1
	If Rotate	<>0 Then MustRotate=1
	
	Dim As Integer	TargetWidth,TargetHeight,TargetBytes,TargetPitch
	If MustLock Then
		screeninfo		_
		TargetWidth , _
		TargetHeight, _
		TargetBytes ,,_
		TargetPitch
		TargetBytes Shr=3
		
		lpTarget=screenptr
	Else
		TargetBytes	= cptr(Uinteger Ptr,lpTarget)[1]
		TargetWidth	= cptr(Uinteger Ptr,lpTarget)[2]
		TargetHeight = cptr(Uinteger Ptr,lpTarget)[3]
		TargetPitch	= cptr(Uinteger Ptr,lpTarget)[4]
		lpTarget		+= 32
	End If
	If (TargetWidth<4) Or (TargetHeight<4) Then Exit Sub
	
	Dim As Integer	 SourceWidth,SourceHeight,SourceBytes,SourcePitch
	If cptr(Integer Ptr,lpSource)[0] = 7 Then
		SourceBytes	= cptr(Uinteger Ptr,lpSource)[1]
		SourceWidth	= cptr(Uinteger Ptr,lpSource)[2]
		SourceHeight = cptr(Uinteger Ptr,lpSource)[3]
		SourcePitch	= cptr(Uinteger Ptr,lpSource)[4]
		lpSource		+= 32
	Else
		SourceBytes	= cptr(Ushort Ptr,lpSource)[0] And 7
		SourceWidth	= cptr(Ushort Ptr,lpSource)[0] Shr 3
		SourceHeight = cptr(Ushort Ptr,lpSource)[1]
		SourcePitch	= SourceWidth * SourceBytes
		lpSource		+= 4
	End If
#if 0
	? TargetWidth & "x" & TargetHeight & "x" & TargetBytes,TargetPitch
	? SourceWidth & "x" & SourceHeight & "x" & SourceBytes,SourcePitch
	? MustLock,Trans
	Sleep:End
#endif
	
	If (SourceWidth<2) Or (SourceHeight<2) Then Exit Sub
	If (TargetBytes<>SourceBytes) Then Exit Sub
	
#define xs 0 'screen
#define ys 1
#define xt 2 'texture
#define yt 3
	Dim As Single Points(3,3)
	points(0,xs)=-SourceWidth/2 * xScale
	points(1,xs)= SourceWidth/2 * xScale
	points(2,xs)= points(1,xs)
	points(3,xs)= points(0,xs)
	
	points(0,ys)=-SourceHeight/2 * yScale
	points(1,ys)= points(0,ys)
	points(2,ys)= SourceHeight/2 * yScale
	points(3,ys)= points(2,ys)
	
	points(1,xt)= SourceWidth-1
	points(2,xt)= points(1,xt)
	points(2,yt)= SourceHeight-1
	points(3,yt)= points(2,yt)
	
If Mirror Then Swap points(0,xt),points(1,xt) :Swap points(2,xt),points(3,xt)
If Flipp Then Swap points(0,yt),points(3,yt) :Swap points(2,yt),points(1,yt)
'if Mirror then swap points(1,xt),points(2,xt)
'if Flipp then swap points(2,yt),points(3,yt)
	
	
	Dim As Uinteger i
	Dim As Single x,y
	If MustRotate Then
		#ifndef UseRad
		Rotate*=Atn(1)/45 'degree 2 rad
		#endif
		While Rotate< 0       :rotate+=8*Atn(1):Wend
		While Rotate>=8*Atn(1):rotate-=8*Atn(1):Wend
		For i=0 To 3
			x=points(i,xs)*Cos(Rotate) - points(i,ys)*Sin(Rotate)
			y=points(i,xs)*Sin(Rotate) + points(i,ys)*Cos(Rotate)
			points(i,xs)=x:points(i,ys)=y
		Next
	End If
	
	Dim As Integer yStart,yEnd,xStart,xEnd
	yStart=100000:yEnd=-yStart:xStart=yStart:xEnd=yEnd
	
#define LI 0   'LeftIndex
#define RI 1   'RightIndex
#define  IND 0 'Index
#define NIND 1 'NextIndex
	Dim As Integer CNS(1,1) 'Counters
	
	For i=0 To 3
		points(i,xs)=Int(points(i,xs)+xMidPos)
		points(i,ys)=Int(points(i,ys)+yMidPos)
		If points(i,ys)<yStart Then yStart=points(i,ys):CNS(LI,IND)=i
		If points(i,ys)>yEnd   Then yEnd  =points(i,ys)
		If points(i,xs)<xStart Then xStart=points(i,xs)
		If points(i,xs)>xEnd   Then xEnd  =points(i,xs)
	Next
	If yStart =yEnd         Then Exit Sub
	If yStart>=TargetHeight Then Exit Sub
	If yEnd   <0            Then Exit Sub
	If xStart = xEnd        Then Exit Sub
	If xStart>=TargetWidth  Then Exit Sub
	If xEnd   <0            Then Exit Sub
	
	Dim As Ubyte    Ptr t1,s1
	Dim As Ushort   Ptr t2,s2
	Dim As Uinteger     t2c, s2c
	Dim As Uinteger Ptr t4,s4
	
	
#define ADD 0
#define CMP 1
#define SET 2
	Dim As Integer ACS(1,2) 'add compare and set
	ACS(LI,ADD)=-1:ACS(LI,CMP)=-1:ACS(LI,SET)=3
	ACS(RI,ADD)= 1:ACS(RI,CMP)= 4:ACS(RI,SET)=0
	
	
#define EX  0
#define EU  1
#define EV  2
#define EXS 3
#define EUS 4
#define EVS 5
	Dim As Single E(2,6),S(6),Length,uSlope,vSlope
	Dim As Integer U,UV,UA,UN,V,VV,VA,VN
	
	' share the same highest point
	CNS(RI,IND)=CNS(LI,IND)
	If MustLock Then screenlock
	' loop from Top to Bottom
	While yStart<yEnd
		'Scan Left and Right sides together
		For i=LI To RI
			' bad to read but fast and short ;-)
			If yStart=points(CNS(i,IND),ys) Then
				CNS(i,NIND)=CNS(i,IND)+ACS(i,Add)
				If CNS(i,NIND)=ACS(i,CMP) Then CNS(i,NIND)=ACS(i,SET)
				While points(CNS(i,IND),ys) = points(CNS(i,NIND),ys)
					CNS(i, IND)=CNS(i,NIND)
					CNS(i,NIND)=CNS(i, IND)+ACS(i,Add)
					If CNS(i,NIND)=ACS(i,CMP) Then CNS(i,NIND)=ACS(i,SET)
				Wend
				E(i,EX) = points(CNS(i, IND),xs)
				E(i,EU) = points(CNS(i, IND),xt)
				E(i,EV) = points(CNS(i, IND),yt)
				Length  = points(CNS(i,NIND),ys)
				Length -= points(CNS(i, IND),ys)
				If Length <> 0.0 Then
					E(i,EXS) = points(CNS(i, NIND),xs)-E(i,EX):E(i,EXS)/=Length
					E(i,EUS) = points(CNS(i, NIND),xt)-E(i,EU):E(i,EUS)/=Length
					E(i,EVS) = points(CNS(i, NIND),yt)-E(i,EV):E(i,EVS)/=Length
				End If
				CNS(i,IND)=CNS(i,NIND)
			End If
		Next
		
		If (yStart<0)                              Then Goto SkipScanLine
		xStart=E(LI,EX)+0.5:If xStart>=TargetWidth Then Goto SkipScanLine
		xEnd  =E(RI,EX)-0.5:If xEnd < 0           Then Goto SkipScanLine
		If (xStart=xEnd)                           Then Goto SkipScanLine
		'if xEnd  <xStart                           then goto SkipScanLine
		Length=xEnd-xStart
		uSlope=E(RI,EU)-E(LI,EU):uSlope/=Length
		vSlope=E(RI,EV)-E(LI,EV):vSlope/=Length
		If xstart<0 Then
			Length=Abs(xStart)
			U=Int(E(LI,EU)+uSlope*Length)
			V=Int(E(LI,EV)+vSlope*Length)
			xStart = 0
		Else
			U=Int(E(LI,EU)):V=Int(E(LI,EV))
		End If
		If xEnd>=TargetWidth Then xEnd=TargetWidth-1
		UV=Int(uSlope):UA=(uSlope-UV)*100000:UN=0
		VV=Int(vSlope):VA=(vSlope-VV)*100000:VN=0
		xEnd-=xStart
		Select Case TargetBytes
			Case 1
				t1=cptr(Ubyte Ptr,lpTarget)
				t1+=yStart*TargetPitch+xStart:xStart=0
				If Custom Then
					While xStart<xEnd
						s1=lpSource+V*SourcePitch+U
						*t1=Custom(*s1,*t1,Param)
						U+=UV:UN+=UA:If UN>=100000 Then U+=1:UN-=100000
						V+=VV:VN+=VA:If VN>=100000 Then V+=1:VN-=100000
						If u<0 Then u=0
						If v<0 Then v=0
						xStart+=1:t1+=1
					Wend
				Elseif Trans=0 Then
					While xStart<xEnd
						s1=lpSource+V*SourcePitch+U
						*t1=*s1
						U+=UV:UN+=UA:If UN>=100000 Then U+=1:UN-=100000
						V+=VV:VN+=VA:If VN>=100000 Then V+=1:VN-=100000
						If u<0 Then u=0
						If v<0 Then v=0
						xStart+=1:t1+=1
					Wend
				Else
					While xStart<xEnd
						s1=lpSource+V*SourcePitch+U
						If *s1 Then *t1=*s1
						U+=UV:UN+=UA:If UN>=100000 Then U+=1:UN-=100000
						V+=VV:VN+=VA:If VN>=100000 Then V+=1:VN-=100000
						If u<0 Then u=0
						If v<0 Then v=0
						xStart+=1:t1+=1
					Wend
				End If
			Case 2
				t2=cptr(Short Ptr,lpTarget)
				t2+=yStart*(TargetPitch Shr 1)+xStart:xStart=0
				If Custom Then
					While xStart<xEnd
						s2=cptr(Short Ptr,lpSource)+V*(SourcePitch Shr 1)+U
						s2c=*s2
						t2c=*t2
						s2c=(s2c And &H001F) Shl 3 Or (s2c Shr 2 And &H000007) Or _
								(s2c And &H07E0) Shl 5 Or (s2c Shr 1 And &H000300) Or _
								(s2c And &HF800) Shl 8 Or (s2c Shl 3 And &H070000) Or &HFF000000
						t2c=(t2c And &H001F) Shl 3 Or (s2c Shr 2 And &H000007) Or _
								(t2c And &H07E0) Shl 5 Or (s2c Shr 1 And &H000300) Or _
								(t2c And &HF800) Shl 8 Or (s2c Shl 3 And &H070000) Or &HFF000000
						t2c=Custom(s2c,t2c,Param)
						*t2=(t2c Shr 3 And &H001F) Or _
								(t2c Shr 5 And &H07E0) Or _
								(t2c Shr 8 And &HF800)
						U+=UV:UN+=UA:If UN>=100000 Then U+=1:UN-=100000
						V+=VV:VN+=VA:If VN>=100000 Then V+=1:VN-=100000
						If u<0 Then u=0
						If v<0 Then v=0
						xStart+=1:t2+=1
					Wend
				Elseif Trans=0 Then
					While xStart<xEnd
						s2=cptr(Short Ptr,lpSource)+V*(SourcePitch Shr 1)+U
						*t2=*s2
						U+=UV:UN+=UA:If UN>=100000 Then U+=1:UN-=100000
						V+=VV:VN+=VA:If VN>=100000 Then V+=1:VN-=100000
						If u<0 Then u=0
						If v<0 Then v=0
						xStart+=1:t2+=1
					Wend
				Else
					While xStart<xEnd
						s2=cptr(Short Ptr,lpSource)+V*(SourcePitch Shr 1)+U
						If *s2<>&HF81F Then *t2=*s2
						U+=UV:UN+=UA:If UN>=100000 Then U+=1:UN-=100000
						V+=VV:VN+=VA:If VN>=100000 Then V+=1:VN-=100000
						If u<0 Then u=0
						If v<0 Then v=0
						xStart+=1:t2+=1
					Wend
				 End If
			Case 4
				t4=cptr(Integer Ptr,lpTarget)+yStart*(TargetPitch Shr 2)+xStart:xStart=0
				If Custom Then
					While xStart<xEnd
						s4=cptr(Integer Ptr,lpSource)+V*(SourcePitch Shr 2)+U
						'***** start alpha blending
						'this set of if...elseif...end if conditions applies alpha blending
						'these 43 lines can be replaced with '*t4 = *s4' to remove blending
						If alphavalue = 0 Then
							'no change needed *t4 = *t4
						Elseif alphavalue = 255 Then
							*t4 = *s4
						Elseif *t4 Shr 24 = 0 Then
							*t4 = *s4
						Elseif *t4 Shr 24 = 255 Then
							srb = *s4 And &h00ff00ff
							sg	= *s4 Xor srb
							sa	= alphavalue
							
							drb = *t4 And &h00ff00ff
							dg	= *t4 Xor drb
							da	= 256 - sa
							
							rb = (drb * da + srb * sa) And &hff00ff00
							g  = (dg  * da + sg  * sa) And &h00ff0000
							
							*t4 = (rb Or g) Shr 8 Or &hff000000
						Else
							sr = (*s4 Shr 16) And 255
							sg = (*s4 Shr  8) And 255
							sb = (*s4       ) And 255
							sa = (alphavalue)
							
							dr = (*t4 Shr 16) And 255
							dg = (*t4 Shr  8) And 255
							db = (*t4       ) And 255
							da = (*t4 Shr 24)
							
							sa2 = sa Shl 8
							da2 = da Shl 8 - da * sa
							a = (sa2 + da2)
							
							r = (dr * da2 + sr * sa2) \ a
							g = (dg * da2 + sg * sa2) \ a
							b = (db * da2 + sb * sa2) \ a
							*t4 = Rgba(r, g, b, a Shr 8)
						End If
						U+=UV:UN+=UA:If UN>=100000 Then U+=1:UN-=100000
						V+=VV:VN+=VA:If VN>=100000 Then V+=1:VN-=100000
						If u<0 Then u=0
						If v<0 Then v=0
						xStart+=1:t4+=1
					Wend
				Elseif Trans=0 Then
					While xStart<xEnd
						s4=cptr(Integer Ptr,lpSource)+V*(SourcePitch Shr 2)+U
						'***** start alpha blending
						'this set of if...elseif...end if conditions applies alpha blending
						'these 43 lines can be replaced with '*t4 = *s4' to remove blending
						If alphavalue = 0 Then
							'no change needed *t4 = *t4
						Elseif alphavalue = 255 And alphachannel = 0 Then
							*t4 = *s4
						Elseif alphavalue = 255 And alphachannel = 1 Then
							sr = (*s4 Shr 16) And 255
							sg = (*s4 Shr  8) And 255
							sb = (*s4       ) And 255
							sa = (*s4 Shr 24)
							
							dr = (*t4 Shr 16) And 255
							dg = (*t4 Shr  8) And 255
							db = (*t4       ) And 255
							da = (*t4 Shr 24)
							
							If (sa = 255) Then
								*t4 = Rgba(sr, sg, sb, sa)
							Else
								sa2 = sa Shl 8
								da2 = da Shl 8 - da * sa
								a = (sa2 + da2)
								If a > 0 Then
									r = (dr * da2 + sr * sa2) \ a
									g = (dg * da2 + sg * sa2) \ a
									b = (db * da2 + sb * sa2) \ a
									*t4 = Rgba(r, g, b, a Shr 8)
								Else
									*t4 = Rgba(dr, dg, db, da)
								EndIf
							EndIf'/'
						ElseIf alphavalue > 0 And alphachannel = 1 Then
							sr = (*s4 Shr 16) And 255
							sg = (*s4 Shr  8) And 255
							sb = (*s4       ) And 255
							sc = (*s4 Shr 24) And 255
							sa = sc * (alphavalue / 255)
							
							dr = (*t4 Shr 16) And 255
							dg = (*t4 Shr  8) And 255
							db = (*t4       ) And 255
							da = (*t4 Shr 24)
							
							sa2 = sa Shl 8
							da2 = da Shl 8 - da * sa
							a = (sa2 + da2)
							If a > 0 Then
								r = (dr * da2 + sr * sa2) \ a
								g = (dg * da2 + sg * sa2) \ a
								b = (db * da2 + sb * sa2) \ a
								*t4 = Rgba(r, g, b, a Shr 8)
							Else
								*t4 = Rgba(dr, dg, db, da)
							EndIf
						Elseif *t4 Shr 24 = 0 Then'/
							*t4 = *s4
						Elseif *t4 Shr 24 = 255 Then
							srb = *s4 And &h00ff00ff
							sg	= *s4 Xor srb
							sa	= alphavalue
							
							drb = *t4 And &h00ff00ff
							dg	= *t4 Xor drb
							da	= 256 - sa
							
							rb = (drb * da + srb * sa) And &hff00ff00
							g  = (dg  * da + sg  * sa) And &h00ff0000
							
							*t4 = (rb Or g) Shr 8 Or &hff000000
						Else
							sr = (*s4 Shr 16) And 255
							sg = (*s4 Shr  8) And 255
							sb = (*s4       ) And 255
							sa = (alphavalue)
							
							dr = (*t4 Shr 16) And 255
							dg = (*t4 Shr  8) And 255
							db = (*t4       ) And 255
							da = (*t4 Shr 24)
							
							sa2 = sa Shl 8
							da2 = da Shl 8 - da * sa
							a = (sa2 + da2)
							
							r = (dr * da2 + sr * sa2) \ a
							g = (dg * da2 + sg * sa2) \ a
							b = (db * da2 + sb * sa2) \ a
							*t4 = Rgba(r, g, b, a Shr 8)
						End If
						'***** end alpha blending
						U+=UV:UN+=UA:If UN>=100000 Then U+=1:UN-=100000
						V+=VV:VN+=VA:If VN>=100000 Then V+=1:VN-=100000
						If u<0 Then u=0
						If v<0 Then v=0
						xStart+=1:t4+=1
					Wend
				Else
					While xStart<xEnd
						's4=cptr(Integer Ptr,lpSource):s4+=V*(SourcePitch shr 2):s4+=U
						s4=cptr(Integer Ptr,lpSource)+V*(SourcePitch Shr 2)+U
						If (*s4 And &HFFFFFF)<>&HFF00FF Then
							'***** start alpha blending
							'this set of if...elseif...end if conditions applies alpha blending
							'these 43 lines can be replaced with '*t4 = *s4' to remove blending
							If alphavalue = 0 Then
								'no change needed *t4 = *t4
							Elseif alphavalue = 255 And alphachannel = 0 Then
								*t4 = *s4
							Elseif alphavalue = 255 And alphachannel = 1 Then
								sr = (*s4 Shr 16) And 255
								sg = (*s4 Shr  8) And 255
								sb = (*s4       ) And 255
								sa = (*s4 Shr 24)
								
								dr = (*t4 Shr 16) And 255
								dg = (*t4 Shr  8) And 255
								db = (*t4       ) And 255
								da = (*t4 Shr 24)
								
'								If (sa = 255) Then
'									*t4 = Rgba(sr, sg, sb, sa)
'								Else
									sa2 = sa Shl 8
									da2 = da Shl 8 - da * sa
									a = (sa2 + da2)
									If a > 0 Then
										r = (dr * da2 + sr * sa2) \ a
										g = (dg * da2 + sg * sa2) \ a
										b = (db * da2 + sb * sa2) \ a
										*t4 = Rgba(r, g, b, a Shr 8)
									Else
										*t4 = Rgba(dr, dg, db, da)
									EndIf
'								EndIf'/'
							ElseIf alphavalue > 0 And alphachannel = 1 Then
								sr = (*s4 Shr 16) And 255
								sg = (*s4 Shr  8) And 255
								sb = (*s4       ) And 255
								sc = (*s4 Shr 24)
								sa = sc * (alphavalue / 255)
								
								dr = (*t4 Shr 16) And 255
								dg = (*t4 Shr  8) And 255
								db = (*t4       ) And 255
								da = (*t4 Shr 24)
								
								sa2 = sa Shl 8
								da2 = da Shl 8 - da * sa
								a = (sa2 + da2)
								If a > 0 Then
									r = (dr * da2 + sr * sa2) \ a
									g = (dg * da2 + sg * sa2) \ a
									b = (db * da2 + sb * sa2) \ a
									*t4 = Rgba(r, g, b, a Shr 8)
								Else
									*t4 = Rgba(dr, dg, db, da)
								EndIf
							Elseif *t4 Shr 24 = 0 Then'/
								*t4 = *s4
							Elseif *t4 Shr 24 = 255 Then
								srb = *s4 And &h00ff00ff
								sg	= *s4 Xor srb
								sa	= alphavalue
								
								drb = *t4 And &h00ff00ff
								dg	= *t4 Xor drb
								da	= 256 - sa
								
								rb = (drb * da + srb * sa) And &hff00ff00
								g  = (dg  * da + sg  * sa) And &h00ff0000
								
								*t4 = (rb Or g) Shr 8 Or &hff000000
							Else
								sr = (*s4 Shr 16) And 255
								sg = (*s4 Shr  8) And 255
								sb = (*s4       ) And 255
								sa = (alphavalue)
								
								dr = (*t4 Shr 16) And 255
								dg = (*t4 Shr  8) And 255
								db = (*t4       ) And 255
								da = (*t4 Shr 24)
								
								sa2 = sa Shl 8
								da2 = da Shl 8 - da * sa
								a = (sa2 + da2)
								
								r = (dr * da2 + sr * sa2) \ a
								g = (dg * da2 + sg * sa2) \ a
								b = (db * da2 + sb * sa2) \ a
								*t4 = Rgba(r, g, b, a Shr 8)
							End If
							'***** end alpha blending
						End If
						U+=UV:UN+=UA:If UN>=100000 Then U+=1:UN-=100000
						V+=VV:VN+=VA:If VN>=100000 Then V+=1:VN-=100000
						If u<0 Then u=0
						If v<0 Then v=0
						xStart+=1:t4+=1
					Wend
				End If
		End Select

SkipScanLine:
		E(LI,EX)+=E(LI,EXS):E(LI,EU)+=E(LI,EUS):E(LI,EV)+=E(LI,EVS)
		E(RI,EX)+=E(RI,EXS):E(RI,EU)+=E(RI,EUS):E(RI,EV)+=E(RI,EVS)
		yStart+=1:If yStart=TargetHeight Then yStart=yEnd 'exit loop
	Wend
	If MustLock Then screenunlock
End Sub

Function Trans(Byval Src As Uinteger, Byval Dest As Uinteger, Byval Param As Any Ptr = 0) As Uinteger
   
    If (Src And &HFFFFFF) = &HFF00FF Then Return Dest Else Return Src
   
End Function
#IfNDef QUIXIE_CGI
	Function LoadNewResourceFromNet(sSrc As String) As String
		'TODO: HTTPS should also be supported -- mj 11.11.15
		'NOTE: sSrc should not contain any HTTP, FTP, etc; scan it out
		' so instead of HTTP://konsolscript.org/logo.png,
		' just give "konsolscript.org/logo.png"
		' -- mjmendoza
'ChiSock
'		Using chi
'		
'		Dim As socket sock
		
		Dim as String sLinkSrc = Get__Path(sSrc)
		Dim sLinkImg as String
		Dim sWWW() as String
		
		sLinkSrc = Replace(sLinkSrc, "\", "/") ' web uses forward slash; not backslash
		
		Split sLinkSrc, "/", sWWW()
		sLinkImg = Mid(sSrc, Len(sLinkSrc)+1)
		
		If Left(sLinkImg, 1) = "/" Then sLinkImg = Mid(sSrc, Len(sLinkSrc) + 2)
		
		Dim As String tmp_dir = GetTempDir() & kseSLASH & kHash("r350urc3_fr03_n6t_" & sLinkImg) 'cryptic, resource_from_net, to avoid loading other non-quixie-cached-resource
		
		If Dir(tmp_dir) <> "" Then Return tmp_dir 'load the cached instead
		'TODO: make a way to MD5 the cached resource
		
		Dim sData As String
'ChiSock		
'		Var socket_result = sock.client( sWWW(0), socket.PORT.HTTP ) 'sWWW(0) should be like: konsolscript.org
'		If( socket_result ) Then Engine_Log translate_error( socket_result ), 1
'		sock.put_HTTP_request( sSrc ) ' sSrc should be like: konsolscript.org/img.png
'		sData = sock.get_until( "" )
		sData = Mid( sData, InStr( sData, Chr(13, 10, 13, 10) ) + 4 )
		
		Dim As Integer iFreeFile = FreeFile
		
		Open tmp_dir For Binary Access Write As #iFreeFile 'tmp_dir should be like: /tmp/img.png
			Put #iFreeFile, ,sData
		Close #iFreeFile
		
		Return tmp_dir
	End Function
	
/'	Sub LoadNewResourceFromNetHelper(sSrc As Any Ptr)
		
		Var socket_result = sock.client( sWWW(0), socket.PORT.HTTP ) 'sWWW(0) should be like: konsolscript.org
		If( socket_result ) Then Engine_Log translate_error( socket_result ), 1
		
		sock.put_HTTP_request( sSrc ) ' sSrc should be like: konsolscript.org/img.png
		
		Dim sData As String
		sData = sock.get_until( "" )
		sData = Mid( sData, InStr( sData, Chr(13, 10, 13, 10) ) + 4 )
		
		Dim As Integer iFreeFile = FreeFile
		
		Open tmp_dir For Binary Access Write As #iFreeFile 'tmp_dir should be like: /tmp/img.png
			Put #iFreeFile, ,sData
		Close #iFreeFile
	End Sub'/
#EndIf
