'translated this 09.13.07@11:26PM by mjmendozaIV
#Include Once "kageExterns.bi"

'NOTE: this file consists all functions used by engine to process script.
'to keep this project manageable, I placed all script-processing functions
'from modKONSoL_Main to this file.		  08.06.06
'										   --Mj Mendoza IV

Public Sub ProcessScript_CleanUp()
	On Error GoTo ptrErr
		Dim i As Long
		Dim ii As Long
		Dim As String l_sTmp
		Dim As Integer l_paren = 0
		'remove all user's-comments
		For i = 0 To iTokenCtr
			If kseToken(i).iLine > 0 Then
				i = KSE_SkipVoidTokens(i)
					If kseToken(i).sToken = kseOPEN_PAREN Then
						'disregard slash until kseCLOSE_PAREN is found; but /* this */ should be allowed
						l_paren = l_paren + 1
					ElseIf kseToken(i).sToken = kseCLOSE_PAREN And l_paren > 1 Then
						l_paren = l_paren - 1
					ElseIf kseToken(i).sToken = kseFORWARD_SLASH Then
						If kseToken(i + 1).sToken = kseFORWARD_SLASH _
								Or kseToken(i + 1).sToken = kseASTERISK Then
							i = SynComment(i, l_paren)
						End If
					ElseIf kseToken(i).sToken = kseTAB Then
						kseToken(i).sToken = kseSPACE
					'im checking for double quotes because a [keyword/constant/identifier]
					'can be written between two quotes
					ElseIf kseToken(i).sToken = kseDOUBLE_QUOTES Then
						i = SynQuotes(i)
						Dim tmpxxx As String = GetTempString()
					'im checking for equal sign since 0.0.95 is capable of [x = 6 + 1 / (8 / 24);]
					'and / can be written as divide symbol in the equation
					ElseIf kseToken(i).sToken = kseEQUAL_SIGN Then
						For ii = i To iTokenCtr
							ii = GetNextIndex(ii)
							'Debug.Print ">>" & ii & vbTab & kseToken(ii).sToken
							If kseToken(ii).sToken = kseSEMICOLON Then
								i = ii
								Exit For
							ElseIf kseToken(ii).sToken = kseFORWARD_SLASH Then
								'check if comment
								If kseToken(ii + 1).sToken = kseFORWARD_SLASH _
										Or kseToken(ii + 1).sToken = kseASTERISK Then
									ii = SynComment(ii, l_paren)
								End If
							'im trying to change KONSoL constants
							ElseIf kseToken(ii).sToken = kseSCREEN Then
								kseToken(ii).sToken = "0"
							ElseIf kseToken(ii).sToken = kseTRUE Then
								kseToken(ii).sToken = "1"
							ElseIf kseToken(ii).sToken = kseFALSE Then
								kseToken(ii).sToken = "0"
							ElseIf kseToken(ii).sToken = ksePATH Then
								l_sTmp = kseDOUBLE_QUOTES & sKonsolPath & kseDOUBLE_QUOTES       'directory has backslash
								l_sTmp = Replace(l_sTmp, kseSLASH, "\\")  'backslash is an escape char  
								kseToken(ii).sToken = l_sTmp
							ElseIf kseToken(ii).sToken = ksePTR_APPEND Then
								kseToken(ii).sToken = "0"
							ElseIf kseToken(ii).sToken = "nochar" Then
								kseToken(ii).sToken = "256"
							End If
							ii = ii - 1
						Next
						i = ii
					'im trying to change KONSoL constants
					ElseIf kseToken(i).sToken = kseSCREEN Then
						kseToken(i).sToken = "0"
					ElseIf kseToken(i).sToken = kseTRUE Then
						kseToken(i).sToken = "1"
					ElseIf kseToken(i).sToken = kseFALSE Then
						kseToken(i).sToken = "0"
					ElseIf kseToken(i).sToken = ksePATH Then
						l_sTmp = kseDOUBLE_QUOTES & sKonsolPath & kseDOUBLE_QUOTES       'directory has backslash
						l_sTmp = Replace(l_sTmp, kseSLASH, "\\")  'backslash is an escape char  
						kseToken(i).sToken = l_sTmp
					ElseIf kseToken(i).sToken = ksePTR_APPEND Then
						kseToken(i).sToken = "0"
					ElseIf kseToken(i).sToken = "nochar" Then
						kseToken(i).sToken = "256"
					End If
			End If
		Next
		Exit Sub
ptrErr:
	Engine_ErrMsg Err, "ProcessScript_CleanUp"
End Sub

Public Sub ProcessScript_Statement_Include()
	On Error GoTo ptrErr
		'will include files based from [#include "myFile"] statement
		Dim i As Integer
		'insert all files included by the user
		For i = 0 To iTokenCtr
		   
			If kseToken(i).iLine > 0 Then
				i = KSE_SkipVoidTokens(i)
					'im checking for double quotes because a [keyword/constant/identifier]
					'can be written between two quotes
					If kseToken(i).sToken = kseDOUBLE_QUOTES Then
						i = SynQuotes(i)
						Dim tmpxxx As String = GetTempString()
					'im trying to look for [include]
					ElseIf kseToken(i).sToken = kseNUMBER_SIGN Then
						i = SynNumSign(i)
					End If
			End If
		Next
		Exit Sub
ptrErr:
	Engine_ErrMsg Err, "ProcessScript_Statement_Include"
End Sub

Public Sub ProcessScript_fromKONSL_toKS()
	On Error GoTo ptrErr
		Dim iFreeFile As Integer
		Dim sFileNme As String
		
		'# KONSL 0.04 file decompilation algorithm
		'----------------------------------------------------
		'   1. decompile file
			sFileNme = Decompile(sScriptPath)
		'----------------------------------------------------
		'   2. read the tmp file
			iFreeFile = FreeFile
			Open sFileNme For Binary Access Read As #iFreeFile	'read byte from file
				Redim sContent(LOF(iFreeFile) - 1) As UByte
				Get #iFreeFile, , sContent()
			Close #iFreeFile
			sKONSoL = fbArrayToStr(sContent())
			'sKONSoL = sContent
		'	   > remove tmp file
				Kill sFileNme
		'	   > verify .konsl file version
				If Val(Right(Mid(sKONSoL, 1, Len(kseKONSL_FILE_MARKER)), 4)) < Val(Right(kseKONSL_FILE_MARKER, 4)) Then
					Engine_Message "Please recompile" & vbCrLf & _
								   "(  " & sScriptPath & "  )", "Deprecated KONSL File"
					Engine_Exit
				ElseIf Left(sKONSoL, Len(kseKONSL_FILE_MARKER)) <> kseKONSL_FILE_MARKER Then
					Engine_Message "Unable to process (  " & sFileNme & ".KONSL  )."
					Engine_Exit
				End If
		'----------------------------------------------------
		'   3. remove file-version verification string then
			sKONSoL = Mid(sKONSoL, Len(kseKONSL_FILE_MARKER) + 1)
			sFileNme = Decompile(sScriptPath)
			Kill sFileNme
		sKONSoL = Mid(StrReverse(sKONSoL), 1) 'we skipped ___ chars; it is the vbCRLF'this line is under debugging
	Exit Sub
ptrErr:
	'Erl	'Gets the line in source code where the error occurred.
	'Erfn 'Gets the name of the function where the error occurred.
	'Ermn 'Gets the name of the source file where the error occurred.
	'Err	'Gets the error number of the last error that occurred.
	If Err = 62 Then
		'> remove tmp file
		Close iFreeFile 'make sure to close it first
		Kill sFileNme
		
		Engine_Message "Unable to process (  " & sScriptPath & "  ).", "Corrupted KONSL File."
		Engine_Exit
	End If
	Engine_ErrMsg Err, "ProcessScript_fromKONSL_toKS"
End Sub

Public Function ProcessScript_Include_KSL(sKONSL_FileName As String) As String
	'On Error GoTo ptrErr
		Dim iFreeFile As Integer
		Dim sFileNme As String
		
		'# KONSL 0.04 file decompilation algorithm
		'----------------------------------------------------
		'   1. decompile file	
		Engine_Log "sKONSL_FileName:" & sKONSL_FileName			
			sFileNme = Decompile(sKONSL_FileName)
		'----------------------------------------------------
		'   2. read the tmp file
			iFreeFile = FreeFile
			Open sFileNme For Binary Access Read As #iFreeFile	'read byte from file
				Redim sContent(LOF(iFreeFile) - 1) As UByte
				Get #iFreeFile, , sContent()
			Close #iFreeFile
			sKONSoL = fbArrayToStr(sContent())
		'	   > remove tmp file
				Kill sFileNme
		'	   > verify .konsl file version
		Engine_Log " : " & Mid(sKONSoL, 1, Len(kseKONSL_FILE_MARKER))
				If Val(Right(Mid(sKONSoL, 1, Len(kseKONSL_FILE_MARKER)), 4)) < Val(Right(kseKONSL_FILE_MARKER, 4)) Then
					Engine_Message "Please recompile" & vbCrLf & _
								   "(  " & sScriptPath & "  )", "Deprecated KONSL File"
					Engine_Exit
				ElseIf Left(sKONSoL, Len(kseKONSL_FILE_MARKER)) <> kseKONSL_FILE_MARKER Then
					Engine_Message "Unable to process (  " & sFileNme & ".KSL  )."
					Engine_Exit
				End If
		'----------------------------------------------------
		'   3. remove file-version verification string then
			sKONSoL = Mid(sKONSoL, Len(kseKONSL_FILE_MARKER) + 1)
			sFileNme = Decompile(sScriptPath)
			Kill sFileNme
		Dim zxc As String = sKONSoL
		
		zxc = StrReverse(zxc)
		'Engine_Log "Rev" & String(20,"~") & vbcrlf & zxc
		Return zxc
	Exit Function
ptrErr:
	Engine_ErrMsg Err, "ProcessScript_Include_KSL"
End Function

Public Sub ProcessScript_Refresh()
	On Error GoTo ptrErr
		Dim sNewScript  As String
		
		Dim iLine As Integer
		Dim iSrc As Integer
		iLine = 1
		iSrc = 0
		
        iLine = 1
        iSrc = 0
        
Dim tmpFile_ As String
Dim iFreeFile As Integer

iFreeFile = FreeFile
tmpFile_ = GetTempDir & kseSLASH & "kse" & Timer & kseTEMP_EXT
Open tmpFile_ For Output As #iFreeFile

		sNewScript = colSourceName.ItemAt(kseToken(0).iSrc) & kseSCRIPT_SEP
		Dim i As Integer
		trace("refresh " & iTokenCtr)
		For i = 0 To iTokenCtr
			If kseToken(i).iLine > 0 Then
				If kseToken(i).iSrc > iSrc Then
					'store source file
					If (i > 0) Then
						sNewScript = sNewScript & kseSOURCE_SEP & colSourceName.ItemAt(kseToken(i).iSrc) & kseSCRIPT_SEP & kseToken(i).sToken
					Else
						sNewScript = sNewScript & kseToken(i).sToken
					EndIf
					iSrc = kseToken(i).iSrc
					iLine = 1   'reset line numbering to 1
				ElseIf kseToken(i).iLine > iLine Then
					'remove whitespaces before commands
					While Left(sNewScript, 1) = vbTab _
							Or Left(sNewScript, 1) = " "
						sNewScript = Mid(sNewScript,2)
					Wend
					'the Print command adds vbLF which will maintain line numbering
					Print #iFreeFile, Trim(sNewScript & vbCR)
					sNewScript = kseToken(i).sToken
					
					iLine = kseToken(i).iLine
				Else
					sNewScript = sNewScript & kseToken(i).sToken
				End If
			End If
		Next
		If sNewScript <> "" Then Print #iFreeFile, , sNewScript
		
'close refreshed script
Close #iFreeFile
'load refreshed script to buffer
sNewScript=""
Open tmpFile_ For Input As #iFreeFile
    sNewScript = Input(LOF(iFreeFile), iFreeFile)
Close #iFreeFile
trace("?refresh " & sNewScript)
Kill tmpFile_
		
		ProcessScript_fromKS_toKONSL sNewScript
		Exit Sub
ptrErr:
	Engine_ErrMsg Err, "ProcessScript_Refresh"
End Sub

Public Sub ProcessScript_fromKS_toKONSL(sNewScript As String)
	On Error GoTo ptrErr
		Dim iFreeFile As Integer
		Dim sFileNme As String
		Dim sTmpArr() As UByte

		iFreeFile = FreeFile
		'# KONSL 0.04 file compilation algorithm
		'----------------------------------------------------
		'   1. make a file with tmp extension but marked with the file-version verification string
			'sTmpArr = kseKONSL_FILE_MARKER & StrReverse(sNewScript)
			fbStrToArray kseKONSL_FILE_MARKER & StrReverse(sNewScript), sTmpArr()
			sFileNme = CreateTempFile(sTmpArr())
		'----------------------------------------------------
		'   2. compress file with .konsl extension
			Compile sFileNme
		'	   > remove tmp file
				Kill sFileNme
		
		'old aglorithm
		'Open sScriptPath & ".konsl" For Output As iFreeFile
		'	Print #1, StrReverse(sNewScript)
		'Close iFreeFile
		Exit Sub
ptrErr:
	Engine_ErrMsg Err, "ProcessScript_fromKS_toKONSL"
End Sub

Public Sub ProcessScript_Statement_Define()
	Dim i As Integer
	On Error GoTo ptrErr
		i = 0
		trace("?def " & iTokenCtr)
		While i <= iTokenCtr 'UBound(kseToken)
			i = KSE_SkipVoidTokens(i)
				If kseToken(i).sToken = kseNUMBER_SIGN Then
					i = SynNumSign(i)
				'im checking for double quotes because a [keyword/constant/identifier]
				'can be written between two quotes
				ElseIf kseToken(i).sToken = kseDOUBLE_QUOTES Then
					i = SynQuotes(i)
					Dim tmpxxx As String = GetTempString
				End If
			i = i + 1
		Wend
		Exit Sub
ptrErr:
	Engine_ErrMsg Err, "ProcessScript_Statement_Define"
End Sub

Public Sub ProcessScript_PushToken(ByVal pToken As String, ByVal pLine As Integer, ByVal pSrc As Integer, ByRef iToken As Integer)
	/'
	If IsNumeric(pToken) Then
		kseToken(iToken).lCmd = kseVALUE_ISNUMERIC
	ElseIf IsHexic(pToken) Then
		kseToken(iToken).lCmd = kseVALUE_ISHEXIC
	ElseIf IsBooleanic(pToken) Then
		kseToken(iToken).lCmd = kseVALUE_ISBOOLEANIC
	ElseIf pToken = kseDOUBLE_QUOTES Then
		kseToken(iToken).lCmd = kseVALUE_OPT_DOUBLE_QUOTES
	ElseIf pToken = kseOPEN_PAREN Then
		kseToken(iToken).lCmd = kseOPT_OPEN_PARENTHESIS
	ElseIf pToken = kseMINUS_SIGN Then
		kseToken(iToken).lCmd = kseVALUE_OPT_MINUS_SIGN
	ElseIf pToken = kseSEMICOLON Then
		kseToken(iToken).lCmd = kseOPT_SEMICOLON
	ElseIf pToken = kseCLOSE_PAREN Then
		kseToken(iToken).lCmd = kseOPT_CLOSE_PARENTHESIS
	ElseIf pToken = kseCOMMA Then
		kseToken(iToken).lCmd = kseOPT_COMMA
	ElseIf pToken = kseCLOSE_BRACKET Then
		kseToken(iToken).lCmd = kseVALUE_OPT_CLOSE_BRACKET
	ElseIf pToken = ksePERCENT_SIGN Then
		kseToken(iToken).lCmd = kseVALUE_OPT_PERCENT_SIGN
	ElseIf pToken = kseCARET Then
		kseToken(iToken).lCmd = kseVALUE_OPT_CARET
	ElseIf pToken = kseASTERISK Then
		kseToken(iToken).lCmd = kseVALUE_OPT_ASTERISK
	ElseIf pToken = kseFORWARD_SLASH Then
		kseToken(iToken).lCmd = kseVALUE_OPT_FORWARD_SLASH
	ElseIf pToken = ksePLUS_SIGN Then
		kseToken(iToken).lCmd = kseVALUE_OPT_PLUS_SIGN
	EndIf
	'/
	Redim Preserve kseToken(iToken+1) As typeToken
	
	kseToken(iToken).sToken = pToken
	kseToken(iToken).iLine = pLine
	kseToken(iToken).iSrc = pSrc
	
	iToken = iToken + 1
End Sub

Public Sub ProcessScript_Parse(ByRef sScript As String)
	On Error GoTo ptrErr
		Dim sChar As String								'for taking each character from user input
		Dim sToken As String								'for taking each token from user input
		Dim iChar As Integer								'for comparing to ascii values of characters
		Dim iLine As Integer								'for line counting
		Dim iToken As Integer								'for token counting
		Dim sArrScript() As String						'for multiple ".KS" file - script
		Dim sArrSource() As String						'for multiple ".KS" file - filename
		Dim iii As Integer
		Dim ptrProceed As Byte
		
		iToken = 0											'start index at 0 (zero)
		
		iTokenCtr = Len(sScript)						'temporarily, set token counter to highest possible count
		trace("parse A " & iTokenCtr)
		Redim kseToken(0) As typeToken		'then set token array-size on highest possible size
		trace("parse B " & Left(sScript, 250) & "... [trimed --mj]")
		'========================================================================
		'==#the idea is to loop and parse all files w/ ln# and file info ========
		'========================================================================
		sScript = sScript & kseSOURCE_SEP & kseSCRIPT_MARK & kseSCRIPT_SEP	 'add marker
		Split(sScript, kseSOURCE_SEP, sArrSource())
		iii = 0
		
		Do While Left(sArrSource(iii), Len(kseSCRIPT_MARK)) <> kseSCRIPT_MARK
			Split(sArrSource(iii), kseSCRIPT_SEP, sArrScript())
			AddSourceName(sArrScript(0))
			sArrScript(1) = Trim(sArrScript(1))
			
			'Engine_Log "sArrScript(0):" & sArrScript(0)
		
		'========================================================================
			iLine = 1										'start line on 1 (one)
			iTokenCtr = Len(sArrScript(1))			'set token counter to highest possible count
			
			If iTokenCtr = 0 Then
				trace(Left(sScript, 250) & "... [trimed --mj]")
			EndIf
			For i As Integer = 1 To iTokenCtr
				sChar = Mid(sArrScript(1), i, 1)
				iChar = Asc(sChar)
				
				'check if a-z/A-Z/0-9/[underscore]
				If iChar >= 97 And iChar <= 122 _
						Or iChar >= 65 And iChar <= 90 _
						Or iChar >= 48 And iChar <= 57 _
						Or iChar = 95 Then
					sToken = sToken & sChar				'append (numeric) character to sToken
				Else
					'# Whatever value the sChar is holding store it to token array
					'# This is to token a special character, separately
					'________________________________________________________________
					ptrProceed = 0
					If sToken <> "" Then							'check if stoken in not empty
						If IsNumeric(sToken) = 0 Then
							ProcessScript_PushToken(sToken, iLine, iii + 1, iToken)
							sToken = "" 'clear token
						ElseIf iChar = 46 And IsNumeric(sToken) Then		'is char DOT
							sToken = sToken & "."				'then add as decimal point to numeric values
							ptrProceed = 1
						Else
							ProcessScript_PushToken(sToken, iLine, iii + 1, iToken)
							sToken = "" 'clear token
						End If
					ElseIf iToken > 0 Then
						If (kseToken(iToken - 1).sToken = "<" Or _
								kseToken(iToken - 1).sToken = kseEXCLAMATION_POINT Or _
								kseToken(iToken - 1).sToken = kseEQUAL_SIGN Or _
								kseToken(iToken - 1).sToken = ">") And iChar = 61 Then   'is char `EQUAL SIGN'
							'08.25.06 - attempt to use C comparison operators --mj
							sChar = kseToken(iToken - 1).sToken & sChar
							kseToken(iToken - 1).sToken = " " 'this should be SPACE (try empty string to see the bug)
						End If
					Else
						'do nothing
					End If
					
					If ptrProceed = 0 Then
						'# If the special character is same to vbCrLf, token a [space]
						If iChar = 13 And i < Len(sScript) Then
							If Asc(Mid(sArrScript(1), i + 1, 1)) = 10 Then '10 is vbLF
								i = i + 1
							Else
								'Previously, only vbCRLF is being considered as new line.
								'This should let vbCr (UNIX line end) alone will be considered too.
							End If
							ProcessScript_PushToken(" ", iLine, iii + 1, iToken)
							'I used SPACE as Token because Quixie
							'will snob it anyway. my purpose is to
							'maintain the integrity of line error once
							iLine = iLine + 1 'source code is pseudo-compiled --Mj
						ElseIf iChar = 10 Then '10 is vbLF
							'added to fix CHR(10) escaping from screening
							ProcessScript_PushToken(" ", iLine, iii + 1, iToken)
							'I used SPACE as Token because Quixie
							'will snob it anyway. my purpose is to
							'maintain the integrity of line error once
							iLine = iLine + 1 'source code is pseudo-compiled --Mj
						Else
							'if not, put sChar
							ProcessScript_PushToken(sChar, iLine, iii + 1, iToken)
							sToken = "" 'clear token
						End If
					End If
				End If
			Next
			
			' # added to fix logic error in parsing
			If sToken <> "" Then                 'check if stoken in not empty
				ProcessScript_PushToken(sToken, iLine, iii + 1, iToken)
				sToken = ""
			End If
		'========================================================================
			iii = iii + 1
		Loop
		'========================================================================
		'========================================================================
		iTokenCtr = iToken									'reset token counter
		If iShowScript = 1 And InStr(1, LCase(sStartScript), ".kh") = 0 Then
			SneakScript
		EndIf
		
		ProcessScript_CheckSyntax
		Exit Sub
ptrErr:
	Engine_ErrMsg Err, "ProcessScript_Parse"
End Sub

Public Sub ProcessScript_ReadCompiled()
	On Error GoTo ptrErr
		If IsLaunchedByFile = 1 Then
			If UCase(Right(sgblCmd, 4)) = ".KON" Then
				'KON~ part
				If Dir(sScriptPath) = "" Then
					Engine_Message "Unable to find starting script file" & vbCrLf & _
								   "(  " & sScriptPath & "  <p_rc:kon>)."
					Engine_Exit
				End If
			ElseIf UCase(Right(sgblCmd, 6)) = ".KONSL" Then
				'KONSL part
				If Dir(sScriptPath) = "" Then
					Engine_Message "Unable to find starting script file" & vbCrLf & _
								   "(  " & sScriptPath & "  <p_rc:konsl>)."
					Engine_Exit
				End If
			ElseIf UCase(Right(sgblCmd, 3)) = ".KS" Then
				'KS part
				If Dir(sScriptPath & ".ks") = "" And Right(sScriptPath, 8) <> "index.ks" Then
					Engine_Message "Unable to find starting script file" & vbCrLf & _
									"(  " & sScriptPath & ".ks  <p_rc:ks1>)."
				ElseIf Dir(sScriptPath & ".ks") = "" Then
					If Dir(sScriptPath) = "" Then
						Engine_Message "Unable to find starting script file " & vbCrLf & vbCrLf & _
										sScriptPath & ".ks <p_rc:ks2>"
					Else
						Engine_Message "Unable to find starting script file" & vbCrLf & _
										"(  " & sScriptPath & "  <p_rc:ks3>)."
					End If
				End If
			Else
				'KH part
				If Dir(sScriptPath & ".kh") = "" Then
					Engine_Message "Unable to find starting script file" & vbCrLf & _
								   "(  " & sScriptPath & "  <p_rc:kh>)."
					Engine_Exit
				End If
			End If
		Else
			'Print "sScriptPath : " & sScriptPath
			If Dir(sScriptPath & ".konsl") = "" Then
				Engine_Message "Unable to find starting script file" & vbCrLf & _
							   "(  " & sScriptPath & ".KONSL  )."
				Engine_Exit
			End If
		End If
		
		ProcessScript_fromKONSL_toKS
		
		'clean up the collection
		For i As Integer = 1 To colSourceName.Count()
			colSourceName.RemoveAt(0)
		Next
		Exit Sub
ptrErr:
	Engine_ErrMsg Err, "ProcessScript_ReadCompiled"
End Sub

Public Sub SneakScript()
	Dim iFreeFile As Integer
	
	'# idea is to show all token
'	Print String(20, "-")
	
	iFreeFile = FreeFile
	Open sKonsolPath & kseSLASH & "parsed-" & sStartScript & ".log" For Output As #iFreeFile
		Print #iFreeFile, String(20, "-")
		Print #iFreeFile, "INDEX" & vbTab & "LINE #" & vbTab & "TOKEN"
		For i As Integer = 0 To iTokenCtr
		   
			If kseToken(i).iLine > 0 Then						'check if current token array-index was used
'				Print "[" & kseToken(i).iLine & "]" & vbTab & ", " & vbTab & ">> " & i & " [" & kseToken(i).sToken & "]" 'if so, show token
				
				Print #iFreeFile, i & vbTab & kseToken(i).iLine & vbTab & " [" & kseToken(i).sToken & "]"   'if so, show token
				'Print #iFreeFile, kseToken(i).sToken
			Else
				Exit For										'if not, exit loop
			End If
		Next
		Print #iFreeFile, String(20, "-")
	Close #iFreeFile
'	Print String(20, "-")
End Sub

Private Function SynNumSign(ByRef iIndex As Long) As Integer
	iIndex = iIndex + 1
	If kseToken(iIndex).sToken = "include" Then
		
		iIndex = NumSign_Include(iIndex)
		
	ElseIf kseToken(iIndex).sToken = "define" Then
		If bKONSoLE_DeclaringVar Then
			'#idea is to process only if all KS are loaded.
			iIndex = NumSign_Define(iIndex)
		End If
		
	ElseIf kseToken(iIndex).sToken = kseEXCLAMATION_POINT Then
		'cgi support
		Dim tmp As Integer
		Dim ln As Integer
		Dim i As Integer
		tmp = iIndex-1 'go back to #; before !
		
		ln = kseToken(i).iLine
		For i = tmp To iTokenCtr
			If kseToken(i).iLine = ln Then
				kseToken(i).sToken = kseNULL_STRING
			End If
		Next
		
		ProcessScript_Refresh
		ProcessScript_ReadCompiled
		'sKONSoL = sKONSoL & kseSOURCE_SEP & sFileName & kseSCRIPT_SEP & sFileScript
		
		ProcessScript_Parse sKONSoL
		ProcessScript_CleanUp
		
		iIndex = -1
	Else
		Engine_Message KSE_GetErrFileSrc(iIndex) & "Expecting (  #include  ) but got (  #" & KSE_GetToken(iIndex) & "  ) instead.", "SYNTAX ERROR AT LINE " & kseToken(iIndex).iLine
		Engine_Exit
	End If
	Return iIndex
End Function

Private Function NumSign_Define(ByRef iIndex As Long) As Integer
	Dim iFreeFile As Integer
	Dim sFileScript As String
	Dim iDefine As Integer
	Dim iFind As Integer
	Dim sReplace As String
	Dim iEndDefineStatement As Integer
	Dim iLn As Integer   'to implement macros
	Dim iNumSign As Integer
	iNumSign = iIndex - 1
	iDefine = iIndex
	
	iIndex = GetNextIndex(iIndex)
	iFind = iIndex	   'get index of what to find
	
	
	iLn = kseToken(iIndex).iLine
	iIndex = GetNextIndex(iIndex)
	While iLn = kseToken(iIndex).iLine
		'# idea is to get the provided macro
		sReplace = sReplace & kseToken(iIndex).sToken
		iIndex = iIndex + 1
	Wend
	iIndex = iIndex - 1 'move back token-pointer
	'
	If sReplace = "" Then
		Engine_Message KSE_GetErrFileSrc(iIndex) & "Please specify any (  define value  ).", "ERROR AT LINE " & kseToken(iIndex).iLine & "."
		Engine_Exit
	End If
	
	iEndDefineStatement = iIndex
	'clean up the [#define statement] to avoid defining again
	kseToken(iNumSign).sToken = kseSPACE  'I placed a [space] to maintain the line numbering
	kseToken(iDefine).sToken = " "
	For i As Integer = iDefine To iEndDefineStatement
		If iFind <> i Then
			kseToken(i).sToken = " "
		End If
	Next
	Engine_Log " >> Defining: " & kseToken(iFind).sToken
	For i As Integer = 0 To iTokenCtr
		If iFind <> i Then
			If kseToken(i).sToken = kseToken(iFind).sToken Then
				kseToken(i).sToken = sReplace
			End If
		End If
	Next
	
	kseToken(iFind).sToken = " "
	
	're-start the script process by refreshing the tokens
	ProcessScript_Refresh
	ProcessScript_ReadCompiled
	'sKONSoL = sKONSoL & kseSOURCE_SEP & sFileName & kseSCRIPT_SEP & sFileScript
	
	ProcessScript_Parse sKONSoL
	ProcessScript_CleanUp
		
	Return	 -1				 'restart interpreting
End Function

Private Function NumSign_Include(ByRef iIndex As Long) As Integer
	Dim iFreeFile As Integer
	Dim sFileScript As String
	Dim sPath As String
	Dim iInclude As Integer
	Dim iNumSign As Integer
	Dim iDblQuote1 As Integer
	Dim iDblQuote2 As Integer
	Dim iLen As Integer
	
	iNumSign = iIndex - 1
	iInclude = iIndex
	
	iIndex = GetNextIndex(iIndex)
	
	iIndex = LookFor(kseDOUBLE_QUOTES, "include", iIndex)   'look for	   (
	iDblQuote1 = iIndex
	
		iIndex = SynQuotes(iIndex)
		iDblQuote2 = iIndex
		'get the string value
		Dim sFileName As String = GetTempString
	
	'check for same file
	For i As Integer = 1 To colSourceName.Count()
	   
		If sFileName = colSourceName.ItemAt(i) Then
			Engine_Log vbTab & "Warning: (  " & colSourceName.ItemAt(kseToken(iDblQuote1).iSrc) & "  ) is trying to include" & vbCrLf & _
					   vbTab & "(  " & sFileName & "  ) which conflicts other included files."
			CleanIncludeStatement iNumSign, iInclude, iDblQuote1, iDblQuote2
			NumSign_Include = -1				 'restart interpreting
			Exit Function
		End If
	Next
	'Print "#including " & """" & sFileName & """"
	If LCase(Right(sFileName, 4)) <> ".ksl" _
			And LCase(Right(sFileName, 3)) <> ".ks" _
			And LCase(Right(sFileName, 3)) <> ".kh" _
			And InStr(1, sFileName, ".") > 0 Then
		Engine_Message KSE_GetErrFileSrc(iDblQuote1) & "Can only include files with" & vbCrLf & _
			   " (  .KS, .KH and .KSL  ) extension.", "SYNTAX ERROR AT LINE " & kseToken(iDblQuote1).iLine
		Engine_Exit
	End If
	
	If Dir(sKonsolPath & kseSLASH & sFileName) <> "" _
			Or Dir(sKonsolPath & kseSLASH & sFileName & ".ksl") <> "" Then
		sPath = sKonsolPath & kseSLASH
	'check if file is in "INCLUDE" dir of Quixie path
	ElseIf Dir(App_Path & kseSLASH & "include" & kseSLASH & sFileName) <> "" _
			Or Dir(App_Path & kseSLASH & "include" & kseSLASH & sFileName & ".ksl") <> "" Then
		sPath = App_Path & kseSLASH & "include" & kseSLASH
	Else
		Engine_Message KSE_GetErrFileSrc(iDblQuote1) & "Unable to find Source file (  " & sFileName & "  )" & vbCrLf & _
					   "either from (  INCLUDE Directory  )" & vbCrLf & _
					   "or from (  " & sKonsolPath & "  )", "ERROR AT LINE " & kseToken(iDblQuote1).iLine
		Engine_Exit
	End If
	
	'basically, the code will not reach this point if the [include "file"] 'is already included' or 'is missing'
	'that is why, we need to simply add the file to main KS
	iFreeFile = FreeFile
	If LCase(Right(sFileName, 3)) = ".ks" _
			Or LCase(Right(sFileName, 3)) = ".kh" Then
		'if file is not compiled, simply read content
		Open sPath & sFileName For Input As #iFreeFile
			sFileScript = Input(LOF(iFreeFile), #iFreeFile)
		Close #iFreeFile
	'again, I used "else" since any type of file ext are already screened
	Else
		'if user includes [.KSL], user is including a compiled KH file :)
		'07.03.06 - compiled KS, KONSL file, cannot be included anymore.
		Dim sFNVal() As String
		Split(sFileName, kseSLASH, sFNVal())
		If InStr(1, sFileName, ".") = 0 Then
			'implementing implicit adding of word '.KSL' in include statement
			sFileScript = ProcessScript_Include_KSL(sPath & sFileName)
			
			'remove the [trailing File marker] from the left most part of the script
			'NOTE: the [File marker] came from writing the compiled source code
			'iLen = Len(sFNVal(UBound(sFNVal())) & kseSCRIPT_SEP & kseSOURCE_SEP & sFNVal(UBound(sFNVal())) & kseSCRIPT_SEP) + 9
			iLen = Len(sFNVal(UBound(sFNVal)) & kseSCRIPT_SEP & kseSOURCE_SEP & sFNVal(UBound(sFNVal)) & kseSCRIPT_SEP) + 7 '6 (two '.KH') + 1 (next char)
			If InStr(1, UCase(sFileScript), UCase(sFNVal(UBound(sFNVal)) & ".KH")) < iLen Then
				sFileScript = Mid(sFileScript, iLen)
			Else
				MsgBox "edit me:think of message", "NumSign_Include a" & InStr(1, UCase(sFileScript), UCase(sFNVal(UBound(sFNVal)) & ".KH"))
			End If
		Else
			sFileScript = ProcessScript_Include_KSL(sPath & Left$(sFileName, Len(sFileName) - Len(".ksl")))
			
			'remove the [trailing File marker] from the left most part of the script
			'NOTE: the [File marker] came from writing the compiled source code
			iLen = Len(kseSOURCE_SEP & sFNVal(UBound(sFNVal)) & kseSCRIPT_SEP & sFNVal(UBound(sFNVal)) & kseSCRIPT_SEP) + 2
			
			If InStr(1, sFileScript, sFNVal(UBound(sFNVal))) < iLen Then
				sFileScript = Mid(sFileScript, iLen)
			Else
				MsgBox "edit me:think of message", "NumSign_Include b"
			End If
		End If
	End If

	'clean up the [include statement] to avoid including the same file again
	CleanIncludeStatement iNumSign, iInclude, iDblQuote1, iDblQuote2
	
	're-start the script process by refreshing the tokens
	ProcessScript_Refresh
	ProcessScript_ReadCompiled
	'add the included script
	sKONSoL = sKONSoL & kseSOURCE_SEP & sFileName & kseSCRIPT_SEP & sFileScript
	'parse the new script
	ProcessScript_Parse sKONSoL
	'refresh again to have a compiled-script with the included-script added
	ProcessScript_Refresh
	ProcessScript_ReadCompiled
	're-parse the new script
	ProcessScript_Parse sKONSoL
	
	ProcessScript_CleanUp
		
	Return -1 'restart interpreting
End Function

Private Sub CleanIncludeStatement(iNumSign As Integer, iInclude As Integer, iDblQuote1 As Integer, iDblQuote2 As Integer)
	kseToken(iNumSign).sToken = kseSPACE  'I placed a [space] to maintain the line numbering
	kseToken(iInclude).sToken = " "
	kseToken(iDblQuote1).sToken = " "
	kseToken(iDblQuote2).sToken = " "
	For i As Integer = iDblQuote1 To iDblQuote2
		kseToken(i).sToken = " "
	Next
End Sub
	
Public Sub ProcessScript_CheckSyntax()
	'attempt to check on basic syntax this 08.11.06 -- Mj Mendoza IV
	'On Error GoTo ptrErr
	
		Dim iParCtr As Integer
		Dim iCurlCtr As Integer
		Dim iBrkCtr As Integer
		Dim i As Integer
		Dim ii As Integer
		'remove all user's-comments
		Dim tmpxxx As String
		Dim ln as Integer
		Dim tmp as Integer
		For i = 0 To iTokenCtr
		   
			If kseToken(i).iLine > 0 Then
				i = KSE_SkipVoidTokens(i)
					If kseToken(i).sToken = kseNUMBER_SIGN Then
						ln = kseToken(i).iLine
						tmp = i
						For i = tmp To iTokenCtr
							If kseToken(i).iLine > ln Then
								tmp = i
								i = iTokenCtr
							End If
						Next
						i= tmp
					ElseIf kseToken(i).sToken = kseFORWARD_SLASH Then
						If kseToken(i + 1).sToken = kseFORWARD_SLASH _
								Or kseToken(i + 1).sToken = kseASTERISK Then
							i = SynComment(i, iParCtr)
						End If
					ElseIf kseToken(i).sToken = kseTAB Then
						kseToken(i).lCmd = -1
						kseToken(i).sToken = kseSPACE
					'im checking for double quotes because a [keyword/constant/identifier]
					'can be written between two quotes
					ElseIf kseToken(i).sToken = kseDOUBLE_QUOTES Then
						kseToken(i).lCmd = kseVALUE_OPT_DOUBLE_QUOTES
						i = SynQuotes(i)
						tmpxxx = GetTempString()
						'trace "tmpxxx " & tmpxxx
/'
		ElseIf IsTokenNum(i) Then
			kseToken(i).lCmd = kseVALUE_ISTOKENNUM
		ElseIf IsTokenNum2(i) Then
			kseToken(i).lCmd = kseVALUE_ISTOKENNUM2
		ElseIf IsTokenStr(i) Then
			kseToken(i).lCmd = kseVALUE_ISTOKENSTR
		ElseIf IsTokenStr2(i) Then
			kseToken(i).lCmd = kseVALUE_ISTOKENSTR2
		ElseIf IsTokenArray(i) Then
			kseToken(i).lCmd = kseVALUE_ISTOKENARRAY
		ElseIf IsTokenUDT(i) Then
			kseToken(i).lCmd = kseVALUE_ISTOKENUDT
		ElseIf IsTokenUDT2(i) Then
			kseToken(i).lCmd = kseVALUE_ISTOKENUDT2
		ElseIf IsTokenFunction(i) Then
			kseToken(i).lCmd = kseVALUE_ISTOKENFUNCTION
		ElseIf IsTokenFunction2(i) Then
			kseToken(i).lCmd = kseVALUE_ISTOKENFUNCTION2
'/
					'im checking for equal sign since 0.0.95 is capable of [x = 6 + 1 / (8 / 24);]
					'and / can be written as divide symbol in the equation
					ElseIf kseToken(i).sToken = kseEQUAL_SIGN Then
						kseToken(i).lCmd = kseVALUE_OPT_EQUAL_SIGN
						For ii = i To iTokenCtr
							ii = GetNextIndex(ii)
							'Debug.Print ">>" & ii & vbTab & kseToken(ii).sToken
							If kseToken(ii).sToken = kseSEMICOLON Then
								kseToken(ii).lCmd = kseOPT_SEMICOLON
								i = ii
								Exit For
							ElseIf kseToken(ii).sToken = kseTAB Then
								kseToken(i).lCmd = -1
								kseToken(ii).sToken = kseSPACE
							ElseIf kseToken(ii).sToken = kseFORWARD_SLASH Then
								kseToken(ii).lCmd = kseVALUE_OPT_FORWARD_SLASH
								'check if comment
								If kseToken(ii + 1).sToken = kseFORWARD_SLASH _
										Or kseToken(ii + 1).sToken = kseASTERISK Then
									ii = SynComment(ii, iParCtr)
								End If
							'im trying to count PARENTHESIS, CURLY BRACES & BRACKETS in pair
							ElseIf kseToken(ii).sToken = kseOPEN_PAREN Then
								kseToken(ii).lCmd = kseOPT_OPEN_PARENTHESIS
								iParCtr = iParCtr + 1
							ElseIf kseToken(ii).sToken = kseCLOSE_PAREN Then
								kseToken(ii).lCmd = kseOPT_CLOSE_PARENTHESIS
								iParCtr = iParCtr - 1
								If iParCtr < 0 Then
									Engine_Message "Unexpected (  Close Parenthesis  ).", "ERROR AT LINE " & kseToken(ii).iLine
								End If
							ElseIf kseToken(ii).sToken = kseOPEN_CURL Then
								kseToken(ii).lCmd = kseOPT_OPEN_CURL
								iCurlCtr = iCurlCtr + 1
							ElseIf kseToken(ii).sToken = kseCLOSE_CURL Then
								kseToken(ii).lCmd = kseOPT_CLOSE_CURL
								iCurlCtr = iCurlCtr - 1
								If iCurlCtr < 0 Then
									Engine_Message "Unexpected (  Close Curly Braces  ).", "ERROR AT LINE " & kseToken(ii).iLine
								End If
							ElseIf kseToken(ii).sToken = kseOPEN_BRACKET Then
								kseToken(ii).lCmd = kseOPT_OPEN_BRACKET
								iBrkCtr = iBrkCtr + 1
							ElseIf kseToken(ii).sToken = kseCLOSE_BRACKET Then
								kseToken(ii).lCmd = kseOPT_CLOSE_BRACKET
								iBrkCtr = iBrkCtr - 1
								If iBrkCtr < 0 Then
									Engine_Message "Unexpected (  Close Bracket  ).", "ERROR AT LINE " & kseToken(ii).iLine
								End If
							ElseIf kseToken(ii).sToken = "else" Then
								ii = GetPrevIndex(ii)
									If kseToken(ii).sToken <> kseCLOSE_CURL Then
										Engine_Message KSE_GetErrFileSrc(ii) & "Expecting (  }  ) after (  else  ) but got (  " & KSE_GetToken(ii) & "  ) instead." & vbCrLf & _
											String(61, kseMINUS_SIGN) & vbCrLf & _
											"Your code is:       " & KSE_GetToken(ii) & " else " & vbCrLf & _
											"Code should be:     } else", "SYNTAX ERROR AT LINE " & kseToken(ii).iLine
									End If
								ii = GetNextIndex(ii)
							End If
							ii = ii - 1
						Next
						i = ii
					'im trying to count PARENTHESIS, CURLY BRACES & BRACKETS in pair
					ElseIf kseToken(i).sToken = kseOPEN_PAREN Then
						kseToken(i).lCmd = kseOPT_OPEN_PARENTHESIS
						iParCtr = iParCtr + 1
					ElseIf kseToken(i).sToken = kseCLOSE_PAREN Then
						kseToken(i).lCmd = kseOPT_CLOSE_PARENTHESIS
						iParCtr = iParCtr - 1
						If iParCtr < 0 Then
							Engine_Message KSE_GetErrFileSrc(i) & "Unexpected (  Close Parenthesis  ).", "ERROR AT LINE " & kseToken(i).iLine
						End If
					ElseIf kseToken(i).sToken = kseOPEN_CURL Then
						kseToken(i).lCmd = kseOPT_OPEN_CURL
						iCurlCtr = iCurlCtr + 1
					ElseIf kseToken(i).sToken = kseCLOSE_CURL Then
						kseToken(i).lCmd = kseOPT_CLOSE_CURL
						iCurlCtr = iCurlCtr - 1
						If iCurlCtr < 0 Then
							Engine_Message KSE_GetErrFileSrc(i) & "Unexpected (  Close Curly Brace  ).", "ERROR AT LINE " & kseToken(i).iLine
						End If
					ElseIf kseToken(i).sToken = kseOPEN_BRACKET Then
						kseToken(i).lCmd = kseOPT_OPEN_BRACKET
						iBrkCtr = iBrkCtr + 1
					ElseIf kseToken(i).sToken = kseCLOSE_BRACKET Then
						kseToken(i).lCmd = kseOPT_CLOSE_BRACKET
						iBrkCtr = iBrkCtr - 1
						If iBrkCtr < 0 Then
							Engine_Message KSE_GetErrFileSrc(i) & "Unexpected (  Close Bracket  ).", "ERROR AT LINE " & kseToken(i).iLine
						End If
					ElseIf kseToken(i).sToken = "else" Then
				      i = GetPrevIndex(i)
				      If kseToken(i).sToken <> kseCLOSE_CURL Then
				         Engine_Message KSE_GetErrFileSrc(i) & "Expecting (  }  ) after (  else  ) but got (  " & KSE_GetToken(i) & "  ) instead." & vbCrLf & _
				            String(61, kseMINUS_SIGN) & vbCrLf & _
				            "Your code is:       " & KSE_GetToken(i) & " else " & vbCrLf & _
				            "Code should be:     } else", "SYNTAX ERROR AT LINE " & kseToken(i).iLine
				      End If
				      i = GetNextIndex(i)
					End If
			End If
		Next
		
		i = i - 2 'bug fix
		If iParCtr > 0 Then
			Engine_Message KSE_GetErrFileSrc(i) & "Missing (  Close Parenthesis  ).", "ERROR AT LINE " & kseToken(i).iLine
			Engine_Exit
		ElseIf iCurlCtr > 0 Then
			Engine_Message KSE_GetErrFileSrc(i) & "Missing (  Close Curly Brace  ).", "ERROR AT LINE " & kseToken(i).iLine
			Engine_Exit
		ElseIf iBrkCtr > 0 Then
			Engine_Message KSE_GetErrFileSrc(i) & "Missing (  Close Bracket  ).", "ERROR AT LINE " & kseToken(i).iLine
			Engine_Exit
		End If

		Exit Sub
ptrErr:
	Engine_ErrMsg Err, "ProcessScript_CheckSyntax"
End Sub
