//translated this 18.06.10 by mjmendozaIV
#include "../../kage.hpp"
#include "../../kageExterns.hpp"

//NOTE: this file consists all functions used by engine to process script.
//to keep this project manageable, I placed all script-processing functions
//from modKONSoL_Main to this file.		  08.06.06
//										   --Mj Mendoza IV

void ProcessScript_CleanUp() {
	unsigned long i, ii;
	string l_sTmp;
	int l_paren = 0;
	//remove all user's-comments
	for (i = 0; i < iTokenCtr; ++i) {
		if (kseToken[i].iLine > 0) {
			i = KSE_SkipVoidTokens(i);
				if (kseToken[i].sToken == kseOPEN_PAREN) {
					//disregard slash until kseCLOSE_PAREN is found; but /* this */ should be allowed
					++l_paren;
				} else if (kseToken[i].sToken == kseCLOSE_PAREN && l_paren > 1) {
					--l_paren;
				} else if (kseToken[i].sToken == kseFORWARD_SLASH) {
					if (kseToken[i + 1].sToken == kseFORWARD_SLASH
							|| kseToken[i + 1].sToken == kseASTERISK) {
						i = SynComment(i, l_paren);
					}
				} else if (kseToken[i].sToken == kseTAB) {
					kseToken[i].sToken = kseSPACE;
				//im checking for double quotes because a [keyword/constant/identifier]
				//can be written between two quotes
				} else if (kseToken[i].sToken == kseDOUBLE_QUOTES) {
					i = SynQuotes(i);
					string tmpxxx = GetTempString();
				//im checking for equal sign since 0.0.95 is capable of [x = 6 + 1 / (8 / 24);]
				//and / can be written as divide symbol in the equation
				} else if (kseToken[i].sToken == kseEQUAL_SIGN) {
					for (ii = i; ii < iTokenCtr; ++ii) {
						ii = GetNextIndex(ii);
						//cout << ">>" + ii + "\t" + kseToken[ii].sToken
						if (kseToken[ii].sToken == kseSEMICOLON) {
							i = ii;
							break;
						} else if (kseToken[ii].sToken == kseFORWARD_SLASH) {
							//check if comment
							if (kseToken[ii + 1].sToken == kseFORWARD_SLASH
									|| kseToken[ii + 1].sToken == kseASTERISK) {
								ii = SynComment(ii, l_paren);
							}
						//im trying to change KONSoL constants
						} else if (kseToken[ii].sToken == kseSCREEN) {
							kseToken[ii].sToken = "0";
						} else if (kseToken[ii].sToken == kseTRUE) {
							kseToken[ii].sToken = "1";
						} else if (kseToken[ii].sToken == kseFALSE) {
							kseToken[ii].sToken = "0";
						} else if (kseToken[ii].sToken == ksePATH) {
							l_sTmp = kseDOUBLE_QUOTES + sKonsolPath + kseDOUBLE_QUOTES;       //directory has backslash
							l_sTmp = Replace(l_sTmp, kseSLASH, "\\");  //backslash is an escape char  
							kseToken[ii].sToken = l_sTmp;
						} else if (kseToken[ii].sToken == ksePTR_APPEND) {
							kseToken[ii].sToken = "0";
						} else if (kseToken[ii].sToken == "nochar") {
							kseToken[ii].sToken = "256";
						}
						--ii;
					}
					i = ii;
				//im trying to change KONSoL constants
				} else if (kseToken[i].sToken == kseSCREEN) {
					kseToken[i].sToken = "0";
				} else if (kseToken[i].sToken == kseTRUE) {
					kseToken[i].sToken = "1";
				} else if (kseToken[i].sToken == kseFALSE) {
					kseToken[i].sToken = "0";
				} else if (kseToken[i].sToken == ksePATH) {
					l_sTmp = kseDOUBLE_QUOTES + sKonsolPath + kseDOUBLE_QUOTES;       //directory has backslash
					l_sTmp = Replace(l_sTmp, kseSLASH, "\\");  //backslash is an escape char  
					kseToken[i].sToken = l_sTmp;
				} else if (kseToken[i].sToken == ksePTR_APPEND) {
					kseToken[i].sToken = "0";
				} else if (kseToken[i].sToken == "nochar") {
					kseToken[i].sToken = "256";
				}
		}
	}
	return;
}

void ProcessScript_Statement_Include() {
	//will include files based from [#include "myFile"] statement
	//insert all files included by the user
	for (unsigned long i = 0; i < iTokenCtr; ++i) {
		if (kseToken[i].iLine > 0) {
			i = KSE_SkipVoidTokens(i);
				//im checking for double quotes because a [keyword/constant/identifier]
				//can be written between two quotes
				if (kseToken[i].sToken == kseDOUBLE_QUOTES) {
					i = SynQuotes(i);
					/*string tmpxxx = */GetTempString();
				//im trying to look for [include]
				} else if (kseToken[i].sToken == kseNUMBER_SIGN) {
					i = SynNumSign(i);
				}
		}
	}
}

void ProcessScript_fromKONSL_toKS() {
	
	string sFileNme = "";
		
	//# KONSL 0.04 file decompilation algorithm
	//----------------------------------------------------
	//   1. decompile file
		sFileNme = zlibUncompress(sScriptPath);
	//----------------------------------------------------
	//   2. read the tmp file
		sKONSoL = fileOpen(sFileNme);
		//sKONSoL = sContent
	//	   > remove tmp file
			remove(sFileNme.c_str());
	//	   > verify .konsl file version
			if (Val(Right(Mid(sKONSoL, 0, kseKONSL_FILE_MARKER.length()), 4)) < Val(Right(kseKONSL_FILE_MARKER, 4))) {
				Engine_Message("Please recompile\r\n(  " + sScriptPath + "  )", "Deprecated KONSL File");
				Engine_Exit();
			} else if (Left(sKONSoL, kseKONSL_FILE_MARKER.length()) != kseKONSL_FILE_MARKER) {
				Engine_Message("Unable to process (  " + sFileNme + ".KONSL  ).");
				Engine_Exit();
			}
	//----------------------------------------------------
	//   3. remove file-version verification string then
		sKONSoL = Mid(sKONSoL, kseKONSL_FILE_MARKER.length());
		sFileNme = zlibUncompress(sScriptPath);
		remove(sFileNme.c_str());
		sKONSoL = StrReverse(sKONSoL); //we skipped ___ chars; it is the vbCRLF//this line is under debugging
}

string ProcessScript_Include_KSL(string sKONSL_FileName) {
	string sFileNme;
	
	//# KONSL 0.04 file decompilation algorithm
	//----------------------------------------------------
	//   1. decompile file	
	Engine_Log("sKONSL_FileName:" + sKONSL_FileName);
		sFileNme = zlibUncompress(sKONSL_FileName);
	//----------------------------------------------------
	//   2. read the tmp file
		sKONSoL = fileOpen(sFileNme);
	//	   > remove tmp file
			remove(sFileNme.c_str());
	//	   > verify .konsl file version
	Engine_Log(" : " + Mid(sKONSoL, 1, kseKONSL_FILE_MARKER.length()));
			if (Val(Right(Mid(sKONSoL, 1, kseKONSL_FILE_MARKER.length()), 4)) < Val(Right(kseKONSL_FILE_MARKER, 4))) {
				Engine_Message("Please recompile\r\n(  " + sScriptPath + "  )", "Deprecated KONSL File");
				Engine_Exit();
			} else if (Left(sKONSoL, kseKONSL_FILE_MARKER.length()) != kseKONSL_FILE_MARKER) {
				Engine_Message("Unable to process (  " + sFileNme + ".KSL  ).");
				Engine_Exit();
			}
	//----------------------------------------------------
	//   3. remove file-version verification string then
		sKONSoL = Mid(sKONSoL, kseKONSL_FILE_MARKER.length());
		sFileNme = zlibUncompress(sScriptPath);
		remove(sFileNme.c_str());
	string zxc = sKONSoL;
		
	zxc = StrReverse(zxc);
	//Engine_Log("Rev" + String(20,"~") + "\r\n" + zxc
	return zxc;
}

void ProcessScript_Refresh() {
	string sNewScript;
	
	unsigned long iLine;
	unsigned long iSrc;
	iLine = 1;
	iSrc = 0;
	
	string tmpFile_ = GetTempDir() + kseSLASH + "kse" + /*Timer*/ Str(kseCurrentTime()) + kseTEMP_EXT; // [QuixiePP] recreate FreeBasic's Timer

	std::ofstream ofsRefresh;
	ofsRefresh.open(tmpFile_, ios::out | ios::binary);

	sNewScript = kseSourceFiles[kseToken[0].iSrc] + kseSCRIPT_SEP;
	unsigned long i;
	trace("refresh " + iTokenCtr);
	for (i = 0; i < iTokenCtr; ++i) {
		if (kseToken[i].iLine > 0) {
			if (kseToken[i].iSrc > iSrc) {
				//store source file
				if (i > 0) {
					sNewScript += (kseSOURCE_SEP + kseSourceFiles[kseToken[i].iSrc] + kseSCRIPT_SEP + kseToken[i].sToken);
				} else {
					sNewScript += kseToken[i].sToken;
				}
				iSrc = kseToken[i].iSrc;
				iLine = 1;   //reset line numbering to 1
			} else if (kseToken[i].iLine > iLine) {
				//remove whitespaces before commands
				while (Left(sNewScript, 1) == "\t"
						|| Left(sNewScript, 1) == " ") {
					sNewScript = Mid(sNewScript, 1);
				}
				//the Print command adds vbLF which will maintain line numbering
				ofsRefresh << Trim(sNewScript + "\r") << endl;
				sNewScript = kseToken[i].sToken;
				
				iLine = kseToken[i].iLine;
			} else {
				sNewScript = sNewScript + kseToken[i].sToken;
			}
		}
	}
	if (sNewScript != "") { ofsRefresh << sNewScript << endl; }
	
	//close refreshed script
	ofsRefresh.close();
	//load refreshed script to buffer
	sNewScript = fileOpen(tmpFile_);
	trace("?refresh " + sNewScript);
	remove(tmpFile_.c_str());
	
	ProcessScript_fromKS_toKONSL(sNewScript);
}

void ProcessScript_fromKS_toKONSL(string sNewScript) {
	string sFileNme;
	vector<unsigned char> sTmpArr;
	
	//# KONSL 0.04 file compilation algorithm
	//----------------------------------------------------
	//   1. make a file with tmp extension but marked with the file-version verification string
		//sTmpArr = kseKONSL_FILE_MARKER + StrReverse(sNewScript)
		sFileNme = CreateTempFile(kseKONSL_FILE_MARKER + StrReverse(sNewScript));
	//----------------------------------------------------
	//   2. compress file with .konsl extension
		zlibCompress(sFileNme);
	//	   > remove tmp file
			remove(sFileNme.c_str());
		
	//old aglorithm
	//ofstream tempFile;
	//tempFile.open (sScriptPath + ".konsl", ios::out | ios::app | ios::binary);
	//	tempFile << StrReverse(sNewScript)
	//tempFile.close();
}

void ProcessScript_Statement_Define() {
	unsigned long i = 0;
	trace("?def " + iTokenCtr);
	while (i < kseToken.size()) {
		i = KSE_SkipVoidTokens(i);
			if (kseToken[i].sToken == kseNUMBER_SIGN) {
				i = SynNumSign(i);
			//im checking for double quotes because a [keyword/constant/identifier]
			//can be written between two quotes
			} else if (kseToken[i].sToken == kseDOUBLE_QUOTES) {
				i = SynQuotes(i);
				/*string tmpxxx = */GetTempString();
			}
		++i;
	}
	return;
}

void ProcessScript_PushToken(string pToken, int pLine, int pSrc, unsigned long &iToken) {
	/*
	if (IsNumeric(pToken)) {
		kseToken[iToken].lCmd = kseVALUE_ISNUMERIC;
	} else if (IsHexic(pToken)) {
		kseToken[iToken].lCmd = kseVALUE_ISHEXIC;
	} else if (IsBooleanic(pToken)) {
		kseToken[iToken].lCmd = kseVALUE_ISBOOLEANIC;
	} else if (pToken == kseDOUBLE_QUOTES) {
		kseToken[iToken].lCmd = kseVALUE_OPT_DOUBLE_QUOTES;
	} else if (pToken == kseOPEN_PAREN) {
		kseToken[iToken].lCmd = kseOPT_OPEN_PARENTHESIS;
	} else if (pToken == kseMINUS_SIGN) {
		kseToken[iToken].lCmd = kseVALUE_OPT_MINUS_SIGN;
	} else if (pToken == kseSEMICOLON) {
		kseToken[iToken].lCmd = kseOPT_SEMICOLON;
	} else if (pToken == kseCLOSE_PAREN) {
		kseToken[iToken].lCmd = kseOPT_CLOSE_PARENTHESIS;
	} else if (pToken == kseCOMMA) {
		kseToken[iToken].lCmd = kseOPT_COMMA;
	} else if (pToken == kseCLOSE_BRACKET) {
		kseToken[iToken].lCmd = kseVALUE_OPT_CLOSE_BRACKET;
	} else if (pToken == ksePERCENT_SIGN) {
		kseToken[iToken].lCmd = kseVALUE_OPT_PERCENT_SIGN;
	} else if (pToken == kseCARET) {
		kseToken[iToken].lCmd = kseVALUE_OPT_CARET;
	} else if (pToken == kseASTERISK) {
		kseToken[iToken].lCmd = kseVALUE_OPT_ASTERISK;
	} else if (pToken == kseFORWARD_SLASH) {
		kseToken[iToken].lCmd = kseVALUE_OPT_FORWARD_SLASH;
	} else if (pToken == ksePLUS_SIGN) {
		kseToken[iToken].lCmd = kseVALUE_OPT_PLUS_SIGN;
	}
	*/
	typeToken l_token;
		l_token.sToken = pToken;
		l_token.iLine = pLine;
		l_token.iSrc = pSrc;
		l_token.dValue = 0;
		l_token.lCmd = 0;
		l_token.lSkip = 0;
		l_token.lSkipNull = 0;
		l_token.iParenPair = 0;
		l_token.lPtr = 0;
		l_token.iFunc = 0;
	kseToken.push_back(l_token);
	
	++iToken;
}

void ProcessScript_Parse(string sScript) {
	string sChar;								//for taking each character from user input
	string sToken;								//for taking each token from user input
	int iChar;									//for comparing to ascii values of characters
	unsigned long iLine;						//for line counting
	unsigned long l_index;						//for token counting
	vector<string> sArrScript;					//for multiple ".KS" file - script
	vector<string> sArrSource;					//for multiple ".KS" file - filename
	unsigned long iii;
	bool proceed;
	
	l_index = 0;											//start index at 0 (zero)
		
	iTokenCtr = sScript.length();						//temporarily, set token counter to highest possible count
	//========================================================================
	//==#the idea is to loop and parse all files w/ ln# and file info ========
	//========================================================================
	sScript = sScript + kseSOURCE_SEP + kseSCRIPT_MARK + kseSCRIPT_SEP;	 //add marker
	sArrSource = split(sScript, kseSOURCE_SEP);
	iii = 0;
	kseToken.clear();
	while (Left(sArrSource[iii], string(kseSCRIPT_MARK).length()) != kseSCRIPT_MARK) {
		sArrScript = split(sArrSource[iii], kseSCRIPT_SEP);
		AddSourceName(sArrScript[0]);
		sArrScript[1] = Trim(sArrScript[1]);
		
		//Engine_Log("sArrScript[0]:" + sArrScript[0]
		
	//========================================================================
		iLine = 1;										//start line on 1 (one)
		iTokenCtr = sArrScript[1].length();			//set token counter to highest possible count
		
		if (iTokenCtr == 0) {
			trace(Left(sScript, 250) + "... [trimed --mj]");
		}
		for (unsigned long i = 0; i < iTokenCtr; ++i) {
			sChar = sArrScript[1][i];
			iChar = sChar[0];
				
			//check if a-z/A-Z/0-9/[underscore]
			if (       (iChar >= 97 && iChar <= 122)
					|| (iChar >= 65 && iChar <= 90)
					|| (iChar >= 48 && iChar <= 57)
					|| iChar == 95) {
				sToken += sChar;				//append (numeric) character to sToken
			} else {
				//# Whatever value the sChar is holding store it to token array
				//# This is to token a special character, separately
				//________________________________________________________________
				proceed = false;
				if (sToken != "") {							//check if stoken in not empty
					if (IsNumeric(sToken) == false) {
						ProcessScript_PushToken(sToken, iLine, iii, l_index);
						sToken = ""; //clear token
					} else if (iChar == 46 && IsNumeric(sToken)) {		//is char DOT
						sToken += ".";				//then add as decimal point to numeric values
						proceed = true;
					} else {
						ProcessScript_PushToken(sToken, iLine, iii, l_index);
						sToken = ""; //clear token
					}
				} else if (l_index > 0) {
					if ((kseToken[l_index - 1].sToken == "<"
							|| kseToken[l_index - 1].sToken == kseEXCLAMATION_POINT
							|| kseToken[l_index - 1].sToken == kseEQUAL_SIGN
							|| kseToken[l_index - 1].sToken == ">") && iChar == 61) {   //is char `EQUAL SIGN//
						//08.25.06 - attempt to use C comparison operators --mj
						sChar = kseToken[l_index - 1].sToken + sChar;
						kseToken[l_index - 1].sToken = " "; //this should be SPACE (try empty string to see the bug)
					}
				}
				
				if (proceed == false) {
					//# If the special character is same to "\r\n", token a [space]
					// purpose is to maintain the integrity of line error once
					// source code is pseudo-compiled
					if (iChar == 13 && i < sScript.length()) {
						if (sArrScript[1][i+1] == 10) { //10 is vbLF
							//Windows NEW LINE
							++i;
						} else {
							//UNIX NEW LINE
						}
						ProcessScript_PushToken(" ", iLine, iii, l_index);
						++iLine;
					} else if (iChar == 10) { //10 is vbLF
						//added to fix CHR(10) escaping from screening
						ProcessScript_PushToken(" ", iLine, iii, l_index);
						++iLine;
					} else {
						//if not, put sChar
						ProcessScript_PushToken(sChar, iLine, iii, l_index);
						sToken = ""; //clear token
					}
				}
			}
		}
		
		// # added to fix logic error in parsing
		if (sToken != "") {                 //check if stoken in not empty
			ProcessScript_PushToken(sToken, iLine, iii, l_index);
			sToken = "";
		}
	//========================================================================
		++iii;
	}
	//========================================================================
	//========================================================================
	iTokenCtr = l_index;									//reset token counter
	if (iShowScript == 1 && InStr(1, LCase(sStartScript), ".kh") == 0) {
		SneakScript();
	}
	
	ProcessScript_CheckSyntax();
}

void ProcessScript_ReadCompiled() {
	if (IsLaunchedByFile() == true) {
		if (stringToUpper(Right(sgblCmd, 4)) == ".KON") {
			//KON~ part
			if (fileExists(sScriptPath) == false) {
				Engine_Message("Unable to find starting script file\r\n(  " + sScriptPath + "  <p_rc:kon>].");
				Engine_Exit();
			}
		} else if (stringToUpper(Right(sgblCmd, 6)) == ".KONSL") {
			//KONSL part
			if (fileExists(sScriptPath) == false) {
				Engine_Message("Unable to find starting script file\r\n(  " + sScriptPath + "  <p_rc:konsl>].");
				Engine_Exit();
			}
		} else if (stringToUpper(Right(sgblCmd, 3)) == ".KS") {
			//KS part
			if (fileExists(sScriptPath + ".ks") == false && Right(sScriptPath, 8) != "index.ks") {
				Engine_Message("Unable to find starting script file\r\n(  " + sScriptPath + ".ks  <p_rc:ks1>].");
			} else if (fileExists(sScriptPath + ".ks") == false) {
				if (fileExists(sScriptPath) == false) {
					Engine_Message("Unable to find starting script file \r\n\r\n" +
									sScriptPath + ".ks <p_rc:ks2>");
				} else {
					Engine_Message("Unable to find starting script file\r\n(  " + sScriptPath + "  <p_rc:ks3>).");
				}
			}
		} else {
			//KH part
			if (fileExists(sScriptPath + ".kh") == false) {
				Engine_Message("Unable to find starting script file\r\n(  " + sScriptPath + "  <p_rc:kh>).");
				Engine_Exit();
			}
		}
	} else {
		//Print "sScriptPath : " + sScriptPath
		if (fileExists(sScriptPath + ".konsl") == false) {
			Engine_Message("Unable to find starting script file\r\n(  " + sScriptPath + ".KONSL  ).");
			Engine_Exit();
		}
	}
		
	ProcessScript_fromKONSL_toKS();
	
	//clean up list
	kseSourceFiles.clear();
}

void SneakScript() {
	//# idea is to show all token
//	cout << String(20, "-") << endl;
	std::ofstream ofsSneak;
	if (sKonsolPath != "") {
		ofsSneak.open(sKonsolPath + kseSLASH + "parsed-" + sStartScript + ".log", std::ofstream::out);
	} else {
		ofsSneak.open("parsed-" + sStartScript + ".log", std::ofstream::out);
	}
	if (ofsSneak.is_open()) {
		ofsSneak << String(20, "-") << endl;
		ofsSneak << "INDEX\tLINE #\tTOKEN\tlCmd\tlSkip\tlSkipNull\tiSrc\tiParenPair" << std::endl;
		for (unsigned long i = 0; i < iTokenCtr; ++i) {
		   
			if (kseToken[i].iLine > 0) {						//check if current token array-index was used
//				cout << ("[" + kseToken[i].iLine + "]\t, \t>> " + i + " [" + kseToken[i].sToken + "]"); //if so, show token
				ofsSneak << i << "\t" << kseToken[i].iLine << "\t " << kseToken[i].sToken <<
				"\t" << kseToken[i].lCmd << "\t" << kseToken[i].lSkip << "\t" << kseToken[i].lSkipNull << "\t" << kseToken[i].iSrc << "\t" << kseToken[i].iParenPair << endl;   //if so, show token
			} else {
				break;										//if not, exit loop
			}
		}
		ofsSneak << "INDEX\tiStart\tiStop" << std::endl;
		for (unsigned long i = 0; i < kseParenPairs.size(); ++i) {
			ofsSneak << i << "\t" << kseParenPairs[i].iStart << "\t" << kseParenPairs[i].iStop << std::endl;
		}
		ofsSneak << String(20, "-") << endl;
	} else {
		std::cerr << "Error: " << strerror(errno) << std::endl;
	}
	ofsSneak.close();
}

unsigned long SynNumSign(unsigned long &iIndex) {
	++iIndex;
	if (kseToken[iIndex].sToken == "include") {
		
		iIndex = NumSign_Include(iIndex);
		
	} else if (kseToken[iIndex].sToken == "define") {
		if (bKONSoLE_DeclaringVar) {
			//#idea is to process only if all KS are loaded.
			iIndex = NumSign_Define(iIndex);
		}
		
	} else if (kseToken[iIndex].sToken == kseEXCLAMATION_POINT) {
		//cgi support
		unsigned long tmp;
		unsigned long ln;
		unsigned long i = iIndex; // [QuixiePP] check with kse_Main_Header_Process.BAS file
		tmp = iIndex-1; //go back to #; before !
		
		ln = kseToken[i].iLine;
		for (i = tmp; i < iTokenCtr; ++i) {
			if (kseToken[i].iLine == ln) {
				kseToken[i].sToken = kseNULL_STRING;
			}
		}
		
		ProcessScript_Refresh();
		ProcessScript_ReadCompiled();
		//sKONSoL = sKONSoL + kseSOURCE_SEP + sFileName + kseSCRIPT_SEP + sFileScript
		
		ProcessScript_Parse(sKONSoL);
		ProcessScript_CleanUp();
		
		iIndex = -1;
	} else {
		Engine_Message(KSE_GetErrFileSrc(iIndex) + "Expecting (  #include  ) but got (  #" + KSE_GetToken(iIndex) + "  ) instead.", "SYNTAX ERROR AT LINE " + kseToken[iIndex].iLine);
		Engine_Exit();
	}
	return iIndex;
}

unsigned long NumSign_Define(unsigned long &iIndex) {
	unsigned long iDefine;
	unsigned long iFind;
	string sReplace;
	unsigned long iEndDefineStatement;
	unsigned long iLn;   //to implement macros
	unsigned long iNumSign = iIndex - 1;
	iDefine = iIndex;
	
	iIndex = GetNextIndex(iIndex);
	iFind = iIndex;	   //get index of what to find
	
	iLn = kseToken[iIndex].iLine;
	iIndex = GetNextIndex(iIndex);
	while (iLn == kseToken[iIndex].iLine) {
		//# idea is to get the provided macro
		sReplace = sReplace + kseToken[iIndex].sToken;
		++iIndex;
	}
	--iIndex; //move back token-pointer
	//
	if (sReplace == "") {
		Engine_Message(KSE_GetErrFileSrc(iIndex) + "Please specify any (  define value  ).", "ERROR AT LINE " + Str(kseToken[iIndex].iLine) + ".");
		Engine_Exit();
	}
	
	iEndDefineStatement = iIndex;
	//clean up the [#define statement] to avoid defining again
	kseToken[iNumSign].sToken = kseSPACE;  //I placed a [space] to maintain the line numbering
	kseToken[iDefine].sToken = " ";
	unsigned long i;
	for (i = iDefine; i < iEndDefineStatement; ++i) {
		if (iFind != i) {
			kseToken[i].sToken = " ";
		}
	}
	Engine_Log(" >> Defining: " + kseToken[iFind].sToken);
	for (i = 0; i < iTokenCtr; ++i) {
		if (iFind != i) {
			if (kseToken[i].sToken == kseToken[iFind].sToken) {
				kseToken[i].sToken = sReplace;
			}
		}
	}
	
	kseToken[iFind].sToken = " ";
	
	//re-start the script process by refreshing the tokens
	ProcessScript_Refresh();
	ProcessScript_ReadCompiled();
	//sKONSoL = sKONSoL + kseSOURCE_SEP + sFileName + kseSCRIPT_SEP + sFileScript
	
	ProcessScript_Parse(sKONSoL);
	ProcessScript_CleanUp();
	
	return 0;				 //restart interpreting
}

unsigned long NumSign_Include(unsigned long &iIndex) {
	string sFileScript;
	string sPath;
	unsigned long iInclude;
	unsigned long iNumSign;
	unsigned long iDblQuote1;
	unsigned long iDblQuote2;
	int iLen;
	
	iNumSign = iIndex - 1;
	iInclude = iIndex;
	
	iIndex = GetNextIndex(iIndex);
	
	iIndex = LookFor(kseDOUBLE_QUOTES, "include", iIndex);   //look for	   (
	iDblQuote1 = iIndex;
	
		iIndex = SynQuotes(iIndex);
		iDblQuote2 = iIndex;
		//get the string value
		string sFileName = GetTempString();
	
	//check for same file
	for (unsigned int i = 0; i < kseSourceFiles.size(); ++i) {
	   
		if (sFileName == kseSourceFiles[i]) {
			Engine_Log("\tWarning: (  " + kseSourceFiles[kseToken[iDblQuote1].iSrc] + "  ) is trying to include\r\n\t(  " + sFileName + "  ) which conflicts other included files.");
			CleanIncludeStatement(iNumSign, iInclude, iDblQuote1, iDblQuote2);
			return ULONG_MAX;				 //restart interpreting
		}
	}
	//Print "#including " + """" + sFileName + """"
	if (LCase(Right(sFileName, 4)) != ".ksl"
			&& LCase(Right(sFileName, 3)) != ".ks"
			&& LCase(Right(sFileName, 3)) != ".kh"
			&& InStr(1, sFileName, ".") > 0) {
		Engine_Message(KSE_GetErrFileSrc(iDblQuote1) + "Can only include files with\r\n" +
			   " (  .KS, .KH and .KSL  ) extension.", "SYNTAX ERROR AT LINE " + kseToken[iDblQuote1].iLine);
		Engine_Exit();
	}
	
	if (fileExists(sKonsolPath + kseSLASH + sFileName) == true
			|| fileExists(sKonsolPath + kseSLASH + sFileName + ".ksl") == true) {
		sPath = sKonsolPath + kseSLASH;
	//check if file is in "INCLUDE" dir of Quixie path
	} else if (fileExists(App_Path + kseSLASH + "include" + kseSLASH + sFileName) == true
			|| fileExists(App_Path + kseSLASH + "include" + kseSLASH + sFileName + ".ksl") == true) {
		sPath = App_Path + kseSLASH + "include" + kseSLASH;
	} else {
		Engine_Message(KSE_GetErrFileSrc(iDblQuote1) + "Unable to find Source file (  " + sFileName + "  )" + "\r\n" +
					   "either from (  INCLUDE Directory  )" + "\r\n" +
					   "or from (  " + sKonsolPath + "  )", "ERROR AT LINE " + kseToken[iDblQuote1].iLine);
		Engine_Exit();
	}
	
	//basically, the code will not reach this point if the [include "file"] //is already included// or //is missing//
	//that is why, we need to simply add the file to main KS
	
	if (LCase(Right(sFileName, 3)) == ".ks"
			|| LCase(Right(sFileName, 3)) == ".kh") {
		//if file is not compiled, simply read content
		
			sFileScript = fileOpen(sPath + sFileName);
		
	//again, I used "else" since any type of file ext are already screened
	} else {
		//if user includes [.KSL], user is including a compiled KH file :)
		//07.03.06 - compiled KS, KONSL file, cannot be included anymore.
		vector<string> sFNVal;
		sFNVal = split(sFileName, kseSLASH);
		if (InStr(1, sFileName, ".") == 0) {
			//implementing implicit adding of word //.KSL// in include statement
			sFileScript = ProcessScript_Include_KSL(sPath + sFileName);
			
			//remove the [trailing File marker] from the left most part of the script
			//NOTE: the [File marker] came from writing the compiled source code
			//iLen = sFNVal(sFNVal().size()).length() + kseSCRIPT_SEP + kseSOURCE_SEP + sFNVal(.size(sFNVal())) + kseSCRIPT_SEP) + 9
			unsigned long sFNVal_length = sFNVal[sFNVal.size()-1].length();
			iLen = (Str(sFNVal_length) + kseSCRIPT_SEP + kseSOURCE_SEP + sFNVal[sFNVal.size()-1] + kseSCRIPT_SEP).length() + 7; //6 (two '.KH') + 1 (next char)
			if (InStr(1, stringToUpper(sFileScript), stringToUpper(sFNVal[sFNVal.size() - 1] + ".KH")) < iLen) {
				sFileScript = Mid(sFileScript, iLen);
			} else {
				MsgBox("edit me:think of message", "NumSign_Include a" + InStr(1, stringToUpper(sFileScript), stringToUpper(sFNVal[sFNVal.size()-1] + ".KH")));
			}
		} else {
			sFileScript = ProcessScript_Include_KSL(sPath + Left(sFileName, sFileName.length() - string(".ksl").length()));
			
			//remove the [trailing File marker] from the left most part of the script
			//NOTE: the [File marker] came from writing the compiled source code
			iLen = kseSOURCE_SEP.length() + (sFNVal[sFNVal.size()-1] + kseSCRIPT_SEP + sFNVal[sFNVal.size()-1] + kseSCRIPT_SEP).length() + 2;
			
			if (InStr(1, sFileScript, sFNVal[sFNVal.size()-1]) < iLen) {
				sFileScript = Mid(sFileScript, iLen);
			} else {
				MsgBox("edit me:think of message", "NumSign_Include b");
			}
		}
	}

	//clean up the [include statement] to avoid including the same file again
	CleanIncludeStatement(iNumSign, iInclude, iDblQuote1, iDblQuote2);
	
	//re-start the script process by refreshing the tokens
	ProcessScript_Refresh();
	ProcessScript_ReadCompiled();
	//add the included script
	sKONSoL += (kseSOURCE_SEP + sFileName + kseSCRIPT_SEP + sFileScript);
	//parse the new script
	ProcessScript_Parse(sKONSoL);
	//refresh again to have a compiled-script with the included-script added
	ProcessScript_Refresh();
	ProcessScript_ReadCompiled();
	//re-parse the new script
	ProcessScript_Parse(sKONSoL);
	
	ProcessScript_CleanUp();
		
	return -1; //restart interpreting
}

void CleanIncludeStatement(unsigned long iNumSign, unsigned long iInclude, unsigned long iDblQuote1, unsigned long iDblQuote2) {
	kseToken[iNumSign].sToken = kseSPACE;  //I placed a [space] to maintain the line numbering
	kseToken[iInclude].sToken = " ";
	kseToken[iDblQuote1].sToken = " ";
	kseToken[iDblQuote2].sToken = " ";
	for (unsigned long i = iDblQuote1; i < iDblQuote2; ++i) {
		kseToken[i].sToken = " ";
	}
}
	
void ProcessScript_CheckSyntax() {
	//attempt to check on basic syntax this 08.11.06 -- Mj Mendoza IV
	int iParCtr = 0;
	int iCurlCtr = 0;
	int iBrkCtr = 0;
	unsigned long i, ii;
	//remove all user//s-comments
	string tmpxxx;
	unsigned long ln;
	unsigned long tmp;
	for (i = 0; i < iTokenCtr; ++i) {
		if (kseToken[i].iLine > 0) {
			i = KSE_SkipVoidTokens(i);
				if (kseToken[i].sToken == kseNUMBER_SIGN) {
					ln = kseToken[i].iLine;
					tmp = i;
					for (i = tmp; i < iTokenCtr; ++i) {
						if (kseToken[i].iLine > ln) {
							tmp = i;
							i = iTokenCtr;
						}
					}
					i = tmp;
				} else if (kseToken[i].sToken == kseFORWARD_SLASH) {
					if (kseToken[i + 1].sToken == kseFORWARD_SLASH
							|| kseToken[i + 1].sToken == kseASTERISK) {
						i = SynComment(i, iParCtr);
					}
				} else if (kseToken[i].sToken == kseTAB) {
					kseToken[i].lCmd = ULONG_MAX;
					kseToken[i].sToken = kseSPACE;
				//im checking for double quotes because a [keyword/constant/identifier]
				//can be written between two quotes
				} else if (kseToken[i].sToken == kseDOUBLE_QUOTES) {
					kseToken[i].lCmd = kseVALUE_OPT_DOUBLE_QUOTES;
					i = SynQuotes(i);
					tmpxxx = GetTempString();
					//trace("tmpxxx " + tmpxxx);
/**
	} else if (IsTokenNum(i)) {
		kseToken[i].lCmd = kseVALUE_ISTOKENNUM;
	} else if (IsTokenNum2(i)) {
		kseToken[i].lCmd = kseVALUE_ISTOKENNUM2;
	} else if (IsTokenStr(i)) {
		kseToken[i].lCmd = kseVALUE_ISTOKENSTR;
	} else if (IsTokenStr2(i)) {
		kseToken[i].lCmd = kseVALUE_ISTOKENSTR2;
	} else if (IsTokenArray(i)) {
		kseToken[i].lCmd = kseVALUE_ISTOKENARRAY;
	} else if (IsTokenUDT(i)) {
		kseToken[i].lCmd = kseVALUE_ISTOKENUDT;
	} else if (IsTokenUDT2(i)) {
		kseToken[i].lCmd = kseVALUE_ISTOKENUDT2;
	} else if (IsTokenFunction(i)) {
		kseToken[i].lCmd = kseVALUE_ISTOKENFUNCTION;
	} else if (IsTokenFunction2(i)) {
		kseToken[i].lCmd = kseVALUE_ISTOKENFUNCTION2;
*/
				//im checking for equal sign since 0.0.95 is capable of [x = 6 + 1 / (8 / 24);]
				//and / can be written as divide symbol in the equation
				} else if (kseToken[i].sToken == kseEQUAL_SIGN) {
					kseToken[i].lCmd = kseVALUE_OPT_EQUAL_SIGN;
					for (ii = i; ii < iTokenCtr; ++ii) {
						ii = GetNextIndex(ii);
						//cout << ">>" + ii + "\t" + kseToken[ii].sToken
						if (kseToken[ii].sToken == kseSEMICOLON) {
							kseToken[ii].lCmd = kseOPT_SEMICOLON;
							i = ii;
							break;
						} else if (kseToken[ii].sToken == kseTAB) {
							kseToken[i].lCmd = -1;
							kseToken[ii].sToken = kseSPACE;
						} else if (kseToken[ii].sToken == kseFORWARD_SLASH) {
							kseToken[ii].lCmd = kseVALUE_OPT_FORWARD_SLASH;
							//check if comment
							if (kseToken[ii + 1].sToken == kseFORWARD_SLASH
									|| kseToken[ii + 1].sToken == kseASTERISK) {
								ii = SynComment(ii, iParCtr);
							}
						//im trying to count PARENTHESIS, CURLY BRACES + BRACKETS in pair
						} else if (kseToken[ii].sToken == kseOPEN_PAREN) {
							kseToken[ii].lCmd = kseOPT_OPEN_PARENTHESIS;
							++iParCtr;
						} else if (kseToken[ii].sToken == kseCLOSE_PAREN) {
							kseToken[ii].lCmd = kseOPT_CLOSE_PARENTHESIS;
							--iParCtr;
							if (iParCtr < 0) {
								Engine_Message("Unexpected (  Close Parenthesis  ).", "ERROR AT LINE " + Str(kseToken[ii].iLine));
							}
						} else if (kseToken[ii].sToken == kseOPEN_CURL) {
							kseToken[ii].lCmd = kseOPT_OPEN_CURL;
							++iCurlCtr;
						} else if (kseToken[ii].sToken == kseCLOSE_CURL) {
							kseToken[ii].lCmd = kseOPT_CLOSE_CURL;
							--iCurlCtr;
							if (iCurlCtr < 0) {
								Engine_Message("Unexpected (  Close Curly Braces  ).", "ERROR AT LINE " + Str(kseToken[ii].iLine));
							}
						} else if (kseToken[ii].sToken == kseOPEN_BRACKET) {
							kseToken[ii].lCmd = kseOPT_OPEN_BRACKET;
							++iBrkCtr;
						} else if (kseToken[ii].sToken == kseCLOSE_BRACKET) {
							kseToken[ii].lCmd = kseOPT_CLOSE_BRACKET;
							--iBrkCtr;
							if (iBrkCtr < 0) {
								Engine_Message("Unexpected (  Close Bracket  ).", "ERROR AT LINE " + Str(kseToken[ii].iLine));
							}
						} else if (kseToken[ii].sToken == "else") {
							ii = GetPrevIndex(ii);
								if (kseToken[ii].sToken != kseCLOSE_CURL) {
									Engine_Message(KSE_GetErrFileSrc(ii) + "Expecting (  }  ) after (  else  ) but got (  " + KSE_GetToken(ii) + "  ) instead." + "\r\n" +
										String(61, kseMINUS_SIGN) + "\r\n" +
										"Your code is:       " + KSE_GetToken(ii) + " else " + "\r\n" +
										"Code should be:     } else", "SYNTAX ERROR AT LINE " + Str(kseToken[ii].iLine));
								}
							ii = GetNextIndex(ii);
						}
						--ii;
					}
					i = ii;
				//im trying to count PARENTHESIS, CURLY BRACES + BRACKETS in pair
				} else if (kseToken[i].sToken == kseOPEN_PAREN) {
					kseToken[i].lCmd = kseOPT_OPEN_PARENTHESIS;
					++iParCtr;
				} else if (kseToken[i].sToken == kseCLOSE_PAREN) {
					kseToken[i].lCmd = kseOPT_CLOSE_PARENTHESIS;
					--iParCtr;
					if (iParCtr < 0) {
						Engine_Message(KSE_GetErrFileSrc(i) + "Unexpected (  Close Parenthesis  ).", "ERROR AT LINE " + Str(kseToken[i].iLine));
					}
				} else if (kseToken[i].sToken == kseOPEN_CURL) {
					kseToken[i].lCmd = kseOPT_OPEN_CURL;
					++iCurlCtr;
				} else if (kseToken[i].sToken == kseCLOSE_CURL) {
					kseToken[i].lCmd = kseOPT_CLOSE_CURL;
					--iCurlCtr;
					if (iCurlCtr < 0) {
						Engine_Message(KSE_GetErrFileSrc(i) + "Unexpected (  Close Curly Brace  ).", "ERROR AT LINE " + Str(kseToken[i].iLine));
					}
				} else if (kseToken[i].sToken == kseOPEN_BRACKET) {
					kseToken[i].lCmd = kseOPT_OPEN_BRACKET;
					++iBrkCtr;
				} else if (kseToken[i].sToken == kseCLOSE_BRACKET) {
					kseToken[i].lCmd = kseOPT_CLOSE_BRACKET;
					--iBrkCtr;
					if (iBrkCtr < 0) {
						Engine_Message(KSE_GetErrFileSrc(i) + "Unexpected (  Close Bracket  ).", "ERROR AT LINE " + Str(kseToken[i].iLine));
					}
				} else if (kseToken[i].sToken == "else") {
					i = GetPrevIndex(i);
					if (kseToken[i].sToken != kseCLOSE_CURL) {
						Engine_Message(KSE_GetErrFileSrc(i) + "Expecting (  }  ) after (  else  ) but got (  " + KSE_GetToken(i) + "  ) instead." + "\r\n" +
							String(61, kseMINUS_SIGN) + "\r\n"
							"Your code is:       " + KSE_GetToken(i) + " else " + "\r\n"
							"Code should be:     } else", "SYNTAX ERROR AT LINE " + Str(kseToken[i].iLine));
					};
						
					i = GetNextIndex(i);
				}
		}
	}
	
	--i; //bug fix
	if (iParCtr > 0) {
		Engine_Message(KSE_GetErrFileSrc(i) + "Missing (  Close Parenthesis  ).", "ERROR AT LINE " +  Str(kseToken[i].iLine));
		Engine_Exit();
	} else if (iCurlCtr > 0) {
		Engine_Message(KSE_GetErrFileSrc(i) + "Missing (  Close Curly Brace  ).", "ERROR AT LINE " + Str(kseToken[i].iLine));
		Engine_Exit();
	} else if (iBrkCtr > 0) {
		Engine_Message(KSE_GetErrFileSrc(i) + "Missing (  Close Bracket  ).", "ERROR AT LINE " + Str(kseToken[i].iLine));
		Engine_Exit();
	}
}
