//translated this 17.09.27 by mjmendozaIV
#include "../kage.hpp"
#include "../kageExterns.hpp"

#include <math.h> //fmod

double GetVal_DoMath(double dLeft, int iOp, double dRight) {
	double dResult;
	
	if (iOp == kseVALUE_OPT_PERCENT_SIGN) {
		dResult = fmod(dLeft, dRight);
	} else if (iOp == kseVALUE_OPT_CARET) {
		dResult = pow(dLeft, dRight);
	} else if (iOp == kseVALUE_OPT_ASTERISK) {
		dResult = dLeft * dRight;
	} else if (iOp == kseVALUE_OPT_FORWARD_SLASH) {
		dResult = dLeft / dRight;
	} else if (iOp == kseVALUE_OPT_PLUS_SIGN) {
		dResult = dLeft + dRight;
	} else if (iOp == kseVALUE_OPT_MINUS_SIGN) {
		dResult = dLeft - dRight;
	}
	
	return dResult;
}

string GetVal_Quotes(unsigned long &iIndex) {
	string sValue = "";
	unsigned long i;
	
//	bool bNewline;
	for (i = iIndex + 1; i < iTokenCtr; ++i) {
		if (kseToken[i].sToken == kseDOUBLE_QUOTES) {
			//if (bKONSoLE_Reading == 0) { break; }
			break;
		} else if (kseToken[i].sToken == kseBACK_SLASH && (bKONSoLE_Reading || bREAD_ESCAPE_CHARS)) {
//			bNewline = false;
			if (Left(kseToken[i + 1].sToken, 1) == "n") {
				//-- \n [Ex. from \nice (suppose to be \n and ice)]
				#ifdef QUIXIE_CGI
					sValue += "\n";
				#else
					sValue += "\r\n";
				#endif
//				bNewline = true;
			} else if (Left(kseToken[i + 1].sToken, 1) == "t") {
				//-- \t [Ex. from \table (suppose to be \t and able)]
				sValue += Space(4); //4 space equivalent to TAB; it was separated to avoid Find&Replace during code-cleanup
			} else if (kseToken[i + 1].sToken == kseDOUBLE_QUOTES) {
				sValue += kseDOUBLE_QUOTES;
			} else if (kseToken[i + 1].sToken == kseBACK_SLASH) {
				sValue += kseSLASH; //use slash used by the OS
			} else {
				//take it as-is
				sValue += kseToken[i + 1].sToken;
			}
			++i;
		} else {
			//take it as-is
			sValue += kseToken[i].sToken;
		}	
	}
	iIndex = i;
	return sValue;
}

double GetVal_OpenPar(unsigned long &iIndex, bool DeclareMode, bool FuncMode, bool ArrayMode, bool ParenMode) {
	double dValue = 0;
	unsigned long i = iIndex;
	
		if (kseToken[i].sToken == kseCLOSE_PAREN) {
			//no value at all -- ()
		} else {
			dValue = GetVal(i, DeclareMode, FuncMode, ArrayMode, true);
		}	
	
	iIndex = i + 1; //skip close-paren
	return dValue;
}

double GetNumValueAt(unsigned long &iIndex, bool DeclareMode, bool FuncMode, bool ArrayMode, bool ParenMode) {

	unsigned long i;
	double dValue;
	string sToken;
	string stmpUDTdata;
	i = iIndex;
//	trace("GetNumValueAt kseToken[" + i + "].sToken " + kseToken[i].sToken + " " + kseToken[i].lCmd);
	if (kseToken[i].lCmd == kseVALUE_ISNUMERIC) {
		dValue = kseToken[i].dValue;
	} else if (kseToken[i].lCmd == kseVALUE_ISHEXIC) {
		dValue = kseToken[i].dValue;
	} else if (kseToken[i].lCmd == kseVALUE_ISBOOLEANIC) {
		dValue = kseToken[i].dValue;
	} else if (kseToken[i].lCmd == kseVALUE_ISTOKENNUM) {
		dValue = JIO_GetNumValue(i);
	} else if (kseToken[i].lCmd == kseVALUE_ISTOKENNUM2) {
		dValue = GetNumValue2(i);
	} else if (kseToken[i].lCmd == kseVALUE_ISTOKENSTR) {
		dValue = CDbl(GetStrValue(i));
	} else if (kseToken[i].lCmd == kseVALUE_ISTOKENSTR2) {
		dValue = CDbl(GetStrValue2(i));
	} else if (kseToken[i].lCmd == kseVALUE_ISTOKENARRAY) {
		dValue = CDbl(ArrGetValue(i));
	} else if (kseToken[i].lCmd == kseVALUE_ISTOKENUDT) {
		stmpUDTdata = GetUDTValue(i);
		if (IsNumeric(stmpUDTdata)) {
		//	stmpUDTdata = Str(stmpUDTdata);
			dValue = CDbl(stmpUDTdata);
		}
	} else if (kseToken[i].lCmd == kseVALUE_ISTOKENUDT2) {
		stmpUDTdata = GetUDTValue2(i);
		if (IsNumeric(stmpUDTdata)) {
		//	stmpUDTdata = Str(stmpUDTdata);
			dValue = CDbl(stmpUDTdata);
		}
	} else if (kseToken[i].lCmd == kseVALUE_ISTOKENFUNCTION || kseToken[i].lCmd == kseVALUE_ISTOKENFUNCTION2) {
//		trace("GetNumValueAt ISTOKENFUNCTION " + kseToken[i].sToken);
		sToken = SynCallFunction2(i);
		dValue = CDbl(sToken);
//		trace("GetNumValueAt ISTOKENFUNCTION dValue " + dValue);
		if (FuncMode) {
			i = GetPrevIndex(i);
		}
//trace("gnva A outB " + dValue + " " + i + " " + kseToken[i].sToken);
	} else if (kseToken[i].lCmd == kseVALUE_ISTOKENFUNCTION2) {
//		trace("GetNumValueAt ISTOKENFUNCTION2 " + kseToken[i].sToken);
		while (kseToken[i].sToken != kseCOMMA && kseToken[i].sToken != kseSEMICOLON) {
			++i;
			i = KSE_SkipVoidTokens(i);
		}
		--i;
	} else if (kseToken[i].lCmd == kseVALUE_OPT_DOUBLE_QUOTES) {
		dValue = CDbl(GetVal_Quotes(i));
	} else if (kseToken[i].lCmd == kseOPT_OPEN_PARENTHESIS) {
		dValue = GetVal_OpenPar(i, DeclareMode, FuncMode, ArrayMode, true);
	} else if (kseToken[i].lCmd == kseVALUE_OPT_MINUS_SIGN) {
		++i; //skip negative
		dValue = 0 - GetNumValueAt(i, DeclareMode, FuncMode, ArrayMode, ParenMode);
	} else {
//		trace("else " + kseToken[i].sToken + " " + i);
		sToken = kseToken[i].sToken;
		if (IsNumeric(sToken)) {
//		trace("else A " + kseToken[i].sToken);
	   	kseToken[i].lCmd = kseVALUE_ISNUMERIC;
			dValue = CDbl(sToken);
			kseToken[i].dValue = dValue;
		} else if (IsHexic(sToken)) {
//		trace("else B " + kseToken[i].sToken);
			kseToken[i].lCmd = kseVALUE_ISHEXIC;
			dValue = CDbl(HexVal(sToken));
			kseToken[i].dValue = dValue;
		} else if (IsBooleanic(sToken)) {
//		trace("else C " + kseToken[i].sToken);
			kseToken[i].lCmd = kseVALUE_ISBOOLEANIC;
			dValue = CDbl(BooleanVal(sToken));
			kseToken[i].dValue = dValue;
		} else if (IsTokenNum(i)) {
//		trace("else D " + kseToken[i].sToken);
			kseToken[i].lCmd = kseVALUE_ISTOKENNUM;
			dValue = GetNumValue(i);
		} else if (IsTokenNum2(i)) {
//		trace("else E " + kseToken[i].sToken);
			kseToken[i].lCmd = kseVALUE_ISTOKENNUM2;
			dValue = GetNumValue2(i);
	   } else if (IsTokenStr(i)) {
//		trace("else F " + kseToken[i].sToken);
			kseToken[i].lCmd = kseVALUE_ISTOKENSTR;
			dValue = CDbl(GetStrValue(i));
	   } else if (IsTokenStr2(i)) {
//		trace("else G " + kseToken[i].sToken);
			kseToken[i].lCmd = kseVALUE_ISTOKENSTR2;
			dValue = CDbl(GetStrValue(i));
	   } else if (IsTokenArray(i)) {
//		trace("else H " + kseToken[i].sToken);
			kseToken[i].lCmd = kseVALUE_ISTOKENARRAY;
			dValue = CDbl(ArrGetValue(i));
		} else if (IsTokenUDT(i)) {
//		trace("else I " + kseToken[i].sToken);
			kseToken[i].lCmd = kseVALUE_ISTOKENUDT;
			stmpUDTdata = GetUDTValue(i);
			if (IsNumeric(stmpUDTdata)) {
				//stmpUDTdata = Str(stmpUDTdata);
				dValue = CDbl(stmpUDTdata);
			}
	   } else if (IsTokenUDT2(i)) {
//		trace("else J " + kseToken[i].sToken);
			kseToken[i].lCmd = kseVALUE_ISTOKENUDT2;
			stmpUDTdata = GetUDTValue2(i);
			if (IsNumeric(stmpUDTdata)) {
			//	stmpUDTdata = Str(stmpUDTdata);
				dValue = CDbl(stmpUDTdata);
			}
	   } else if (IsTokenFunction(i)) {
//		trace("else K " + kseToken[i].sToken);
			kseToken[i].lCmd = kseVALUE_ISTOKENFUNCTION;
			sToken = SynCallFunction2(i);
			dValue = CDbl(sToken);
			if (FuncMode == true) {
				i = GetPrevIndex(i);
			} else { //temp fix
			}
		} else if (IsTokenFunction2(i)) {
//		trace("else L " + kseToken[i].sToken);
			kseToken[i].lCmd = kseVALUE_ISTOKENFUNCTION2;
			while (kseToken[i].sToken != kseCOMMA && kseToken[i].sToken != kseSEMICOLON) {
				++i;
				i = KSE_SkipVoidTokens(i);
			}
			--i;
	   } else if (sToken == kseDOUBLE_QUOTES) {
//		trace("else M " + kseToken[i].sToken);
			kseToken[i].lCmd = kseVALUE_OPT_DOUBLE_QUOTES;
			dValue = CDbl(GetVal_Quotes(i));
		} else if (sToken == kseOPEN_PAREN) {
//		trace("else N " + kseToken[i].sToken);
			kseToken[i].lCmd = kseOPT_OPEN_PARENTHESIS;
			dValue = GetVal_OpenPar(i, DeclareMode, FuncMode, ArrayMode, true);
		} else if (sToken == kseMINUS_SIGN) {
//		trace("else O " + kseToken[i].sToken);
			kseToken[i].lCmd = kseVALUE_OPT_MINUS_SIGN;
			//dValue = KSE_GetNegativeValue(i);
			++i; //skip negative
			dValue = 0 - GetNumValueAt(i, DeclareMode, FuncMode, ArrayMode, ParenMode);
//			trace "dValue _ " + Str(dValue);
		} else {
//		trace("else P " + kseToken[i].sToken);
			Engine_Message("Expecting (  value  ) before (  " + KSE_GetToken(i) + "  ).", "ERROR AT LINE " + Str(kseToken[i].iLine));
			Engine_Exit();
		}
	}
//	trace("    dValue=" + dValue + " i=" + i);
	iIndex = i;
	return dValue;
}

double GetVal(unsigned long &iIndex, bool DeclareMode, bool FuncMode, bool ArrayMode, bool ParenMode) {
//added DeclareMode as parameter since I wanted to use this
//function if user tries to declare something like
//			   Var:Number myCirc = 2 * 3.1416 , myCircArea = myCirc * 10;
// -- mj mendoza 12.24.06 (rewritten this 03.31.11)
	string sToken = "";
	unsigned long i = 0;
	double dValue = 0.0;
	double dValueLeft = 0.0;
	double dValueRight = 0.0;
	vector<double> dValues;
	vector<int> iOps;
	int iOp = 0;
	
//	trace("GetVal");
	i = iIndex;
	do {
		i = GetNextIndex(i);
//		trace("GetVal old " + i);
		dValue = GetNumValueAt(i, DeclareMode, FuncMode, ArrayMode, ParenMode);
//		trace("GetVal new " + i + " " + dValue);
		
//		trace("GetVal iOp " + iOp);
		if (iOp == 0) {
			dValues.push_back(dValue);
//			trace("push value " + Str(dValue));
		} else {
			//do math
			dValueLeft = dValues[dValues.size()-1];
			dValueRight = dValue;
			
				dValues.push_back(GetVal_DoMath(dValueLeft, iOp, dValueRight));
			
//			trace("     value " + Str(dValues[dValues.size()-1]) + " from " + Str(dValueLeft) + " and " + dValueRight);
			iOp = 0; //reset to NO-OPERATOR
		}
//		trace("GetVal A " + i);
		i = GetNextIndex(i);
//		trace("GetVal B " + i);
		
		sToken = kseToken[i].sToken;
//		trace("GetVal sToken " + sToken);
		if (kseToken[i].lCmd == kseOPT_SEMICOLON) {
			if (ArrayMode == false && FuncMode == false) {
				break;
			//} else if (DeclareMode == false) {
			//	break;
			} else {
				ErrMsg_NotMathOp(i);
			}
		} else if (kseToken[i].lCmd == kseOPT_CLOSE_PARENTHESIS) {
			if (FuncMode == true || ParenMode == true) {
				break;
			} else {
				ErrMsg_NotMathOp(i);
			}
		} else if (kseToken[i].lCmd == kseOPT_COMMA) {
			if (DeclareMode == true || FuncMode == true) {
				break;
			} else {
				ErrMsg_NotMathOp(i);
			}
		} else if (kseToken[i].lCmd == kseVALUE_OPT_CLOSE_BRACKET) {
			if (ArrayMode == true) {
				break;
			} else {
				ErrMsg_NotMathOp(i);
			}
		} else if (kseToken[i].lCmd == kseVALUE_OPT_PERCENT_SIGN) {
			iOp = kseVALUE_OPT_PERCENT_SIGN;
		} else if (kseToken[i].lCmd == kseVALUE_OPT_CARET) {
			iOp = kseVALUE_OPT_CARET;
		} else if (kseToken[i].lCmd == kseVALUE_OPT_ASTERISK) {
			iOp = kseVALUE_OPT_ASTERISK;
		} else if (kseToken[i].lCmd == kseVALUE_OPT_FORWARD_SLASH) {
			iOp = kseVALUE_OPT_FORWARD_SLASH;
		} else if (kseToken[i].lCmd == kseVALUE_OPT_PLUS_SIGN) {
			iOps.push_back(kseVALUE_OPT_PLUS_SIGN);
		} else if (kseToken[i].lCmd == kseVALUE_OPT_MINUS_SIGN) {
			iOps.push_back(kseVALUE_OPT_MINUS_SIGN);
		} else {
			if (sToken == kseSEMICOLON) {
				kseToken[i].lCmd = kseOPT_SEMICOLON;
				if (ArrayMode == false && FuncMode == false) {
					break;
				//} else (DeclareMode == false) {
				//	break;
				} else {
					ErrMsg_NotMathOp(i);
				}
			} else if (sToken == kseCLOSE_PAREN) {
				kseToken[i].lCmd = kseOPT_CLOSE_PARENTHESIS;
				if (FuncMode == true || ParenMode == true) {
					break;
				} else {
					ErrMsg_NotMathOp(i);
				}
			} else if (sToken == kseCOMMA) {
				kseToken[i].lCmd = kseOPT_COMMA;
				if (DeclareMode || FuncMode) {
					break;
				} else {
					ErrMsg_NotMathOp(i);
				}
			} else if (sToken == kseCLOSE_BRACKET) {
				kseToken[i].lCmd = kseVALUE_OPT_CLOSE_BRACKET;
				if (ArrayMode == true) {
					break;
				} else {
					ErrMsg_NotMathOp(i);
				}
			} else if (sToken == ksePERCENT_SIGN) {
				kseToken[i].lCmd = kseVALUE_OPT_PERCENT_SIGN;
				iOp = kseVALUE_OPT_PERCENT_SIGN;
			} else if (sToken == kseCARET) {
				kseToken[i].lCmd = kseVALUE_OPT_CARET;
				iOp = kseVALUE_OPT_CARET;
			} else if (sToken == kseASTERISK) {
				kseToken[i].lCmd = kseVALUE_OPT_ASTERISK;
				iOp = kseVALUE_OPT_ASTERISK;
			} else if (sToken == kseFORWARD_SLASH) {
				kseToken[i].lCmd = kseVALUE_OPT_FORWARD_SLASH;
				iOp = kseVALUE_OPT_FORWARD_SLASH;
			} else if (sToken == ksePLUS_SIGN) {
				kseToken[i].lCmd = kseVALUE_OPT_PLUS_SIGN;
				iOps.push_back(kseVALUE_OPT_PLUS_SIGN);
			} else if (sToken == kseMINUS_SIGN) {
				kseToken[i].lCmd = kseVALUE_OPT_MINUS_SIGN;
				iOps.push_back(kseVALUE_OPT_MINUS_SIGN);
			} else {
				ErrMsg_NotMathOp(i);
			}
		}
	} while (kseToken[i].sToken != kseSEMICOLON);
	
	//start from right most to pop back
	unsigned int opCtr = iOps.size();
	
	int ptrRight = 1;
	while (dValues.size() > 1 && opCtr > 0) {
		dValues[0] = GetVal_DoMath(
						dValues[0],
						   iOps[ptrRight-1],
						dValues[ptrRight]
					);
		--opCtr;
		
		++ptrRight;
	}
//trace("gv 1 " + iIndex);
	iIndex = i - 1; //move back one-index
//trace("gv 2 " + iIndex + " " + iTokenCtr);
	return dValues[0]; //only one item is left, which is the result
	
	/*
	double dResult;
	
	string sToken;
	int i;
	int ii;
	bool bBlank;
	
	i = iIndex;
	do {
		i = GetNextIndex(i);
		
		if (kseToken[i].lCmd == kseOPT_OPEN_PARENTHESIS) {
			if (bBlank = false) {
		      dResult = OpenPar(i);
		      bBlank = true;
		      //cout << kseToken[i].sToken;
		      //++i;
		   } else {
		      ErrMsg_NotMathOp(i);
		   }
		} else {
			sToken = kseToken[i].sToken;
		   if (sToken == kseOPEN_PAREN) {
				kseToken[i].lCmd = kseOPT_OPEN_PARENTHESIS;
				if (bBlank = false) {
					dResult = OpenPar(i);
					bBlank = true;
					//cout << kseToken[i].sToken;
					//++i;
				} else {
					ErrMsg_NotMathOp(i);
				}
		   } else {
				if (bBlank == false) {
					Engine_Message("Unexpected (  " + KSE_GetToken(i) + "  ).", "ERROR AT LINE " + kseToken[i].iLine);
					Engine_Exit();
				} else {
					ErrMsg_NotMathOp(i);
				}
		   }
		}
	} while (kseToken[i].sToken != kseSEMICOLON);
	
	iIndex = i - 1;
	return dResult*/
}

double OpenPar(unsigned long &iIndex) {
	return GetVal_OpenPar(iIndex, false, false, false, true);
//this was publicized this 09.14.06 for use of modKONSoL_String_Equation
/*	string sToken;
	string sValue;
	double iValue;
	int i;
	int ii;
	bool bBlank;
	
	string stmpUDTdata;
	
	i = iIndex;
	do {
		sToken = GetTokenStr(i);
		if (IsNumeric(sToken)) {
			if (bBlank == false) {
				sValue = sToken;
				bBlank = true;
			} else {
				ErrMsg_NotMathOp(i);
			}
		} else if (IsTokenNum(i)) {
			if (bBlank = false) {
				sValue = Str(GetNumValue(i));
				bBlank = true;
			} else {
				ErrMsg_NotMathOp(i);
			}
		} else if (IsTokenNum2(i)) {
			if (bBlank = false) {
				sValue = Str(GetNumValue2(i));
				bBlank = true;
			} else {
				ErrMsg_NotMathOp(i);
			}
		} else if (IsTokenStr(i)) {
			if (bBlank = false) {
				sValue = Str(Val(GetStrValue(i)));
				bBlank = true;
			} else {
				ErrMsg_NotMathOp(i);
			}
		} else if (IsTokenStr2(i)) {
			if (bBlank = false) {
				sValue = Str(Val(GetStrValue2(i)));
				bBlank = true;
			} else {
				ErrMsg_NotMathOp(i);
			}
		} else if (IsTokenArray(i)) {
			if (bBlank = false) {
				sValue = Str(ArrGetValue(i));
				bBlank = true;
			} else {
				ErrMsg_NotMathOp(i);
			}
		} else if (IsTokenUDT(i)) {
			if (bBlank == false) {
				stmpUDTdata = GetUDTValue(i);
				if (IsNumeric(stmpUDTdata)) {
					stmpUDTdata = Str(stmpUDTdata);
				}
				iValue = Val(stmpUDTdata);
				bBlank = true;
			} else {
				ErrMsg_NotMathOp(i);
			}
		} else if (IsTokenUDT2(i)) {
			if (bBlank = false) {
				stmpUDTdata = GetUDTValue2(i);
				if (IsNumeric(stmpUDTdata)) {
					stmpUDTdata = Str(stmpUDTdata);
				}
				iValue = Val(stmpUDTdata);
				bBlank = true;
			} else {
				ErrMsg_NotMathOp(i);
			}
		} else if (sToken == kseASTERISK) {
			sToken = GetTokenStr(i);
			if (IsNumeric(sToken)) {
				iValue = Val(sValue) * Val(sToken);
			} else if (sToken = kseOPEN_PAREN) {
				iValue = Val(sValue) * OpenPar(i);
				bBlank = false;
			} else if (IsTokenArray(i)) {
				iValue = Val(sValue) * Val(ArrGetValue(i));
			} else {
				iValue = Val(sValue) * GetNumValue(i);
			}
			sValue = Str(iValue);
		} else if (sToken == kseFORWARD_SLASH) {
			sToken = GetTokenStr(i);
			if (IsNumeric(sToken)) {
				iValue = Val(sValue) / Val(sToken);
			} else if (sToken = kseOPEN_PAREN) {
				iValue = Val(sValue) / OpenPar(i);
				bBlank = false;
			} else if (IsTokenArray(i)) {
				iValue = Val(sValue) / Val(ArrGetValue(i));
			} else {
				iValue = Val(sValue) / GetNumValue(i);
			}
			sValue = Str(iValue);
		} else if (sToken == ksePLUS_SIGN) {
			sToken = GetTokenStr(i);
			if (IsNumeric(sToken)) {
				iValue = Val(sValue) + Val(sToken);
			} else if (sToken = kseOPEN_PAREN) {
				iValue = Val(sValue) + OpenPar(i);
				bBlank = false;
			} else if (IsTokenArray(i)) {
				iValue = Val(sValue) + Val(ArrGetValue(i));
			} else {
				iValue = Val(sValue) + GetNumValue(i);
			}
			sValue = Str(iValue);
		} else if (sToken == kseMINUS_SIGN) {
			sToken = GetTokenStr(i);
			if (IsNumeric(sToken)) {
				iValue = Val(sValue) - Val(sToken);
			} else if (sToken = kseOPEN_PAREN) {
				iValue = Val(sValue) - OpenPar(i);
				bBlank = false;
			} else if (IsTokenArray(i)) {
				iValue = Val(sValue) - Val(ArrGetValue(i));
			} else {
				iValue = Val(sValue) - GetNumValue(i);
			}
			sValue = Str(iValue);
		} else if (sToken == ksePERCENT_SIGN) {
			sToken = GetTokenStr(i);
			if (IsNumeric(sToken)) {
				iValue = Val(sValue) % Val(sToken);
			} else if (sToken == kseOPEN_PAREN) {
				iValue = Val(sValue) % OpenPar(i);
				bBlank = false;
			} else if (IsTokenArray(i)) {
				iValue = Val(sValue) % Val(ArrGetValue(i));
			} else {
				iValue = Val(sValue) % GetNumValue(i);
			}
			sValue = Str(iValue);
		} else if (sToken == kseCARET) {
			sToken = GetTokenStr(i);
			if (IsNumeric(sToken)) {
				iValue = Val(sValue) ^ Val(sToken);
			} else if (sToken = kseOPEN_PAREN) {
				iValue = Val(sValue) ^ OpenPar(i);
				bBlank = false;
			} else if (IsTokenFunction(i)) {
				iValue = Val(sValue) ^ Val(SynCallFunction2(i));
			} else if (IsTokenArray(i)) {
				iValue = Val(sValue) ^ Val(ArrGetValue(i));
			} else {
				iValue = Val(sValue) ^ GetNumValue(i);
			}
			sValue = Str(iValue)
		} else if (sToken == kseOPEN_PAREN) {
			sValue = Str(OpenPar(i));
		} else if (sToken == kseCLOSE_PAREN) {
			break;
		} else if (sToken = kseSEMICOLON) {
			break;
		} else {
			if (bBlank == false) {
				//the GetNumValue function contains a fix on prompting technical err_msg.
				sValue = Str(GetNumValue(i));
			} else {
				ErrMsg_NotMathOp(i);
			}
		}
	} while (kseToken[i].sToken != kseSEMICOLON);
	iIndex = i;
	return Val(sValue)*/
}

string GetTokenStr(unsigned long &iIndex) {
//this was publicized this 09.14.06 for use of modKONSoL_String_Equation
	//this returns the content of a token
	iIndex = GetNextIndex(iIndex);
	return kseToken[iIndex].sToken;
}

void ErrMsg_NotMathOp(unsigned long &iIndex) {
//this was publicized this 09.14.06 for use of modKONSoL_String_Equation
	SneakScript();
	Engine_Message(KSE_GetErrFileSrc(iIndex) + "Expecting a (  Math operator  ) before (  " + KSE_GetToken(iIndex) + "  ).", "SYNTAX ERROR AT LINE " + Str(kseToken[iIndex].iLine) + " | " + Str(iIndex));
	Engine_Exit();
}
