//translated this 17.09.30 by mjmendozaIV
#include "../kage.hpp"
#include "../kageExterns.hpp"

//this contains the parser for
//	 mystring = myOtherstring + " is " + myNumber + " years old";
//would give a value that goes something like
//	 'Ab-ban is 4 years old'
//						   --Mj Mendoza IV

string GetStrValueAt(unsigned long &iIndex, bool FuncMode) {
	string sValue = "";
	string sToken = "";
	unsigned long i = iIndex;
	if (kseToken[i].lCmd == kseVALUE_ISNUMERIC) {
		sValue = kseToken[i].sToken;
	} else if (kseToken[i].lCmd == kseVALUE_ISHEXIC) {
		sValue = kseToken[i].sToken;
	} else if (kseToken[i].lCmd == kseVALUE_ISBOOLEANIC) {
		sValue = kseToken[i].sToken;
	} else if (kseToken[i].lCmd == kseVALUE_ISTOKENNUM) {
		sValue = Str(JIO_GetNumValue(i));
	} else if (kseToken[i].lCmd == kseVALUE_ISTOKENNUM2) {
		sValue = Str(GetNumValue2(i));
	} else if (kseToken[i].lCmd == kseVALUE_ISTOKENSTR) {
		sValue = GetStrValue(i);
	} else if (kseToken[i].lCmd == kseVALUE_ISTOKENSTR2) {
		sValue = GetStrValue2(i);
	} else if (kseToken[i].lCmd == kseVALUE_ISTOKENARRAY) {
		sValue = ArrGetValue(i);
	} else if (kseToken[i].lCmd == kseVALUE_ISTOKENUDT) {
		sValue = GetUDTValue(i);
	} else if (kseToken[i].lCmd == kseVALUE_ISTOKENUDT2) {
		sValue = GetUDTValue2(i);
	} else if (kseToken[i].lCmd == kseVALUE_ISTOKENFUNCTION) {
		sValue = SynCallFunction2(i);
		if (FuncMode == true) {
			i = GetPrevIndex(i);
		}
	} else if (kseToken[i].lCmd == kseVALUE_ISTOKENFUNCTION2) {
		while (kseToken[i].sToken != kseCOMMA && kseToken[i].sToken != kseSEMICOLON) {
			++i;
			i = KSE_SkipVoidTokens(i);
		}
		--i;
	} else if (kseToken[i].lCmd == kseVALUE_OPT_DOUBLE_QUOTES) {
		sValue = GetVal_Quotes(i);
	} else if (kseToken[i].lCmd == kseOPT_OPEN_PARENTHESIS) {
		sValue = Str(GetVal_OpenPar(i, false, FuncMode, false, true));
	} else if (kseToken[i].lCmd == kseVALUE_OPT_MINUS_SIGN) {
		++i; //skip negative
		sValue = Str(0 - GetNumValueAt(i, false, FuncMode, false, false));
	} else {
		sToken = kseToken[i].sToken;
		if (IsNumeric(sToken)) {
	   	kseToken[i].lCmd = kseVALUE_ISNUMERIC;
			sValue = sToken;
		} else if (IsHexic(sToken)) {
			kseToken[i].lCmd = kseVALUE_ISHEXIC;
			sValue = sToken;
		} else if (IsBooleanic(sToken)) {
			kseToken[i].lCmd = kseVALUE_ISBOOLEANIC;
			sValue = sToken;
		} else if (IsTokenNum(i)) {
	   	kseToken[i].lCmd = kseVALUE_ISTOKENNUM;
			sValue = Str(GetNumValue(i));
		} else if (IsTokenNum2(i)) {
			kseToken[i].lCmd = kseVALUE_ISTOKENNUM2;
			sValue = Str(GetNumValue2(i));
	   } else if (IsTokenStr(i)) {
	   	kseToken[i].lCmd = kseVALUE_ISTOKENSTR;
			sValue = GetStrValue(i);
	   } else if (IsTokenStr2(i)) {
	   	kseToken[i].lCmd = kseVALUE_ISTOKENSTR2;
			sValue = GetStrValue(i);
	   } else if (IsTokenArray(i)) {
			kseToken[i].lCmd = kseVALUE_ISTOKENARRAY;
			sValue = ArrGetValue(i);
		} else if (IsTokenUDT(i)) {
			kseToken[i].lCmd = kseVALUE_ISTOKENUDT;
			sValue = GetUDTValue(i);
	   } else if (IsTokenUDT2(i)) {
			kseToken[i].lCmd = kseVALUE_ISTOKENUDT2;
			sValue = GetUDTValue2(i);
	   } else if (IsTokenFunction(i)) {
			kseToken[i].lCmd = kseVALUE_ISTOKENFUNCTION;
			sValue = SynCallFunction2(i);
			if (FuncMode == true) {
				i = GetPrevIndex(i);
			}
		} else if (IsTokenFunction2(i)) {
			kseToken[i].lCmd = kseVALUE_ISTOKENFUNCTION2;
			while (kseToken[i].sToken != kseCOMMA && kseToken[i].sToken != kseSEMICOLON) {
				++i;
				i = KSE_SkipVoidTokens(i);
			}
			--i;
	   } else if (sToken == kseDOUBLE_QUOTES) {
			kseToken[i].lCmd = kseVALUE_OPT_DOUBLE_QUOTES;
			sValue = GetVal_Quotes(i);
		} else if (sToken == kseOPEN_PAREN) {
			kseToken[i].lCmd = kseOPT_OPEN_PARENTHESIS;
			sValue = Str(GetVal_OpenPar(i, false, FuncMode, false, true));
		} else if (sToken == kseMINUS_SIGN) {
			kseToken[i].lCmd = kseVALUE_OPT_MINUS_SIGN;
			++i; //skip negative
			sValue = Str(0 - GetNumValueAt(i, false, FuncMode, false, false));
		} else {
			Engine_Message("Expecting (  value  ) before (  " + KSE_GetToken(i) + "  ).", "ERROR AT LINE " + Str(kseToken[i].iLine));
			Engine_Exit();
		}
	}
	
	iIndex = i;
	return sValue;
}

string GetStrVal_New(unsigned long &iIndex, bool FuncMode, bool CondiMode, string CondiChr) {
	int iOp = 0;
	string sValue = "";
	unsigned long i = iIndex;
	do {
		i = GetNextIndex(i);
		sValue = GetStrValueAt(i, FuncMode);
		
		if (iOp == 0) {
			// [QuixiePP] err?!?
		}
	} while (kseToken[i].sToken != kseSEMICOLON);
	return ""; //what's the purpose of this function anyway?!? 11.07.14 // [QuixiePP] same question here
}


string GetStrVal(unsigned long &iIndex, bool FuncMode, bool CondiMode, string CondiChr) {
	string sToken = "";
	string sResult = "";
	unsigned long i = iIndex;
	bool bBlank = false;
	
	do {
		sToken = GetTokenStr(i);
		if (sToken == kseOPEN_PAREN) {
			kseToken[i].lCmd = kseOPT_OPEN_PARENTHESIS;
			if (bBlank == false) {
				sResult = Str(OpenPar(i));
				bBlank = 1;
			} else {
				ErrMsg_NotMathOp(i);
			}
		} else if (sToken == kseCLOSE_PAREN) {
			kseToken[i].lCmd = kseOPT_CLOSE_PARENTHESIS;
			if (FuncMode || CondiMode) {
				break;
			} else {
				Engine_Message(KSE_GetErrFileSrc(i) + "Unexpected (  )  ).", "SYNTAX ERROR AT LINE " + Str(kseToken[i].iLine));
				Engine_Exit();
			}
		} else if (sToken == kseCOMMA) {
			kseToken[i].lCmd = kseOPT_COMMA;
			if (FuncMode) {
				break;
			} else {
				Engine_Message(KSE_GetErrFileSrc(i) + "Unexpected (  ,  ).", "SYNTAX ERROR AT LINE " + Str(kseToken[i].iLine));
				Engine_Exit();
			}
		} else if (sToken == kseSEMICOLON) {
			kseToken[i].lCmd = kseOPT_SEMICOLON;
			break;
		} else if (sToken == kseDOUBLE_QUOTES) {
			kseToken[i].lCmd = kseVALUE_OPT_DOUBLE_QUOTES;
			i = SynQuotes(i);
			//get the string value
			if (bBlank == false) {
				sResult = GetTempString();
				bBlank = true;
			} else {
				sResult += GetTempString();
			}
			
		} else if (sToken == ksePLUS_SIGN) {
			kseToken[i].lCmd = kseVALUE_OPT_PLUS_SIGN;
			sToken = GetTokenStr(i);
			if (IsNumeric(sToken)) {
				if (IsNumeric(sResult)) {
					sResult = Str(Val(sResult) + Val(sToken));
				} else {
					sResult += Val(sToken);
				}
			} else if (sToken == kseOPEN_PAREN) {
				sResult += Str(OpenPar(i));
				bBlank = false;
			} else if (IsTokenNum(i)) {
				if (IsNumeric(sResult)) {
					sResult = Str(Val(sResult) + GetNumValue(i));
				} else {
					sResult += GetNumValue(i);
				} 
			} else if (IsTokenStr(i)) {
				sResult = sResult + GetStrValue(i);
			} else if (IsTokenBool(i)) {
				sResult = sResult + Str(GetBoolValue(i));
			} else if (sToken == kseDOUBLE_QUOTES) {
				i = SynQuotes(i);
				//get the string value
				sResult += GetTempString();
			} else if (IsTokenFunction(i)) {
				if (true) {
					//asd
				}
			}
		} else if (sToken == kseMINUS_SIGN) {
			kseToken[i].lCmd = kseVALUE_OPT_MINUS_SIGN;
			sToken = GetTokenStr(i);
			//if sResult is numeric, sResult less succeeding value
			//else, "helloworld" - "low" = "helorld" //[QuixiePP] err?!?
			if (IsNumeric(sToken)) {
				if (IsNumeric(sResult)) {
					sResult = Str(Val(sResult) - Val(sToken));
				} else {
					sResult = Replace(sResult, sToken, "");
				}
			} else if (sToken == kseOPEN_PAREN) {
				if (IsNumeric(sResult)) {
					sResult = Str(Val(sResult) - OpenPar(i));
				} else {
					sResult = Replace(sResult, Str(OpenPar(i)), "");
				}
				bBlank = false;
			} else if (IsTokenNum(i)) {
				if (IsNumeric(sResult)) {
					sResult = Str(Val(sResult) - GetNumValue(i));
				} else {
					sResult = Replace(sResult, Str(GetNumValue(i)), "");
				} 
			} else if (IsTokenStr(i)) {
				if (IsNumeric(sResult)) {
					sResult = Str(Val(sResult) - Val(GetStrValue(i)));
				} else {
					sResult = Replace(sResult, GetStrValue(i), "");
				}
			} else if (IsTokenBool(i)) {
				if (IsNumeric(sResult)) {
					sResult = sResult + Str(GetBoolValue(i));
				} else {
					if (GetBoolValue(i) != 0) {
						sResult = Replace(sResult, "true", "");
					} else {
						sResult = Replace(sResult, "false", "");
					}
				}
			} else if (sToken == kseDOUBLE_QUOTES) {
				i = SynQuotes(i);
				//get the string value
				if (IsNumeric(sResult)) {
					sResult = Str(Val(sResult) + Val(GetTempString()));
				} else {
					sResult = Replace(sResult, GetTempString(), "");
				}
			} else if (IsTokenFunction(i)) {
				if (true) {
					//asd
				}
			}
		} else if (sToken == kseASTERISK) {
			kseToken[i].lCmd = kseVALUE_OPT_ASTERISK;
			sToken = GetTokenStr(i);
			//if sResult is numeric, sResult times succeeding value
			//or if sToken is numeric, "helloworld" * 3 = "helloworldhelloworldhelloworld"
			if (IsNumeric(sToken)) {
				if (IsNumeric(sResult)) {
					if (IsNumeric(sToken)) {
						sResult = Str(Val(sResult) * Val(sToken));
					} else {
						sResult = String(Val(sResult),sToken);
					}
				} else {
					sResult = String(Val(sToken),sResult);
				}
			} else if (sToken == kseOPEN_PAREN) {
				if (IsNumeric(sResult)) {
					sResult = Str(Val(sResult) * OpenPar(i));
				} else {
					sResult = String(OpenPar(i),sResult);
				}
				bBlank = false;
			} else if (IsTokenNum(i)) {
				if (IsNumeric(sResult)) {
					sResult = Str(Val(sResult) * GetNumValue(i));
				} else {
					sResult = String(GetNumValue(i),sResult);
				} 
			} else if (IsTokenStr(i)) {
				if (IsNumeric(sResult)) {
					sResult = Str(Val(sResult) * Val(GetStrValue(i)));
				} else {
					sResult = String(Val(GetStrValue(i)),sResult);
				}
			} else if (IsTokenBool(i)) {
				if (IsNumeric(sResult)) {
					if (GetBoolValue(i) == true) {
						sResult = Str(Val(sResult) * 1);
					} else {
						sResult = Str(Val(sResult) * 0); // good as 0 (i think :P -- mj)
					}
				} else {
					sResult = String(Val(sToken),sResult);
					if (GetBoolValue(i) != false) {
						sResult = String(1,sResult);
					} else {
						sResult = String(0,sResult); // good as "" (i think :P -- mj)
					}
				}
			} else if (sToken == kseDOUBLE_QUOTES) {
				i = SynQuotes(i);
				//get the string value
				if (IsNumeric(sResult)) {
					sResult = Str(Val(sResult) * Val(GetTempString()));
				} else {
					sResult = String(Val(GetTempString()),sResult);
				}
			} else if (IsTokenFunction(i)) {
				if (true) {
					//asd
				}
			}
		} else if (IsNumeric(sToken)) {
			kseToken[i].lCmd = kseVALUE_ISNUMERIC;
			if (bBlank == false) {
				sResult = sToken;
				bBlank = true;
			} else {
				ErrMsg_NotMathOp(i);
			}
		} else if (KSE_IsNegativeValue(i)) {
			if (bBlank == false) {
				sResult = Str(KSE_GetNegativeValue(i));
				bBlank = true;
			} else {
				ErrMsg_NotMathOp(i);
			}
		} else if (IsTokenNum(i)) {
			kseToken[i].lCmd = kseVALUE_ISTOKENNUM;
			if (bBlank == false) {
				sResult = Str(GetNumValue(i));
				bBlank = true;
			} else {
				ErrMsg_NotMathOp(i);
			}
		} else if (IsTokenStr(i)) {
			kseToken[i].lCmd = kseVALUE_ISTOKENSTR;
			if (bBlank == false) {
				sResult = GetStrValue(i);
				bBlank = true;
			} else {
				ErrMsg_NotMathOp(i);
			}
		} else if (IsTokenBool(i)) {
			kseToken[i].lCmd = kseVALUE_ISTOKENBOOL;
			if (bBlank == false) {
				sResult = Str(GetBoolValue(i));
				bBlank = true;
			} else {
				ErrMsg_NotMathOp(i);
			}
		} else if (IsTokenArray(i)) {
			kseToken[i].lCmd = kseVALUE_ISTOKENARRAY;
			if (bBlank == false) {
				sResult = ArrGetValue(i);
				bBlank = true;
			} else {
				ErrMsg_NotMathOp(i);
			}
		} else if (IsTokenUDT(i)) {
			kseToken[i].lCmd = kseVALUE_ISTOKENUDT;
			if (bBlank == false) {
				string stmpUDTdata = GetUDTValue(i);
				if (IsNumeric(stmpUDTdata)) {
					//stmpUDTdata = Str(stmpUDTdata);
				}
				sResult = stmpUDTdata;
				bBlank = true;
			} else {
				ErrMsg_NotMathOp(i);
			}
		} else if (IsTokenFunction(i)) {
			kseToken[i].lCmd = kseVALUE_ISTOKENFUNCTION;
			sToken = SynCallFunction2(i);
			if (bBlank == false) {
				sResult = sToken;
				if (FuncMode) {
					i = GetPrevIndex(i);
				} else {
					bBlank = true;
				}
			} else {
				ErrMsg_NotMathOp(i);
			}
		} else {
			if (bBlank == false) {
				//the GetStrValue function contains a fix on prompting technical err_msg.
				sResult = GetStrValue(i);
			} else if (CondiMode == true) {
				if (KSE_IsTokenCondiOp(sToken) || sToken == CondiChr) {
					break;
				} else {
					ErrMsg_NotMathOp(i);
				}
			} else if (FuncMode == true) {
				break;
			} else {
				ErrMsg_NotMathOp(i);
			}
		}
		
	} while (kseToken[i].sToken != kseSEMICOLON);
	iIndex = i - 1;
	
	return sResult;
}

string JIO_GetStrVal(unsigned long &iIndex, bool FuncMode, bool CondiMode, string CondiChr) {
	string sToken = "";
	string sResult = "";
	unsigned long i;
	bool bBlank = false;
	
	i = iIndex;
	do {
		i = GetNextIndex(i);
		
		if (kseToken[i].lCmd == kseOPT_OPEN_PARENTHESIS) {
			if (bBlank == false) {
				sResult = Str(OpenPar(i));
				bBlank = true;
			} else {
				ErrMsg_NotMathOp(i);
			}
		} else if (kseToken[i].lCmd == kseOPT_CLOSE_PARENTHESIS) {
			if (FuncMode || CondiMode) {
				break;
			} else {
				Engine_Message(KSE_GetErrFileSrc(i) + "Unexpected (  )  ).", "SYNTAX ERROR AT LINE " + Str(kseToken[i].iLine));
				Engine_Exit();
			}
		} else if (kseToken[i].lCmd == kseOPT_COMMA) {
			if (FuncMode) {
				break;
			} else {
				Engine_Message(KSE_GetErrFileSrc(i) + "Unexpected (  ,  ).", "SYNTAX ERROR AT LINE " + Str(kseToken[i].iLine));
				Engine_Exit();
			}
		} else if (kseToken[i].lCmd == kseOPT_SEMICOLON) {
			break;
		} else if (kseToken[i].lCmd == kseVALUE_OPT_DOUBLE_QUOTES) {
			i = SynQuotes(i);
			//get the string value
			if (bBlank == false) {
				sResult = GetTempString();
				bBlank = true;
			} else {
				sResult += GetTempString();
			}
			
		} else if (kseToken[i].lCmd == kseVALUE_OPT_PLUS_SIGN) {
			sToken = GetTokenStr(i);
			if (IsNumeric(sToken)) {
				if (IsNumeric(sResult)) {
					sResult = Str(Val(sResult) + Val(sToken));
				} else {
					sResult += Val(sToken);
				}
			} else if (sToken == kseOPEN_PAREN) {
				sResult += Str(OpenPar(i));
				bBlank = false;
			} else if (IsTokenNum(i)) {
				if (IsNumeric(sResult)) {
					sResult = Str((Val(sResult) + GetNumValue(i)));
				} else {
					sResult += Str(GetNumValue(i));
				} 
			} else if (IsTokenStr(i)) {
				sResult = sResult + JIO_GetStrValue(i);
			} else if (IsTokenBool(i)) {
				sResult = sResult + Str(GetBoolValue(i));
			} else if (sToken == kseDOUBLE_QUOTES) {
				i = SynQuotes(i);
				//get the string value
				sResult += GetTempString();
			} else if (IsTokenFunction(i)) {
				if (1 == 1) {
					//asd
				}
			}
		} else if (kseToken[i].lCmd == kseVALUE_OPT_MINUS_SIGN) {
			sToken = GetTokenStr(i);
			//if sResult is numeric, sResult less succeeding value
			//else, "helloworld" - "low" = "helorld"
			if (IsNumeric(sToken)) {
				if (IsNumeric(sResult)) {
					sResult = Str(Val(sResult) - Val(sToken));
				} else {
					sResult = Replace(sResult, sToken, "");
				}
			} else if (sToken == kseOPEN_PAREN) {
				if (IsNumeric(sResult)) {
					sResult = Str(Val(sResult) - OpenPar(i));
				} else {
					sResult = Replace(sResult, Str(OpenPar(i)), "");
				}
				bBlank = false;
			} else if (IsTokenNum(i)) {
				if (IsNumeric(sResult)) {
					sResult = Str(Val(sResult) - GetNumValue(i));
				} else {
					sResult = Replace(sResult, Str(GetNumValue(i)), "");
				} 
			} else if (IsTokenStr(i)) {
				if (IsNumeric(sResult)) {
					sResult = Str(Val(sResult) - Val(JIO_GetStrValue(i)));
				} else {
					sResult = Replace(sResult, GetStrValue(i), "");
				}
			} else if (IsTokenBool(i)) {
				if (IsNumeric(sResult)) {
					sResult += Str(GetBoolValue(i));
				} else {
					if (GetBoolValue(i) != 0) {
						sResult = Replace(sResult, "true", "");
					} else {
						sResult = Replace(sResult, "false", "");
					}
				}
			} else if (sToken == kseDOUBLE_QUOTES) {
				i = SynQuotes(i);
				//get the string value
				if (IsNumeric(sResult)) {
					sResult = Str(Val(sResult) + Val(GetTempString()));
				} else {
					sResult = Replace(sResult, GetTempString(), "");
				}
			} else if (IsTokenFunction(i)) {
				if (1 == 1) {
					//asd
				}
			}
		} else if (kseToken[i].lCmd == kseVALUE_ISNUMERIC) {
			if (bBlank == false) {
				sResult = kseToken[i].sToken;
				bBlank = true;
			} else {
				ErrMsg_NotMathOp(i);
			}
		} else if (KSE_IsNegativeValue(i)) {
			if (bBlank == false) {
				sResult = Str(KSE_GetNegativeValue(i));
				bBlank = true;
			} else {
				ErrMsg_NotMathOp(i);
			}
		} else if (kseToken[i].lCmd == kseVALUE_ISTOKENNUM) {
			if (bBlank == false) {
				sResult = Str(JIO_GetNumValue(i));
				bBlank = true;
			} else {
				ErrMsg_NotMathOp(i);
			}
		} else if (kseToken[i].lCmd == kseVALUE_ISTOKENSTR) {
			if (bBlank == false) {
				sResult = JIO_GetStrValue(i);
				bBlank = true;
			} else {
				ErrMsg_NotMathOp(i);
			}
		} else if (kseToken[i].lCmd == kseVALUE_ISTOKENBOOL) {
			if (bBlank == false) {
				sResult = Str(GetBoolValue(i));
				bBlank = true;
			} else {
				ErrMsg_NotMathOp(i);
			}
		} else if (kseToken[i].lCmd == kseVALUE_ISTOKENARRAY) {
			if (bBlank == false) {
				sResult = ArrGetValue(i);
				bBlank = true;
			} else {
				ErrMsg_NotMathOp(i);
			}
		} else if (kseToken[i].lCmd == kseVALUE_ISTOKENUDT) {
			if (bBlank == false) {
				string stmpUDTdata = GetUDTValue(i);
//				if (IsNumeric(stmpUDTdata)) {
//					stmpUDTdata = stmpUDTdata;
//				}
				sResult = stmpUDTdata;
				bBlank = true;
			} else {
				ErrMsg_NotMathOp(i);
			}
		} else if (kseToken[i].lCmd == kseVALUE_ISTOKENFUNCTION) {
			sToken = SynCallFunction2(i);
			if (bBlank == false) {
				sResult = sToken;
				if (FuncMode) {
					i = GetPrevIndex(i);
				} else {
					bBlank = true;
				}
			} else {
				ErrMsg_NotMathOp(i);
			}
		} else {
			if (bBlank == false) {
				//the GetStrValue function contains a fix on prompting technical err_msg.
				sResult = JIO_GetStrValue(i);
			} else if (CondiMode == true) {
				if (JIO_KSE_IsTokenCondiOp(i) || sToken == CondiChr) {
					break;
				} else {
					ErrMsg_NotMathOp(i);
				}
			} else if (FuncMode == true) {
				break;
			} else {
				ErrMsg_NotMathOp(i);
			}
		}
		
	} while (kseToken[i].sToken != kseSEMICOLON);
	iIndex = i - 1;
	return sResult;
}

bool KSE_IsTokenCondiOp(string sToken) {
	string sOp = sToken;
	if (sOp == "EQ" || sOp == "=="
			|| sOp == "NE" || sOp == "!="
			|| sOp == "GT" || sOp == ">"
			|| sOp == "GE" || sOp == ">="
			|| sOp == "LT" || sOp == "<"
			|| sOp == "LE" || sOp == "<=") {
		return true;
	} else {
		return false;
	}
}

bool JIO_KSE_IsTokenCondiOp(unsigned long &iIndex) {
	if (kseToken[iIndex].lCmd > kseOPT_EQ
			&& kseToken[iIndex].lCmd < kseOPT_LE) {
		return true;
	} else {
		return false;
	}
}

unsigned long SynQuotes(unsigned long &iIndex) {
	unsigned long i;
	unsigned long iTemp;
	unsigned long iLine;
	string sTmp;
	bool bNewline = false;
	
	//sTempString = "";									   //set default value
	iLine = kseToken[iIndex + 1].iLine;					   //get code line
	
	for (i = iIndex + 1; i < iTokenCtr; ++i) {
		//DoEvents //added for more KS speed
		if (kseToken[i].sToken == kseDOUBLE_QUOTES) {
			if (bKONSoLE_Reading == 0) { break; }
			//# idea is to let users concatenate in setting string value
			//==========================================
			iTemp = i;									   //temporarily store i's value
			do {
				//DoEvents //added for more KS speed
				i = GetNextIndex(i);
				if (kseToken[i].sToken == ksePLUS_SIGN) {
					i = GetNextIndex(i);
//					trace("SynQuotes " + kseToken[i].sToken);
					if (IsNumeric(kseToken[i].sToken)) {
						sTempString += kseToken[i].sToken;
					} else if (IsTokenStr(i) == true) {
						sTempString += GetStrValue(i);
					} else if (IsTokenNum(i)) {
						//sTmp = GetNumValue(i);
						//sTempString = sTempString + Trim(sTmp);
						sTmp = Str(GetTokenNumValue(i));
						sTempString += Trim(sTmp);
					} else if (IsTokenBool(i)) {
						sTmp = Str(GetBoolValue(i));
						sTempString += Trim(sTmp);
					} else if (IsTokenFunction(i)) {
						i = SynCallFunction(i);
					} else if (IsTokenArray(i)) {
						sTempString += ArrGetValue(i);
					} else if (IsTokenUDT(i)) {
						sTempString += GetUDTValue(i);
					} else if (kseToken[i].sToken == kseDOUBLE_QUOTES) {
						i = SynQuotes(i);
					} else if (kseToken[i].sToken == kseOPEN_PAREN) {
							sTempString += Str(OpenPar(i));
						++i;
					} else {
						Engine_Message(KSE_GetErrFileSrc(i) + "Expecting a (  string parameter  ) but got (  " + KSE_GetToken(i) + "  ) instead.", "SYNTAX ERROR AT LINE " + kseToken[i].iLine);
						Engine_Exit();
					}
					iTemp = i;							   //temporarily store i's value
				} else {
					i = iTemp;
					break;
				}
			} while (true);
			//==========================================
			break;
		} else if (kseToken[i].sToken == kseBACK_SLASH && (bKONSoLE_Reading == true || bREAD_ESCAPE_CHARS == true)) {
			//check for escape characters
			//# (i+1) was taken instead of GetNextIndex since escape chars should be written as one word
			
			bNewline = false;
			if (kseToken[i + 1].sToken == "n") {
				#ifdef QUIXIE_CGI
					sTempString = sTempString + "\n";
				#else
					sTempString = sTempString + "\r\n";
				#endif
				++i;
			} else if (Left(kseToken[i + 1].sToken, 1) == "n") {
				#ifdef QUIXIE_CGI
					sTempString += "\n";
				#else
					sTempString += "\r\n";
				#endif
				bNewline = true;	//to correct \n [Ex. from \nice (suppose to be \n and ice)]
				
			} else if (kseToken[i + 1].sToken == "t") {
				sTempString += "\t";
				++i;
			} else if (Left(kseToken[i + 1].sToken, 1) == "t") {
			
				sTempString += "\t";
				bNewline = true;	//to correct \t [Ex. from \table (suppose to be \t and able)]
				
			} else if (kseToken[i + 1].sToken == kseDOUBLE_QUOTES) {
				sTempString += kseDOUBLE_QUOTES;
				++i;
			} else if (kseToken[i + 1].sToken == kseBACK_SLASH) {
				sTempString += kseSLASH; //use slash used by the OS
				++i;
			} else if (kseToken[i + 1].sToken == kseOPEN_PAREN) {
				sTempString += OpenPar(i);
				++i;
			} else {
				sTempString += kseToken[i + 1].sToken;
				++i;
			}
		//# idea is to prevent broken string value
		//sample: "asdasdasd...
		//			  ...qweqweqwe"
		//should be:
		//		"asdasdasd\nqweqweqwe"
		} else if (kseToken[i].iLine == iLine) {
			if (bNewline == true) {
				sTempString = sTempString + kseToken[i].sToken;
				bNewline = false;
			} else {
				sTempString = sTempString + kseToken[i].sToken;
			}
		} else {
			Engine_Message(KSE_GetErrFileSrc(i) + "Expecting (  ""  ) but got (  " + KSE_GetToken(i) + "  ) instead.", "SYNTAX ERROR AT LINE " + Str(kseToken[i].iLine));
			Engine_Exit();
		}
	}
	return i;
}

string GetTempString() {
	string retVal = sTempString;
	sTempString = ""; //clear buffer
	return retVal;    //retrieve buffer content
}
